// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/Box.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__BOX__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__BOX__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__Box __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__Box __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Box_
{
  using Type = Box_<ContainerAllocator>;

  explicit Box_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->x = 0.0;
      this->y = 0.0;
      this->z = 0.0;
    }
  }

  explicit Box_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->x = 0.0;
      this->y = 0.0;
      this->z = 0.0;
    }
  }

  // field types and members
  using _x_type =
    double;
  _x_type x;
  using _y_type =
    double;
  _y_type y;
  using _z_type =
    double;
  _z_type z;

  // setters for named parameter idiom
  Type & set__x(
    const double & _arg)
  {
    this->x = _arg;
    return *this;
  }
  Type & set__y(
    const double & _arg)
  {
    this->y = _arg;
    return *this;
  }
  Type & set__z(
    const double & _arg)
  {
    this->z = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::Box_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::Box_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::Box_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::Box_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::Box_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::Box_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::Box_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::Box_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::Box_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::Box_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__Box
    std::shared_ptr<rc_reason_msgs::msg::Box_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__Box
    std::shared_ptr<rc_reason_msgs::msg::Box_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Box_ & other) const
  {
    if (this->x != other.x) {
      return false;
    }
    if (this->y != other.y) {
      return false;
    }
    if (this->z != other.z) {
      return false;
    }
    return true;
  }
  bool operator!=(const Box_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Box_

// alias to use template instance with default allocator
using Box =
  rc_reason_msgs::msg::Box_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__BOX__STRUCT_HPP_
