// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/CellFillingLevel.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/cell_filling_level__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `cell_size`
#include "rc_reason_msgs/msg/rectangle__functions.h"
// Member `cell_position`
#include "geometry_msgs/msg/point__functions.h"
// Member `level_in_percent`
// Member `level_free_in_meters`
#include "rc_reason_msgs/msg/range_value__functions.h"

bool
rc_reason_msgs__msg__CellFillingLevel__init(rc_reason_msgs__msg__CellFillingLevel * msg)
{
  if (!msg) {
    return false;
  }
  // cell_size
  if (!rc_reason_msgs__msg__Rectangle__init(&msg->cell_size)) {
    rc_reason_msgs__msg__CellFillingLevel__fini(msg);
    return false;
  }
  // cell_position
  if (!geometry_msgs__msg__Point__init(&msg->cell_position)) {
    rc_reason_msgs__msg__CellFillingLevel__fini(msg);
    return false;
  }
  // level_in_percent
  if (!rc_reason_msgs__msg__RangeValue__init(&msg->level_in_percent)) {
    rc_reason_msgs__msg__CellFillingLevel__fini(msg);
    return false;
  }
  // level_free_in_meters
  if (!rc_reason_msgs__msg__RangeValue__init(&msg->level_free_in_meters)) {
    rc_reason_msgs__msg__CellFillingLevel__fini(msg);
    return false;
  }
  // coverage
  return true;
}

void
rc_reason_msgs__msg__CellFillingLevel__fini(rc_reason_msgs__msg__CellFillingLevel * msg)
{
  if (!msg) {
    return;
  }
  // cell_size
  rc_reason_msgs__msg__Rectangle__fini(&msg->cell_size);
  // cell_position
  geometry_msgs__msg__Point__fini(&msg->cell_position);
  // level_in_percent
  rc_reason_msgs__msg__RangeValue__fini(&msg->level_in_percent);
  // level_free_in_meters
  rc_reason_msgs__msg__RangeValue__fini(&msg->level_free_in_meters);
  // coverage
}

rc_reason_msgs__msg__CellFillingLevel *
rc_reason_msgs__msg__CellFillingLevel__create()
{
  rc_reason_msgs__msg__CellFillingLevel * msg = (rc_reason_msgs__msg__CellFillingLevel *)malloc(sizeof(rc_reason_msgs__msg__CellFillingLevel));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__CellFillingLevel));
  bool success = rc_reason_msgs__msg__CellFillingLevel__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__CellFillingLevel__destroy(rc_reason_msgs__msg__CellFillingLevel * msg)
{
  if (msg) {
    rc_reason_msgs__msg__CellFillingLevel__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__msg__CellFillingLevel__Sequence__init(rc_reason_msgs__msg__CellFillingLevel__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__msg__CellFillingLevel * data = NULL;
  if (size) {
    data = (rc_reason_msgs__msg__CellFillingLevel *)calloc(size, sizeof(rc_reason_msgs__msg__CellFillingLevel));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__CellFillingLevel__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__CellFillingLevel__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__CellFillingLevel__Sequence__fini(rc_reason_msgs__msg__CellFillingLevel__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__CellFillingLevel__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__CellFillingLevel__Sequence *
rc_reason_msgs__msg__CellFillingLevel__Sequence__create(size_t size)
{
  rc_reason_msgs__msg__CellFillingLevel__Sequence * array = (rc_reason_msgs__msg__CellFillingLevel__Sequence *)malloc(sizeof(rc_reason_msgs__msg__CellFillingLevel__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__CellFillingLevel__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__CellFillingLevel__Sequence__destroy(rc_reason_msgs__msg__CellFillingLevel__Sequence * array)
{
  if (array) {
    rc_reason_msgs__msg__CellFillingLevel__Sequence__fini(array);
  }
  free(array);
}
