// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/CellFillingLevel.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__CELL_FILLING_LEVEL__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__CELL_FILLING_LEVEL__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'cell_size'
#include "rc_reason_msgs/msg/rectangle__struct.hpp"
// Member 'cell_position'
#include "geometry_msgs/msg/point__struct.hpp"
// Member 'level_in_percent'
// Member 'level_free_in_meters'
#include "rc_reason_msgs/msg/range_value__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__CellFillingLevel __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__CellFillingLevel __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CellFillingLevel_
{
  using Type = CellFillingLevel_<ContainerAllocator>;

  explicit CellFillingLevel_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : cell_size(_init),
    cell_position(_init),
    level_in_percent(_init),
    level_free_in_meters(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->coverage = 0.0;
    }
  }

  explicit CellFillingLevel_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : cell_size(_alloc, _init),
    cell_position(_alloc, _init),
    level_in_percent(_alloc, _init),
    level_free_in_meters(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->coverage = 0.0;
    }
  }

  // field types and members
  using _cell_size_type =
    rc_reason_msgs::msg::Rectangle_<ContainerAllocator>;
  _cell_size_type cell_size;
  using _cell_position_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _cell_position_type cell_position;
  using _level_in_percent_type =
    rc_reason_msgs::msg::RangeValue_<ContainerAllocator>;
  _level_in_percent_type level_in_percent;
  using _level_free_in_meters_type =
    rc_reason_msgs::msg::RangeValue_<ContainerAllocator>;
  _level_free_in_meters_type level_free_in_meters;
  using _coverage_type =
    double;
  _coverage_type coverage;

  // setters for named parameter idiom
  Type & set__cell_size(
    const rc_reason_msgs::msg::Rectangle_<ContainerAllocator> & _arg)
  {
    this->cell_size = _arg;
    return *this;
  }
  Type & set__cell_position(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->cell_position = _arg;
    return *this;
  }
  Type & set__level_in_percent(
    const rc_reason_msgs::msg::RangeValue_<ContainerAllocator> & _arg)
  {
    this->level_in_percent = _arg;
    return *this;
  }
  Type & set__level_free_in_meters(
    const rc_reason_msgs::msg::RangeValue_<ContainerAllocator> & _arg)
  {
    this->level_free_in_meters = _arg;
    return *this;
  }
  Type & set__coverage(
    const double & _arg)
  {
    this->coverage = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__CellFillingLevel
    std::shared_ptr<rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__CellFillingLevel
    std::shared_ptr<rc_reason_msgs::msg::CellFillingLevel_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CellFillingLevel_ & other) const
  {
    if (this->cell_size != other.cell_size) {
      return false;
    }
    if (this->cell_position != other.cell_position) {
      return false;
    }
    if (this->level_in_percent != other.level_in_percent) {
      return false;
    }
    if (this->level_free_in_meters != other.level_free_in_meters) {
      return false;
    }
    if (this->coverage != other.coverage) {
      return false;
    }
    return true;
  }
  bool operator!=(const CellFillingLevel_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CellFillingLevel_

// alias to use template instance with default allocator
using CellFillingLevel =
  rc_reason_msgs::msg::CellFillingLevel_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__CELL_FILLING_LEVEL__STRUCT_HPP_
