// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/CollisionDetection.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__COLLISION_DETECTION__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__COLLISION_DETECTION__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'pre_grasp_offset'
#include "geometry_msgs/msg/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__CollisionDetection __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__CollisionDetection __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CollisionDetection_
{
  using Type = CollisionDetection_<ContainerAllocator>;

  explicit CollisionDetection_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : pre_grasp_offset(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->gripper_id = "";
    }
  }

  explicit CollisionDetection_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : gripper_id(_alloc),
    pre_grasp_offset(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->gripper_id = "";
    }
  }

  // field types and members
  using _gripper_id_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _gripper_id_type gripper_id;
  using _pre_grasp_offset_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _pre_grasp_offset_type pre_grasp_offset;

  // setters for named parameter idiom
  Type & set__gripper_id(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->gripper_id = _arg;
    return *this;
  }
  Type & set__pre_grasp_offset(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->pre_grasp_offset = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__CollisionDetection
    std::shared_ptr<rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__CollisionDetection
    std::shared_ptr<rc_reason_msgs::msg::CollisionDetection_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CollisionDetection_ & other) const
  {
    if (this->gripper_id != other.gripper_id) {
      return false;
    }
    if (this->pre_grasp_offset != other.pre_grasp_offset) {
      return false;
    }
    return true;
  }
  bool operator!=(const CollisionDetection_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CollisionDetection_

// alias to use template instance with default allocator
using CollisionDetection =
  rc_reason_msgs::msg::CollisionDetection_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__COLLISION_DETECTION__STRUCT_HPP_
