#ifndef _H_B6A1ED64F8DDE307BFA57CA0D001A3B0_CollisionDetection_DCPS_H_
#define _H_B6A1ED64F8DDE307BFA57CA0D001A3B0_CollisionDetection_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CollisionDetection_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CollisionDetection_TypeSupportInterface;

            typedef CollisionDetection_TypeSupportInterface * CollisionDetection_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CollisionDetection_TypeSupportInterface> CollisionDetection_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CollisionDetection_TypeSupportInterface> CollisionDetection_TypeSupportInterface_out;


            class CollisionDetection_DataWriter;

            typedef CollisionDetection_DataWriter * CollisionDetection_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CollisionDetection_DataWriter> CollisionDetection_DataWriter_var;
            typedef DDS_DCPSInterface_out < CollisionDetection_DataWriter> CollisionDetection_DataWriter_out;


            class CollisionDetection_DataReader;

            typedef CollisionDetection_DataReader * CollisionDetection_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CollisionDetection_DataReader> CollisionDetection_DataReader_var;
            typedef DDS_DCPSInterface_out < CollisionDetection_DataReader> CollisionDetection_DataReader_out;


            class CollisionDetection_DataReaderView;

            typedef CollisionDetection_DataReaderView * CollisionDetection_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CollisionDetection_DataReaderView> CollisionDetection_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CollisionDetection_DataReaderView> CollisionDetection_DataReaderView_out;

            struct CollisionDetection_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CollisionDetection_, struct CollisionDetection_Seq_uniq_> CollisionDetection_Seq;
            typedef DDS_DCPSSequence_var < CollisionDetection_Seq> CollisionDetection_Seq_var;
            typedef DDS_DCPSSequence_out < CollisionDetection_Seq> CollisionDetection_Seq_out;

            class  CollisionDetection_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CollisionDetection_TypeSupportInterface_ptr _ptr_type;
                typedef CollisionDetection_TypeSupportInterface_var _var_type;

                static CollisionDetection_TypeSupportInterface_ptr _duplicate (CollisionDetection_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionDetection_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CollisionDetection_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionDetection_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionDetection_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CollisionDetection_TypeSupportInterface () {};
                ~CollisionDetection_TypeSupportInterface () {};
            private:
                CollisionDetection_TypeSupportInterface (const CollisionDetection_TypeSupportInterface &);
                CollisionDetection_TypeSupportInterface & operator = (const CollisionDetection_TypeSupportInterface &);
            };

            class  CollisionDetection_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CollisionDetection_DataWriter_ptr _ptr_type;
                typedef CollisionDetection_DataWriter_var _var_type;

                static CollisionDetection_DataWriter_ptr _duplicate (CollisionDetection_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionDetection_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CollisionDetection_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionDetection_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionDetection_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CollisionDetection_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CollisionDetection_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CollisionDetection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CollisionDetection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CollisionDetection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CollisionDetection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CollisionDetection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CollisionDetection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CollisionDetection_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CollisionDetection_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CollisionDetection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CollisionDetection_& instance_data) = 0;

            protected:
                CollisionDetection_DataWriter () {};
                ~CollisionDetection_DataWriter () {};
            private:
                CollisionDetection_DataWriter (const CollisionDetection_DataWriter &);
                CollisionDetection_DataWriter & operator = (const CollisionDetection_DataWriter &);
            };

            class  CollisionDetection_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CollisionDetection_DataReader_ptr _ptr_type;
                typedef CollisionDetection_DataReader_var _var_type;

                static CollisionDetection_DataReader_ptr _duplicate (CollisionDetection_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionDetection_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CollisionDetection_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionDetection_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionDetection_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CollisionDetection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CollisionDetection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CollisionDetection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CollisionDetection_& instance) = 0;

            protected:
                CollisionDetection_DataReader () {};
                ~CollisionDetection_DataReader () {};
            private:
                CollisionDetection_DataReader (const CollisionDetection_DataReader &);
                CollisionDetection_DataReader & operator = (const CollisionDetection_DataReader &);
            };

            class  CollisionDetection_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CollisionDetection_DataReaderView_ptr _ptr_type;
                typedef CollisionDetection_DataReaderView_var _var_type;

                static CollisionDetection_DataReaderView_ptr _duplicate (CollisionDetection_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CollisionDetection_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CollisionDetection_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CollisionDetection_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CollisionDetection_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CollisionDetection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CollisionDetection_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CollisionDetection_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CollisionDetection_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CollisionDetection_& instance) = 0;

            protected:
                CollisionDetection_DataReaderView () {};
                ~CollisionDetection_DataReaderView () {};
            private:
                CollisionDetection_DataReaderView (const CollisionDetection_DataReaderView &);
                CollisionDetection_DataReaderView & operator = (const CollisionDetection_DataReaderView &);
            };
        }

    }

}

#endif
