#ifndef _H_79252AD5F684C84291E8907F3B0EAF72_DetectedTag_DCPS_H_
#define _H_79252AD5F684C84291E8907F3B0EAF72_DetectedTag_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DetectedTag_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DetectedTag_TypeSupportInterface;

            typedef DetectedTag_TypeSupportInterface * DetectedTag_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectedTag_TypeSupportInterface> DetectedTag_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectedTag_TypeSupportInterface> DetectedTag_TypeSupportInterface_out;


            class DetectedTag_DataWriter;

            typedef DetectedTag_DataWriter * DetectedTag_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectedTag_DataWriter> DetectedTag_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectedTag_DataWriter> DetectedTag_DataWriter_out;


            class DetectedTag_DataReader;

            typedef DetectedTag_DataReader * DetectedTag_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectedTag_DataReader> DetectedTag_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectedTag_DataReader> DetectedTag_DataReader_out;


            class DetectedTag_DataReaderView;

            typedef DetectedTag_DataReaderView * DetectedTag_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectedTag_DataReaderView> DetectedTag_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectedTag_DataReaderView> DetectedTag_DataReaderView_out;

            struct DetectedTag_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DetectedTag_, struct DetectedTag_Seq_uniq_> DetectedTag_Seq;
            typedef DDS_DCPSSequence_var < DetectedTag_Seq> DetectedTag_Seq_var;
            typedef DDS_DCPSSequence_out < DetectedTag_Seq> DetectedTag_Seq_out;

            class  DetectedTag_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectedTag_TypeSupportInterface_ptr _ptr_type;
                typedef DetectedTag_TypeSupportInterface_var _var_type;

                static DetectedTag_TypeSupportInterface_ptr _duplicate (DetectedTag_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedTag_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectedTag_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedTag_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedTag_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectedTag_TypeSupportInterface () {};
                ~DetectedTag_TypeSupportInterface () {};
            private:
                DetectedTag_TypeSupportInterface (const DetectedTag_TypeSupportInterface &);
                DetectedTag_TypeSupportInterface & operator = (const DetectedTag_TypeSupportInterface &);
            };

            class  DetectedTag_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectedTag_DataWriter_ptr _ptr_type;
                typedef DetectedTag_DataWriter_var _var_type;

                static DetectedTag_DataWriter_ptr _duplicate (DetectedTag_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedTag_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectedTag_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedTag_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedTag_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectedTag_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectedTag_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectedTag_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectedTag_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectedTag_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectedTag_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectedTag_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectedTag_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectedTag_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectedTag_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectedTag_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectedTag_& instance_data) = 0;

            protected:
                DetectedTag_DataWriter () {};
                ~DetectedTag_DataWriter () {};
            private:
                DetectedTag_DataWriter (const DetectedTag_DataWriter &);
                DetectedTag_DataWriter & operator = (const DetectedTag_DataWriter &);
            };

            class  DetectedTag_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectedTag_DataReader_ptr _ptr_type;
                typedef DetectedTag_DataReader_var _var_type;

                static DetectedTag_DataReader_ptr _duplicate (DetectedTag_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedTag_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectedTag_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedTag_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedTag_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectedTag_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectedTag_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectedTag_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectedTag_& instance) = 0;

            protected:
                DetectedTag_DataReader () {};
                ~DetectedTag_DataReader () {};
            private:
                DetectedTag_DataReader (const DetectedTag_DataReader &);
                DetectedTag_DataReader & operator = (const DetectedTag_DataReader &);
            };

            class  DetectedTag_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectedTag_DataReaderView_ptr _ptr_type;
                typedef DetectedTag_DataReaderView_var _var_type;

                static DetectedTag_DataReaderView_ptr _duplicate (DetectedTag_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedTag_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectedTag_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedTag_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedTag_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectedTag_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectedTag_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectedTag_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectedTag_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectedTag_& instance) = 0;

            protected:
                DetectedTag_DataReaderView () {};
                ~DetectedTag_DataReaderView () {};
            private:
                DetectedTag_DataReaderView (const DetectedTag_DataReaderView &);
                DetectedTag_DataReaderView & operator = (const DetectedTag_DataReaderView &);
            };
        }

    }

}

#endif
