#ifndef _H_72309AA3D1114E3EBD2FE70B54DF7CAA_GridSize_DCPS_H_
#define _H_72309AA3D1114E3EBD2FE70B54DF7CAA_GridSize_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GridSize_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GridSize_TypeSupportInterface;

            typedef GridSize_TypeSupportInterface * GridSize_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GridSize_TypeSupportInterface> GridSize_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GridSize_TypeSupportInterface> GridSize_TypeSupportInterface_out;


            class GridSize_DataWriter;

            typedef GridSize_DataWriter * GridSize_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GridSize_DataWriter> GridSize_DataWriter_var;
            typedef DDS_DCPSInterface_out < GridSize_DataWriter> GridSize_DataWriter_out;


            class GridSize_DataReader;

            typedef GridSize_DataReader * GridSize_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GridSize_DataReader> GridSize_DataReader_var;
            typedef DDS_DCPSInterface_out < GridSize_DataReader> GridSize_DataReader_out;


            class GridSize_DataReaderView;

            typedef GridSize_DataReaderView * GridSize_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GridSize_DataReaderView> GridSize_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GridSize_DataReaderView> GridSize_DataReaderView_out;

            struct GridSize_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GridSize_, struct GridSize_Seq_uniq_> GridSize_Seq;
            typedef DDS_DCPSSequence_var < GridSize_Seq> GridSize_Seq_var;
            typedef DDS_DCPSSequence_out < GridSize_Seq> GridSize_Seq_out;

            class  GridSize_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GridSize_TypeSupportInterface_ptr _ptr_type;
                typedef GridSize_TypeSupportInterface_var _var_type;

                static GridSize_TypeSupportInterface_ptr _duplicate (GridSize_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GridSize_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GridSize_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GridSize_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GridSize_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GridSize_TypeSupportInterface () {};
                ~GridSize_TypeSupportInterface () {};
            private:
                GridSize_TypeSupportInterface (const GridSize_TypeSupportInterface &);
                GridSize_TypeSupportInterface & operator = (const GridSize_TypeSupportInterface &);
            };

            class  GridSize_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GridSize_DataWriter_ptr _ptr_type;
                typedef GridSize_DataWriter_var _var_type;

                static GridSize_DataWriter_ptr _duplicate (GridSize_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GridSize_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GridSize_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GridSize_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GridSize_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GridSize_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GridSize_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GridSize_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GridSize_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GridSize_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GridSize_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GridSize_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GridSize_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GridSize_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GridSize_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GridSize_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GridSize_& instance_data) = 0;

            protected:
                GridSize_DataWriter () {};
                ~GridSize_DataWriter () {};
            private:
                GridSize_DataWriter (const GridSize_DataWriter &);
                GridSize_DataWriter & operator = (const GridSize_DataWriter &);
            };

            class  GridSize_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GridSize_DataReader_ptr _ptr_type;
                typedef GridSize_DataReader_var _var_type;

                static GridSize_DataReader_ptr _duplicate (GridSize_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GridSize_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GridSize_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GridSize_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GridSize_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GridSize_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GridSize_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GridSize_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GridSize_& instance) = 0;

            protected:
                GridSize_DataReader () {};
                ~GridSize_DataReader () {};
            private:
                GridSize_DataReader (const GridSize_DataReader &);
                GridSize_DataReader & operator = (const GridSize_DataReader &);
            };

            class  GridSize_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GridSize_DataReaderView_ptr _ptr_type;
                typedef GridSize_DataReaderView_var _var_type;

                static GridSize_DataReaderView_ptr _duplicate (GridSize_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GridSize_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GridSize_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GridSize_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GridSize_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GridSize_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GridSize_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GridSize_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GridSize_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GridSize_& instance) = 0;

            protected:
                GridSize_DataReaderView () {};
                ~GridSize_DataReaderView () {};
            private:
                GridSize_DataReaderView (const GridSize_DataReaderView &);
                GridSize_DataReaderView & operator = (const GridSize_DataReaderView &);
            };
        }

    }

}

#endif
