#ifndef _H_26F87ABF5C2651430E21A61AD602AAAA_LoadCarrierWithFillingLevel__H_
#define _H_26F87ABF5C2651430E21A61AD602AAAA_LoadCarrierWithFillingLevel__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/Box_.h"
#include "rc_reason_msgs/msg/dds_opensplice/Rectangle_.h"
#include "geometry_msgs/msg/dds_opensplice/PoseStamped_.h"
#include "rc_reason_msgs/msg/dds_opensplice/CellFillingLevel_.h"
#include "rc_reason_msgs/msg/dds_opensplice/GridSize_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  LoadCarrierWithFillingLevel_
            {
                struct _cells_filling_levels__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::rc_reason_msgs::msg::dds_::CellFillingLevel_, struct _cells_filling_levels__seq_uniq_ > _cells_filling_levels__seq;
                typedef DDS_DCPSSequence_var< _cells_filling_levels__seq > _cells_filling_levels__seq_var;
                typedef DDS_DCPSSequence_out< _cells_filling_levels__seq > _cells_filling_levels__seq_out;
                ::DDS::String_mgr id_;
                ::rc_reason_msgs::msg::dds_::Box_ outer_dimensions_;
                ::rc_reason_msgs::msg::dds_::Box_ inner_dimensions_;
                ::rc_reason_msgs::msg::dds_::Rectangle_ rim_thickness_;
                ::geometry_msgs::msg::dds_::PoseStamped_ pose_;
                ::DDS::Boolean overfilled_;
                ::rc_reason_msgs::msg::dds_::CellFillingLevel_ overall_filling_level_;
                _cells_filling_levels__seq cells_filling_levels_;
                ::rc_reason_msgs::msg::dds_::GridSize_ filling_level_cell_count_;
            };

            typedef DDS_DCPSStruct_var<LoadCarrierWithFillingLevel_> LoadCarrierWithFillingLevel__var;
            typedef DDS_DCPSStruct_out < LoadCarrierWithFillingLevel_> LoadCarrierWithFillingLevel__out;

        }

    }

}

#endif /* _H_26F87ABF5C2651430E21A61AD602AAAA_LoadCarrierWithFillingLevel__H_ */
