#ifndef _H_26F87ABF5C2651430E21A61AD602AAAA_LoadCarrierWithFillingLevel_DCPS_H_
#define _H_26F87ABF5C2651430E21A61AD602AAAA_LoadCarrierWithFillingLevel_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LoadCarrierWithFillingLevel_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LoadCarrierWithFillingLevel_TypeSupportInterface;

            typedef LoadCarrierWithFillingLevel_TypeSupportInterface * LoadCarrierWithFillingLevel_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LoadCarrierWithFillingLevel_TypeSupportInterface> LoadCarrierWithFillingLevel_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LoadCarrierWithFillingLevel_TypeSupportInterface> LoadCarrierWithFillingLevel_TypeSupportInterface_out;


            class LoadCarrierWithFillingLevel_DataWriter;

            typedef LoadCarrierWithFillingLevel_DataWriter * LoadCarrierWithFillingLevel_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LoadCarrierWithFillingLevel_DataWriter> LoadCarrierWithFillingLevel_DataWriter_var;
            typedef DDS_DCPSInterface_out < LoadCarrierWithFillingLevel_DataWriter> LoadCarrierWithFillingLevel_DataWriter_out;


            class LoadCarrierWithFillingLevel_DataReader;

            typedef LoadCarrierWithFillingLevel_DataReader * LoadCarrierWithFillingLevel_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LoadCarrierWithFillingLevel_DataReader> LoadCarrierWithFillingLevel_DataReader_var;
            typedef DDS_DCPSInterface_out < LoadCarrierWithFillingLevel_DataReader> LoadCarrierWithFillingLevel_DataReader_out;


            class LoadCarrierWithFillingLevel_DataReaderView;

            typedef LoadCarrierWithFillingLevel_DataReaderView * LoadCarrierWithFillingLevel_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LoadCarrierWithFillingLevel_DataReaderView> LoadCarrierWithFillingLevel_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LoadCarrierWithFillingLevel_DataReaderView> LoadCarrierWithFillingLevel_DataReaderView_out;

            struct LoadCarrierWithFillingLevel_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LoadCarrierWithFillingLevel_, struct LoadCarrierWithFillingLevel_Seq_uniq_> LoadCarrierWithFillingLevel_Seq;
            typedef DDS_DCPSSequence_var < LoadCarrierWithFillingLevel_Seq> LoadCarrierWithFillingLevel_Seq_var;
            typedef DDS_DCPSSequence_out < LoadCarrierWithFillingLevel_Seq> LoadCarrierWithFillingLevel_Seq_out;

            class  LoadCarrierWithFillingLevel_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LoadCarrierWithFillingLevel_TypeSupportInterface_ptr _ptr_type;
                typedef LoadCarrierWithFillingLevel_TypeSupportInterface_var _var_type;

                static LoadCarrierWithFillingLevel_TypeSupportInterface_ptr _duplicate (LoadCarrierWithFillingLevel_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadCarrierWithFillingLevel_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LoadCarrierWithFillingLevel_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadCarrierWithFillingLevel_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadCarrierWithFillingLevel_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LoadCarrierWithFillingLevel_TypeSupportInterface () {};
                ~LoadCarrierWithFillingLevel_TypeSupportInterface () {};
            private:
                LoadCarrierWithFillingLevel_TypeSupportInterface (const LoadCarrierWithFillingLevel_TypeSupportInterface &);
                LoadCarrierWithFillingLevel_TypeSupportInterface & operator = (const LoadCarrierWithFillingLevel_TypeSupportInterface &);
            };

            class  LoadCarrierWithFillingLevel_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LoadCarrierWithFillingLevel_DataWriter_ptr _ptr_type;
                typedef LoadCarrierWithFillingLevel_DataWriter_var _var_type;

                static LoadCarrierWithFillingLevel_DataWriter_ptr _duplicate (LoadCarrierWithFillingLevel_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadCarrierWithFillingLevel_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LoadCarrierWithFillingLevel_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadCarrierWithFillingLevel_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadCarrierWithFillingLevel_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LoadCarrierWithFillingLevel_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LoadCarrierWithFillingLevel_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LoadCarrierWithFillingLevel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LoadCarrierWithFillingLevel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LoadCarrierWithFillingLevel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LoadCarrierWithFillingLevel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LoadCarrierWithFillingLevel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LoadCarrierWithFillingLevel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LoadCarrierWithFillingLevel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LoadCarrierWithFillingLevel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LoadCarrierWithFillingLevel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoadCarrierWithFillingLevel_& instance_data) = 0;

            protected:
                LoadCarrierWithFillingLevel_DataWriter () {};
                ~LoadCarrierWithFillingLevel_DataWriter () {};
            private:
                LoadCarrierWithFillingLevel_DataWriter (const LoadCarrierWithFillingLevel_DataWriter &);
                LoadCarrierWithFillingLevel_DataWriter & operator = (const LoadCarrierWithFillingLevel_DataWriter &);
            };

            class  LoadCarrierWithFillingLevel_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LoadCarrierWithFillingLevel_DataReader_ptr _ptr_type;
                typedef LoadCarrierWithFillingLevel_DataReader_var _var_type;

                static LoadCarrierWithFillingLevel_DataReader_ptr _duplicate (LoadCarrierWithFillingLevel_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadCarrierWithFillingLevel_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LoadCarrierWithFillingLevel_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadCarrierWithFillingLevel_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadCarrierWithFillingLevel_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LoadCarrierWithFillingLevel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LoadCarrierWithFillingLevel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LoadCarrierWithFillingLevel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoadCarrierWithFillingLevel_& instance) = 0;

            protected:
                LoadCarrierWithFillingLevel_DataReader () {};
                ~LoadCarrierWithFillingLevel_DataReader () {};
            private:
                LoadCarrierWithFillingLevel_DataReader (const LoadCarrierWithFillingLevel_DataReader &);
                LoadCarrierWithFillingLevel_DataReader & operator = (const LoadCarrierWithFillingLevel_DataReader &);
            };

            class  LoadCarrierWithFillingLevel_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LoadCarrierWithFillingLevel_DataReaderView_ptr _ptr_type;
                typedef LoadCarrierWithFillingLevel_DataReaderView_var _var_type;

                static LoadCarrierWithFillingLevel_DataReaderView_ptr _duplicate (LoadCarrierWithFillingLevel_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadCarrierWithFillingLevel_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LoadCarrierWithFillingLevel_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadCarrierWithFillingLevel_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadCarrierWithFillingLevel_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LoadCarrierWithFillingLevel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LoadCarrierWithFillingLevel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LoadCarrierWithFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LoadCarrierWithFillingLevel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoadCarrierWithFillingLevel_& instance) = 0;

            protected:
                LoadCarrierWithFillingLevel_DataReaderView () {};
                ~LoadCarrierWithFillingLevel_DataReaderView () {};
            private:
                LoadCarrierWithFillingLevel_DataReaderView (const LoadCarrierWithFillingLevel_DataReaderView &);
                LoadCarrierWithFillingLevel_DataReaderView & operator = (const LoadCarrierWithFillingLevel_DataReaderView &);
            };
        }

    }

}

#endif
