#ifndef _H_587AFB043A743B76DB412CBE63D2F531_LoadCarrier__H_
#define _H_587AFB043A743B76DB412CBE63D2F531_LoadCarrier__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/Box_.h"
#include "rc_reason_msgs/msg/dds_opensplice/Rectangle_.h"
#include "geometry_msgs/msg/dds_opensplice/PoseStamped_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  LoadCarrier_
            {
                ::DDS::String_mgr id_;
                ::rc_reason_msgs::msg::dds_::Box_ outer_dimensions_;
                ::rc_reason_msgs::msg::dds_::Box_ inner_dimensions_;
                ::rc_reason_msgs::msg::dds_::Rectangle_ rim_thickness_;
                ::geometry_msgs::msg::dds_::PoseStamped_ pose_;
                ::DDS::Boolean overfilled_;
            };

            typedef DDS_DCPSStruct_var<LoadCarrier_> LoadCarrier__var;
            typedef DDS_DCPSStruct_out < LoadCarrier_> LoadCarrier__out;

        }

    }

}

#endif /* _H_587AFB043A743B76DB412CBE63D2F531_LoadCarrier__H_ */
