#ifndef _H_587AFB043A743B76DB412CBE63D2F531_LoadCarrier_DCPS_H_
#define _H_587AFB043A743B76DB412CBE63D2F531_LoadCarrier_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LoadCarrier_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LoadCarrier_TypeSupportInterface;

            typedef LoadCarrier_TypeSupportInterface * LoadCarrier_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LoadCarrier_TypeSupportInterface> LoadCarrier_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LoadCarrier_TypeSupportInterface> LoadCarrier_TypeSupportInterface_out;


            class LoadCarrier_DataWriter;

            typedef LoadCarrier_DataWriter * LoadCarrier_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LoadCarrier_DataWriter> LoadCarrier_DataWriter_var;
            typedef DDS_DCPSInterface_out < LoadCarrier_DataWriter> LoadCarrier_DataWriter_out;


            class LoadCarrier_DataReader;

            typedef LoadCarrier_DataReader * LoadCarrier_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LoadCarrier_DataReader> LoadCarrier_DataReader_var;
            typedef DDS_DCPSInterface_out < LoadCarrier_DataReader> LoadCarrier_DataReader_out;


            class LoadCarrier_DataReaderView;

            typedef LoadCarrier_DataReaderView * LoadCarrier_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LoadCarrier_DataReaderView> LoadCarrier_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LoadCarrier_DataReaderView> LoadCarrier_DataReaderView_out;

            struct LoadCarrier_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LoadCarrier_, struct LoadCarrier_Seq_uniq_> LoadCarrier_Seq;
            typedef DDS_DCPSSequence_var < LoadCarrier_Seq> LoadCarrier_Seq_var;
            typedef DDS_DCPSSequence_out < LoadCarrier_Seq> LoadCarrier_Seq_out;

            class  LoadCarrier_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LoadCarrier_TypeSupportInterface_ptr _ptr_type;
                typedef LoadCarrier_TypeSupportInterface_var _var_type;

                static LoadCarrier_TypeSupportInterface_ptr _duplicate (LoadCarrier_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadCarrier_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LoadCarrier_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadCarrier_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadCarrier_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LoadCarrier_TypeSupportInterface () {};
                ~LoadCarrier_TypeSupportInterface () {};
            private:
                LoadCarrier_TypeSupportInterface (const LoadCarrier_TypeSupportInterface &);
                LoadCarrier_TypeSupportInterface & operator = (const LoadCarrier_TypeSupportInterface &);
            };

            class  LoadCarrier_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LoadCarrier_DataWriter_ptr _ptr_type;
                typedef LoadCarrier_DataWriter_var _var_type;

                static LoadCarrier_DataWriter_ptr _duplicate (LoadCarrier_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadCarrier_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LoadCarrier_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadCarrier_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadCarrier_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LoadCarrier_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LoadCarrier_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LoadCarrier_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LoadCarrier_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LoadCarrier_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LoadCarrier_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LoadCarrier_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LoadCarrier_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LoadCarrier_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LoadCarrier_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LoadCarrier_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoadCarrier_& instance_data) = 0;

            protected:
                LoadCarrier_DataWriter () {};
                ~LoadCarrier_DataWriter () {};
            private:
                LoadCarrier_DataWriter (const LoadCarrier_DataWriter &);
                LoadCarrier_DataWriter & operator = (const LoadCarrier_DataWriter &);
            };

            class  LoadCarrier_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LoadCarrier_DataReader_ptr _ptr_type;
                typedef LoadCarrier_DataReader_var _var_type;

                static LoadCarrier_DataReader_ptr _duplicate (LoadCarrier_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadCarrier_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LoadCarrier_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadCarrier_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadCarrier_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LoadCarrier_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LoadCarrier_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LoadCarrier_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoadCarrier_& instance) = 0;

            protected:
                LoadCarrier_DataReader () {};
                ~LoadCarrier_DataReader () {};
            private:
                LoadCarrier_DataReader (const LoadCarrier_DataReader &);
                LoadCarrier_DataReader & operator = (const LoadCarrier_DataReader &);
            };

            class  LoadCarrier_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LoadCarrier_DataReaderView_ptr _ptr_type;
                typedef LoadCarrier_DataReaderView_var _var_type;

                static LoadCarrier_DataReaderView_ptr _duplicate (LoadCarrier_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LoadCarrier_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LoadCarrier_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LoadCarrier_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LoadCarrier_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LoadCarrier_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LoadCarrier_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LoadCarrier_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LoadCarrier_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LoadCarrier_& instance) = 0;

            protected:
                LoadCarrier_DataReaderView () {};
                ~LoadCarrier_DataReaderView () {};
            private:
                LoadCarrier_DataReaderView (const LoadCarrier_DataReaderView &);
                LoadCarrier_DataReaderView & operator = (const LoadCarrier_DataReaderView &);
            };
        }

    }

}

#endif
