#ifndef _H_B22FE2FCC4EAA96E8ABD94CBF10460F5_RangeBox_DCPS_H_
#define _H_B22FE2FCC4EAA96E8ABD94CBF10460F5_RangeBox_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RangeBox_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RangeBox_TypeSupportInterface;

            typedef RangeBox_TypeSupportInterface * RangeBox_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RangeBox_TypeSupportInterface> RangeBox_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RangeBox_TypeSupportInterface> RangeBox_TypeSupportInterface_out;


            class RangeBox_DataWriter;

            typedef RangeBox_DataWriter * RangeBox_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RangeBox_DataWriter> RangeBox_DataWriter_var;
            typedef DDS_DCPSInterface_out < RangeBox_DataWriter> RangeBox_DataWriter_out;


            class RangeBox_DataReader;

            typedef RangeBox_DataReader * RangeBox_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RangeBox_DataReader> RangeBox_DataReader_var;
            typedef DDS_DCPSInterface_out < RangeBox_DataReader> RangeBox_DataReader_out;


            class RangeBox_DataReaderView;

            typedef RangeBox_DataReaderView * RangeBox_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RangeBox_DataReaderView> RangeBox_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RangeBox_DataReaderView> RangeBox_DataReaderView_out;

            struct RangeBox_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < RangeBox_, struct RangeBox_Seq_uniq_> RangeBox_Seq;
            typedef DDS_DCPSSequence_var < RangeBox_Seq> RangeBox_Seq_var;
            typedef DDS_DCPSSequence_out < RangeBox_Seq> RangeBox_Seq_out;

            class  RangeBox_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RangeBox_TypeSupportInterface_ptr _ptr_type;
                typedef RangeBox_TypeSupportInterface_var _var_type;

                static RangeBox_TypeSupportInterface_ptr _duplicate (RangeBox_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeBox_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RangeBox_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeBox_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeBox_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RangeBox_TypeSupportInterface () {};
                ~RangeBox_TypeSupportInterface () {};
            private:
                RangeBox_TypeSupportInterface (const RangeBox_TypeSupportInterface &);
                RangeBox_TypeSupportInterface & operator = (const RangeBox_TypeSupportInterface &);
            };

            class  RangeBox_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RangeBox_DataWriter_ptr _ptr_type;
                typedef RangeBox_DataWriter_var _var_type;

                static RangeBox_DataWriter_ptr _duplicate (RangeBox_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeBox_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RangeBox_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeBox_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeBox_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RangeBox_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RangeBox_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RangeBox_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RangeBox_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RangeBox_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RangeBox_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RangeBox_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RangeBox_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RangeBox_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RangeBox_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RangeBox_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeBox_& instance_data) = 0;

            protected:
                RangeBox_DataWriter () {};
                ~RangeBox_DataWriter () {};
            private:
                RangeBox_DataWriter (const RangeBox_DataWriter &);
                RangeBox_DataWriter & operator = (const RangeBox_DataWriter &);
            };

            class  RangeBox_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RangeBox_DataReader_ptr _ptr_type;
                typedef RangeBox_DataReader_var _var_type;

                static RangeBox_DataReader_ptr _duplicate (RangeBox_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeBox_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RangeBox_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeBox_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeBox_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RangeBox_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RangeBox_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RangeBox_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeBox_& instance) = 0;

            protected:
                RangeBox_DataReader () {};
                ~RangeBox_DataReader () {};
            private:
                RangeBox_DataReader (const RangeBox_DataReader &);
                RangeBox_DataReader & operator = (const RangeBox_DataReader &);
            };

            class  RangeBox_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RangeBox_DataReaderView_ptr _ptr_type;
                typedef RangeBox_DataReaderView_var _var_type;

                static RangeBox_DataReaderView_ptr _duplicate (RangeBox_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeBox_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RangeBox_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeBox_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeBox_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RangeBox_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RangeBox_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RangeBox_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RangeBox_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeBox_& instance) = 0;

            protected:
                RangeBox_DataReaderView () {};
                ~RangeBox_DataReaderView () {};
            private:
                RangeBox_DataReaderView (const RangeBox_DataReaderView &);
                RangeBox_DataReaderView & operator = (const RangeBox_DataReaderView &);
            };
        }

    }

}

#endif
