#ifndef _H_D8C52FC66642FBA71E133B354AA1D3A3_RangeRectangle_DCPS_H_
#define _H_D8C52FC66642FBA71E133B354AA1D3A3_RangeRectangle_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RangeRectangle_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RangeRectangle_TypeSupportInterface;

            typedef RangeRectangle_TypeSupportInterface * RangeRectangle_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RangeRectangle_TypeSupportInterface> RangeRectangle_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RangeRectangle_TypeSupportInterface> RangeRectangle_TypeSupportInterface_out;


            class RangeRectangle_DataWriter;

            typedef RangeRectangle_DataWriter * RangeRectangle_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RangeRectangle_DataWriter> RangeRectangle_DataWriter_var;
            typedef DDS_DCPSInterface_out < RangeRectangle_DataWriter> RangeRectangle_DataWriter_out;


            class RangeRectangle_DataReader;

            typedef RangeRectangle_DataReader * RangeRectangle_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RangeRectangle_DataReader> RangeRectangle_DataReader_var;
            typedef DDS_DCPSInterface_out < RangeRectangle_DataReader> RangeRectangle_DataReader_out;


            class RangeRectangle_DataReaderView;

            typedef RangeRectangle_DataReaderView * RangeRectangle_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RangeRectangle_DataReaderView> RangeRectangle_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RangeRectangle_DataReaderView> RangeRectangle_DataReaderView_out;

            struct RangeRectangle_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < RangeRectangle_, struct RangeRectangle_Seq_uniq_> RangeRectangle_Seq;
            typedef DDS_DCPSSequence_var < RangeRectangle_Seq> RangeRectangle_Seq_var;
            typedef DDS_DCPSSequence_out < RangeRectangle_Seq> RangeRectangle_Seq_out;

            class  RangeRectangle_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RangeRectangle_TypeSupportInterface_ptr _ptr_type;
                typedef RangeRectangle_TypeSupportInterface_var _var_type;

                static RangeRectangle_TypeSupportInterface_ptr _duplicate (RangeRectangle_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeRectangle_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RangeRectangle_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeRectangle_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeRectangle_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RangeRectangle_TypeSupportInterface () {};
                ~RangeRectangle_TypeSupportInterface () {};
            private:
                RangeRectangle_TypeSupportInterface (const RangeRectangle_TypeSupportInterface &);
                RangeRectangle_TypeSupportInterface & operator = (const RangeRectangle_TypeSupportInterface &);
            };

            class  RangeRectangle_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RangeRectangle_DataWriter_ptr _ptr_type;
                typedef RangeRectangle_DataWriter_var _var_type;

                static RangeRectangle_DataWriter_ptr _duplicate (RangeRectangle_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeRectangle_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RangeRectangle_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeRectangle_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeRectangle_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RangeRectangle_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RangeRectangle_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RangeRectangle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RangeRectangle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RangeRectangle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RangeRectangle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RangeRectangle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RangeRectangle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RangeRectangle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RangeRectangle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RangeRectangle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeRectangle_& instance_data) = 0;

            protected:
                RangeRectangle_DataWriter () {};
                ~RangeRectangle_DataWriter () {};
            private:
                RangeRectangle_DataWriter (const RangeRectangle_DataWriter &);
                RangeRectangle_DataWriter & operator = (const RangeRectangle_DataWriter &);
            };

            class  RangeRectangle_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RangeRectangle_DataReader_ptr _ptr_type;
                typedef RangeRectangle_DataReader_var _var_type;

                static RangeRectangle_DataReader_ptr _duplicate (RangeRectangle_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeRectangle_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RangeRectangle_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeRectangle_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeRectangle_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RangeRectangle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RangeRectangle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RangeRectangle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeRectangle_& instance) = 0;

            protected:
                RangeRectangle_DataReader () {};
                ~RangeRectangle_DataReader () {};
            private:
                RangeRectangle_DataReader (const RangeRectangle_DataReader &);
                RangeRectangle_DataReader & operator = (const RangeRectangle_DataReader &);
            };

            class  RangeRectangle_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RangeRectangle_DataReaderView_ptr _ptr_type;
                typedef RangeRectangle_DataReaderView_var _var_type;

                static RangeRectangle_DataReaderView_ptr _duplicate (RangeRectangle_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeRectangle_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RangeRectangle_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeRectangle_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeRectangle_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RangeRectangle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RangeRectangle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RangeRectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RangeRectangle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeRectangle_& instance) = 0;

            protected:
                RangeRectangle_DataReaderView () {};
                ~RangeRectangle_DataReaderView () {};
            private:
                RangeRectangle_DataReaderView (const RangeRectangle_DataReaderView &);
                RangeRectangle_DataReaderView & operator = (const RangeRectangle_DataReaderView &);
            };
        }

    }

}

#endif
