#ifndef _H_6A5C08AEB279C0805E83552843607FB5_RegionOfInterest2D_DCPS_H_
#define _H_6A5C08AEB279C0805E83552843607FB5_RegionOfInterest2D_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RegionOfInterest2D_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RegionOfInterest2D_TypeSupportInterface;

            typedef RegionOfInterest2D_TypeSupportInterface * RegionOfInterest2D_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RegionOfInterest2D_TypeSupportInterface> RegionOfInterest2D_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RegionOfInterest2D_TypeSupportInterface> RegionOfInterest2D_TypeSupportInterface_out;


            class RegionOfInterest2D_DataWriter;

            typedef RegionOfInterest2D_DataWriter * RegionOfInterest2D_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RegionOfInterest2D_DataWriter> RegionOfInterest2D_DataWriter_var;
            typedef DDS_DCPSInterface_out < RegionOfInterest2D_DataWriter> RegionOfInterest2D_DataWriter_out;


            class RegionOfInterest2D_DataReader;

            typedef RegionOfInterest2D_DataReader * RegionOfInterest2D_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RegionOfInterest2D_DataReader> RegionOfInterest2D_DataReader_var;
            typedef DDS_DCPSInterface_out < RegionOfInterest2D_DataReader> RegionOfInterest2D_DataReader_out;


            class RegionOfInterest2D_DataReaderView;

            typedef RegionOfInterest2D_DataReaderView * RegionOfInterest2D_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RegionOfInterest2D_DataReaderView> RegionOfInterest2D_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RegionOfInterest2D_DataReaderView> RegionOfInterest2D_DataReaderView_out;

            struct RegionOfInterest2D_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RegionOfInterest2D_, struct RegionOfInterest2D_Seq_uniq_> RegionOfInterest2D_Seq;
            typedef DDS_DCPSSequence_var < RegionOfInterest2D_Seq> RegionOfInterest2D_Seq_var;
            typedef DDS_DCPSSequence_out < RegionOfInterest2D_Seq> RegionOfInterest2D_Seq_out;

            class  RegionOfInterest2D_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RegionOfInterest2D_TypeSupportInterface_ptr _ptr_type;
                typedef RegionOfInterest2D_TypeSupportInterface_var _var_type;

                static RegionOfInterest2D_TypeSupportInterface_ptr _duplicate (RegionOfInterest2D_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RegionOfInterest2D_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RegionOfInterest2D_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RegionOfInterest2D_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RegionOfInterest2D_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RegionOfInterest2D_TypeSupportInterface () {};
                ~RegionOfInterest2D_TypeSupportInterface () {};
            private:
                RegionOfInterest2D_TypeSupportInterface (const RegionOfInterest2D_TypeSupportInterface &);
                RegionOfInterest2D_TypeSupportInterface & operator = (const RegionOfInterest2D_TypeSupportInterface &);
            };

            class  RegionOfInterest2D_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RegionOfInterest2D_DataWriter_ptr _ptr_type;
                typedef RegionOfInterest2D_DataWriter_var _var_type;

                static RegionOfInterest2D_DataWriter_ptr _duplicate (RegionOfInterest2D_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RegionOfInterest2D_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RegionOfInterest2D_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RegionOfInterest2D_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RegionOfInterest2D_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RegionOfInterest2D_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RegionOfInterest2D_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RegionOfInterest2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RegionOfInterest2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RegionOfInterest2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RegionOfInterest2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RegionOfInterest2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RegionOfInterest2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RegionOfInterest2D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RegionOfInterest2D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RegionOfInterest2D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RegionOfInterest2D_& instance_data) = 0;

            protected:
                RegionOfInterest2D_DataWriter () {};
                ~RegionOfInterest2D_DataWriter () {};
            private:
                RegionOfInterest2D_DataWriter (const RegionOfInterest2D_DataWriter &);
                RegionOfInterest2D_DataWriter & operator = (const RegionOfInterest2D_DataWriter &);
            };

            class  RegionOfInterest2D_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RegionOfInterest2D_DataReader_ptr _ptr_type;
                typedef RegionOfInterest2D_DataReader_var _var_type;

                static RegionOfInterest2D_DataReader_ptr _duplicate (RegionOfInterest2D_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RegionOfInterest2D_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RegionOfInterest2D_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RegionOfInterest2D_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RegionOfInterest2D_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RegionOfInterest2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RegionOfInterest2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RegionOfInterest2D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RegionOfInterest2D_& instance) = 0;

            protected:
                RegionOfInterest2D_DataReader () {};
                ~RegionOfInterest2D_DataReader () {};
            private:
                RegionOfInterest2D_DataReader (const RegionOfInterest2D_DataReader &);
                RegionOfInterest2D_DataReader & operator = (const RegionOfInterest2D_DataReader &);
            };

            class  RegionOfInterest2D_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RegionOfInterest2D_DataReaderView_ptr _ptr_type;
                typedef RegionOfInterest2D_DataReaderView_var _var_type;

                static RegionOfInterest2D_DataReaderView_ptr _duplicate (RegionOfInterest2D_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RegionOfInterest2D_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RegionOfInterest2D_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RegionOfInterest2D_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RegionOfInterest2D_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RegionOfInterest2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RegionOfInterest2D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RegionOfInterest2D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RegionOfInterest2D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RegionOfInterest2D_& instance) = 0;

            protected:
                RegionOfInterest2D_DataReaderView () {};
                ~RegionOfInterest2D_DataReaderView () {};
            private:
                RegionOfInterest2D_DataReaderView (const RegionOfInterest2D_DataReaderView &);
                RegionOfInterest2D_DataReaderView & operator = (const RegionOfInterest2D_DataReaderView &);
            };
        }

    }

}

#endif
