#ifndef _H_ADB5D59311A44AC2E054AC1A7E7202D5_SilhouetteMatchInstance__H_
#define _H_ADB5D59311A44AC2E054AC1A7E7202D5_SilhouetteMatchInstance__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  SilhouetteMatchInstance_
            {
                ::builtin_interfaces::msg::dds_::Time_ timestamp_;
                ::DDS::String_mgr id_;
                ::DDS::String_mgr object_id_;
                ::DDS::String_mgr pose_frame_;
                ::geometry_msgs::msg::dds_::Pose_ pose_;
            };

            typedef DDS_DCPSStruct_var<SilhouetteMatchInstance_> SilhouetteMatchInstance__var;
            typedef DDS_DCPSStruct_out < SilhouetteMatchInstance_> SilhouetteMatchInstance__out;

        }

    }

}

#endif /* _H_ADB5D59311A44AC2E054AC1A7E7202D5_SilhouetteMatchInstance__H_ */
