#ifndef _H_8A525D7AB991F09E5FA29B8CC700F2CA_SilhouetteMatchObject_DCPS_H_
#define _H_8A525D7AB991F09E5FA29B8CC700F2CA_SilhouetteMatchObject_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SilhouetteMatchObject_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SilhouetteMatchObject_TypeSupportInterface;

            typedef SilhouetteMatchObject_TypeSupportInterface * SilhouetteMatchObject_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchObject_TypeSupportInterface> SilhouetteMatchObject_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchObject_TypeSupportInterface> SilhouetteMatchObject_TypeSupportInterface_out;


            class SilhouetteMatchObject_DataWriter;

            typedef SilhouetteMatchObject_DataWriter * SilhouetteMatchObject_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchObject_DataWriter> SilhouetteMatchObject_DataWriter_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchObject_DataWriter> SilhouetteMatchObject_DataWriter_out;


            class SilhouetteMatchObject_DataReader;

            typedef SilhouetteMatchObject_DataReader * SilhouetteMatchObject_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchObject_DataReader> SilhouetteMatchObject_DataReader_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchObject_DataReader> SilhouetteMatchObject_DataReader_out;


            class SilhouetteMatchObject_DataReaderView;

            typedef SilhouetteMatchObject_DataReaderView * SilhouetteMatchObject_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchObject_DataReaderView> SilhouetteMatchObject_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchObject_DataReaderView> SilhouetteMatchObject_DataReaderView_out;

            struct SilhouetteMatchObject_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SilhouetteMatchObject_, struct SilhouetteMatchObject_Seq_uniq_> SilhouetteMatchObject_Seq;
            typedef DDS_DCPSSequence_var < SilhouetteMatchObject_Seq> SilhouetteMatchObject_Seq_var;
            typedef DDS_DCPSSequence_out < SilhouetteMatchObject_Seq> SilhouetteMatchObject_Seq_out;

            class  SilhouetteMatchObject_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SilhouetteMatchObject_TypeSupportInterface_ptr _ptr_type;
                typedef SilhouetteMatchObject_TypeSupportInterface_var _var_type;

                static SilhouetteMatchObject_TypeSupportInterface_ptr _duplicate (SilhouetteMatchObject_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchObject_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchObject_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchObject_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchObject_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SilhouetteMatchObject_TypeSupportInterface () {};
                ~SilhouetteMatchObject_TypeSupportInterface () {};
            private:
                SilhouetteMatchObject_TypeSupportInterface (const SilhouetteMatchObject_TypeSupportInterface &);
                SilhouetteMatchObject_TypeSupportInterface & operator = (const SilhouetteMatchObject_TypeSupportInterface &);
            };

            class  SilhouetteMatchObject_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SilhouetteMatchObject_DataWriter_ptr _ptr_type;
                typedef SilhouetteMatchObject_DataWriter_var _var_type;

                static SilhouetteMatchObject_DataWriter_ptr _duplicate (SilhouetteMatchObject_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchObject_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchObject_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchObject_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchObject_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SilhouetteMatchObject_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SilhouetteMatchObject_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SilhouetteMatchObject_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SilhouetteMatchObject_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SilhouetteMatchObject_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SilhouetteMatchObject_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SilhouetteMatchObject_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SilhouetteMatchObject_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SilhouetteMatchObject_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SilhouetteMatchObject_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchObject_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchObject_& instance_data) = 0;

            protected:
                SilhouetteMatchObject_DataWriter () {};
                ~SilhouetteMatchObject_DataWriter () {};
            private:
                SilhouetteMatchObject_DataWriter (const SilhouetteMatchObject_DataWriter &);
                SilhouetteMatchObject_DataWriter & operator = (const SilhouetteMatchObject_DataWriter &);
            };

            class  SilhouetteMatchObject_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SilhouetteMatchObject_DataReader_ptr _ptr_type;
                typedef SilhouetteMatchObject_DataReader_var _var_type;

                static SilhouetteMatchObject_DataReader_ptr _duplicate (SilhouetteMatchObject_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchObject_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchObject_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchObject_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchObject_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SilhouetteMatchObject_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SilhouetteMatchObject_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchObject_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchObject_& instance) = 0;

            protected:
                SilhouetteMatchObject_DataReader () {};
                ~SilhouetteMatchObject_DataReader () {};
            private:
                SilhouetteMatchObject_DataReader (const SilhouetteMatchObject_DataReader &);
                SilhouetteMatchObject_DataReader & operator = (const SilhouetteMatchObject_DataReader &);
            };

            class  SilhouetteMatchObject_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SilhouetteMatchObject_DataReaderView_ptr _ptr_type;
                typedef SilhouetteMatchObject_DataReaderView_var _var_type;

                static SilhouetteMatchObject_DataReaderView_ptr _duplicate (SilhouetteMatchObject_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchObject_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchObject_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchObject_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchObject_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SilhouetteMatchObject_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SilhouetteMatchObject_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SilhouetteMatchObject_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchObject_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchObject_& instance) = 0;

            protected:
                SilhouetteMatchObject_DataReaderView () {};
                ~SilhouetteMatchObject_DataReaderView () {};
            private:
                SilhouetteMatchObject_DataReaderView (const SilhouetteMatchObject_DataReaderView &);
                SilhouetteMatchObject_DataReaderView & operator = (const SilhouetteMatchObject_DataReaderView &);
            };
        }

    }

}

#endif
