// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/ItemModel.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/item_model__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `type`
#include "rosidl_generator_c/string_functions.h"
// Member `unknown`
#include "rc_reason_msgs/msg/range_box__functions.h"
// Member `rectangle`
#include "rc_reason_msgs/msg/range_rectangle__functions.h"

bool
rc_reason_msgs__msg__ItemModel__init(rc_reason_msgs__msg__ItemModel * msg)
{
  if (!msg) {
    return false;
  }
  // type
  if (!rosidl_generator_c__String__init(&msg->type)) {
    rc_reason_msgs__msg__ItemModel__fini(msg);
    return false;
  }
  // unknown
  if (!rc_reason_msgs__msg__RangeBox__init(&msg->unknown)) {
    rc_reason_msgs__msg__ItemModel__fini(msg);
    return false;
  }
  // rectangle
  if (!rc_reason_msgs__msg__RangeRectangle__init(&msg->rectangle)) {
    rc_reason_msgs__msg__ItemModel__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__ItemModel__fini(rc_reason_msgs__msg__ItemModel * msg)
{
  if (!msg) {
    return;
  }
  // type
  rosidl_generator_c__String__fini(&msg->type);
  // unknown
  rc_reason_msgs__msg__RangeBox__fini(&msg->unknown);
  // rectangle
  rc_reason_msgs__msg__RangeRectangle__fini(&msg->rectangle);
}

rc_reason_msgs__msg__ItemModel *
rc_reason_msgs__msg__ItemModel__create()
{
  rc_reason_msgs__msg__ItemModel * msg = (rc_reason_msgs__msg__ItemModel *)malloc(sizeof(rc_reason_msgs__msg__ItemModel));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__ItemModel));
  bool success = rc_reason_msgs__msg__ItemModel__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__ItemModel__destroy(rc_reason_msgs__msg__ItemModel * msg)
{
  if (msg) {
    rc_reason_msgs__msg__ItemModel__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__msg__ItemModel__Sequence__init(rc_reason_msgs__msg__ItemModel__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__msg__ItemModel * data = NULL;
  if (size) {
    data = (rc_reason_msgs__msg__ItemModel *)calloc(size, sizeof(rc_reason_msgs__msg__ItemModel));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__ItemModel__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__ItemModel__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__ItemModel__Sequence__fini(rc_reason_msgs__msg__ItemModel__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__ItemModel__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__ItemModel__Sequence *
rc_reason_msgs__msg__ItemModel__Sequence__create(size_t size)
{
  rc_reason_msgs__msg__ItemModel__Sequence * array = (rc_reason_msgs__msg__ItemModel__Sequence *)malloc(sizeof(rc_reason_msgs__msg__ItemModel__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__ItemModel__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__ItemModel__Sequence__destroy(rc_reason_msgs__msg__ItemModel__Sequence * array)
{
  if (array) {
    rc_reason_msgs__msg__ItemModel__Sequence__fini(array);
  }
  free(array);
}
