// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/SilhouetteMatchInstance.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/silhouette_match_instance__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/time__functions.h"
// Member `id`
// Member `object_id`
// Member `pose_frame`
#include "rosidl_generator_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/pose__functions.h"

bool
rc_reason_msgs__msg__SilhouetteMatchInstance__init(rc_reason_msgs__msg__SilhouetteMatchInstance * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
    return false;
  }
  // id
  if (!rosidl_generator_c__String__init(&msg->id)) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
    return false;
  }
  // object_id
  if (!rosidl_generator_c__String__init(&msg->object_id)) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
    return false;
  }
  // pose_frame
  if (!rosidl_generator_c__String__init(&msg->pose_frame)) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__SilhouetteMatchInstance__fini(rc_reason_msgs__msg__SilhouetteMatchInstance * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // id
  rosidl_generator_c__String__fini(&msg->id);
  // object_id
  rosidl_generator_c__String__fini(&msg->object_id);
  // pose_frame
  rosidl_generator_c__String__fini(&msg->pose_frame);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
}

rc_reason_msgs__msg__SilhouetteMatchInstance *
rc_reason_msgs__msg__SilhouetteMatchInstance__create()
{
  rc_reason_msgs__msg__SilhouetteMatchInstance * msg = (rc_reason_msgs__msg__SilhouetteMatchInstance *)malloc(sizeof(rc_reason_msgs__msg__SilhouetteMatchInstance));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__SilhouetteMatchInstance));
  bool success = rc_reason_msgs__msg__SilhouetteMatchInstance__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__SilhouetteMatchInstance__destroy(rc_reason_msgs__msg__SilhouetteMatchInstance * msg)
{
  if (msg) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__init(rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__msg__SilhouetteMatchInstance * data = NULL;
  if (size) {
    data = (rc_reason_msgs__msg__SilhouetteMatchInstance *)calloc(size, sizeof(rc_reason_msgs__msg__SilhouetteMatchInstance));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__SilhouetteMatchInstance__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__SilhouetteMatchInstance__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__fini(rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__SilhouetteMatchInstance__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence *
rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__create(size_t size)
{
  rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * array = (rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence *)malloc(sizeof(rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__destroy(rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * array)
{
  if (array) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__fini(array);
  }
  free(array);
}
