#ifndef _H_C6B8CF14FBABAC2008EA820496232314_ComputeGrasps_DCPS_H_
#define _H_C6B8CF14FBABAC2008EA820496232314_ComputeGrasps_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ComputeGrasps_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class ComputeGrasps_Request_TypeSupportInterface;

            typedef ComputeGrasps_Request_TypeSupportInterface * ComputeGrasps_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ComputeGrasps_Request_TypeSupportInterface> ComputeGrasps_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ComputeGrasps_Request_TypeSupportInterface> ComputeGrasps_Request_TypeSupportInterface_out;


            class ComputeGrasps_Request_DataWriter;

            typedef ComputeGrasps_Request_DataWriter * ComputeGrasps_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ComputeGrasps_Request_DataWriter> ComputeGrasps_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ComputeGrasps_Request_DataWriter> ComputeGrasps_Request_DataWriter_out;


            class ComputeGrasps_Request_DataReader;

            typedef ComputeGrasps_Request_DataReader * ComputeGrasps_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ComputeGrasps_Request_DataReader> ComputeGrasps_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ComputeGrasps_Request_DataReader> ComputeGrasps_Request_DataReader_out;


            class ComputeGrasps_Request_DataReaderView;

            typedef ComputeGrasps_Request_DataReaderView * ComputeGrasps_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ComputeGrasps_Request_DataReaderView> ComputeGrasps_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ComputeGrasps_Request_DataReaderView> ComputeGrasps_Request_DataReaderView_out;

            struct ComputeGrasps_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ComputeGrasps_Request_, struct ComputeGrasps_Request_Seq_uniq_> ComputeGrasps_Request_Seq;
            typedef DDS_DCPSSequence_var < ComputeGrasps_Request_Seq> ComputeGrasps_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ComputeGrasps_Request_Seq> ComputeGrasps_Request_Seq_out;

            class  ComputeGrasps_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ComputeGrasps_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ComputeGrasps_Request_TypeSupportInterface_var _var_type;

                static ComputeGrasps_Request_TypeSupportInterface_ptr _duplicate (ComputeGrasps_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComputeGrasps_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ComputeGrasps_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ComputeGrasps_Request_TypeSupportInterface () {};
                ~ComputeGrasps_Request_TypeSupportInterface () {};
            private:
                ComputeGrasps_Request_TypeSupportInterface (const ComputeGrasps_Request_TypeSupportInterface &);
                ComputeGrasps_Request_TypeSupportInterface & operator = (const ComputeGrasps_Request_TypeSupportInterface &);
            };

            class  ComputeGrasps_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ComputeGrasps_Request_DataWriter_ptr _ptr_type;
                typedef ComputeGrasps_Request_DataWriter_var _var_type;

                static ComputeGrasps_Request_DataWriter_ptr _duplicate (ComputeGrasps_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComputeGrasps_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ComputeGrasps_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ComputeGrasps_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ComputeGrasps_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ComputeGrasps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ComputeGrasps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ComputeGrasps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ComputeGrasps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ComputeGrasps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ComputeGrasps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ComputeGrasps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ComputeGrasps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ComputeGrasps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ComputeGrasps_Request_& instance_data) = 0;

            protected:
                ComputeGrasps_Request_DataWriter () {};
                ~ComputeGrasps_Request_DataWriter () {};
            private:
                ComputeGrasps_Request_DataWriter (const ComputeGrasps_Request_DataWriter &);
                ComputeGrasps_Request_DataWriter & operator = (const ComputeGrasps_Request_DataWriter &);
            };

            class  ComputeGrasps_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ComputeGrasps_Request_DataReader_ptr _ptr_type;
                typedef ComputeGrasps_Request_DataReader_var _var_type;

                static ComputeGrasps_Request_DataReader_ptr _duplicate (ComputeGrasps_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComputeGrasps_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ComputeGrasps_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ComputeGrasps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ComputeGrasps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ComputeGrasps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ComputeGrasps_Request_& instance) = 0;

            protected:
                ComputeGrasps_Request_DataReader () {};
                ~ComputeGrasps_Request_DataReader () {};
            private:
                ComputeGrasps_Request_DataReader (const ComputeGrasps_Request_DataReader &);
                ComputeGrasps_Request_DataReader & operator = (const ComputeGrasps_Request_DataReader &);
            };

            class  ComputeGrasps_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ComputeGrasps_Request_DataReaderView_ptr _ptr_type;
                typedef ComputeGrasps_Request_DataReaderView_var _var_type;

                static ComputeGrasps_Request_DataReaderView_ptr _duplicate (ComputeGrasps_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComputeGrasps_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ComputeGrasps_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ComputeGrasps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ComputeGrasps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ComputeGrasps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ComputeGrasps_Request_& instance) = 0;

            protected:
                ComputeGrasps_Request_DataReaderView () {};
                ~ComputeGrasps_Request_DataReaderView () {};
            private:
                ComputeGrasps_Request_DataReaderView (const ComputeGrasps_Request_DataReaderView &);
                ComputeGrasps_Request_DataReaderView & operator = (const ComputeGrasps_Request_DataReaderView &);
            };
            class ComputeGrasps_Response_TypeSupportInterface;

            typedef ComputeGrasps_Response_TypeSupportInterface * ComputeGrasps_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ComputeGrasps_Response_TypeSupportInterface> ComputeGrasps_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ComputeGrasps_Response_TypeSupportInterface> ComputeGrasps_Response_TypeSupportInterface_out;


            class ComputeGrasps_Response_DataWriter;

            typedef ComputeGrasps_Response_DataWriter * ComputeGrasps_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ComputeGrasps_Response_DataWriter> ComputeGrasps_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ComputeGrasps_Response_DataWriter> ComputeGrasps_Response_DataWriter_out;


            class ComputeGrasps_Response_DataReader;

            typedef ComputeGrasps_Response_DataReader * ComputeGrasps_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ComputeGrasps_Response_DataReader> ComputeGrasps_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ComputeGrasps_Response_DataReader> ComputeGrasps_Response_DataReader_out;


            class ComputeGrasps_Response_DataReaderView;

            typedef ComputeGrasps_Response_DataReaderView * ComputeGrasps_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ComputeGrasps_Response_DataReaderView> ComputeGrasps_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ComputeGrasps_Response_DataReaderView> ComputeGrasps_Response_DataReaderView_out;

            struct ComputeGrasps_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ComputeGrasps_Response_, struct ComputeGrasps_Response_Seq_uniq_> ComputeGrasps_Response_Seq;
            typedef DDS_DCPSSequence_var < ComputeGrasps_Response_Seq> ComputeGrasps_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ComputeGrasps_Response_Seq> ComputeGrasps_Response_Seq_out;

            class  ComputeGrasps_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ComputeGrasps_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ComputeGrasps_Response_TypeSupportInterface_var _var_type;

                static ComputeGrasps_Response_TypeSupportInterface_ptr _duplicate (ComputeGrasps_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComputeGrasps_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ComputeGrasps_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ComputeGrasps_Response_TypeSupportInterface () {};
                ~ComputeGrasps_Response_TypeSupportInterface () {};
            private:
                ComputeGrasps_Response_TypeSupportInterface (const ComputeGrasps_Response_TypeSupportInterface &);
                ComputeGrasps_Response_TypeSupportInterface & operator = (const ComputeGrasps_Response_TypeSupportInterface &);
            };

            class  ComputeGrasps_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ComputeGrasps_Response_DataWriter_ptr _ptr_type;
                typedef ComputeGrasps_Response_DataWriter_var _var_type;

                static ComputeGrasps_Response_DataWriter_ptr _duplicate (ComputeGrasps_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComputeGrasps_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ComputeGrasps_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ComputeGrasps_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ComputeGrasps_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ComputeGrasps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ComputeGrasps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ComputeGrasps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ComputeGrasps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ComputeGrasps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ComputeGrasps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ComputeGrasps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ComputeGrasps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ComputeGrasps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ComputeGrasps_Response_& instance_data) = 0;

            protected:
                ComputeGrasps_Response_DataWriter () {};
                ~ComputeGrasps_Response_DataWriter () {};
            private:
                ComputeGrasps_Response_DataWriter (const ComputeGrasps_Response_DataWriter &);
                ComputeGrasps_Response_DataWriter & operator = (const ComputeGrasps_Response_DataWriter &);
            };

            class  ComputeGrasps_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ComputeGrasps_Response_DataReader_ptr _ptr_type;
                typedef ComputeGrasps_Response_DataReader_var _var_type;

                static ComputeGrasps_Response_DataReader_ptr _duplicate (ComputeGrasps_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComputeGrasps_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ComputeGrasps_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ComputeGrasps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ComputeGrasps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ComputeGrasps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ComputeGrasps_Response_& instance) = 0;

            protected:
                ComputeGrasps_Response_DataReader () {};
                ~ComputeGrasps_Response_DataReader () {};
            private:
                ComputeGrasps_Response_DataReader (const ComputeGrasps_Response_DataReader &);
                ComputeGrasps_Response_DataReader & operator = (const ComputeGrasps_Response_DataReader &);
            };

            class  ComputeGrasps_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ComputeGrasps_Response_DataReaderView_ptr _ptr_type;
                typedef ComputeGrasps_Response_DataReaderView_var _var_type;

                static ComputeGrasps_Response_DataReaderView_ptr _duplicate (ComputeGrasps_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ComputeGrasps_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ComputeGrasps_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ComputeGrasps_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ComputeGrasps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ComputeGrasps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ComputeGrasps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ComputeGrasps_Response_& instance) = 0;

            protected:
                ComputeGrasps_Response_DataReaderView () {};
                ~ComputeGrasps_Response_DataReaderView () {};
            private:
                ComputeGrasps_Response_DataReaderView (const ComputeGrasps_Response_DataReaderView &);
                ComputeGrasps_Response_DataReaderView & operator = (const ComputeGrasps_Response_DataReaderView &);
            };
            class Sample_ComputeGrasps_Request_TypeSupportInterface;

            typedef Sample_ComputeGrasps_Request_TypeSupportInterface * Sample_ComputeGrasps_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ComputeGrasps_Request_TypeSupportInterface> Sample_ComputeGrasps_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ComputeGrasps_Request_TypeSupportInterface> Sample_ComputeGrasps_Request_TypeSupportInterface_out;


            class Sample_ComputeGrasps_Request_DataWriter;

            typedef Sample_ComputeGrasps_Request_DataWriter * Sample_ComputeGrasps_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ComputeGrasps_Request_DataWriter> Sample_ComputeGrasps_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ComputeGrasps_Request_DataWriter> Sample_ComputeGrasps_Request_DataWriter_out;


            class Sample_ComputeGrasps_Request_DataReader;

            typedef Sample_ComputeGrasps_Request_DataReader * Sample_ComputeGrasps_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ComputeGrasps_Request_DataReader> Sample_ComputeGrasps_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ComputeGrasps_Request_DataReader> Sample_ComputeGrasps_Request_DataReader_out;


            class Sample_ComputeGrasps_Request_DataReaderView;

            typedef Sample_ComputeGrasps_Request_DataReaderView * Sample_ComputeGrasps_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ComputeGrasps_Request_DataReaderView> Sample_ComputeGrasps_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ComputeGrasps_Request_DataReaderView> Sample_ComputeGrasps_Request_DataReaderView_out;

            struct Sample_ComputeGrasps_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ComputeGrasps_Request_, struct Sample_ComputeGrasps_Request_Seq_uniq_> Sample_ComputeGrasps_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ComputeGrasps_Request_Seq> Sample_ComputeGrasps_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ComputeGrasps_Request_Seq> Sample_ComputeGrasps_Request_Seq_out;

            class  Sample_ComputeGrasps_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ComputeGrasps_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ComputeGrasps_Request_TypeSupportInterface_var _var_type;

                static Sample_ComputeGrasps_Request_TypeSupportInterface_ptr _duplicate (Sample_ComputeGrasps_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ComputeGrasps_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ComputeGrasps_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ComputeGrasps_Request_TypeSupportInterface () {};
                ~Sample_ComputeGrasps_Request_TypeSupportInterface () {};
            private:
                Sample_ComputeGrasps_Request_TypeSupportInterface (const Sample_ComputeGrasps_Request_TypeSupportInterface &);
                Sample_ComputeGrasps_Request_TypeSupportInterface & operator = (const Sample_ComputeGrasps_Request_TypeSupportInterface &);
            };

            class  Sample_ComputeGrasps_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ComputeGrasps_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ComputeGrasps_Request_DataWriter_var _var_type;

                static Sample_ComputeGrasps_Request_DataWriter_ptr _duplicate (Sample_ComputeGrasps_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ComputeGrasps_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ComputeGrasps_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ComputeGrasps_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ComputeGrasps_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ComputeGrasps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ComputeGrasps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ComputeGrasps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ComputeGrasps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ComputeGrasps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ComputeGrasps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ComputeGrasps_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ComputeGrasps_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ComputeGrasps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ComputeGrasps_Request_& instance_data) = 0;

            protected:
                Sample_ComputeGrasps_Request_DataWriter () {};
                ~Sample_ComputeGrasps_Request_DataWriter () {};
            private:
                Sample_ComputeGrasps_Request_DataWriter (const Sample_ComputeGrasps_Request_DataWriter &);
                Sample_ComputeGrasps_Request_DataWriter & operator = (const Sample_ComputeGrasps_Request_DataWriter &);
            };

            class  Sample_ComputeGrasps_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ComputeGrasps_Request_DataReader_ptr _ptr_type;
                typedef Sample_ComputeGrasps_Request_DataReader_var _var_type;

                static Sample_ComputeGrasps_Request_DataReader_ptr _duplicate (Sample_ComputeGrasps_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ComputeGrasps_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ComputeGrasps_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ComputeGrasps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ComputeGrasps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ComputeGrasps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ComputeGrasps_Request_& instance) = 0;

            protected:
                Sample_ComputeGrasps_Request_DataReader () {};
                ~Sample_ComputeGrasps_Request_DataReader () {};
            private:
                Sample_ComputeGrasps_Request_DataReader (const Sample_ComputeGrasps_Request_DataReader &);
                Sample_ComputeGrasps_Request_DataReader & operator = (const Sample_ComputeGrasps_Request_DataReader &);
            };

            class  Sample_ComputeGrasps_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ComputeGrasps_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ComputeGrasps_Request_DataReaderView_var _var_type;

                static Sample_ComputeGrasps_Request_DataReaderView_ptr _duplicate (Sample_ComputeGrasps_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ComputeGrasps_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ComputeGrasps_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ComputeGrasps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ComputeGrasps_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ComputeGrasps_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ComputeGrasps_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ComputeGrasps_Request_& instance) = 0;

            protected:
                Sample_ComputeGrasps_Request_DataReaderView () {};
                ~Sample_ComputeGrasps_Request_DataReaderView () {};
            private:
                Sample_ComputeGrasps_Request_DataReaderView (const Sample_ComputeGrasps_Request_DataReaderView &);
                Sample_ComputeGrasps_Request_DataReaderView & operator = (const Sample_ComputeGrasps_Request_DataReaderView &);
            };
            class Sample_ComputeGrasps_Response_TypeSupportInterface;

            typedef Sample_ComputeGrasps_Response_TypeSupportInterface * Sample_ComputeGrasps_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ComputeGrasps_Response_TypeSupportInterface> Sample_ComputeGrasps_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ComputeGrasps_Response_TypeSupportInterface> Sample_ComputeGrasps_Response_TypeSupportInterface_out;


            class Sample_ComputeGrasps_Response_DataWriter;

            typedef Sample_ComputeGrasps_Response_DataWriter * Sample_ComputeGrasps_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ComputeGrasps_Response_DataWriter> Sample_ComputeGrasps_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ComputeGrasps_Response_DataWriter> Sample_ComputeGrasps_Response_DataWriter_out;


            class Sample_ComputeGrasps_Response_DataReader;

            typedef Sample_ComputeGrasps_Response_DataReader * Sample_ComputeGrasps_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ComputeGrasps_Response_DataReader> Sample_ComputeGrasps_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ComputeGrasps_Response_DataReader> Sample_ComputeGrasps_Response_DataReader_out;


            class Sample_ComputeGrasps_Response_DataReaderView;

            typedef Sample_ComputeGrasps_Response_DataReaderView * Sample_ComputeGrasps_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ComputeGrasps_Response_DataReaderView> Sample_ComputeGrasps_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ComputeGrasps_Response_DataReaderView> Sample_ComputeGrasps_Response_DataReaderView_out;

            struct Sample_ComputeGrasps_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ComputeGrasps_Response_, struct Sample_ComputeGrasps_Response_Seq_uniq_> Sample_ComputeGrasps_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ComputeGrasps_Response_Seq> Sample_ComputeGrasps_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ComputeGrasps_Response_Seq> Sample_ComputeGrasps_Response_Seq_out;

            class  Sample_ComputeGrasps_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ComputeGrasps_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ComputeGrasps_Response_TypeSupportInterface_var _var_type;

                static Sample_ComputeGrasps_Response_TypeSupportInterface_ptr _duplicate (Sample_ComputeGrasps_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ComputeGrasps_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ComputeGrasps_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ComputeGrasps_Response_TypeSupportInterface () {};
                ~Sample_ComputeGrasps_Response_TypeSupportInterface () {};
            private:
                Sample_ComputeGrasps_Response_TypeSupportInterface (const Sample_ComputeGrasps_Response_TypeSupportInterface &);
                Sample_ComputeGrasps_Response_TypeSupportInterface & operator = (const Sample_ComputeGrasps_Response_TypeSupportInterface &);
            };

            class  Sample_ComputeGrasps_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ComputeGrasps_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ComputeGrasps_Response_DataWriter_var _var_type;

                static Sample_ComputeGrasps_Response_DataWriter_ptr _duplicate (Sample_ComputeGrasps_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ComputeGrasps_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ComputeGrasps_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ComputeGrasps_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ComputeGrasps_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ComputeGrasps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ComputeGrasps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ComputeGrasps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ComputeGrasps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ComputeGrasps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ComputeGrasps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ComputeGrasps_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ComputeGrasps_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ComputeGrasps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ComputeGrasps_Response_& instance_data) = 0;

            protected:
                Sample_ComputeGrasps_Response_DataWriter () {};
                ~Sample_ComputeGrasps_Response_DataWriter () {};
            private:
                Sample_ComputeGrasps_Response_DataWriter (const Sample_ComputeGrasps_Response_DataWriter &);
                Sample_ComputeGrasps_Response_DataWriter & operator = (const Sample_ComputeGrasps_Response_DataWriter &);
            };

            class  Sample_ComputeGrasps_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ComputeGrasps_Response_DataReader_ptr _ptr_type;
                typedef Sample_ComputeGrasps_Response_DataReader_var _var_type;

                static Sample_ComputeGrasps_Response_DataReader_ptr _duplicate (Sample_ComputeGrasps_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ComputeGrasps_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ComputeGrasps_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ComputeGrasps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ComputeGrasps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ComputeGrasps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ComputeGrasps_Response_& instance) = 0;

            protected:
                Sample_ComputeGrasps_Response_DataReader () {};
                ~Sample_ComputeGrasps_Response_DataReader () {};
            private:
                Sample_ComputeGrasps_Response_DataReader (const Sample_ComputeGrasps_Response_DataReader &);
                Sample_ComputeGrasps_Response_DataReader & operator = (const Sample_ComputeGrasps_Response_DataReader &);
            };

            class  Sample_ComputeGrasps_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ComputeGrasps_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ComputeGrasps_Response_DataReaderView_var _var_type;

                static Sample_ComputeGrasps_Response_DataReaderView_ptr _duplicate (Sample_ComputeGrasps_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ComputeGrasps_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ComputeGrasps_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ComputeGrasps_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ComputeGrasps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ComputeGrasps_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ComputeGrasps_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ComputeGrasps_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ComputeGrasps_Response_& instance) = 0;

            protected:
                Sample_ComputeGrasps_Response_DataReaderView () {};
                ~Sample_ComputeGrasps_Response_DataReaderView () {};
            private:
                Sample_ComputeGrasps_Response_DataReaderView (const Sample_ComputeGrasps_Response_DataReaderView &);
                Sample_ComputeGrasps_Response_DataReaderView & operator = (const Sample_ComputeGrasps_Response_DataReaderView &);
            };
        }

    }

}

#endif
