#ifndef _H_35CAD909EF2CB227DAA9C5432E58A2CE_DeleteBasePlaneCalibration__H_
#define _H_35CAD909EF2CB227DAA9C5432E58A2CE_DeleteBasePlaneCalibration__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  DeleteBasePlaneCalibration_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<DeleteBasePlaneCalibration_Request_> DeleteBasePlaneCalibration_Request__var;
            typedef DeleteBasePlaneCalibration_Request_& DeleteBasePlaneCalibration_Request__out;

            struct  DeleteBasePlaneCalibration_Response_
            {
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<DeleteBasePlaneCalibration_Response_> DeleteBasePlaneCalibration_Response__var;
            typedef DDS_DCPSStruct_out < DeleteBasePlaneCalibration_Response_> DeleteBasePlaneCalibration_Response__out;

            struct  Sample_DeleteBasePlaneCalibration_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DeleteBasePlaneCalibration_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_DeleteBasePlaneCalibration_Request_> Sample_DeleteBasePlaneCalibration_Request__var;
            typedef Sample_DeleteBasePlaneCalibration_Request_& Sample_DeleteBasePlaneCalibration_Request__out;

            struct  Sample_DeleteBasePlaneCalibration_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DeleteBasePlaneCalibration_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_DeleteBasePlaneCalibration_Response_> Sample_DeleteBasePlaneCalibration_Response__var;
            typedef DDS_DCPSStruct_out < Sample_DeleteBasePlaneCalibration_Response_> Sample_DeleteBasePlaneCalibration_Response__out;

        }

    }

}

#endif /* _H_35CAD909EF2CB227DAA9C5432E58A2CE_DeleteBasePlaneCalibration__H_ */
