#ifndef _H_35CAD909EF2CB227DAA9C5432E58A2CE_DeleteBasePlaneCalibration_DCPS_H_
#define _H_35CAD909EF2CB227DAA9C5432E58A2CE_DeleteBasePlaneCalibration_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DeleteBasePlaneCalibration_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class DeleteBasePlaneCalibration_Request_TypeSupportInterface;

            typedef DeleteBasePlaneCalibration_Request_TypeSupportInterface * DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeleteBasePlaneCalibration_Request_TypeSupportInterface> DeleteBasePlaneCalibration_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeleteBasePlaneCalibration_Request_TypeSupportInterface> DeleteBasePlaneCalibration_Request_TypeSupportInterface_out;


            class DeleteBasePlaneCalibration_Request_DataWriter;

            typedef DeleteBasePlaneCalibration_Request_DataWriter * DeleteBasePlaneCalibration_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeleteBasePlaneCalibration_Request_DataWriter> DeleteBasePlaneCalibration_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeleteBasePlaneCalibration_Request_DataWriter> DeleteBasePlaneCalibration_Request_DataWriter_out;


            class DeleteBasePlaneCalibration_Request_DataReader;

            typedef DeleteBasePlaneCalibration_Request_DataReader * DeleteBasePlaneCalibration_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeleteBasePlaneCalibration_Request_DataReader> DeleteBasePlaneCalibration_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < DeleteBasePlaneCalibration_Request_DataReader> DeleteBasePlaneCalibration_Request_DataReader_out;


            class DeleteBasePlaneCalibration_Request_DataReaderView;

            typedef DeleteBasePlaneCalibration_Request_DataReaderView * DeleteBasePlaneCalibration_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeleteBasePlaneCalibration_Request_DataReaderView> DeleteBasePlaneCalibration_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeleteBasePlaneCalibration_Request_DataReaderView> DeleteBasePlaneCalibration_Request_DataReaderView_out;

            struct DeleteBasePlaneCalibration_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DeleteBasePlaneCalibration_Request_, struct DeleteBasePlaneCalibration_Request_Seq_uniq_> DeleteBasePlaneCalibration_Request_Seq;
            typedef DDS_DCPSSequence_var < DeleteBasePlaneCalibration_Request_Seq> DeleteBasePlaneCalibration_Request_Seq_var;
            typedef DDS_DCPSSequence_out < DeleteBasePlaneCalibration_Request_Seq> DeleteBasePlaneCalibration_Request_Seq_out;

            class  DeleteBasePlaneCalibration_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _ptr_type;
                typedef DeleteBasePlaneCalibration_Request_TypeSupportInterface_var _var_type;

                static DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _duplicate (DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeleteBasePlaneCalibration_Request_TypeSupportInterface () {};
                ~DeleteBasePlaneCalibration_Request_TypeSupportInterface () {};
            private:
                DeleteBasePlaneCalibration_Request_TypeSupportInterface (const DeleteBasePlaneCalibration_Request_TypeSupportInterface &);
                DeleteBasePlaneCalibration_Request_TypeSupportInterface & operator = (const DeleteBasePlaneCalibration_Request_TypeSupportInterface &);
            };

            class  DeleteBasePlaneCalibration_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeleteBasePlaneCalibration_Request_DataWriter_ptr _ptr_type;
                typedef DeleteBasePlaneCalibration_Request_DataWriter_var _var_type;

                static DeleteBasePlaneCalibration_Request_DataWriter_ptr _duplicate (DeleteBasePlaneCalibration_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteBasePlaneCalibration_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteBasePlaneCalibration_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeleteBasePlaneCalibration_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeleteBasePlaneCalibration_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeleteBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteBasePlaneCalibration_Request_& instance_data) = 0;

            protected:
                DeleteBasePlaneCalibration_Request_DataWriter () {};
                ~DeleteBasePlaneCalibration_Request_DataWriter () {};
            private:
                DeleteBasePlaneCalibration_Request_DataWriter (const DeleteBasePlaneCalibration_Request_DataWriter &);
                DeleteBasePlaneCalibration_Request_DataWriter & operator = (const DeleteBasePlaneCalibration_Request_DataWriter &);
            };

            class  DeleteBasePlaneCalibration_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeleteBasePlaneCalibration_Request_DataReader_ptr _ptr_type;
                typedef DeleteBasePlaneCalibration_Request_DataReader_var _var_type;

                static DeleteBasePlaneCalibration_Request_DataReader_ptr _duplicate (DeleteBasePlaneCalibration_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteBasePlaneCalibration_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteBasePlaneCalibration_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteBasePlaneCalibration_Request_& instance) = 0;

            protected:
                DeleteBasePlaneCalibration_Request_DataReader () {};
                ~DeleteBasePlaneCalibration_Request_DataReader () {};
            private:
                DeleteBasePlaneCalibration_Request_DataReader (const DeleteBasePlaneCalibration_Request_DataReader &);
                DeleteBasePlaneCalibration_Request_DataReader & operator = (const DeleteBasePlaneCalibration_Request_DataReader &);
            };

            class  DeleteBasePlaneCalibration_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeleteBasePlaneCalibration_Request_DataReaderView_ptr _ptr_type;
                typedef DeleteBasePlaneCalibration_Request_DataReaderView_var _var_type;

                static DeleteBasePlaneCalibration_Request_DataReaderView_ptr _duplicate (DeleteBasePlaneCalibration_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteBasePlaneCalibration_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteBasePlaneCalibration_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteBasePlaneCalibration_Request_& instance) = 0;

            protected:
                DeleteBasePlaneCalibration_Request_DataReaderView () {};
                ~DeleteBasePlaneCalibration_Request_DataReaderView () {};
            private:
                DeleteBasePlaneCalibration_Request_DataReaderView (const DeleteBasePlaneCalibration_Request_DataReaderView &);
                DeleteBasePlaneCalibration_Request_DataReaderView & operator = (const DeleteBasePlaneCalibration_Request_DataReaderView &);
            };
            class DeleteBasePlaneCalibration_Response_TypeSupportInterface;

            typedef DeleteBasePlaneCalibration_Response_TypeSupportInterface * DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeleteBasePlaneCalibration_Response_TypeSupportInterface> DeleteBasePlaneCalibration_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeleteBasePlaneCalibration_Response_TypeSupportInterface> DeleteBasePlaneCalibration_Response_TypeSupportInterface_out;


            class DeleteBasePlaneCalibration_Response_DataWriter;

            typedef DeleteBasePlaneCalibration_Response_DataWriter * DeleteBasePlaneCalibration_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeleteBasePlaneCalibration_Response_DataWriter> DeleteBasePlaneCalibration_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeleteBasePlaneCalibration_Response_DataWriter> DeleteBasePlaneCalibration_Response_DataWriter_out;


            class DeleteBasePlaneCalibration_Response_DataReader;

            typedef DeleteBasePlaneCalibration_Response_DataReader * DeleteBasePlaneCalibration_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeleteBasePlaneCalibration_Response_DataReader> DeleteBasePlaneCalibration_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DeleteBasePlaneCalibration_Response_DataReader> DeleteBasePlaneCalibration_Response_DataReader_out;


            class DeleteBasePlaneCalibration_Response_DataReaderView;

            typedef DeleteBasePlaneCalibration_Response_DataReaderView * DeleteBasePlaneCalibration_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeleteBasePlaneCalibration_Response_DataReaderView> DeleteBasePlaneCalibration_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeleteBasePlaneCalibration_Response_DataReaderView> DeleteBasePlaneCalibration_Response_DataReaderView_out;

            struct DeleteBasePlaneCalibration_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DeleteBasePlaneCalibration_Response_, struct DeleteBasePlaneCalibration_Response_Seq_uniq_> DeleteBasePlaneCalibration_Response_Seq;
            typedef DDS_DCPSSequence_var < DeleteBasePlaneCalibration_Response_Seq> DeleteBasePlaneCalibration_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DeleteBasePlaneCalibration_Response_Seq> DeleteBasePlaneCalibration_Response_Seq_out;

            class  DeleteBasePlaneCalibration_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DeleteBasePlaneCalibration_Response_TypeSupportInterface_var _var_type;

                static DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _duplicate (DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeleteBasePlaneCalibration_Response_TypeSupportInterface () {};
                ~DeleteBasePlaneCalibration_Response_TypeSupportInterface () {};
            private:
                DeleteBasePlaneCalibration_Response_TypeSupportInterface (const DeleteBasePlaneCalibration_Response_TypeSupportInterface &);
                DeleteBasePlaneCalibration_Response_TypeSupportInterface & operator = (const DeleteBasePlaneCalibration_Response_TypeSupportInterface &);
            };

            class  DeleteBasePlaneCalibration_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeleteBasePlaneCalibration_Response_DataWriter_ptr _ptr_type;
                typedef DeleteBasePlaneCalibration_Response_DataWriter_var _var_type;

                static DeleteBasePlaneCalibration_Response_DataWriter_ptr _duplicate (DeleteBasePlaneCalibration_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteBasePlaneCalibration_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteBasePlaneCalibration_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeleteBasePlaneCalibration_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeleteBasePlaneCalibration_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeleteBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteBasePlaneCalibration_Response_& instance_data) = 0;

            protected:
                DeleteBasePlaneCalibration_Response_DataWriter () {};
                ~DeleteBasePlaneCalibration_Response_DataWriter () {};
            private:
                DeleteBasePlaneCalibration_Response_DataWriter (const DeleteBasePlaneCalibration_Response_DataWriter &);
                DeleteBasePlaneCalibration_Response_DataWriter & operator = (const DeleteBasePlaneCalibration_Response_DataWriter &);
            };

            class  DeleteBasePlaneCalibration_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeleteBasePlaneCalibration_Response_DataReader_ptr _ptr_type;
                typedef DeleteBasePlaneCalibration_Response_DataReader_var _var_type;

                static DeleteBasePlaneCalibration_Response_DataReader_ptr _duplicate (DeleteBasePlaneCalibration_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteBasePlaneCalibration_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteBasePlaneCalibration_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteBasePlaneCalibration_Response_& instance) = 0;

            protected:
                DeleteBasePlaneCalibration_Response_DataReader () {};
                ~DeleteBasePlaneCalibration_Response_DataReader () {};
            private:
                DeleteBasePlaneCalibration_Response_DataReader (const DeleteBasePlaneCalibration_Response_DataReader &);
                DeleteBasePlaneCalibration_Response_DataReader & operator = (const DeleteBasePlaneCalibration_Response_DataReader &);
            };

            class  DeleteBasePlaneCalibration_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeleteBasePlaneCalibration_Response_DataReaderView_ptr _ptr_type;
                typedef DeleteBasePlaneCalibration_Response_DataReaderView_var _var_type;

                static DeleteBasePlaneCalibration_Response_DataReaderView_ptr _duplicate (DeleteBasePlaneCalibration_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteBasePlaneCalibration_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteBasePlaneCalibration_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteBasePlaneCalibration_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteBasePlaneCalibration_Response_& instance) = 0;

            protected:
                DeleteBasePlaneCalibration_Response_DataReaderView () {};
                ~DeleteBasePlaneCalibration_Response_DataReaderView () {};
            private:
                DeleteBasePlaneCalibration_Response_DataReaderView (const DeleteBasePlaneCalibration_Response_DataReaderView &);
                DeleteBasePlaneCalibration_Response_DataReaderView & operator = (const DeleteBasePlaneCalibration_Response_DataReaderView &);
            };
            class Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface;

            typedef Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface * Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface> Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface> Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_out;


            class Sample_DeleteBasePlaneCalibration_Request_DataWriter;

            typedef Sample_DeleteBasePlaneCalibration_Request_DataWriter * Sample_DeleteBasePlaneCalibration_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteBasePlaneCalibration_Request_DataWriter> Sample_DeleteBasePlaneCalibration_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteBasePlaneCalibration_Request_DataWriter> Sample_DeleteBasePlaneCalibration_Request_DataWriter_out;


            class Sample_DeleteBasePlaneCalibration_Request_DataReader;

            typedef Sample_DeleteBasePlaneCalibration_Request_DataReader * Sample_DeleteBasePlaneCalibration_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteBasePlaneCalibration_Request_DataReader> Sample_DeleteBasePlaneCalibration_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteBasePlaneCalibration_Request_DataReader> Sample_DeleteBasePlaneCalibration_Request_DataReader_out;


            class Sample_DeleteBasePlaneCalibration_Request_DataReaderView;

            typedef Sample_DeleteBasePlaneCalibration_Request_DataReaderView * Sample_DeleteBasePlaneCalibration_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteBasePlaneCalibration_Request_DataReaderView> Sample_DeleteBasePlaneCalibration_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteBasePlaneCalibration_Request_DataReaderView> Sample_DeleteBasePlaneCalibration_Request_DataReaderView_out;

            struct Sample_DeleteBasePlaneCalibration_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_DeleteBasePlaneCalibration_Request_, struct Sample_DeleteBasePlaneCalibration_Request_Seq_uniq_> Sample_DeleteBasePlaneCalibration_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_DeleteBasePlaneCalibration_Request_Seq> Sample_DeleteBasePlaneCalibration_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DeleteBasePlaneCalibration_Request_Seq> Sample_DeleteBasePlaneCalibration_Request_Seq_out;

            class  Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_var _var_type;

                static Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _duplicate (Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface () {};
                ~Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface () {};
            private:
                Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface (const Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface &);
                Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface & operator = (const Sample_DeleteBasePlaneCalibration_Request_TypeSupportInterface &);
            };

            class  Sample_DeleteBasePlaneCalibration_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DeleteBasePlaneCalibration_Request_DataWriter_ptr _ptr_type;
                typedef Sample_DeleteBasePlaneCalibration_Request_DataWriter_var _var_type;

                static Sample_DeleteBasePlaneCalibration_Request_DataWriter_ptr _duplicate (Sample_DeleteBasePlaneCalibration_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteBasePlaneCalibration_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteBasePlaneCalibration_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DeleteBasePlaneCalibration_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DeleteBasePlaneCalibration_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DeleteBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteBasePlaneCalibration_Request_& instance_data) = 0;

            protected:
                Sample_DeleteBasePlaneCalibration_Request_DataWriter () {};
                ~Sample_DeleteBasePlaneCalibration_Request_DataWriter () {};
            private:
                Sample_DeleteBasePlaneCalibration_Request_DataWriter (const Sample_DeleteBasePlaneCalibration_Request_DataWriter &);
                Sample_DeleteBasePlaneCalibration_Request_DataWriter & operator = (const Sample_DeleteBasePlaneCalibration_Request_DataWriter &);
            };

            class  Sample_DeleteBasePlaneCalibration_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DeleteBasePlaneCalibration_Request_DataReader_ptr _ptr_type;
                typedef Sample_DeleteBasePlaneCalibration_Request_DataReader_var _var_type;

                static Sample_DeleteBasePlaneCalibration_Request_DataReader_ptr _duplicate (Sample_DeleteBasePlaneCalibration_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteBasePlaneCalibration_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteBasePlaneCalibration_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteBasePlaneCalibration_Request_& instance) = 0;

            protected:
                Sample_DeleteBasePlaneCalibration_Request_DataReader () {};
                ~Sample_DeleteBasePlaneCalibration_Request_DataReader () {};
            private:
                Sample_DeleteBasePlaneCalibration_Request_DataReader (const Sample_DeleteBasePlaneCalibration_Request_DataReader &);
                Sample_DeleteBasePlaneCalibration_Request_DataReader & operator = (const Sample_DeleteBasePlaneCalibration_Request_DataReader &);
            };

            class  Sample_DeleteBasePlaneCalibration_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DeleteBasePlaneCalibration_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_DeleteBasePlaneCalibration_Request_DataReaderView_var _var_type;

                static Sample_DeleteBasePlaneCalibration_Request_DataReaderView_ptr _duplicate (Sample_DeleteBasePlaneCalibration_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteBasePlaneCalibration_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteBasePlaneCalibration_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteBasePlaneCalibration_Request_& instance) = 0;

            protected:
                Sample_DeleteBasePlaneCalibration_Request_DataReaderView () {};
                ~Sample_DeleteBasePlaneCalibration_Request_DataReaderView () {};
            private:
                Sample_DeleteBasePlaneCalibration_Request_DataReaderView (const Sample_DeleteBasePlaneCalibration_Request_DataReaderView &);
                Sample_DeleteBasePlaneCalibration_Request_DataReaderView & operator = (const Sample_DeleteBasePlaneCalibration_Request_DataReaderView &);
            };
            class Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface;

            typedef Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface * Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface> Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface> Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_out;


            class Sample_DeleteBasePlaneCalibration_Response_DataWriter;

            typedef Sample_DeleteBasePlaneCalibration_Response_DataWriter * Sample_DeleteBasePlaneCalibration_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteBasePlaneCalibration_Response_DataWriter> Sample_DeleteBasePlaneCalibration_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteBasePlaneCalibration_Response_DataWriter> Sample_DeleteBasePlaneCalibration_Response_DataWriter_out;


            class Sample_DeleteBasePlaneCalibration_Response_DataReader;

            typedef Sample_DeleteBasePlaneCalibration_Response_DataReader * Sample_DeleteBasePlaneCalibration_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteBasePlaneCalibration_Response_DataReader> Sample_DeleteBasePlaneCalibration_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteBasePlaneCalibration_Response_DataReader> Sample_DeleteBasePlaneCalibration_Response_DataReader_out;


            class Sample_DeleteBasePlaneCalibration_Response_DataReaderView;

            typedef Sample_DeleteBasePlaneCalibration_Response_DataReaderView * Sample_DeleteBasePlaneCalibration_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteBasePlaneCalibration_Response_DataReaderView> Sample_DeleteBasePlaneCalibration_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteBasePlaneCalibration_Response_DataReaderView> Sample_DeleteBasePlaneCalibration_Response_DataReaderView_out;

            struct Sample_DeleteBasePlaneCalibration_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DeleteBasePlaneCalibration_Response_, struct Sample_DeleteBasePlaneCalibration_Response_Seq_uniq_> Sample_DeleteBasePlaneCalibration_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_DeleteBasePlaneCalibration_Response_Seq> Sample_DeleteBasePlaneCalibration_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DeleteBasePlaneCalibration_Response_Seq> Sample_DeleteBasePlaneCalibration_Response_Seq_out;

            class  Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_var _var_type;

                static Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _duplicate (Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface () {};
                ~Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface () {};
            private:
                Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface (const Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface &);
                Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface & operator = (const Sample_DeleteBasePlaneCalibration_Response_TypeSupportInterface &);
            };

            class  Sample_DeleteBasePlaneCalibration_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DeleteBasePlaneCalibration_Response_DataWriter_ptr _ptr_type;
                typedef Sample_DeleteBasePlaneCalibration_Response_DataWriter_var _var_type;

                static Sample_DeleteBasePlaneCalibration_Response_DataWriter_ptr _duplicate (Sample_DeleteBasePlaneCalibration_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteBasePlaneCalibration_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteBasePlaneCalibration_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DeleteBasePlaneCalibration_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DeleteBasePlaneCalibration_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DeleteBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteBasePlaneCalibration_Response_& instance_data) = 0;

            protected:
                Sample_DeleteBasePlaneCalibration_Response_DataWriter () {};
                ~Sample_DeleteBasePlaneCalibration_Response_DataWriter () {};
            private:
                Sample_DeleteBasePlaneCalibration_Response_DataWriter (const Sample_DeleteBasePlaneCalibration_Response_DataWriter &);
                Sample_DeleteBasePlaneCalibration_Response_DataWriter & operator = (const Sample_DeleteBasePlaneCalibration_Response_DataWriter &);
            };

            class  Sample_DeleteBasePlaneCalibration_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DeleteBasePlaneCalibration_Response_DataReader_ptr _ptr_type;
                typedef Sample_DeleteBasePlaneCalibration_Response_DataReader_var _var_type;

                static Sample_DeleteBasePlaneCalibration_Response_DataReader_ptr _duplicate (Sample_DeleteBasePlaneCalibration_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteBasePlaneCalibration_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteBasePlaneCalibration_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteBasePlaneCalibration_Response_& instance) = 0;

            protected:
                Sample_DeleteBasePlaneCalibration_Response_DataReader () {};
                ~Sample_DeleteBasePlaneCalibration_Response_DataReader () {};
            private:
                Sample_DeleteBasePlaneCalibration_Response_DataReader (const Sample_DeleteBasePlaneCalibration_Response_DataReader &);
                Sample_DeleteBasePlaneCalibration_Response_DataReader & operator = (const Sample_DeleteBasePlaneCalibration_Response_DataReader &);
            };

            class  Sample_DeleteBasePlaneCalibration_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DeleteBasePlaneCalibration_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_DeleteBasePlaneCalibration_Response_DataReaderView_var _var_type;

                static Sample_DeleteBasePlaneCalibration_Response_DataReaderView_ptr _duplicate (Sample_DeleteBasePlaneCalibration_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteBasePlaneCalibration_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteBasePlaneCalibration_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteBasePlaneCalibration_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteBasePlaneCalibration_Response_& instance) = 0;

            protected:
                Sample_DeleteBasePlaneCalibration_Response_DataReaderView () {};
                ~Sample_DeleteBasePlaneCalibration_Response_DataReaderView () {};
            private:
                Sample_DeleteBasePlaneCalibration_Response_DataReaderView (const Sample_DeleteBasePlaneCalibration_Response_DataReaderView &);
                Sample_DeleteBasePlaneCalibration_Response_DataReaderView & operator = (const Sample_DeleteBasePlaneCalibration_Response_DataReaderView &);
            };
        }

    }

}

#endif
