#ifndef _H_1FA0F7D7B6F29794FDD84C1638DEEEAD_DeleteLoadCarriers__H_
#define _H_1FA0F7D7B6F29794FDD84C1638DEEEAD_DeleteLoadCarriers__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  DeleteLoadCarriers_Request_
            {
                struct _load_carrier_ids__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _load_carrier_ids__seq_uniq_ > _load_carrier_ids__seq;
                typedef DDS_DCPSUStrSeq_var< _load_carrier_ids__seq > _load_carrier_ids__seq_var;
                typedef DDS_DCPSUStrSeq_out< _load_carrier_ids__seq > _load_carrier_ids__seq_out;
                _load_carrier_ids__seq load_carrier_ids_;
            };

            typedef DDS_DCPSStruct_var<DeleteLoadCarriers_Request_> DeleteLoadCarriers_Request__var;
            typedef DDS_DCPSStruct_out < DeleteLoadCarriers_Request_> DeleteLoadCarriers_Request__out;

            struct  DeleteLoadCarriers_Response_
            {
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<DeleteLoadCarriers_Response_> DeleteLoadCarriers_Response__var;
            typedef DDS_DCPSStruct_out < DeleteLoadCarriers_Response_> DeleteLoadCarriers_Response__out;

            struct  Sample_DeleteLoadCarriers_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DeleteLoadCarriers_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_DeleteLoadCarriers_Request_> Sample_DeleteLoadCarriers_Request__var;
            typedef DDS_DCPSStruct_out < Sample_DeleteLoadCarriers_Request_> Sample_DeleteLoadCarriers_Request__out;

            struct  Sample_DeleteLoadCarriers_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DeleteLoadCarriers_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_DeleteLoadCarriers_Response_> Sample_DeleteLoadCarriers_Response__var;
            typedef DDS_DCPSStruct_out < Sample_DeleteLoadCarriers_Response_> Sample_DeleteLoadCarriers_Response__out;

        }

    }

}

#endif /* _H_1FA0F7D7B6F29794FDD84C1638DEEEAD_DeleteLoadCarriers__H_ */
