#ifndef _H_1FA0F7D7B6F29794FDD84C1638DEEEAD_DeleteLoadCarriers_DCPS_H_
#define _H_1FA0F7D7B6F29794FDD84C1638DEEEAD_DeleteLoadCarriers_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DeleteLoadCarriers_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class DeleteLoadCarriers_Request_TypeSupportInterface;

            typedef DeleteLoadCarriers_Request_TypeSupportInterface * DeleteLoadCarriers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeleteLoadCarriers_Request_TypeSupportInterface> DeleteLoadCarriers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeleteLoadCarriers_Request_TypeSupportInterface> DeleteLoadCarriers_Request_TypeSupportInterface_out;


            class DeleteLoadCarriers_Request_DataWriter;

            typedef DeleteLoadCarriers_Request_DataWriter * DeleteLoadCarriers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeleteLoadCarriers_Request_DataWriter> DeleteLoadCarriers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeleteLoadCarriers_Request_DataWriter> DeleteLoadCarriers_Request_DataWriter_out;


            class DeleteLoadCarriers_Request_DataReader;

            typedef DeleteLoadCarriers_Request_DataReader * DeleteLoadCarriers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeleteLoadCarriers_Request_DataReader> DeleteLoadCarriers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < DeleteLoadCarriers_Request_DataReader> DeleteLoadCarriers_Request_DataReader_out;


            class DeleteLoadCarriers_Request_DataReaderView;

            typedef DeleteLoadCarriers_Request_DataReaderView * DeleteLoadCarriers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeleteLoadCarriers_Request_DataReaderView> DeleteLoadCarriers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeleteLoadCarriers_Request_DataReaderView> DeleteLoadCarriers_Request_DataReaderView_out;

            struct DeleteLoadCarriers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DeleteLoadCarriers_Request_, struct DeleteLoadCarriers_Request_Seq_uniq_> DeleteLoadCarriers_Request_Seq;
            typedef DDS_DCPSSequence_var < DeleteLoadCarriers_Request_Seq> DeleteLoadCarriers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < DeleteLoadCarriers_Request_Seq> DeleteLoadCarriers_Request_Seq_out;

            class  DeleteLoadCarriers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeleteLoadCarriers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef DeleteLoadCarriers_Request_TypeSupportInterface_var _var_type;

                static DeleteLoadCarriers_Request_TypeSupportInterface_ptr _duplicate (DeleteLoadCarriers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLoadCarriers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLoadCarriers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeleteLoadCarriers_Request_TypeSupportInterface () {};
                ~DeleteLoadCarriers_Request_TypeSupportInterface () {};
            private:
                DeleteLoadCarriers_Request_TypeSupportInterface (const DeleteLoadCarriers_Request_TypeSupportInterface &);
                DeleteLoadCarriers_Request_TypeSupportInterface & operator = (const DeleteLoadCarriers_Request_TypeSupportInterface &);
            };

            class  DeleteLoadCarriers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeleteLoadCarriers_Request_DataWriter_ptr _ptr_type;
                typedef DeleteLoadCarriers_Request_DataWriter_var _var_type;

                static DeleteLoadCarriers_Request_DataWriter_ptr _duplicate (DeleteLoadCarriers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLoadCarriers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLoadCarriers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeleteLoadCarriers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeleteLoadCarriers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeleteLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteLoadCarriers_Request_& instance_data) = 0;

            protected:
                DeleteLoadCarriers_Request_DataWriter () {};
                ~DeleteLoadCarriers_Request_DataWriter () {};
            private:
                DeleteLoadCarriers_Request_DataWriter (const DeleteLoadCarriers_Request_DataWriter &);
                DeleteLoadCarriers_Request_DataWriter & operator = (const DeleteLoadCarriers_Request_DataWriter &);
            };

            class  DeleteLoadCarriers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeleteLoadCarriers_Request_DataReader_ptr _ptr_type;
                typedef DeleteLoadCarriers_Request_DataReader_var _var_type;

                static DeleteLoadCarriers_Request_DataReader_ptr _duplicate (DeleteLoadCarriers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLoadCarriers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLoadCarriers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteLoadCarriers_Request_& instance) = 0;

            protected:
                DeleteLoadCarriers_Request_DataReader () {};
                ~DeleteLoadCarriers_Request_DataReader () {};
            private:
                DeleteLoadCarriers_Request_DataReader (const DeleteLoadCarriers_Request_DataReader &);
                DeleteLoadCarriers_Request_DataReader & operator = (const DeleteLoadCarriers_Request_DataReader &);
            };

            class  DeleteLoadCarriers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeleteLoadCarriers_Request_DataReaderView_ptr _ptr_type;
                typedef DeleteLoadCarriers_Request_DataReaderView_var _var_type;

                static DeleteLoadCarriers_Request_DataReaderView_ptr _duplicate (DeleteLoadCarriers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLoadCarriers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLoadCarriers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteLoadCarriers_Request_& instance) = 0;

            protected:
                DeleteLoadCarriers_Request_DataReaderView () {};
                ~DeleteLoadCarriers_Request_DataReaderView () {};
            private:
                DeleteLoadCarriers_Request_DataReaderView (const DeleteLoadCarriers_Request_DataReaderView &);
                DeleteLoadCarriers_Request_DataReaderView & operator = (const DeleteLoadCarriers_Request_DataReaderView &);
            };
            class DeleteLoadCarriers_Response_TypeSupportInterface;

            typedef DeleteLoadCarriers_Response_TypeSupportInterface * DeleteLoadCarriers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DeleteLoadCarriers_Response_TypeSupportInterface> DeleteLoadCarriers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DeleteLoadCarriers_Response_TypeSupportInterface> DeleteLoadCarriers_Response_TypeSupportInterface_out;


            class DeleteLoadCarriers_Response_DataWriter;

            typedef DeleteLoadCarriers_Response_DataWriter * DeleteLoadCarriers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DeleteLoadCarriers_Response_DataWriter> DeleteLoadCarriers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DeleteLoadCarriers_Response_DataWriter> DeleteLoadCarriers_Response_DataWriter_out;


            class DeleteLoadCarriers_Response_DataReader;

            typedef DeleteLoadCarriers_Response_DataReader * DeleteLoadCarriers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DeleteLoadCarriers_Response_DataReader> DeleteLoadCarriers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DeleteLoadCarriers_Response_DataReader> DeleteLoadCarriers_Response_DataReader_out;


            class DeleteLoadCarriers_Response_DataReaderView;

            typedef DeleteLoadCarriers_Response_DataReaderView * DeleteLoadCarriers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DeleteLoadCarriers_Response_DataReaderView> DeleteLoadCarriers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DeleteLoadCarriers_Response_DataReaderView> DeleteLoadCarriers_Response_DataReaderView_out;

            struct DeleteLoadCarriers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DeleteLoadCarriers_Response_, struct DeleteLoadCarriers_Response_Seq_uniq_> DeleteLoadCarriers_Response_Seq;
            typedef DDS_DCPSSequence_var < DeleteLoadCarriers_Response_Seq> DeleteLoadCarriers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DeleteLoadCarriers_Response_Seq> DeleteLoadCarriers_Response_Seq_out;

            class  DeleteLoadCarriers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DeleteLoadCarriers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DeleteLoadCarriers_Response_TypeSupportInterface_var _var_type;

                static DeleteLoadCarriers_Response_TypeSupportInterface_ptr _duplicate (DeleteLoadCarriers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLoadCarriers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLoadCarriers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DeleteLoadCarriers_Response_TypeSupportInterface () {};
                ~DeleteLoadCarriers_Response_TypeSupportInterface () {};
            private:
                DeleteLoadCarriers_Response_TypeSupportInterface (const DeleteLoadCarriers_Response_TypeSupportInterface &);
                DeleteLoadCarriers_Response_TypeSupportInterface & operator = (const DeleteLoadCarriers_Response_TypeSupportInterface &);
            };

            class  DeleteLoadCarriers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DeleteLoadCarriers_Response_DataWriter_ptr _ptr_type;
                typedef DeleteLoadCarriers_Response_DataWriter_var _var_type;

                static DeleteLoadCarriers_Response_DataWriter_ptr _duplicate (DeleteLoadCarriers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLoadCarriers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLoadCarriers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DeleteLoadCarriers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DeleteLoadCarriers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DeleteLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteLoadCarriers_Response_& instance_data) = 0;

            protected:
                DeleteLoadCarriers_Response_DataWriter () {};
                ~DeleteLoadCarriers_Response_DataWriter () {};
            private:
                DeleteLoadCarriers_Response_DataWriter (const DeleteLoadCarriers_Response_DataWriter &);
                DeleteLoadCarriers_Response_DataWriter & operator = (const DeleteLoadCarriers_Response_DataWriter &);
            };

            class  DeleteLoadCarriers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DeleteLoadCarriers_Response_DataReader_ptr _ptr_type;
                typedef DeleteLoadCarriers_Response_DataReader_var _var_type;

                static DeleteLoadCarriers_Response_DataReader_ptr _duplicate (DeleteLoadCarriers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLoadCarriers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLoadCarriers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteLoadCarriers_Response_& instance) = 0;

            protected:
                DeleteLoadCarriers_Response_DataReader () {};
                ~DeleteLoadCarriers_Response_DataReader () {};
            private:
                DeleteLoadCarriers_Response_DataReader (const DeleteLoadCarriers_Response_DataReader &);
                DeleteLoadCarriers_Response_DataReader & operator = (const DeleteLoadCarriers_Response_DataReader &);
            };

            class  DeleteLoadCarriers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DeleteLoadCarriers_Response_DataReaderView_ptr _ptr_type;
                typedef DeleteLoadCarriers_Response_DataReaderView_var _var_type;

                static DeleteLoadCarriers_Response_DataReaderView_ptr _duplicate (DeleteLoadCarriers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DeleteLoadCarriers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DeleteLoadCarriers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DeleteLoadCarriers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DeleteLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DeleteLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DeleteLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DeleteLoadCarriers_Response_& instance) = 0;

            protected:
                DeleteLoadCarriers_Response_DataReaderView () {};
                ~DeleteLoadCarriers_Response_DataReaderView () {};
            private:
                DeleteLoadCarriers_Response_DataReaderView (const DeleteLoadCarriers_Response_DataReaderView &);
                DeleteLoadCarriers_Response_DataReaderView & operator = (const DeleteLoadCarriers_Response_DataReaderView &);
            };
            class Sample_DeleteLoadCarriers_Request_TypeSupportInterface;

            typedef Sample_DeleteLoadCarriers_Request_TypeSupportInterface * Sample_DeleteLoadCarriers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteLoadCarriers_Request_TypeSupportInterface> Sample_DeleteLoadCarriers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteLoadCarriers_Request_TypeSupportInterface> Sample_DeleteLoadCarriers_Request_TypeSupportInterface_out;


            class Sample_DeleteLoadCarriers_Request_DataWriter;

            typedef Sample_DeleteLoadCarriers_Request_DataWriter * Sample_DeleteLoadCarriers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteLoadCarriers_Request_DataWriter> Sample_DeleteLoadCarriers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteLoadCarriers_Request_DataWriter> Sample_DeleteLoadCarriers_Request_DataWriter_out;


            class Sample_DeleteLoadCarriers_Request_DataReader;

            typedef Sample_DeleteLoadCarriers_Request_DataReader * Sample_DeleteLoadCarriers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteLoadCarriers_Request_DataReader> Sample_DeleteLoadCarriers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteLoadCarriers_Request_DataReader> Sample_DeleteLoadCarriers_Request_DataReader_out;


            class Sample_DeleteLoadCarriers_Request_DataReaderView;

            typedef Sample_DeleteLoadCarriers_Request_DataReaderView * Sample_DeleteLoadCarriers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteLoadCarriers_Request_DataReaderView> Sample_DeleteLoadCarriers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteLoadCarriers_Request_DataReaderView> Sample_DeleteLoadCarriers_Request_DataReaderView_out;

            struct Sample_DeleteLoadCarriers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DeleteLoadCarriers_Request_, struct Sample_DeleteLoadCarriers_Request_Seq_uniq_> Sample_DeleteLoadCarriers_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_DeleteLoadCarriers_Request_Seq> Sample_DeleteLoadCarriers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DeleteLoadCarriers_Request_Seq> Sample_DeleteLoadCarriers_Request_Seq_out;

            class  Sample_DeleteLoadCarriers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DeleteLoadCarriers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DeleteLoadCarriers_Request_TypeSupportInterface_var _var_type;

                static Sample_DeleteLoadCarriers_Request_TypeSupportInterface_ptr _duplicate (Sample_DeleteLoadCarriers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteLoadCarriers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteLoadCarriers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DeleteLoadCarriers_Request_TypeSupportInterface () {};
                ~Sample_DeleteLoadCarriers_Request_TypeSupportInterface () {};
            private:
                Sample_DeleteLoadCarriers_Request_TypeSupportInterface (const Sample_DeleteLoadCarriers_Request_TypeSupportInterface &);
                Sample_DeleteLoadCarriers_Request_TypeSupportInterface & operator = (const Sample_DeleteLoadCarriers_Request_TypeSupportInterface &);
            };

            class  Sample_DeleteLoadCarriers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DeleteLoadCarriers_Request_DataWriter_ptr _ptr_type;
                typedef Sample_DeleteLoadCarriers_Request_DataWriter_var _var_type;

                static Sample_DeleteLoadCarriers_Request_DataWriter_ptr _duplicate (Sample_DeleteLoadCarriers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteLoadCarriers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteLoadCarriers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DeleteLoadCarriers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DeleteLoadCarriers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DeleteLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteLoadCarriers_Request_& instance_data) = 0;

            protected:
                Sample_DeleteLoadCarriers_Request_DataWriter () {};
                ~Sample_DeleteLoadCarriers_Request_DataWriter () {};
            private:
                Sample_DeleteLoadCarriers_Request_DataWriter (const Sample_DeleteLoadCarriers_Request_DataWriter &);
                Sample_DeleteLoadCarriers_Request_DataWriter & operator = (const Sample_DeleteLoadCarriers_Request_DataWriter &);
            };

            class  Sample_DeleteLoadCarriers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DeleteLoadCarriers_Request_DataReader_ptr _ptr_type;
                typedef Sample_DeleteLoadCarriers_Request_DataReader_var _var_type;

                static Sample_DeleteLoadCarriers_Request_DataReader_ptr _duplicate (Sample_DeleteLoadCarriers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteLoadCarriers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteLoadCarriers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteLoadCarriers_Request_& instance) = 0;

            protected:
                Sample_DeleteLoadCarriers_Request_DataReader () {};
                ~Sample_DeleteLoadCarriers_Request_DataReader () {};
            private:
                Sample_DeleteLoadCarriers_Request_DataReader (const Sample_DeleteLoadCarriers_Request_DataReader &);
                Sample_DeleteLoadCarriers_Request_DataReader & operator = (const Sample_DeleteLoadCarriers_Request_DataReader &);
            };

            class  Sample_DeleteLoadCarriers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DeleteLoadCarriers_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_DeleteLoadCarriers_Request_DataReaderView_var _var_type;

                static Sample_DeleteLoadCarriers_Request_DataReaderView_ptr _duplicate (Sample_DeleteLoadCarriers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteLoadCarriers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteLoadCarriers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteLoadCarriers_Request_& instance) = 0;

            protected:
                Sample_DeleteLoadCarriers_Request_DataReaderView () {};
                ~Sample_DeleteLoadCarriers_Request_DataReaderView () {};
            private:
                Sample_DeleteLoadCarriers_Request_DataReaderView (const Sample_DeleteLoadCarriers_Request_DataReaderView &);
                Sample_DeleteLoadCarriers_Request_DataReaderView & operator = (const Sample_DeleteLoadCarriers_Request_DataReaderView &);
            };
            class Sample_DeleteLoadCarriers_Response_TypeSupportInterface;

            typedef Sample_DeleteLoadCarriers_Response_TypeSupportInterface * Sample_DeleteLoadCarriers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteLoadCarriers_Response_TypeSupportInterface> Sample_DeleteLoadCarriers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteLoadCarriers_Response_TypeSupportInterface> Sample_DeleteLoadCarriers_Response_TypeSupportInterface_out;


            class Sample_DeleteLoadCarriers_Response_DataWriter;

            typedef Sample_DeleteLoadCarriers_Response_DataWriter * Sample_DeleteLoadCarriers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteLoadCarriers_Response_DataWriter> Sample_DeleteLoadCarriers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteLoadCarriers_Response_DataWriter> Sample_DeleteLoadCarriers_Response_DataWriter_out;


            class Sample_DeleteLoadCarriers_Response_DataReader;

            typedef Sample_DeleteLoadCarriers_Response_DataReader * Sample_DeleteLoadCarriers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteLoadCarriers_Response_DataReader> Sample_DeleteLoadCarriers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteLoadCarriers_Response_DataReader> Sample_DeleteLoadCarriers_Response_DataReader_out;


            class Sample_DeleteLoadCarriers_Response_DataReaderView;

            typedef Sample_DeleteLoadCarriers_Response_DataReaderView * Sample_DeleteLoadCarriers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DeleteLoadCarriers_Response_DataReaderView> Sample_DeleteLoadCarriers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DeleteLoadCarriers_Response_DataReaderView> Sample_DeleteLoadCarriers_Response_DataReaderView_out;

            struct Sample_DeleteLoadCarriers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DeleteLoadCarriers_Response_, struct Sample_DeleteLoadCarriers_Response_Seq_uniq_> Sample_DeleteLoadCarriers_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_DeleteLoadCarriers_Response_Seq> Sample_DeleteLoadCarriers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DeleteLoadCarriers_Response_Seq> Sample_DeleteLoadCarriers_Response_Seq_out;

            class  Sample_DeleteLoadCarriers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DeleteLoadCarriers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DeleteLoadCarriers_Response_TypeSupportInterface_var _var_type;

                static Sample_DeleteLoadCarriers_Response_TypeSupportInterface_ptr _duplicate (Sample_DeleteLoadCarriers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteLoadCarriers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteLoadCarriers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DeleteLoadCarriers_Response_TypeSupportInterface () {};
                ~Sample_DeleteLoadCarriers_Response_TypeSupportInterface () {};
            private:
                Sample_DeleteLoadCarriers_Response_TypeSupportInterface (const Sample_DeleteLoadCarriers_Response_TypeSupportInterface &);
                Sample_DeleteLoadCarriers_Response_TypeSupportInterface & operator = (const Sample_DeleteLoadCarriers_Response_TypeSupportInterface &);
            };

            class  Sample_DeleteLoadCarriers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DeleteLoadCarriers_Response_DataWriter_ptr _ptr_type;
                typedef Sample_DeleteLoadCarriers_Response_DataWriter_var _var_type;

                static Sample_DeleteLoadCarriers_Response_DataWriter_ptr _duplicate (Sample_DeleteLoadCarriers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteLoadCarriers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteLoadCarriers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DeleteLoadCarriers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DeleteLoadCarriers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DeleteLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteLoadCarriers_Response_& instance_data) = 0;

            protected:
                Sample_DeleteLoadCarriers_Response_DataWriter () {};
                ~Sample_DeleteLoadCarriers_Response_DataWriter () {};
            private:
                Sample_DeleteLoadCarriers_Response_DataWriter (const Sample_DeleteLoadCarriers_Response_DataWriter &);
                Sample_DeleteLoadCarriers_Response_DataWriter & operator = (const Sample_DeleteLoadCarriers_Response_DataWriter &);
            };

            class  Sample_DeleteLoadCarriers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DeleteLoadCarriers_Response_DataReader_ptr _ptr_type;
                typedef Sample_DeleteLoadCarriers_Response_DataReader_var _var_type;

                static Sample_DeleteLoadCarriers_Response_DataReader_ptr _duplicate (Sample_DeleteLoadCarriers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteLoadCarriers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteLoadCarriers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteLoadCarriers_Response_& instance) = 0;

            protected:
                Sample_DeleteLoadCarriers_Response_DataReader () {};
                ~Sample_DeleteLoadCarriers_Response_DataReader () {};
            private:
                Sample_DeleteLoadCarriers_Response_DataReader (const Sample_DeleteLoadCarriers_Response_DataReader &);
                Sample_DeleteLoadCarriers_Response_DataReader & operator = (const Sample_DeleteLoadCarriers_Response_DataReader &);
            };

            class  Sample_DeleteLoadCarriers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DeleteLoadCarriers_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_DeleteLoadCarriers_Response_DataReaderView_var _var_type;

                static Sample_DeleteLoadCarriers_Response_DataReaderView_ptr _duplicate (Sample_DeleteLoadCarriers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DeleteLoadCarriers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DeleteLoadCarriers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DeleteLoadCarriers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DeleteLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DeleteLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DeleteLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DeleteLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DeleteLoadCarriers_Response_& instance) = 0;

            protected:
                Sample_DeleteLoadCarriers_Response_DataReaderView () {};
                ~Sample_DeleteLoadCarriers_Response_DataReaderView () {};
            private:
                Sample_DeleteLoadCarriers_Response_DataReaderView (const Sample_DeleteLoadCarriers_Response_DataReaderView &);
                Sample_DeleteLoadCarriers_Response_DataReaderView & operator = (const Sample_DeleteLoadCarriers_Response_DataReaderView &);
            };
        }

    }

}

#endif
