#ifndef _H_8BACBD1AACE913D19928C3592B4B0BBA_DeleteRegionsOfInterest3D__H_
#define _H_8BACBD1AACE913D19928C3592B4B0BBA_DeleteRegionsOfInterest3D__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  DeleteRegionsOfInterest3D_Request_
            {
                struct _region_of_interest_ids__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _region_of_interest_ids__seq_uniq_ > _region_of_interest_ids__seq;
                typedef DDS_DCPSUStrSeq_var< _region_of_interest_ids__seq > _region_of_interest_ids__seq_var;
                typedef DDS_DCPSUStrSeq_out< _region_of_interest_ids__seq > _region_of_interest_ids__seq_out;
                _region_of_interest_ids__seq region_of_interest_ids_;
            };

            typedef DDS_DCPSStruct_var<DeleteRegionsOfInterest3D_Request_> DeleteRegionsOfInterest3D_Request__var;
            typedef DDS_DCPSStruct_out < DeleteRegionsOfInterest3D_Request_> DeleteRegionsOfInterest3D_Request__out;

            struct  DeleteRegionsOfInterest3D_Response_
            {
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<DeleteRegionsOfInterest3D_Response_> DeleteRegionsOfInterest3D_Response__var;
            typedef DDS_DCPSStruct_out < DeleteRegionsOfInterest3D_Response_> DeleteRegionsOfInterest3D_Response__out;

            struct  Sample_DeleteRegionsOfInterest3D_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DeleteRegionsOfInterest3D_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_DeleteRegionsOfInterest3D_Request_> Sample_DeleteRegionsOfInterest3D_Request__var;
            typedef DDS_DCPSStruct_out < Sample_DeleteRegionsOfInterest3D_Request_> Sample_DeleteRegionsOfInterest3D_Request__out;

            struct  Sample_DeleteRegionsOfInterest3D_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DeleteRegionsOfInterest3D_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_DeleteRegionsOfInterest3D_Response_> Sample_DeleteRegionsOfInterest3D_Response__var;
            typedef DDS_DCPSStruct_out < Sample_DeleteRegionsOfInterest3D_Response_> Sample_DeleteRegionsOfInterest3D_Response__out;

        }

    }

}

#endif /* _H_8BACBD1AACE913D19928C3592B4B0BBA_DeleteRegionsOfInterest3D__H_ */
