#ifndef _H_2ADF26F633068B85CBA047959144856D_DetectFillingLevel_DCPS_H_
#define _H_2ADF26F633068B85CBA047959144856D_DetectFillingLevel_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DetectFillingLevel_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class DetectFillingLevel_Request_TypeSupportInterface;

            typedef DetectFillingLevel_Request_TypeSupportInterface * DetectFillingLevel_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectFillingLevel_Request_TypeSupportInterface> DetectFillingLevel_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectFillingLevel_Request_TypeSupportInterface> DetectFillingLevel_Request_TypeSupportInterface_out;


            class DetectFillingLevel_Request_DataWriter;

            typedef DetectFillingLevel_Request_DataWriter * DetectFillingLevel_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectFillingLevel_Request_DataWriter> DetectFillingLevel_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectFillingLevel_Request_DataWriter> DetectFillingLevel_Request_DataWriter_out;


            class DetectFillingLevel_Request_DataReader;

            typedef DetectFillingLevel_Request_DataReader * DetectFillingLevel_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectFillingLevel_Request_DataReader> DetectFillingLevel_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectFillingLevel_Request_DataReader> DetectFillingLevel_Request_DataReader_out;


            class DetectFillingLevel_Request_DataReaderView;

            typedef DetectFillingLevel_Request_DataReaderView * DetectFillingLevel_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectFillingLevel_Request_DataReaderView> DetectFillingLevel_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectFillingLevel_Request_DataReaderView> DetectFillingLevel_Request_DataReaderView_out;

            struct DetectFillingLevel_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DetectFillingLevel_Request_, struct DetectFillingLevel_Request_Seq_uniq_> DetectFillingLevel_Request_Seq;
            typedef DDS_DCPSSequence_var < DetectFillingLevel_Request_Seq> DetectFillingLevel_Request_Seq_var;
            typedef DDS_DCPSSequence_out < DetectFillingLevel_Request_Seq> DetectFillingLevel_Request_Seq_out;

            class  DetectFillingLevel_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectFillingLevel_Request_TypeSupportInterface_ptr _ptr_type;
                typedef DetectFillingLevel_Request_TypeSupportInterface_var _var_type;

                static DetectFillingLevel_Request_TypeSupportInterface_ptr _duplicate (DetectFillingLevel_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectFillingLevel_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectFillingLevel_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectFillingLevel_Request_TypeSupportInterface () {};
                ~DetectFillingLevel_Request_TypeSupportInterface () {};
            private:
                DetectFillingLevel_Request_TypeSupportInterface (const DetectFillingLevel_Request_TypeSupportInterface &);
                DetectFillingLevel_Request_TypeSupportInterface & operator = (const DetectFillingLevel_Request_TypeSupportInterface &);
            };

            class  DetectFillingLevel_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectFillingLevel_Request_DataWriter_ptr _ptr_type;
                typedef DetectFillingLevel_Request_DataWriter_var _var_type;

                static DetectFillingLevel_Request_DataWriter_ptr _duplicate (DetectFillingLevel_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectFillingLevel_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectFillingLevel_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectFillingLevel_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectFillingLevel_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectFillingLevel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectFillingLevel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectFillingLevel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectFillingLevel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectFillingLevel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectFillingLevel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectFillingLevel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectFillingLevel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectFillingLevel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectFillingLevel_Request_& instance_data) = 0;

            protected:
                DetectFillingLevel_Request_DataWriter () {};
                ~DetectFillingLevel_Request_DataWriter () {};
            private:
                DetectFillingLevel_Request_DataWriter (const DetectFillingLevel_Request_DataWriter &);
                DetectFillingLevel_Request_DataWriter & operator = (const DetectFillingLevel_Request_DataWriter &);
            };

            class  DetectFillingLevel_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectFillingLevel_Request_DataReader_ptr _ptr_type;
                typedef DetectFillingLevel_Request_DataReader_var _var_type;

                static DetectFillingLevel_Request_DataReader_ptr _duplicate (DetectFillingLevel_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectFillingLevel_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectFillingLevel_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectFillingLevel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectFillingLevel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectFillingLevel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectFillingLevel_Request_& instance) = 0;

            protected:
                DetectFillingLevel_Request_DataReader () {};
                ~DetectFillingLevel_Request_DataReader () {};
            private:
                DetectFillingLevel_Request_DataReader (const DetectFillingLevel_Request_DataReader &);
                DetectFillingLevel_Request_DataReader & operator = (const DetectFillingLevel_Request_DataReader &);
            };

            class  DetectFillingLevel_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectFillingLevel_Request_DataReaderView_ptr _ptr_type;
                typedef DetectFillingLevel_Request_DataReaderView_var _var_type;

                static DetectFillingLevel_Request_DataReaderView_ptr _duplicate (DetectFillingLevel_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectFillingLevel_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectFillingLevel_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectFillingLevel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectFillingLevel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectFillingLevel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectFillingLevel_Request_& instance) = 0;

            protected:
                DetectFillingLevel_Request_DataReaderView () {};
                ~DetectFillingLevel_Request_DataReaderView () {};
            private:
                DetectFillingLevel_Request_DataReaderView (const DetectFillingLevel_Request_DataReaderView &);
                DetectFillingLevel_Request_DataReaderView & operator = (const DetectFillingLevel_Request_DataReaderView &);
            };
            class DetectFillingLevel_Response_TypeSupportInterface;

            typedef DetectFillingLevel_Response_TypeSupportInterface * DetectFillingLevel_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectFillingLevel_Response_TypeSupportInterface> DetectFillingLevel_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectFillingLevel_Response_TypeSupportInterface> DetectFillingLevel_Response_TypeSupportInterface_out;


            class DetectFillingLevel_Response_DataWriter;

            typedef DetectFillingLevel_Response_DataWriter * DetectFillingLevel_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectFillingLevel_Response_DataWriter> DetectFillingLevel_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectFillingLevel_Response_DataWriter> DetectFillingLevel_Response_DataWriter_out;


            class DetectFillingLevel_Response_DataReader;

            typedef DetectFillingLevel_Response_DataReader * DetectFillingLevel_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectFillingLevel_Response_DataReader> DetectFillingLevel_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectFillingLevel_Response_DataReader> DetectFillingLevel_Response_DataReader_out;


            class DetectFillingLevel_Response_DataReaderView;

            typedef DetectFillingLevel_Response_DataReaderView * DetectFillingLevel_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectFillingLevel_Response_DataReaderView> DetectFillingLevel_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectFillingLevel_Response_DataReaderView> DetectFillingLevel_Response_DataReaderView_out;

            struct DetectFillingLevel_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DetectFillingLevel_Response_, struct DetectFillingLevel_Response_Seq_uniq_> DetectFillingLevel_Response_Seq;
            typedef DDS_DCPSSequence_var < DetectFillingLevel_Response_Seq> DetectFillingLevel_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DetectFillingLevel_Response_Seq> DetectFillingLevel_Response_Seq_out;

            class  DetectFillingLevel_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectFillingLevel_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DetectFillingLevel_Response_TypeSupportInterface_var _var_type;

                static DetectFillingLevel_Response_TypeSupportInterface_ptr _duplicate (DetectFillingLevel_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectFillingLevel_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectFillingLevel_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectFillingLevel_Response_TypeSupportInterface () {};
                ~DetectFillingLevel_Response_TypeSupportInterface () {};
            private:
                DetectFillingLevel_Response_TypeSupportInterface (const DetectFillingLevel_Response_TypeSupportInterface &);
                DetectFillingLevel_Response_TypeSupportInterface & operator = (const DetectFillingLevel_Response_TypeSupportInterface &);
            };

            class  DetectFillingLevel_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectFillingLevel_Response_DataWriter_ptr _ptr_type;
                typedef DetectFillingLevel_Response_DataWriter_var _var_type;

                static DetectFillingLevel_Response_DataWriter_ptr _duplicate (DetectFillingLevel_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectFillingLevel_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectFillingLevel_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectFillingLevel_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectFillingLevel_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectFillingLevel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectFillingLevel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectFillingLevel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectFillingLevel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectFillingLevel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectFillingLevel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectFillingLevel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectFillingLevel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectFillingLevel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectFillingLevel_Response_& instance_data) = 0;

            protected:
                DetectFillingLevel_Response_DataWriter () {};
                ~DetectFillingLevel_Response_DataWriter () {};
            private:
                DetectFillingLevel_Response_DataWriter (const DetectFillingLevel_Response_DataWriter &);
                DetectFillingLevel_Response_DataWriter & operator = (const DetectFillingLevel_Response_DataWriter &);
            };

            class  DetectFillingLevel_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectFillingLevel_Response_DataReader_ptr _ptr_type;
                typedef DetectFillingLevel_Response_DataReader_var _var_type;

                static DetectFillingLevel_Response_DataReader_ptr _duplicate (DetectFillingLevel_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectFillingLevel_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectFillingLevel_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectFillingLevel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectFillingLevel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectFillingLevel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectFillingLevel_Response_& instance) = 0;

            protected:
                DetectFillingLevel_Response_DataReader () {};
                ~DetectFillingLevel_Response_DataReader () {};
            private:
                DetectFillingLevel_Response_DataReader (const DetectFillingLevel_Response_DataReader &);
                DetectFillingLevel_Response_DataReader & operator = (const DetectFillingLevel_Response_DataReader &);
            };

            class  DetectFillingLevel_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectFillingLevel_Response_DataReaderView_ptr _ptr_type;
                typedef DetectFillingLevel_Response_DataReaderView_var _var_type;

                static DetectFillingLevel_Response_DataReaderView_ptr _duplicate (DetectFillingLevel_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectFillingLevel_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectFillingLevel_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectFillingLevel_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectFillingLevel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectFillingLevel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectFillingLevel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectFillingLevel_Response_& instance) = 0;

            protected:
                DetectFillingLevel_Response_DataReaderView () {};
                ~DetectFillingLevel_Response_DataReaderView () {};
            private:
                DetectFillingLevel_Response_DataReaderView (const DetectFillingLevel_Response_DataReaderView &);
                DetectFillingLevel_Response_DataReaderView & operator = (const DetectFillingLevel_Response_DataReaderView &);
            };
            class Sample_DetectFillingLevel_Request_TypeSupportInterface;

            typedef Sample_DetectFillingLevel_Request_TypeSupportInterface * Sample_DetectFillingLevel_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectFillingLevel_Request_TypeSupportInterface> Sample_DetectFillingLevel_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DetectFillingLevel_Request_TypeSupportInterface> Sample_DetectFillingLevel_Request_TypeSupportInterface_out;


            class Sample_DetectFillingLevel_Request_DataWriter;

            typedef Sample_DetectFillingLevel_Request_DataWriter * Sample_DetectFillingLevel_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectFillingLevel_Request_DataWriter> Sample_DetectFillingLevel_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DetectFillingLevel_Request_DataWriter> Sample_DetectFillingLevel_Request_DataWriter_out;


            class Sample_DetectFillingLevel_Request_DataReader;

            typedef Sample_DetectFillingLevel_Request_DataReader * Sample_DetectFillingLevel_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectFillingLevel_Request_DataReader> Sample_DetectFillingLevel_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DetectFillingLevel_Request_DataReader> Sample_DetectFillingLevel_Request_DataReader_out;


            class Sample_DetectFillingLevel_Request_DataReaderView;

            typedef Sample_DetectFillingLevel_Request_DataReaderView * Sample_DetectFillingLevel_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectFillingLevel_Request_DataReaderView> Sample_DetectFillingLevel_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DetectFillingLevel_Request_DataReaderView> Sample_DetectFillingLevel_Request_DataReaderView_out;

            struct Sample_DetectFillingLevel_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DetectFillingLevel_Request_, struct Sample_DetectFillingLevel_Request_Seq_uniq_> Sample_DetectFillingLevel_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_DetectFillingLevel_Request_Seq> Sample_DetectFillingLevel_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DetectFillingLevel_Request_Seq> Sample_DetectFillingLevel_Request_Seq_out;

            class  Sample_DetectFillingLevel_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DetectFillingLevel_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DetectFillingLevel_Request_TypeSupportInterface_var _var_type;

                static Sample_DetectFillingLevel_Request_TypeSupportInterface_ptr _duplicate (Sample_DetectFillingLevel_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectFillingLevel_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectFillingLevel_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DetectFillingLevel_Request_TypeSupportInterface () {};
                ~Sample_DetectFillingLevel_Request_TypeSupportInterface () {};
            private:
                Sample_DetectFillingLevel_Request_TypeSupportInterface (const Sample_DetectFillingLevel_Request_TypeSupportInterface &);
                Sample_DetectFillingLevel_Request_TypeSupportInterface & operator = (const Sample_DetectFillingLevel_Request_TypeSupportInterface &);
            };

            class  Sample_DetectFillingLevel_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DetectFillingLevel_Request_DataWriter_ptr _ptr_type;
                typedef Sample_DetectFillingLevel_Request_DataWriter_var _var_type;

                static Sample_DetectFillingLevel_Request_DataWriter_ptr _duplicate (Sample_DetectFillingLevel_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectFillingLevel_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectFillingLevel_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DetectFillingLevel_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DetectFillingLevel_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DetectFillingLevel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DetectFillingLevel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DetectFillingLevel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DetectFillingLevel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DetectFillingLevel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DetectFillingLevel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DetectFillingLevel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DetectFillingLevel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DetectFillingLevel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectFillingLevel_Request_& instance_data) = 0;

            protected:
                Sample_DetectFillingLevel_Request_DataWriter () {};
                ~Sample_DetectFillingLevel_Request_DataWriter () {};
            private:
                Sample_DetectFillingLevel_Request_DataWriter (const Sample_DetectFillingLevel_Request_DataWriter &);
                Sample_DetectFillingLevel_Request_DataWriter & operator = (const Sample_DetectFillingLevel_Request_DataWriter &);
            };

            class  Sample_DetectFillingLevel_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DetectFillingLevel_Request_DataReader_ptr _ptr_type;
                typedef Sample_DetectFillingLevel_Request_DataReader_var _var_type;

                static Sample_DetectFillingLevel_Request_DataReader_ptr _duplicate (Sample_DetectFillingLevel_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectFillingLevel_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectFillingLevel_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectFillingLevel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectFillingLevel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectFillingLevel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectFillingLevel_Request_& instance) = 0;

            protected:
                Sample_DetectFillingLevel_Request_DataReader () {};
                ~Sample_DetectFillingLevel_Request_DataReader () {};
            private:
                Sample_DetectFillingLevel_Request_DataReader (const Sample_DetectFillingLevel_Request_DataReader &);
                Sample_DetectFillingLevel_Request_DataReader & operator = (const Sample_DetectFillingLevel_Request_DataReader &);
            };

            class  Sample_DetectFillingLevel_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DetectFillingLevel_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_DetectFillingLevel_Request_DataReaderView_var _var_type;

                static Sample_DetectFillingLevel_Request_DataReaderView_ptr _duplicate (Sample_DetectFillingLevel_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectFillingLevel_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectFillingLevel_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectFillingLevel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectFillingLevel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectFillingLevel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectFillingLevel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectFillingLevel_Request_& instance) = 0;

            protected:
                Sample_DetectFillingLevel_Request_DataReaderView () {};
                ~Sample_DetectFillingLevel_Request_DataReaderView () {};
            private:
                Sample_DetectFillingLevel_Request_DataReaderView (const Sample_DetectFillingLevel_Request_DataReaderView &);
                Sample_DetectFillingLevel_Request_DataReaderView & operator = (const Sample_DetectFillingLevel_Request_DataReaderView &);
            };
            class Sample_DetectFillingLevel_Response_TypeSupportInterface;

            typedef Sample_DetectFillingLevel_Response_TypeSupportInterface * Sample_DetectFillingLevel_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectFillingLevel_Response_TypeSupportInterface> Sample_DetectFillingLevel_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DetectFillingLevel_Response_TypeSupportInterface> Sample_DetectFillingLevel_Response_TypeSupportInterface_out;


            class Sample_DetectFillingLevel_Response_DataWriter;

            typedef Sample_DetectFillingLevel_Response_DataWriter * Sample_DetectFillingLevel_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectFillingLevel_Response_DataWriter> Sample_DetectFillingLevel_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DetectFillingLevel_Response_DataWriter> Sample_DetectFillingLevel_Response_DataWriter_out;


            class Sample_DetectFillingLevel_Response_DataReader;

            typedef Sample_DetectFillingLevel_Response_DataReader * Sample_DetectFillingLevel_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectFillingLevel_Response_DataReader> Sample_DetectFillingLevel_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DetectFillingLevel_Response_DataReader> Sample_DetectFillingLevel_Response_DataReader_out;


            class Sample_DetectFillingLevel_Response_DataReaderView;

            typedef Sample_DetectFillingLevel_Response_DataReaderView * Sample_DetectFillingLevel_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectFillingLevel_Response_DataReaderView> Sample_DetectFillingLevel_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DetectFillingLevel_Response_DataReaderView> Sample_DetectFillingLevel_Response_DataReaderView_out;

            struct Sample_DetectFillingLevel_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DetectFillingLevel_Response_, struct Sample_DetectFillingLevel_Response_Seq_uniq_> Sample_DetectFillingLevel_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_DetectFillingLevel_Response_Seq> Sample_DetectFillingLevel_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DetectFillingLevel_Response_Seq> Sample_DetectFillingLevel_Response_Seq_out;

            class  Sample_DetectFillingLevel_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DetectFillingLevel_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DetectFillingLevel_Response_TypeSupportInterface_var _var_type;

                static Sample_DetectFillingLevel_Response_TypeSupportInterface_ptr _duplicate (Sample_DetectFillingLevel_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectFillingLevel_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectFillingLevel_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DetectFillingLevel_Response_TypeSupportInterface () {};
                ~Sample_DetectFillingLevel_Response_TypeSupportInterface () {};
            private:
                Sample_DetectFillingLevel_Response_TypeSupportInterface (const Sample_DetectFillingLevel_Response_TypeSupportInterface &);
                Sample_DetectFillingLevel_Response_TypeSupportInterface & operator = (const Sample_DetectFillingLevel_Response_TypeSupportInterface &);
            };

            class  Sample_DetectFillingLevel_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DetectFillingLevel_Response_DataWriter_ptr _ptr_type;
                typedef Sample_DetectFillingLevel_Response_DataWriter_var _var_type;

                static Sample_DetectFillingLevel_Response_DataWriter_ptr _duplicate (Sample_DetectFillingLevel_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectFillingLevel_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectFillingLevel_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DetectFillingLevel_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DetectFillingLevel_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DetectFillingLevel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DetectFillingLevel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DetectFillingLevel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DetectFillingLevel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DetectFillingLevel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DetectFillingLevel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DetectFillingLevel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DetectFillingLevel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DetectFillingLevel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectFillingLevel_Response_& instance_data) = 0;

            protected:
                Sample_DetectFillingLevel_Response_DataWriter () {};
                ~Sample_DetectFillingLevel_Response_DataWriter () {};
            private:
                Sample_DetectFillingLevel_Response_DataWriter (const Sample_DetectFillingLevel_Response_DataWriter &);
                Sample_DetectFillingLevel_Response_DataWriter & operator = (const Sample_DetectFillingLevel_Response_DataWriter &);
            };

            class  Sample_DetectFillingLevel_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DetectFillingLevel_Response_DataReader_ptr _ptr_type;
                typedef Sample_DetectFillingLevel_Response_DataReader_var _var_type;

                static Sample_DetectFillingLevel_Response_DataReader_ptr _duplicate (Sample_DetectFillingLevel_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectFillingLevel_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectFillingLevel_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectFillingLevel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectFillingLevel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectFillingLevel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectFillingLevel_Response_& instance) = 0;

            protected:
                Sample_DetectFillingLevel_Response_DataReader () {};
                ~Sample_DetectFillingLevel_Response_DataReader () {};
            private:
                Sample_DetectFillingLevel_Response_DataReader (const Sample_DetectFillingLevel_Response_DataReader &);
                Sample_DetectFillingLevel_Response_DataReader & operator = (const Sample_DetectFillingLevel_Response_DataReader &);
            };

            class  Sample_DetectFillingLevel_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DetectFillingLevel_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_DetectFillingLevel_Response_DataReaderView_var _var_type;

                static Sample_DetectFillingLevel_Response_DataReaderView_ptr _duplicate (Sample_DetectFillingLevel_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectFillingLevel_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectFillingLevel_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectFillingLevel_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectFillingLevel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectFillingLevel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectFillingLevel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectFillingLevel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectFillingLevel_Response_& instance) = 0;

            protected:
                Sample_DetectFillingLevel_Response_DataReaderView () {};
                ~Sample_DetectFillingLevel_Response_DataReaderView () {};
            private:
                Sample_DetectFillingLevel_Response_DataReaderView (const Sample_DetectFillingLevel_Response_DataReaderView &);
                Sample_DetectFillingLevel_Response_DataReaderView & operator = (const Sample_DetectFillingLevel_Response_DataReaderView &);
            };
        }

    }

}

#endif
