#ifndef _H_7CF64F99DC6D41084FE00DC34064F962_GetLoadCarriers_DCPS_H_
#define _H_7CF64F99DC6D41084FE00DC34064F962_GetLoadCarriers_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetLoadCarriers_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetLoadCarriers_Request_TypeSupportInterface;

            typedef GetLoadCarriers_Request_TypeSupportInterface * GetLoadCarriers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetLoadCarriers_Request_TypeSupportInterface> GetLoadCarriers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetLoadCarriers_Request_TypeSupportInterface> GetLoadCarriers_Request_TypeSupportInterface_out;


            class GetLoadCarriers_Request_DataWriter;

            typedef GetLoadCarriers_Request_DataWriter * GetLoadCarriers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetLoadCarriers_Request_DataWriter> GetLoadCarriers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetLoadCarriers_Request_DataWriter> GetLoadCarriers_Request_DataWriter_out;


            class GetLoadCarriers_Request_DataReader;

            typedef GetLoadCarriers_Request_DataReader * GetLoadCarriers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetLoadCarriers_Request_DataReader> GetLoadCarriers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetLoadCarriers_Request_DataReader> GetLoadCarriers_Request_DataReader_out;


            class GetLoadCarriers_Request_DataReaderView;

            typedef GetLoadCarriers_Request_DataReaderView * GetLoadCarriers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetLoadCarriers_Request_DataReaderView> GetLoadCarriers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetLoadCarriers_Request_DataReaderView> GetLoadCarriers_Request_DataReaderView_out;

            struct GetLoadCarriers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetLoadCarriers_Request_, struct GetLoadCarriers_Request_Seq_uniq_> GetLoadCarriers_Request_Seq;
            typedef DDS_DCPSSequence_var < GetLoadCarriers_Request_Seq> GetLoadCarriers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetLoadCarriers_Request_Seq> GetLoadCarriers_Request_Seq_out;

            class  GetLoadCarriers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetLoadCarriers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetLoadCarriers_Request_TypeSupportInterface_var _var_type;

                static GetLoadCarriers_Request_TypeSupportInterface_ptr _duplicate (GetLoadCarriers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLoadCarriers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLoadCarriers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetLoadCarriers_Request_TypeSupportInterface () {};
                ~GetLoadCarriers_Request_TypeSupportInterface () {};
            private:
                GetLoadCarriers_Request_TypeSupportInterface (const GetLoadCarriers_Request_TypeSupportInterface &);
                GetLoadCarriers_Request_TypeSupportInterface & operator = (const GetLoadCarriers_Request_TypeSupportInterface &);
            };

            class  GetLoadCarriers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetLoadCarriers_Request_DataWriter_ptr _ptr_type;
                typedef GetLoadCarriers_Request_DataWriter_var _var_type;

                static GetLoadCarriers_Request_DataWriter_ptr _duplicate (GetLoadCarriers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLoadCarriers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLoadCarriers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetLoadCarriers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetLoadCarriers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLoadCarriers_Request_& instance_data) = 0;

            protected:
                GetLoadCarriers_Request_DataWriter () {};
                ~GetLoadCarriers_Request_DataWriter () {};
            private:
                GetLoadCarriers_Request_DataWriter (const GetLoadCarriers_Request_DataWriter &);
                GetLoadCarriers_Request_DataWriter & operator = (const GetLoadCarriers_Request_DataWriter &);
            };

            class  GetLoadCarriers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetLoadCarriers_Request_DataReader_ptr _ptr_type;
                typedef GetLoadCarriers_Request_DataReader_var _var_type;

                static GetLoadCarriers_Request_DataReader_ptr _duplicate (GetLoadCarriers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLoadCarriers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLoadCarriers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLoadCarriers_Request_& instance) = 0;

            protected:
                GetLoadCarriers_Request_DataReader () {};
                ~GetLoadCarriers_Request_DataReader () {};
            private:
                GetLoadCarriers_Request_DataReader (const GetLoadCarriers_Request_DataReader &);
                GetLoadCarriers_Request_DataReader & operator = (const GetLoadCarriers_Request_DataReader &);
            };

            class  GetLoadCarriers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetLoadCarriers_Request_DataReaderView_ptr _ptr_type;
                typedef GetLoadCarriers_Request_DataReaderView_var _var_type;

                static GetLoadCarriers_Request_DataReaderView_ptr _duplicate (GetLoadCarriers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLoadCarriers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLoadCarriers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLoadCarriers_Request_& instance) = 0;

            protected:
                GetLoadCarriers_Request_DataReaderView () {};
                ~GetLoadCarriers_Request_DataReaderView () {};
            private:
                GetLoadCarriers_Request_DataReaderView (const GetLoadCarriers_Request_DataReaderView &);
                GetLoadCarriers_Request_DataReaderView & operator = (const GetLoadCarriers_Request_DataReaderView &);
            };
            class GetLoadCarriers_Response_TypeSupportInterface;

            typedef GetLoadCarriers_Response_TypeSupportInterface * GetLoadCarriers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetLoadCarriers_Response_TypeSupportInterface> GetLoadCarriers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetLoadCarriers_Response_TypeSupportInterface> GetLoadCarriers_Response_TypeSupportInterface_out;


            class GetLoadCarriers_Response_DataWriter;

            typedef GetLoadCarriers_Response_DataWriter * GetLoadCarriers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetLoadCarriers_Response_DataWriter> GetLoadCarriers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetLoadCarriers_Response_DataWriter> GetLoadCarriers_Response_DataWriter_out;


            class GetLoadCarriers_Response_DataReader;

            typedef GetLoadCarriers_Response_DataReader * GetLoadCarriers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetLoadCarriers_Response_DataReader> GetLoadCarriers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetLoadCarriers_Response_DataReader> GetLoadCarriers_Response_DataReader_out;


            class GetLoadCarriers_Response_DataReaderView;

            typedef GetLoadCarriers_Response_DataReaderView * GetLoadCarriers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetLoadCarriers_Response_DataReaderView> GetLoadCarriers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetLoadCarriers_Response_DataReaderView> GetLoadCarriers_Response_DataReaderView_out;

            struct GetLoadCarriers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetLoadCarriers_Response_, struct GetLoadCarriers_Response_Seq_uniq_> GetLoadCarriers_Response_Seq;
            typedef DDS_DCPSSequence_var < GetLoadCarriers_Response_Seq> GetLoadCarriers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetLoadCarriers_Response_Seq> GetLoadCarriers_Response_Seq_out;

            class  GetLoadCarriers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetLoadCarriers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetLoadCarriers_Response_TypeSupportInterface_var _var_type;

                static GetLoadCarriers_Response_TypeSupportInterface_ptr _duplicate (GetLoadCarriers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLoadCarriers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLoadCarriers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetLoadCarriers_Response_TypeSupportInterface () {};
                ~GetLoadCarriers_Response_TypeSupportInterface () {};
            private:
                GetLoadCarriers_Response_TypeSupportInterface (const GetLoadCarriers_Response_TypeSupportInterface &);
                GetLoadCarriers_Response_TypeSupportInterface & operator = (const GetLoadCarriers_Response_TypeSupportInterface &);
            };

            class  GetLoadCarriers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetLoadCarriers_Response_DataWriter_ptr _ptr_type;
                typedef GetLoadCarriers_Response_DataWriter_var _var_type;

                static GetLoadCarriers_Response_DataWriter_ptr _duplicate (GetLoadCarriers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLoadCarriers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLoadCarriers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetLoadCarriers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetLoadCarriers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLoadCarriers_Response_& instance_data) = 0;

            protected:
                GetLoadCarriers_Response_DataWriter () {};
                ~GetLoadCarriers_Response_DataWriter () {};
            private:
                GetLoadCarriers_Response_DataWriter (const GetLoadCarriers_Response_DataWriter &);
                GetLoadCarriers_Response_DataWriter & operator = (const GetLoadCarriers_Response_DataWriter &);
            };

            class  GetLoadCarriers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetLoadCarriers_Response_DataReader_ptr _ptr_type;
                typedef GetLoadCarriers_Response_DataReader_var _var_type;

                static GetLoadCarriers_Response_DataReader_ptr _duplicate (GetLoadCarriers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLoadCarriers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLoadCarriers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLoadCarriers_Response_& instance) = 0;

            protected:
                GetLoadCarriers_Response_DataReader () {};
                ~GetLoadCarriers_Response_DataReader () {};
            private:
                GetLoadCarriers_Response_DataReader (const GetLoadCarriers_Response_DataReader &);
                GetLoadCarriers_Response_DataReader & operator = (const GetLoadCarriers_Response_DataReader &);
            };

            class  GetLoadCarriers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetLoadCarriers_Response_DataReaderView_ptr _ptr_type;
                typedef GetLoadCarriers_Response_DataReaderView_var _var_type;

                static GetLoadCarriers_Response_DataReaderView_ptr _duplicate (GetLoadCarriers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetLoadCarriers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetLoadCarriers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetLoadCarriers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetLoadCarriers_Response_& instance) = 0;

            protected:
                GetLoadCarriers_Response_DataReaderView () {};
                ~GetLoadCarriers_Response_DataReaderView () {};
            private:
                GetLoadCarriers_Response_DataReaderView (const GetLoadCarriers_Response_DataReaderView &);
                GetLoadCarriers_Response_DataReaderView & operator = (const GetLoadCarriers_Response_DataReaderView &);
            };
            class Sample_GetLoadCarriers_Request_TypeSupportInterface;

            typedef Sample_GetLoadCarriers_Request_TypeSupportInterface * Sample_GetLoadCarriers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetLoadCarriers_Request_TypeSupportInterface> Sample_GetLoadCarriers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetLoadCarriers_Request_TypeSupportInterface> Sample_GetLoadCarriers_Request_TypeSupportInterface_out;


            class Sample_GetLoadCarriers_Request_DataWriter;

            typedef Sample_GetLoadCarriers_Request_DataWriter * Sample_GetLoadCarriers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetLoadCarriers_Request_DataWriter> Sample_GetLoadCarriers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetLoadCarriers_Request_DataWriter> Sample_GetLoadCarriers_Request_DataWriter_out;


            class Sample_GetLoadCarriers_Request_DataReader;

            typedef Sample_GetLoadCarriers_Request_DataReader * Sample_GetLoadCarriers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetLoadCarriers_Request_DataReader> Sample_GetLoadCarriers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetLoadCarriers_Request_DataReader> Sample_GetLoadCarriers_Request_DataReader_out;


            class Sample_GetLoadCarriers_Request_DataReaderView;

            typedef Sample_GetLoadCarriers_Request_DataReaderView * Sample_GetLoadCarriers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetLoadCarriers_Request_DataReaderView> Sample_GetLoadCarriers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetLoadCarriers_Request_DataReaderView> Sample_GetLoadCarriers_Request_DataReaderView_out;

            struct Sample_GetLoadCarriers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetLoadCarriers_Request_, struct Sample_GetLoadCarriers_Request_Seq_uniq_> Sample_GetLoadCarriers_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetLoadCarriers_Request_Seq> Sample_GetLoadCarriers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetLoadCarriers_Request_Seq> Sample_GetLoadCarriers_Request_Seq_out;

            class  Sample_GetLoadCarriers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetLoadCarriers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetLoadCarriers_Request_TypeSupportInterface_var _var_type;

                static Sample_GetLoadCarriers_Request_TypeSupportInterface_ptr _duplicate (Sample_GetLoadCarriers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetLoadCarriers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetLoadCarriers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetLoadCarriers_Request_TypeSupportInterface () {};
                ~Sample_GetLoadCarriers_Request_TypeSupportInterface () {};
            private:
                Sample_GetLoadCarriers_Request_TypeSupportInterface (const Sample_GetLoadCarriers_Request_TypeSupportInterface &);
                Sample_GetLoadCarriers_Request_TypeSupportInterface & operator = (const Sample_GetLoadCarriers_Request_TypeSupportInterface &);
            };

            class  Sample_GetLoadCarriers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetLoadCarriers_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetLoadCarriers_Request_DataWriter_var _var_type;

                static Sample_GetLoadCarriers_Request_DataWriter_ptr _duplicate (Sample_GetLoadCarriers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetLoadCarriers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetLoadCarriers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetLoadCarriers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetLoadCarriers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetLoadCarriers_Request_& instance_data) = 0;

            protected:
                Sample_GetLoadCarriers_Request_DataWriter () {};
                ~Sample_GetLoadCarriers_Request_DataWriter () {};
            private:
                Sample_GetLoadCarriers_Request_DataWriter (const Sample_GetLoadCarriers_Request_DataWriter &);
                Sample_GetLoadCarriers_Request_DataWriter & operator = (const Sample_GetLoadCarriers_Request_DataWriter &);
            };

            class  Sample_GetLoadCarriers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetLoadCarriers_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetLoadCarriers_Request_DataReader_var _var_type;

                static Sample_GetLoadCarriers_Request_DataReader_ptr _duplicate (Sample_GetLoadCarriers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetLoadCarriers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetLoadCarriers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetLoadCarriers_Request_& instance) = 0;

            protected:
                Sample_GetLoadCarriers_Request_DataReader () {};
                ~Sample_GetLoadCarriers_Request_DataReader () {};
            private:
                Sample_GetLoadCarriers_Request_DataReader (const Sample_GetLoadCarriers_Request_DataReader &);
                Sample_GetLoadCarriers_Request_DataReader & operator = (const Sample_GetLoadCarriers_Request_DataReader &);
            };

            class  Sample_GetLoadCarriers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetLoadCarriers_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetLoadCarriers_Request_DataReaderView_var _var_type;

                static Sample_GetLoadCarriers_Request_DataReaderView_ptr _duplicate (Sample_GetLoadCarriers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetLoadCarriers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetLoadCarriers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetLoadCarriers_Request_& instance) = 0;

            protected:
                Sample_GetLoadCarriers_Request_DataReaderView () {};
                ~Sample_GetLoadCarriers_Request_DataReaderView () {};
            private:
                Sample_GetLoadCarriers_Request_DataReaderView (const Sample_GetLoadCarriers_Request_DataReaderView &);
                Sample_GetLoadCarriers_Request_DataReaderView & operator = (const Sample_GetLoadCarriers_Request_DataReaderView &);
            };
            class Sample_GetLoadCarriers_Response_TypeSupportInterface;

            typedef Sample_GetLoadCarriers_Response_TypeSupportInterface * Sample_GetLoadCarriers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetLoadCarriers_Response_TypeSupportInterface> Sample_GetLoadCarriers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetLoadCarriers_Response_TypeSupportInterface> Sample_GetLoadCarriers_Response_TypeSupportInterface_out;


            class Sample_GetLoadCarriers_Response_DataWriter;

            typedef Sample_GetLoadCarriers_Response_DataWriter * Sample_GetLoadCarriers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetLoadCarriers_Response_DataWriter> Sample_GetLoadCarriers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetLoadCarriers_Response_DataWriter> Sample_GetLoadCarriers_Response_DataWriter_out;


            class Sample_GetLoadCarriers_Response_DataReader;

            typedef Sample_GetLoadCarriers_Response_DataReader * Sample_GetLoadCarriers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetLoadCarriers_Response_DataReader> Sample_GetLoadCarriers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetLoadCarriers_Response_DataReader> Sample_GetLoadCarriers_Response_DataReader_out;


            class Sample_GetLoadCarriers_Response_DataReaderView;

            typedef Sample_GetLoadCarriers_Response_DataReaderView * Sample_GetLoadCarriers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetLoadCarriers_Response_DataReaderView> Sample_GetLoadCarriers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetLoadCarriers_Response_DataReaderView> Sample_GetLoadCarriers_Response_DataReaderView_out;

            struct Sample_GetLoadCarriers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetLoadCarriers_Response_, struct Sample_GetLoadCarriers_Response_Seq_uniq_> Sample_GetLoadCarriers_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetLoadCarriers_Response_Seq> Sample_GetLoadCarriers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetLoadCarriers_Response_Seq> Sample_GetLoadCarriers_Response_Seq_out;

            class  Sample_GetLoadCarriers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetLoadCarriers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetLoadCarriers_Response_TypeSupportInterface_var _var_type;

                static Sample_GetLoadCarriers_Response_TypeSupportInterface_ptr _duplicate (Sample_GetLoadCarriers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetLoadCarriers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetLoadCarriers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetLoadCarriers_Response_TypeSupportInterface () {};
                ~Sample_GetLoadCarriers_Response_TypeSupportInterface () {};
            private:
                Sample_GetLoadCarriers_Response_TypeSupportInterface (const Sample_GetLoadCarriers_Response_TypeSupportInterface &);
                Sample_GetLoadCarriers_Response_TypeSupportInterface & operator = (const Sample_GetLoadCarriers_Response_TypeSupportInterface &);
            };

            class  Sample_GetLoadCarriers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetLoadCarriers_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetLoadCarriers_Response_DataWriter_var _var_type;

                static Sample_GetLoadCarriers_Response_DataWriter_ptr _duplicate (Sample_GetLoadCarriers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetLoadCarriers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetLoadCarriers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetLoadCarriers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetLoadCarriers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetLoadCarriers_Response_& instance_data) = 0;

            protected:
                Sample_GetLoadCarriers_Response_DataWriter () {};
                ~Sample_GetLoadCarriers_Response_DataWriter () {};
            private:
                Sample_GetLoadCarriers_Response_DataWriter (const Sample_GetLoadCarriers_Response_DataWriter &);
                Sample_GetLoadCarriers_Response_DataWriter & operator = (const Sample_GetLoadCarriers_Response_DataWriter &);
            };

            class  Sample_GetLoadCarriers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetLoadCarriers_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetLoadCarriers_Response_DataReader_var _var_type;

                static Sample_GetLoadCarriers_Response_DataReader_ptr _duplicate (Sample_GetLoadCarriers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetLoadCarriers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetLoadCarriers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetLoadCarriers_Response_& instance) = 0;

            protected:
                Sample_GetLoadCarriers_Response_DataReader () {};
                ~Sample_GetLoadCarriers_Response_DataReader () {};
            private:
                Sample_GetLoadCarriers_Response_DataReader (const Sample_GetLoadCarriers_Response_DataReader &);
                Sample_GetLoadCarriers_Response_DataReader & operator = (const Sample_GetLoadCarriers_Response_DataReader &);
            };

            class  Sample_GetLoadCarriers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetLoadCarriers_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetLoadCarriers_Response_DataReaderView_var _var_type;

                static Sample_GetLoadCarriers_Response_DataReaderView_ptr _duplicate (Sample_GetLoadCarriers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetLoadCarriers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetLoadCarriers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetLoadCarriers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetLoadCarriers_Response_& instance) = 0;

            protected:
                Sample_GetLoadCarriers_Response_DataReaderView () {};
                ~Sample_GetLoadCarriers_Response_DataReaderView () {};
            private:
                Sample_GetLoadCarriers_Response_DataReaderView (const Sample_GetLoadCarriers_Response_DataReaderView &);
                Sample_GetLoadCarriers_Response_DataReaderView & operator = (const Sample_GetLoadCarriers_Response_DataReaderView &);
            };
        }

    }

}

#endif
