#ifndef _H_4E6966AF1534183B759B11814EE4CA93_GetRegionsOfInterest2D__H_
#define _H_4E6966AF1534183B759B11814EE4CA93_GetRegionsOfInterest2D__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/RegionOfInterest2D_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetRegionsOfInterest2D_Request_
            {
                struct _region_of_interest_2d_ids__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _region_of_interest_2d_ids__seq_uniq_ > _region_of_interest_2d_ids__seq;
                typedef DDS_DCPSUStrSeq_var< _region_of_interest_2d_ids__seq > _region_of_interest_2d_ids__seq_var;
                typedef DDS_DCPSUStrSeq_out< _region_of_interest_2d_ids__seq > _region_of_interest_2d_ids__seq_out;
                _region_of_interest_2d_ids__seq region_of_interest_2d_ids_;
            };

            typedef DDS_DCPSStruct_var<GetRegionsOfInterest2D_Request_> GetRegionsOfInterest2D_Request__var;
            typedef DDS_DCPSStruct_out < GetRegionsOfInterest2D_Request_> GetRegionsOfInterest2D_Request__out;

            struct  GetRegionsOfInterest2D_Response_
            {
                struct _regions_of_interest__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_reason_msgs::msg::dds_::RegionOfInterest2D_, struct _regions_of_interest__seq_uniq_ > _regions_of_interest__seq;
                typedef DDS_DCPSSequence_var< _regions_of_interest__seq > _regions_of_interest__seq_var;
                typedef DDS_DCPSSequence_out< _regions_of_interest__seq > _regions_of_interest__seq_out;
                _regions_of_interest__seq regions_of_interest_;
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<GetRegionsOfInterest2D_Response_> GetRegionsOfInterest2D_Response__var;
            typedef DDS_DCPSStruct_out < GetRegionsOfInterest2D_Response_> GetRegionsOfInterest2D_Response__out;

            struct  Sample_GetRegionsOfInterest2D_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::GetRegionsOfInterest2D_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetRegionsOfInterest2D_Request_> Sample_GetRegionsOfInterest2D_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetRegionsOfInterest2D_Request_> Sample_GetRegionsOfInterest2D_Request__out;

            struct  Sample_GetRegionsOfInterest2D_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::GetRegionsOfInterest2D_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetRegionsOfInterest2D_Response_> Sample_GetRegionsOfInterest2D_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetRegionsOfInterest2D_Response_> Sample_GetRegionsOfInterest2D_Response__out;

        }

    }

}

#endif /* _H_4E6966AF1534183B759B11814EE4CA93_GetRegionsOfInterest2D__H_ */
