#ifndef _H_4E6966AF1534183B759B11814EE4CA93_GetRegionsOfInterest2D_DCPS_H_
#define _H_4E6966AF1534183B759B11814EE4CA93_GetRegionsOfInterest2D_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetRegionsOfInterest2D_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetRegionsOfInterest2D_Request_TypeSupportInterface;

            typedef GetRegionsOfInterest2D_Request_TypeSupportInterface * GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetRegionsOfInterest2D_Request_TypeSupportInterface> GetRegionsOfInterest2D_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetRegionsOfInterest2D_Request_TypeSupportInterface> GetRegionsOfInterest2D_Request_TypeSupportInterface_out;


            class GetRegionsOfInterest2D_Request_DataWriter;

            typedef GetRegionsOfInterest2D_Request_DataWriter * GetRegionsOfInterest2D_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetRegionsOfInterest2D_Request_DataWriter> GetRegionsOfInterest2D_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetRegionsOfInterest2D_Request_DataWriter> GetRegionsOfInterest2D_Request_DataWriter_out;


            class GetRegionsOfInterest2D_Request_DataReader;

            typedef GetRegionsOfInterest2D_Request_DataReader * GetRegionsOfInterest2D_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetRegionsOfInterest2D_Request_DataReader> GetRegionsOfInterest2D_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetRegionsOfInterest2D_Request_DataReader> GetRegionsOfInterest2D_Request_DataReader_out;


            class GetRegionsOfInterest2D_Request_DataReaderView;

            typedef GetRegionsOfInterest2D_Request_DataReaderView * GetRegionsOfInterest2D_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetRegionsOfInterest2D_Request_DataReaderView> GetRegionsOfInterest2D_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetRegionsOfInterest2D_Request_DataReaderView> GetRegionsOfInterest2D_Request_DataReaderView_out;

            struct GetRegionsOfInterest2D_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetRegionsOfInterest2D_Request_, struct GetRegionsOfInterest2D_Request_Seq_uniq_> GetRegionsOfInterest2D_Request_Seq;
            typedef DDS_DCPSSequence_var < GetRegionsOfInterest2D_Request_Seq> GetRegionsOfInterest2D_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetRegionsOfInterest2D_Request_Seq> GetRegionsOfInterest2D_Request_Seq_out;

            class  GetRegionsOfInterest2D_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetRegionsOfInterest2D_Request_TypeSupportInterface_var _var_type;

                static GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _duplicate (GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetRegionsOfInterest2D_Request_TypeSupportInterface () {};
                ~GetRegionsOfInterest2D_Request_TypeSupportInterface () {};
            private:
                GetRegionsOfInterest2D_Request_TypeSupportInterface (const GetRegionsOfInterest2D_Request_TypeSupportInterface &);
                GetRegionsOfInterest2D_Request_TypeSupportInterface & operator = (const GetRegionsOfInterest2D_Request_TypeSupportInterface &);
            };

            class  GetRegionsOfInterest2D_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetRegionsOfInterest2D_Request_DataWriter_ptr _ptr_type;
                typedef GetRegionsOfInterest2D_Request_DataWriter_var _var_type;

                static GetRegionsOfInterest2D_Request_DataWriter_ptr _duplicate (GetRegionsOfInterest2D_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRegionsOfInterest2D_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRegionsOfInterest2D_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetRegionsOfInterest2D_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetRegionsOfInterest2D_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetRegionsOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRegionsOfInterest2D_Request_& instance_data) = 0;

            protected:
                GetRegionsOfInterest2D_Request_DataWriter () {};
                ~GetRegionsOfInterest2D_Request_DataWriter () {};
            private:
                GetRegionsOfInterest2D_Request_DataWriter (const GetRegionsOfInterest2D_Request_DataWriter &);
                GetRegionsOfInterest2D_Request_DataWriter & operator = (const GetRegionsOfInterest2D_Request_DataWriter &);
            };

            class  GetRegionsOfInterest2D_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetRegionsOfInterest2D_Request_DataReader_ptr _ptr_type;
                typedef GetRegionsOfInterest2D_Request_DataReader_var _var_type;

                static GetRegionsOfInterest2D_Request_DataReader_ptr _duplicate (GetRegionsOfInterest2D_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRegionsOfInterest2D_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRegionsOfInterest2D_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRegionsOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRegionsOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRegionsOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRegionsOfInterest2D_Request_& instance) = 0;

            protected:
                GetRegionsOfInterest2D_Request_DataReader () {};
                ~GetRegionsOfInterest2D_Request_DataReader () {};
            private:
                GetRegionsOfInterest2D_Request_DataReader (const GetRegionsOfInterest2D_Request_DataReader &);
                GetRegionsOfInterest2D_Request_DataReader & operator = (const GetRegionsOfInterest2D_Request_DataReader &);
            };

            class  GetRegionsOfInterest2D_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetRegionsOfInterest2D_Request_DataReaderView_ptr _ptr_type;
                typedef GetRegionsOfInterest2D_Request_DataReaderView_var _var_type;

                static GetRegionsOfInterest2D_Request_DataReaderView_ptr _duplicate (GetRegionsOfInterest2D_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRegionsOfInterest2D_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRegionsOfInterest2D_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRegionsOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRegionsOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRegionsOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRegionsOfInterest2D_Request_& instance) = 0;

            protected:
                GetRegionsOfInterest2D_Request_DataReaderView () {};
                ~GetRegionsOfInterest2D_Request_DataReaderView () {};
            private:
                GetRegionsOfInterest2D_Request_DataReaderView (const GetRegionsOfInterest2D_Request_DataReaderView &);
                GetRegionsOfInterest2D_Request_DataReaderView & operator = (const GetRegionsOfInterest2D_Request_DataReaderView &);
            };
            class GetRegionsOfInterest2D_Response_TypeSupportInterface;

            typedef GetRegionsOfInterest2D_Response_TypeSupportInterface * GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetRegionsOfInterest2D_Response_TypeSupportInterface> GetRegionsOfInterest2D_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetRegionsOfInterest2D_Response_TypeSupportInterface> GetRegionsOfInterest2D_Response_TypeSupportInterface_out;


            class GetRegionsOfInterest2D_Response_DataWriter;

            typedef GetRegionsOfInterest2D_Response_DataWriter * GetRegionsOfInterest2D_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetRegionsOfInterest2D_Response_DataWriter> GetRegionsOfInterest2D_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetRegionsOfInterest2D_Response_DataWriter> GetRegionsOfInterest2D_Response_DataWriter_out;


            class GetRegionsOfInterest2D_Response_DataReader;

            typedef GetRegionsOfInterest2D_Response_DataReader * GetRegionsOfInterest2D_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetRegionsOfInterest2D_Response_DataReader> GetRegionsOfInterest2D_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetRegionsOfInterest2D_Response_DataReader> GetRegionsOfInterest2D_Response_DataReader_out;


            class GetRegionsOfInterest2D_Response_DataReaderView;

            typedef GetRegionsOfInterest2D_Response_DataReaderView * GetRegionsOfInterest2D_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetRegionsOfInterest2D_Response_DataReaderView> GetRegionsOfInterest2D_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetRegionsOfInterest2D_Response_DataReaderView> GetRegionsOfInterest2D_Response_DataReaderView_out;

            struct GetRegionsOfInterest2D_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetRegionsOfInterest2D_Response_, struct GetRegionsOfInterest2D_Response_Seq_uniq_> GetRegionsOfInterest2D_Response_Seq;
            typedef DDS_DCPSSequence_var < GetRegionsOfInterest2D_Response_Seq> GetRegionsOfInterest2D_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetRegionsOfInterest2D_Response_Seq> GetRegionsOfInterest2D_Response_Seq_out;

            class  GetRegionsOfInterest2D_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetRegionsOfInterest2D_Response_TypeSupportInterface_var _var_type;

                static GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _duplicate (GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetRegionsOfInterest2D_Response_TypeSupportInterface () {};
                ~GetRegionsOfInterest2D_Response_TypeSupportInterface () {};
            private:
                GetRegionsOfInterest2D_Response_TypeSupportInterface (const GetRegionsOfInterest2D_Response_TypeSupportInterface &);
                GetRegionsOfInterest2D_Response_TypeSupportInterface & operator = (const GetRegionsOfInterest2D_Response_TypeSupportInterface &);
            };

            class  GetRegionsOfInterest2D_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetRegionsOfInterest2D_Response_DataWriter_ptr _ptr_type;
                typedef GetRegionsOfInterest2D_Response_DataWriter_var _var_type;

                static GetRegionsOfInterest2D_Response_DataWriter_ptr _duplicate (GetRegionsOfInterest2D_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRegionsOfInterest2D_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRegionsOfInterest2D_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetRegionsOfInterest2D_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetRegionsOfInterest2D_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetRegionsOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRegionsOfInterest2D_Response_& instance_data) = 0;

            protected:
                GetRegionsOfInterest2D_Response_DataWriter () {};
                ~GetRegionsOfInterest2D_Response_DataWriter () {};
            private:
                GetRegionsOfInterest2D_Response_DataWriter (const GetRegionsOfInterest2D_Response_DataWriter &);
                GetRegionsOfInterest2D_Response_DataWriter & operator = (const GetRegionsOfInterest2D_Response_DataWriter &);
            };

            class  GetRegionsOfInterest2D_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetRegionsOfInterest2D_Response_DataReader_ptr _ptr_type;
                typedef GetRegionsOfInterest2D_Response_DataReader_var _var_type;

                static GetRegionsOfInterest2D_Response_DataReader_ptr _duplicate (GetRegionsOfInterest2D_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRegionsOfInterest2D_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRegionsOfInterest2D_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRegionsOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRegionsOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRegionsOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRegionsOfInterest2D_Response_& instance) = 0;

            protected:
                GetRegionsOfInterest2D_Response_DataReader () {};
                ~GetRegionsOfInterest2D_Response_DataReader () {};
            private:
                GetRegionsOfInterest2D_Response_DataReader (const GetRegionsOfInterest2D_Response_DataReader &);
                GetRegionsOfInterest2D_Response_DataReader & operator = (const GetRegionsOfInterest2D_Response_DataReader &);
            };

            class  GetRegionsOfInterest2D_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetRegionsOfInterest2D_Response_DataReaderView_ptr _ptr_type;
                typedef GetRegionsOfInterest2D_Response_DataReaderView_var _var_type;

                static GetRegionsOfInterest2D_Response_DataReaderView_ptr _duplicate (GetRegionsOfInterest2D_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetRegionsOfInterest2D_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetRegionsOfInterest2D_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetRegionsOfInterest2D_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetRegionsOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetRegionsOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetRegionsOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetRegionsOfInterest2D_Response_& instance) = 0;

            protected:
                GetRegionsOfInterest2D_Response_DataReaderView () {};
                ~GetRegionsOfInterest2D_Response_DataReaderView () {};
            private:
                GetRegionsOfInterest2D_Response_DataReaderView (const GetRegionsOfInterest2D_Response_DataReaderView &);
                GetRegionsOfInterest2D_Response_DataReaderView & operator = (const GetRegionsOfInterest2D_Response_DataReaderView &);
            };
            class Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface;

            typedef Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface * Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface> Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface> Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_out;


            class Sample_GetRegionsOfInterest2D_Request_DataWriter;

            typedef Sample_GetRegionsOfInterest2D_Request_DataWriter * Sample_GetRegionsOfInterest2D_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRegionsOfInterest2D_Request_DataWriter> Sample_GetRegionsOfInterest2D_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetRegionsOfInterest2D_Request_DataWriter> Sample_GetRegionsOfInterest2D_Request_DataWriter_out;


            class Sample_GetRegionsOfInterest2D_Request_DataReader;

            typedef Sample_GetRegionsOfInterest2D_Request_DataReader * Sample_GetRegionsOfInterest2D_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRegionsOfInterest2D_Request_DataReader> Sample_GetRegionsOfInterest2D_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetRegionsOfInterest2D_Request_DataReader> Sample_GetRegionsOfInterest2D_Request_DataReader_out;


            class Sample_GetRegionsOfInterest2D_Request_DataReaderView;

            typedef Sample_GetRegionsOfInterest2D_Request_DataReaderView * Sample_GetRegionsOfInterest2D_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRegionsOfInterest2D_Request_DataReaderView> Sample_GetRegionsOfInterest2D_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetRegionsOfInterest2D_Request_DataReaderView> Sample_GetRegionsOfInterest2D_Request_DataReaderView_out;

            struct Sample_GetRegionsOfInterest2D_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetRegionsOfInterest2D_Request_, struct Sample_GetRegionsOfInterest2D_Request_Seq_uniq_> Sample_GetRegionsOfInterest2D_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetRegionsOfInterest2D_Request_Seq> Sample_GetRegionsOfInterest2D_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetRegionsOfInterest2D_Request_Seq> Sample_GetRegionsOfInterest2D_Request_Seq_out;

            class  Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_var _var_type;

                static Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _duplicate (Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface () {};
                ~Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface () {};
            private:
                Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface (const Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface &);
                Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface & operator = (const Sample_GetRegionsOfInterest2D_Request_TypeSupportInterface &);
            };

            class  Sample_GetRegionsOfInterest2D_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetRegionsOfInterest2D_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetRegionsOfInterest2D_Request_DataWriter_var _var_type;

                static Sample_GetRegionsOfInterest2D_Request_DataWriter_ptr _duplicate (Sample_GetRegionsOfInterest2D_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRegionsOfInterest2D_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRegionsOfInterest2D_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetRegionsOfInterest2D_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetRegionsOfInterest2D_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetRegionsOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetRegionsOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRegionsOfInterest2D_Request_& instance_data) = 0;

            protected:
                Sample_GetRegionsOfInterest2D_Request_DataWriter () {};
                ~Sample_GetRegionsOfInterest2D_Request_DataWriter () {};
            private:
                Sample_GetRegionsOfInterest2D_Request_DataWriter (const Sample_GetRegionsOfInterest2D_Request_DataWriter &);
                Sample_GetRegionsOfInterest2D_Request_DataWriter & operator = (const Sample_GetRegionsOfInterest2D_Request_DataWriter &);
            };

            class  Sample_GetRegionsOfInterest2D_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetRegionsOfInterest2D_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetRegionsOfInterest2D_Request_DataReader_var _var_type;

                static Sample_GetRegionsOfInterest2D_Request_DataReader_ptr _duplicate (Sample_GetRegionsOfInterest2D_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRegionsOfInterest2D_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRegionsOfInterest2D_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRegionsOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRegionsOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRegionsOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRegionsOfInterest2D_Request_& instance) = 0;

            protected:
                Sample_GetRegionsOfInterest2D_Request_DataReader () {};
                ~Sample_GetRegionsOfInterest2D_Request_DataReader () {};
            private:
                Sample_GetRegionsOfInterest2D_Request_DataReader (const Sample_GetRegionsOfInterest2D_Request_DataReader &);
                Sample_GetRegionsOfInterest2D_Request_DataReader & operator = (const Sample_GetRegionsOfInterest2D_Request_DataReader &);
            };

            class  Sample_GetRegionsOfInterest2D_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetRegionsOfInterest2D_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetRegionsOfInterest2D_Request_DataReaderView_var _var_type;

                static Sample_GetRegionsOfInterest2D_Request_DataReaderView_ptr _duplicate (Sample_GetRegionsOfInterest2D_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRegionsOfInterest2D_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRegionsOfInterest2D_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRegionsOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRegionsOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRegionsOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRegionsOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRegionsOfInterest2D_Request_& instance) = 0;

            protected:
                Sample_GetRegionsOfInterest2D_Request_DataReaderView () {};
                ~Sample_GetRegionsOfInterest2D_Request_DataReaderView () {};
            private:
                Sample_GetRegionsOfInterest2D_Request_DataReaderView (const Sample_GetRegionsOfInterest2D_Request_DataReaderView &);
                Sample_GetRegionsOfInterest2D_Request_DataReaderView & operator = (const Sample_GetRegionsOfInterest2D_Request_DataReaderView &);
            };
            class Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface;

            typedef Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface * Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface> Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface> Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_out;


            class Sample_GetRegionsOfInterest2D_Response_DataWriter;

            typedef Sample_GetRegionsOfInterest2D_Response_DataWriter * Sample_GetRegionsOfInterest2D_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRegionsOfInterest2D_Response_DataWriter> Sample_GetRegionsOfInterest2D_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetRegionsOfInterest2D_Response_DataWriter> Sample_GetRegionsOfInterest2D_Response_DataWriter_out;


            class Sample_GetRegionsOfInterest2D_Response_DataReader;

            typedef Sample_GetRegionsOfInterest2D_Response_DataReader * Sample_GetRegionsOfInterest2D_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRegionsOfInterest2D_Response_DataReader> Sample_GetRegionsOfInterest2D_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetRegionsOfInterest2D_Response_DataReader> Sample_GetRegionsOfInterest2D_Response_DataReader_out;


            class Sample_GetRegionsOfInterest2D_Response_DataReaderView;

            typedef Sample_GetRegionsOfInterest2D_Response_DataReaderView * Sample_GetRegionsOfInterest2D_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetRegionsOfInterest2D_Response_DataReaderView> Sample_GetRegionsOfInterest2D_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetRegionsOfInterest2D_Response_DataReaderView> Sample_GetRegionsOfInterest2D_Response_DataReaderView_out;

            struct Sample_GetRegionsOfInterest2D_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetRegionsOfInterest2D_Response_, struct Sample_GetRegionsOfInterest2D_Response_Seq_uniq_> Sample_GetRegionsOfInterest2D_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetRegionsOfInterest2D_Response_Seq> Sample_GetRegionsOfInterest2D_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetRegionsOfInterest2D_Response_Seq> Sample_GetRegionsOfInterest2D_Response_Seq_out;

            class  Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_var _var_type;

                static Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _duplicate (Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface () {};
                ~Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface () {};
            private:
                Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface (const Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface &);
                Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface & operator = (const Sample_GetRegionsOfInterest2D_Response_TypeSupportInterface &);
            };

            class  Sample_GetRegionsOfInterest2D_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetRegionsOfInterest2D_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetRegionsOfInterest2D_Response_DataWriter_var _var_type;

                static Sample_GetRegionsOfInterest2D_Response_DataWriter_ptr _duplicate (Sample_GetRegionsOfInterest2D_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRegionsOfInterest2D_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRegionsOfInterest2D_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetRegionsOfInterest2D_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetRegionsOfInterest2D_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetRegionsOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetRegionsOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRegionsOfInterest2D_Response_& instance_data) = 0;

            protected:
                Sample_GetRegionsOfInterest2D_Response_DataWriter () {};
                ~Sample_GetRegionsOfInterest2D_Response_DataWriter () {};
            private:
                Sample_GetRegionsOfInterest2D_Response_DataWriter (const Sample_GetRegionsOfInterest2D_Response_DataWriter &);
                Sample_GetRegionsOfInterest2D_Response_DataWriter & operator = (const Sample_GetRegionsOfInterest2D_Response_DataWriter &);
            };

            class  Sample_GetRegionsOfInterest2D_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetRegionsOfInterest2D_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetRegionsOfInterest2D_Response_DataReader_var _var_type;

                static Sample_GetRegionsOfInterest2D_Response_DataReader_ptr _duplicate (Sample_GetRegionsOfInterest2D_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRegionsOfInterest2D_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRegionsOfInterest2D_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRegionsOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRegionsOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRegionsOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRegionsOfInterest2D_Response_& instance) = 0;

            protected:
                Sample_GetRegionsOfInterest2D_Response_DataReader () {};
                ~Sample_GetRegionsOfInterest2D_Response_DataReader () {};
            private:
                Sample_GetRegionsOfInterest2D_Response_DataReader (const Sample_GetRegionsOfInterest2D_Response_DataReader &);
                Sample_GetRegionsOfInterest2D_Response_DataReader & operator = (const Sample_GetRegionsOfInterest2D_Response_DataReader &);
            };

            class  Sample_GetRegionsOfInterest2D_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetRegionsOfInterest2D_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetRegionsOfInterest2D_Response_DataReaderView_var _var_type;

                static Sample_GetRegionsOfInterest2D_Response_DataReaderView_ptr _duplicate (Sample_GetRegionsOfInterest2D_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetRegionsOfInterest2D_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetRegionsOfInterest2D_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetRegionsOfInterest2D_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetRegionsOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetRegionsOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetRegionsOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetRegionsOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetRegionsOfInterest2D_Response_& instance) = 0;

            protected:
                Sample_GetRegionsOfInterest2D_Response_DataReaderView () {};
                ~Sample_GetRegionsOfInterest2D_Response_DataReaderView () {};
            private:
                Sample_GetRegionsOfInterest2D_Response_DataReaderView (const Sample_GetRegionsOfInterest2D_Response_DataReaderView &);
                Sample_GetRegionsOfInterest2D_Response_DataReaderView & operator = (const Sample_GetRegionsOfInterest2D_Response_DataReaderView &);
            };
        }

    }

}

#endif
