#ifndef _H_0E5AF07A5635C6ACE327B0C4C0680A63_GetRegionsOfInterest3D__H_
#define _H_0E5AF07A5635C6ACE327B0C4C0680A63_GetRegionsOfInterest3D__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/RegionOfInterest3D_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetRegionsOfInterest3D_Request_
            {
                struct _region_of_interest_ids__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _region_of_interest_ids__seq_uniq_ > _region_of_interest_ids__seq;
                typedef DDS_DCPSUStrSeq_var< _region_of_interest_ids__seq > _region_of_interest_ids__seq_var;
                typedef DDS_DCPSUStrSeq_out< _region_of_interest_ids__seq > _region_of_interest_ids__seq_out;
                _region_of_interest_ids__seq region_of_interest_ids_;
            };

            typedef DDS_DCPSStruct_var<GetRegionsOfInterest3D_Request_> GetRegionsOfInterest3D_Request__var;
            typedef DDS_DCPSStruct_out < GetRegionsOfInterest3D_Request_> GetRegionsOfInterest3D_Request__out;

            struct  GetRegionsOfInterest3D_Response_
            {
                struct _regions_of_interest__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_reason_msgs::msg::dds_::RegionOfInterest3D_, struct _regions_of_interest__seq_uniq_ > _regions_of_interest__seq;
                typedef DDS_DCPSSequence_var< _regions_of_interest__seq > _regions_of_interest__seq_var;
                typedef DDS_DCPSSequence_out< _regions_of_interest__seq > _regions_of_interest__seq_out;
                _regions_of_interest__seq regions_of_interest_;
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<GetRegionsOfInterest3D_Response_> GetRegionsOfInterest3D_Response__var;
            typedef DDS_DCPSStruct_out < GetRegionsOfInterest3D_Response_> GetRegionsOfInterest3D_Response__out;

            struct  Sample_GetRegionsOfInterest3D_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::GetRegionsOfInterest3D_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetRegionsOfInterest3D_Request_> Sample_GetRegionsOfInterest3D_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetRegionsOfInterest3D_Request_> Sample_GetRegionsOfInterest3D_Request__out;

            struct  Sample_GetRegionsOfInterest3D_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::GetRegionsOfInterest3D_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetRegionsOfInterest3D_Response_> Sample_GetRegionsOfInterest3D_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetRegionsOfInterest3D_Response_> Sample_GetRegionsOfInterest3D_Response__out;

        }

    }

}

#endif /* _H_0E5AF07A5635C6ACE327B0C4C0680A63_GetRegionsOfInterest3D__H_ */
