#ifndef _H_657E97851AC38AF689D1FD6810143346_HandEyeCalibration__H_
#define _H_657E97851AC38AF689D1FD6810143346_HandEyeCalibration__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  HandEyeCalibration_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<HandEyeCalibration_Request_> HandEyeCalibration_Request__var;
            typedef HandEyeCalibration_Request_& HandEyeCalibration_Request__out;

            struct  HandEyeCalibration_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::Long status_;
                ::DDS::String_mgr message_;
                ::geometry_msgs::msg::dds_::Pose_ pose_;
                ::DDS::Double error_;
                ::DDS::Double translation_error_meter_;
                ::DDS::Double rotation_error_degree_;
                ::DDS::Boolean robot_mounted_;
            };

            typedef DDS_DCPSStruct_var<HandEyeCalibration_Response_> HandEyeCalibration_Response__var;
            typedef DDS_DCPSStruct_out < HandEyeCalibration_Response_> HandEyeCalibration_Response__out;

            struct  Sample_HandEyeCalibration_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::HandEyeCalibration_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_HandEyeCalibration_Request_> Sample_HandEyeCalibration_Request__var;
            typedef Sample_HandEyeCalibration_Request_& Sample_HandEyeCalibration_Request__out;

            struct  Sample_HandEyeCalibration_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::HandEyeCalibration_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_HandEyeCalibration_Response_> Sample_HandEyeCalibration_Response__var;
            typedef DDS_DCPSStruct_out < Sample_HandEyeCalibration_Response_> Sample_HandEyeCalibration_Response__out;

        }

    }

}

#endif /* _H_657E97851AC38AF689D1FD6810143346_HandEyeCalibration__H_ */
