#ifndef _H_657E97851AC38AF689D1FD6810143346_HandEyeCalibration_DCPS_H_
#define _H_657E97851AC38AF689D1FD6810143346_HandEyeCalibration_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HandEyeCalibration_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class HandEyeCalibration_Request_TypeSupportInterface;

            typedef HandEyeCalibration_Request_TypeSupportInterface * HandEyeCalibration_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibration_Request_TypeSupportInterface> HandEyeCalibration_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibration_Request_TypeSupportInterface> HandEyeCalibration_Request_TypeSupportInterface_out;


            class HandEyeCalibration_Request_DataWriter;

            typedef HandEyeCalibration_Request_DataWriter * HandEyeCalibration_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibration_Request_DataWriter> HandEyeCalibration_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibration_Request_DataWriter> HandEyeCalibration_Request_DataWriter_out;


            class HandEyeCalibration_Request_DataReader;

            typedef HandEyeCalibration_Request_DataReader * HandEyeCalibration_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibration_Request_DataReader> HandEyeCalibration_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibration_Request_DataReader> HandEyeCalibration_Request_DataReader_out;


            class HandEyeCalibration_Request_DataReaderView;

            typedef HandEyeCalibration_Request_DataReaderView * HandEyeCalibration_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibration_Request_DataReaderView> HandEyeCalibration_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibration_Request_DataReaderView> HandEyeCalibration_Request_DataReaderView_out;

            struct HandEyeCalibration_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < HandEyeCalibration_Request_, struct HandEyeCalibration_Request_Seq_uniq_> HandEyeCalibration_Request_Seq;
            typedef DDS_DCPSSequence_var < HandEyeCalibration_Request_Seq> HandEyeCalibration_Request_Seq_var;
            typedef DDS_DCPSSequence_out < HandEyeCalibration_Request_Seq> HandEyeCalibration_Request_Seq_out;

            class  HandEyeCalibration_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HandEyeCalibration_Request_TypeSupportInterface_ptr _ptr_type;
                typedef HandEyeCalibration_Request_TypeSupportInterface_var _var_type;

                static HandEyeCalibration_Request_TypeSupportInterface_ptr _duplicate (HandEyeCalibration_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibration_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibration_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HandEyeCalibration_Request_TypeSupportInterface () {};
                ~HandEyeCalibration_Request_TypeSupportInterface () {};
            private:
                HandEyeCalibration_Request_TypeSupportInterface (const HandEyeCalibration_Request_TypeSupportInterface &);
                HandEyeCalibration_Request_TypeSupportInterface & operator = (const HandEyeCalibration_Request_TypeSupportInterface &);
            };

            class  HandEyeCalibration_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HandEyeCalibration_Request_DataWriter_ptr _ptr_type;
                typedef HandEyeCalibration_Request_DataWriter_var _var_type;

                static HandEyeCalibration_Request_DataWriter_ptr _duplicate (HandEyeCalibration_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibration_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibration_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HandEyeCalibration_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HandEyeCalibration_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibration_Request_& instance_data) = 0;

            protected:
                HandEyeCalibration_Request_DataWriter () {};
                ~HandEyeCalibration_Request_DataWriter () {};
            private:
                HandEyeCalibration_Request_DataWriter (const HandEyeCalibration_Request_DataWriter &);
                HandEyeCalibration_Request_DataWriter & operator = (const HandEyeCalibration_Request_DataWriter &);
            };

            class  HandEyeCalibration_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HandEyeCalibration_Request_DataReader_ptr _ptr_type;
                typedef HandEyeCalibration_Request_DataReader_var _var_type;

                static HandEyeCalibration_Request_DataReader_ptr _duplicate (HandEyeCalibration_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibration_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibration_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibration_Request_& instance) = 0;

            protected:
                HandEyeCalibration_Request_DataReader () {};
                ~HandEyeCalibration_Request_DataReader () {};
            private:
                HandEyeCalibration_Request_DataReader (const HandEyeCalibration_Request_DataReader &);
                HandEyeCalibration_Request_DataReader & operator = (const HandEyeCalibration_Request_DataReader &);
            };

            class  HandEyeCalibration_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HandEyeCalibration_Request_DataReaderView_ptr _ptr_type;
                typedef HandEyeCalibration_Request_DataReaderView_var _var_type;

                static HandEyeCalibration_Request_DataReaderView_ptr _duplicate (HandEyeCalibration_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibration_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibration_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibration_Request_& instance) = 0;

            protected:
                HandEyeCalibration_Request_DataReaderView () {};
                ~HandEyeCalibration_Request_DataReaderView () {};
            private:
                HandEyeCalibration_Request_DataReaderView (const HandEyeCalibration_Request_DataReaderView &);
                HandEyeCalibration_Request_DataReaderView & operator = (const HandEyeCalibration_Request_DataReaderView &);
            };
            class HandEyeCalibration_Response_TypeSupportInterface;

            typedef HandEyeCalibration_Response_TypeSupportInterface * HandEyeCalibration_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibration_Response_TypeSupportInterface> HandEyeCalibration_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibration_Response_TypeSupportInterface> HandEyeCalibration_Response_TypeSupportInterface_out;


            class HandEyeCalibration_Response_DataWriter;

            typedef HandEyeCalibration_Response_DataWriter * HandEyeCalibration_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibration_Response_DataWriter> HandEyeCalibration_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibration_Response_DataWriter> HandEyeCalibration_Response_DataWriter_out;


            class HandEyeCalibration_Response_DataReader;

            typedef HandEyeCalibration_Response_DataReader * HandEyeCalibration_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibration_Response_DataReader> HandEyeCalibration_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibration_Response_DataReader> HandEyeCalibration_Response_DataReader_out;


            class HandEyeCalibration_Response_DataReaderView;

            typedef HandEyeCalibration_Response_DataReaderView * HandEyeCalibration_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibration_Response_DataReaderView> HandEyeCalibration_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibration_Response_DataReaderView> HandEyeCalibration_Response_DataReaderView_out;

            struct HandEyeCalibration_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HandEyeCalibration_Response_, struct HandEyeCalibration_Response_Seq_uniq_> HandEyeCalibration_Response_Seq;
            typedef DDS_DCPSSequence_var < HandEyeCalibration_Response_Seq> HandEyeCalibration_Response_Seq_var;
            typedef DDS_DCPSSequence_out < HandEyeCalibration_Response_Seq> HandEyeCalibration_Response_Seq_out;

            class  HandEyeCalibration_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HandEyeCalibration_Response_TypeSupportInterface_ptr _ptr_type;
                typedef HandEyeCalibration_Response_TypeSupportInterface_var _var_type;

                static HandEyeCalibration_Response_TypeSupportInterface_ptr _duplicate (HandEyeCalibration_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibration_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibration_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HandEyeCalibration_Response_TypeSupportInterface () {};
                ~HandEyeCalibration_Response_TypeSupportInterface () {};
            private:
                HandEyeCalibration_Response_TypeSupportInterface (const HandEyeCalibration_Response_TypeSupportInterface &);
                HandEyeCalibration_Response_TypeSupportInterface & operator = (const HandEyeCalibration_Response_TypeSupportInterface &);
            };

            class  HandEyeCalibration_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HandEyeCalibration_Response_DataWriter_ptr _ptr_type;
                typedef HandEyeCalibration_Response_DataWriter_var _var_type;

                static HandEyeCalibration_Response_DataWriter_ptr _duplicate (HandEyeCalibration_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibration_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibration_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HandEyeCalibration_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HandEyeCalibration_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibration_Response_& instance_data) = 0;

            protected:
                HandEyeCalibration_Response_DataWriter () {};
                ~HandEyeCalibration_Response_DataWriter () {};
            private:
                HandEyeCalibration_Response_DataWriter (const HandEyeCalibration_Response_DataWriter &);
                HandEyeCalibration_Response_DataWriter & operator = (const HandEyeCalibration_Response_DataWriter &);
            };

            class  HandEyeCalibration_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HandEyeCalibration_Response_DataReader_ptr _ptr_type;
                typedef HandEyeCalibration_Response_DataReader_var _var_type;

                static HandEyeCalibration_Response_DataReader_ptr _duplicate (HandEyeCalibration_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibration_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibration_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibration_Response_& instance) = 0;

            protected:
                HandEyeCalibration_Response_DataReader () {};
                ~HandEyeCalibration_Response_DataReader () {};
            private:
                HandEyeCalibration_Response_DataReader (const HandEyeCalibration_Response_DataReader &);
                HandEyeCalibration_Response_DataReader & operator = (const HandEyeCalibration_Response_DataReader &);
            };

            class  HandEyeCalibration_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HandEyeCalibration_Response_DataReaderView_ptr _ptr_type;
                typedef HandEyeCalibration_Response_DataReaderView_var _var_type;

                static HandEyeCalibration_Response_DataReaderView_ptr _duplicate (HandEyeCalibration_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibration_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibration_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibration_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibration_Response_& instance) = 0;

            protected:
                HandEyeCalibration_Response_DataReaderView () {};
                ~HandEyeCalibration_Response_DataReaderView () {};
            private:
                HandEyeCalibration_Response_DataReaderView (const HandEyeCalibration_Response_DataReaderView &);
                HandEyeCalibration_Response_DataReaderView & operator = (const HandEyeCalibration_Response_DataReaderView &);
            };
            class Sample_HandEyeCalibration_Request_TypeSupportInterface;

            typedef Sample_HandEyeCalibration_Request_TypeSupportInterface * Sample_HandEyeCalibration_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibration_Request_TypeSupportInterface> Sample_HandEyeCalibration_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibration_Request_TypeSupportInterface> Sample_HandEyeCalibration_Request_TypeSupportInterface_out;


            class Sample_HandEyeCalibration_Request_DataWriter;

            typedef Sample_HandEyeCalibration_Request_DataWriter * Sample_HandEyeCalibration_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibration_Request_DataWriter> Sample_HandEyeCalibration_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibration_Request_DataWriter> Sample_HandEyeCalibration_Request_DataWriter_out;


            class Sample_HandEyeCalibration_Request_DataReader;

            typedef Sample_HandEyeCalibration_Request_DataReader * Sample_HandEyeCalibration_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibration_Request_DataReader> Sample_HandEyeCalibration_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibration_Request_DataReader> Sample_HandEyeCalibration_Request_DataReader_out;


            class Sample_HandEyeCalibration_Request_DataReaderView;

            typedef Sample_HandEyeCalibration_Request_DataReaderView * Sample_HandEyeCalibration_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibration_Request_DataReaderView> Sample_HandEyeCalibration_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibration_Request_DataReaderView> Sample_HandEyeCalibration_Request_DataReaderView_out;

            struct Sample_HandEyeCalibration_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_HandEyeCalibration_Request_, struct Sample_HandEyeCalibration_Request_Seq_uniq_> Sample_HandEyeCalibration_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_HandEyeCalibration_Request_Seq> Sample_HandEyeCalibration_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_HandEyeCalibration_Request_Seq> Sample_HandEyeCalibration_Request_Seq_out;

            class  Sample_HandEyeCalibration_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_HandEyeCalibration_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_HandEyeCalibration_Request_TypeSupportInterface_var _var_type;

                static Sample_HandEyeCalibration_Request_TypeSupportInterface_ptr _duplicate (Sample_HandEyeCalibration_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibration_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibration_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_HandEyeCalibration_Request_TypeSupportInterface () {};
                ~Sample_HandEyeCalibration_Request_TypeSupportInterface () {};
            private:
                Sample_HandEyeCalibration_Request_TypeSupportInterface (const Sample_HandEyeCalibration_Request_TypeSupportInterface &);
                Sample_HandEyeCalibration_Request_TypeSupportInterface & operator = (const Sample_HandEyeCalibration_Request_TypeSupportInterface &);
            };

            class  Sample_HandEyeCalibration_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_HandEyeCalibration_Request_DataWriter_ptr _ptr_type;
                typedef Sample_HandEyeCalibration_Request_DataWriter_var _var_type;

                static Sample_HandEyeCalibration_Request_DataWriter_ptr _duplicate (Sample_HandEyeCalibration_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibration_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibration_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_HandEyeCalibration_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_HandEyeCalibration_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_HandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_HandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_HandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_HandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_HandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_HandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_HandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_HandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibration_Request_& instance_data) = 0;

            protected:
                Sample_HandEyeCalibration_Request_DataWriter () {};
                ~Sample_HandEyeCalibration_Request_DataWriter () {};
            private:
                Sample_HandEyeCalibration_Request_DataWriter (const Sample_HandEyeCalibration_Request_DataWriter &);
                Sample_HandEyeCalibration_Request_DataWriter & operator = (const Sample_HandEyeCalibration_Request_DataWriter &);
            };

            class  Sample_HandEyeCalibration_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_HandEyeCalibration_Request_DataReader_ptr _ptr_type;
                typedef Sample_HandEyeCalibration_Request_DataReader_var _var_type;

                static Sample_HandEyeCalibration_Request_DataReader_ptr _duplicate (Sample_HandEyeCalibration_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibration_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibration_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibration_Request_& instance) = 0;

            protected:
                Sample_HandEyeCalibration_Request_DataReader () {};
                ~Sample_HandEyeCalibration_Request_DataReader () {};
            private:
                Sample_HandEyeCalibration_Request_DataReader (const Sample_HandEyeCalibration_Request_DataReader &);
                Sample_HandEyeCalibration_Request_DataReader & operator = (const Sample_HandEyeCalibration_Request_DataReader &);
            };

            class  Sample_HandEyeCalibration_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_HandEyeCalibration_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_HandEyeCalibration_Request_DataReaderView_var _var_type;

                static Sample_HandEyeCalibration_Request_DataReaderView_ptr _duplicate (Sample_HandEyeCalibration_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibration_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibration_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibration_Request_& instance) = 0;

            protected:
                Sample_HandEyeCalibration_Request_DataReaderView () {};
                ~Sample_HandEyeCalibration_Request_DataReaderView () {};
            private:
                Sample_HandEyeCalibration_Request_DataReaderView (const Sample_HandEyeCalibration_Request_DataReaderView &);
                Sample_HandEyeCalibration_Request_DataReaderView & operator = (const Sample_HandEyeCalibration_Request_DataReaderView &);
            };
            class Sample_HandEyeCalibration_Response_TypeSupportInterface;

            typedef Sample_HandEyeCalibration_Response_TypeSupportInterface * Sample_HandEyeCalibration_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibration_Response_TypeSupportInterface> Sample_HandEyeCalibration_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibration_Response_TypeSupportInterface> Sample_HandEyeCalibration_Response_TypeSupportInterface_out;


            class Sample_HandEyeCalibration_Response_DataWriter;

            typedef Sample_HandEyeCalibration_Response_DataWriter * Sample_HandEyeCalibration_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibration_Response_DataWriter> Sample_HandEyeCalibration_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibration_Response_DataWriter> Sample_HandEyeCalibration_Response_DataWriter_out;


            class Sample_HandEyeCalibration_Response_DataReader;

            typedef Sample_HandEyeCalibration_Response_DataReader * Sample_HandEyeCalibration_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibration_Response_DataReader> Sample_HandEyeCalibration_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibration_Response_DataReader> Sample_HandEyeCalibration_Response_DataReader_out;


            class Sample_HandEyeCalibration_Response_DataReaderView;

            typedef Sample_HandEyeCalibration_Response_DataReaderView * Sample_HandEyeCalibration_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibration_Response_DataReaderView> Sample_HandEyeCalibration_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibration_Response_DataReaderView> Sample_HandEyeCalibration_Response_DataReaderView_out;

            struct Sample_HandEyeCalibration_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_HandEyeCalibration_Response_, struct Sample_HandEyeCalibration_Response_Seq_uniq_> Sample_HandEyeCalibration_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_HandEyeCalibration_Response_Seq> Sample_HandEyeCalibration_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_HandEyeCalibration_Response_Seq> Sample_HandEyeCalibration_Response_Seq_out;

            class  Sample_HandEyeCalibration_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_HandEyeCalibration_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_HandEyeCalibration_Response_TypeSupportInterface_var _var_type;

                static Sample_HandEyeCalibration_Response_TypeSupportInterface_ptr _duplicate (Sample_HandEyeCalibration_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibration_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibration_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_HandEyeCalibration_Response_TypeSupportInterface () {};
                ~Sample_HandEyeCalibration_Response_TypeSupportInterface () {};
            private:
                Sample_HandEyeCalibration_Response_TypeSupportInterface (const Sample_HandEyeCalibration_Response_TypeSupportInterface &);
                Sample_HandEyeCalibration_Response_TypeSupportInterface & operator = (const Sample_HandEyeCalibration_Response_TypeSupportInterface &);
            };

            class  Sample_HandEyeCalibration_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_HandEyeCalibration_Response_DataWriter_ptr _ptr_type;
                typedef Sample_HandEyeCalibration_Response_DataWriter_var _var_type;

                static Sample_HandEyeCalibration_Response_DataWriter_ptr _duplicate (Sample_HandEyeCalibration_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibration_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibration_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_HandEyeCalibration_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_HandEyeCalibration_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_HandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_HandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_HandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_HandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_HandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_HandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_HandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_HandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibration_Response_& instance_data) = 0;

            protected:
                Sample_HandEyeCalibration_Response_DataWriter () {};
                ~Sample_HandEyeCalibration_Response_DataWriter () {};
            private:
                Sample_HandEyeCalibration_Response_DataWriter (const Sample_HandEyeCalibration_Response_DataWriter &);
                Sample_HandEyeCalibration_Response_DataWriter & operator = (const Sample_HandEyeCalibration_Response_DataWriter &);
            };

            class  Sample_HandEyeCalibration_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_HandEyeCalibration_Response_DataReader_ptr _ptr_type;
                typedef Sample_HandEyeCalibration_Response_DataReader_var _var_type;

                static Sample_HandEyeCalibration_Response_DataReader_ptr _duplicate (Sample_HandEyeCalibration_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibration_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibration_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibration_Response_& instance) = 0;

            protected:
                Sample_HandEyeCalibration_Response_DataReader () {};
                ~Sample_HandEyeCalibration_Response_DataReader () {};
            private:
                Sample_HandEyeCalibration_Response_DataReader (const Sample_HandEyeCalibration_Response_DataReader &);
                Sample_HandEyeCalibration_Response_DataReader & operator = (const Sample_HandEyeCalibration_Response_DataReader &);
            };

            class  Sample_HandEyeCalibration_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_HandEyeCalibration_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_HandEyeCalibration_Response_DataReaderView_var _var_type;

                static Sample_HandEyeCalibration_Response_DataReaderView_ptr _duplicate (Sample_HandEyeCalibration_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibration_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibration_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibration_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibration_Response_& instance) = 0;

            protected:
                Sample_HandEyeCalibration_Response_DataReaderView () {};
                ~Sample_HandEyeCalibration_Response_DataReaderView () {};
            private:
                Sample_HandEyeCalibration_Response_DataReaderView (const Sample_HandEyeCalibration_Response_DataReaderView &);
                Sample_HandEyeCalibration_Response_DataReaderView & operator = (const Sample_HandEyeCalibration_Response_DataReaderView &);
            };
        }

    }

}

#endif
