#ifndef _H_BFB04E4F46022A40E76CC5AF46E63AB6_SetHandEyeCalibrationPose__H_
#define _H_BFB04E4F46022A40E76CC5AF46E63AB6_SetHandEyeCalibrationPose__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SetHandEyeCalibrationPose_Request_
            {
                ::DDS::Long slot_;
                ::geometry_msgs::msg::dds_::Pose_ pose_;
            };

            typedef DDS_DCPSStruct_var<SetHandEyeCalibrationPose_Request_> SetHandEyeCalibrationPose_Request__var;
            typedef SetHandEyeCalibrationPose_Request_& SetHandEyeCalibrationPose_Request__out;

            struct  SetHandEyeCalibrationPose_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::Long status_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<SetHandEyeCalibrationPose_Response_> SetHandEyeCalibrationPose_Response__var;
            typedef DDS_DCPSStruct_out < SetHandEyeCalibrationPose_Response_> SetHandEyeCalibrationPose_Response__out;

            struct  Sample_SetHandEyeCalibrationPose_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SetHandEyeCalibrationPose_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetHandEyeCalibrationPose_Request_> Sample_SetHandEyeCalibrationPose_Request__var;
            typedef Sample_SetHandEyeCalibrationPose_Request_& Sample_SetHandEyeCalibrationPose_Request__out;

            struct  Sample_SetHandEyeCalibrationPose_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SetHandEyeCalibrationPose_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetHandEyeCalibrationPose_Response_> Sample_SetHandEyeCalibrationPose_Response__var;
            typedef DDS_DCPSStruct_out < Sample_SetHandEyeCalibrationPose_Response_> Sample_SetHandEyeCalibrationPose_Response__out;

        }

    }

}

#endif /* _H_BFB04E4F46022A40E76CC5AF46E63AB6_SetHandEyeCalibrationPose__H_ */
