#ifndef _H_2010DAD39D41136A7B4918E45906EB91_SetLoadCarrier__H_
#define _H_2010DAD39D41136A7B4918E45906EB91_SetLoadCarrier__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/LoadCarrier_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SetLoadCarrier_Request_
            {
                ::rc_reason_msgs::msg::dds_::LoadCarrier_ load_carrier_;
            };

            typedef DDS_DCPSStruct_var<SetLoadCarrier_Request_> SetLoadCarrier_Request__var;
            typedef DDS_DCPSStruct_out < SetLoadCarrier_Request_> SetLoadCarrier_Request__out;

            struct  SetLoadCarrier_Response_
            {
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<SetLoadCarrier_Response_> SetLoadCarrier_Response__var;
            typedef DDS_DCPSStruct_out < SetLoadCarrier_Response_> SetLoadCarrier_Response__out;

            struct  Sample_SetLoadCarrier_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SetLoadCarrier_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetLoadCarrier_Request_> Sample_SetLoadCarrier_Request__var;
            typedef DDS_DCPSStruct_out < Sample_SetLoadCarrier_Request_> Sample_SetLoadCarrier_Request__out;

            struct  Sample_SetLoadCarrier_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SetLoadCarrier_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetLoadCarrier_Response_> Sample_SetLoadCarrier_Response__var;
            typedef DDS_DCPSStruct_out < Sample_SetLoadCarrier_Response_> Sample_SetLoadCarrier_Response__out;

        }

    }

}

#endif /* _H_2010DAD39D41136A7B4918E45906EB91_SetLoadCarrier__H_ */
