#ifndef _H_2010DAD39D41136A7B4918E45906EB91_SetLoadCarrier_DCPS_H_
#define _H_2010DAD39D41136A7B4918E45906EB91_SetLoadCarrier_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetLoadCarrier_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetLoadCarrier_Request_TypeSupportInterface;

            typedef SetLoadCarrier_Request_TypeSupportInterface * SetLoadCarrier_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetLoadCarrier_Request_TypeSupportInterface> SetLoadCarrier_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetLoadCarrier_Request_TypeSupportInterface> SetLoadCarrier_Request_TypeSupportInterface_out;


            class SetLoadCarrier_Request_DataWriter;

            typedef SetLoadCarrier_Request_DataWriter * SetLoadCarrier_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetLoadCarrier_Request_DataWriter> SetLoadCarrier_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetLoadCarrier_Request_DataWriter> SetLoadCarrier_Request_DataWriter_out;


            class SetLoadCarrier_Request_DataReader;

            typedef SetLoadCarrier_Request_DataReader * SetLoadCarrier_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetLoadCarrier_Request_DataReader> SetLoadCarrier_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetLoadCarrier_Request_DataReader> SetLoadCarrier_Request_DataReader_out;


            class SetLoadCarrier_Request_DataReaderView;

            typedef SetLoadCarrier_Request_DataReaderView * SetLoadCarrier_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetLoadCarrier_Request_DataReaderView> SetLoadCarrier_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetLoadCarrier_Request_DataReaderView> SetLoadCarrier_Request_DataReaderView_out;

            struct SetLoadCarrier_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetLoadCarrier_Request_, struct SetLoadCarrier_Request_Seq_uniq_> SetLoadCarrier_Request_Seq;
            typedef DDS_DCPSSequence_var < SetLoadCarrier_Request_Seq> SetLoadCarrier_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetLoadCarrier_Request_Seq> SetLoadCarrier_Request_Seq_out;

            class  SetLoadCarrier_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetLoadCarrier_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetLoadCarrier_Request_TypeSupportInterface_var _var_type;

                static SetLoadCarrier_Request_TypeSupportInterface_ptr _duplicate (SetLoadCarrier_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLoadCarrier_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLoadCarrier_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetLoadCarrier_Request_TypeSupportInterface () {};
                ~SetLoadCarrier_Request_TypeSupportInterface () {};
            private:
                SetLoadCarrier_Request_TypeSupportInterface (const SetLoadCarrier_Request_TypeSupportInterface &);
                SetLoadCarrier_Request_TypeSupportInterface & operator = (const SetLoadCarrier_Request_TypeSupportInterface &);
            };

            class  SetLoadCarrier_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetLoadCarrier_Request_DataWriter_ptr _ptr_type;
                typedef SetLoadCarrier_Request_DataWriter_var _var_type;

                static SetLoadCarrier_Request_DataWriter_ptr _duplicate (SetLoadCarrier_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLoadCarrier_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLoadCarrier_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetLoadCarrier_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetLoadCarrier_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetLoadCarrier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetLoadCarrier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetLoadCarrier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetLoadCarrier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetLoadCarrier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetLoadCarrier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetLoadCarrier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetLoadCarrier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetLoadCarrier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLoadCarrier_Request_& instance_data) = 0;

            protected:
                SetLoadCarrier_Request_DataWriter () {};
                ~SetLoadCarrier_Request_DataWriter () {};
            private:
                SetLoadCarrier_Request_DataWriter (const SetLoadCarrier_Request_DataWriter &);
                SetLoadCarrier_Request_DataWriter & operator = (const SetLoadCarrier_Request_DataWriter &);
            };

            class  SetLoadCarrier_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetLoadCarrier_Request_DataReader_ptr _ptr_type;
                typedef SetLoadCarrier_Request_DataReader_var _var_type;

                static SetLoadCarrier_Request_DataReader_ptr _duplicate (SetLoadCarrier_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLoadCarrier_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLoadCarrier_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetLoadCarrier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetLoadCarrier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetLoadCarrier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLoadCarrier_Request_& instance) = 0;

            protected:
                SetLoadCarrier_Request_DataReader () {};
                ~SetLoadCarrier_Request_DataReader () {};
            private:
                SetLoadCarrier_Request_DataReader (const SetLoadCarrier_Request_DataReader &);
                SetLoadCarrier_Request_DataReader & operator = (const SetLoadCarrier_Request_DataReader &);
            };

            class  SetLoadCarrier_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetLoadCarrier_Request_DataReaderView_ptr _ptr_type;
                typedef SetLoadCarrier_Request_DataReaderView_var _var_type;

                static SetLoadCarrier_Request_DataReaderView_ptr _duplicate (SetLoadCarrier_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLoadCarrier_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLoadCarrier_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetLoadCarrier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetLoadCarrier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetLoadCarrier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLoadCarrier_Request_& instance) = 0;

            protected:
                SetLoadCarrier_Request_DataReaderView () {};
                ~SetLoadCarrier_Request_DataReaderView () {};
            private:
                SetLoadCarrier_Request_DataReaderView (const SetLoadCarrier_Request_DataReaderView &);
                SetLoadCarrier_Request_DataReaderView & operator = (const SetLoadCarrier_Request_DataReaderView &);
            };
            class SetLoadCarrier_Response_TypeSupportInterface;

            typedef SetLoadCarrier_Response_TypeSupportInterface * SetLoadCarrier_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetLoadCarrier_Response_TypeSupportInterface> SetLoadCarrier_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetLoadCarrier_Response_TypeSupportInterface> SetLoadCarrier_Response_TypeSupportInterface_out;


            class SetLoadCarrier_Response_DataWriter;

            typedef SetLoadCarrier_Response_DataWriter * SetLoadCarrier_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetLoadCarrier_Response_DataWriter> SetLoadCarrier_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetLoadCarrier_Response_DataWriter> SetLoadCarrier_Response_DataWriter_out;


            class SetLoadCarrier_Response_DataReader;

            typedef SetLoadCarrier_Response_DataReader * SetLoadCarrier_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetLoadCarrier_Response_DataReader> SetLoadCarrier_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetLoadCarrier_Response_DataReader> SetLoadCarrier_Response_DataReader_out;


            class SetLoadCarrier_Response_DataReaderView;

            typedef SetLoadCarrier_Response_DataReaderView * SetLoadCarrier_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetLoadCarrier_Response_DataReaderView> SetLoadCarrier_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetLoadCarrier_Response_DataReaderView> SetLoadCarrier_Response_DataReaderView_out;

            struct SetLoadCarrier_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetLoadCarrier_Response_, struct SetLoadCarrier_Response_Seq_uniq_> SetLoadCarrier_Response_Seq;
            typedef DDS_DCPSSequence_var < SetLoadCarrier_Response_Seq> SetLoadCarrier_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetLoadCarrier_Response_Seq> SetLoadCarrier_Response_Seq_out;

            class  SetLoadCarrier_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetLoadCarrier_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetLoadCarrier_Response_TypeSupportInterface_var _var_type;

                static SetLoadCarrier_Response_TypeSupportInterface_ptr _duplicate (SetLoadCarrier_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLoadCarrier_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLoadCarrier_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetLoadCarrier_Response_TypeSupportInterface () {};
                ~SetLoadCarrier_Response_TypeSupportInterface () {};
            private:
                SetLoadCarrier_Response_TypeSupportInterface (const SetLoadCarrier_Response_TypeSupportInterface &);
                SetLoadCarrier_Response_TypeSupportInterface & operator = (const SetLoadCarrier_Response_TypeSupportInterface &);
            };

            class  SetLoadCarrier_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetLoadCarrier_Response_DataWriter_ptr _ptr_type;
                typedef SetLoadCarrier_Response_DataWriter_var _var_type;

                static SetLoadCarrier_Response_DataWriter_ptr _duplicate (SetLoadCarrier_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLoadCarrier_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLoadCarrier_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetLoadCarrier_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetLoadCarrier_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetLoadCarrier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetLoadCarrier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetLoadCarrier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetLoadCarrier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetLoadCarrier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetLoadCarrier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetLoadCarrier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetLoadCarrier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetLoadCarrier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLoadCarrier_Response_& instance_data) = 0;

            protected:
                SetLoadCarrier_Response_DataWriter () {};
                ~SetLoadCarrier_Response_DataWriter () {};
            private:
                SetLoadCarrier_Response_DataWriter (const SetLoadCarrier_Response_DataWriter &);
                SetLoadCarrier_Response_DataWriter & operator = (const SetLoadCarrier_Response_DataWriter &);
            };

            class  SetLoadCarrier_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetLoadCarrier_Response_DataReader_ptr _ptr_type;
                typedef SetLoadCarrier_Response_DataReader_var _var_type;

                static SetLoadCarrier_Response_DataReader_ptr _duplicate (SetLoadCarrier_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLoadCarrier_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLoadCarrier_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetLoadCarrier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetLoadCarrier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetLoadCarrier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLoadCarrier_Response_& instance) = 0;

            protected:
                SetLoadCarrier_Response_DataReader () {};
                ~SetLoadCarrier_Response_DataReader () {};
            private:
                SetLoadCarrier_Response_DataReader (const SetLoadCarrier_Response_DataReader &);
                SetLoadCarrier_Response_DataReader & operator = (const SetLoadCarrier_Response_DataReader &);
            };

            class  SetLoadCarrier_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetLoadCarrier_Response_DataReaderView_ptr _ptr_type;
                typedef SetLoadCarrier_Response_DataReaderView_var _var_type;

                static SetLoadCarrier_Response_DataReaderView_ptr _duplicate (SetLoadCarrier_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetLoadCarrier_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetLoadCarrier_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetLoadCarrier_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetLoadCarrier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetLoadCarrier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetLoadCarrier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetLoadCarrier_Response_& instance) = 0;

            protected:
                SetLoadCarrier_Response_DataReaderView () {};
                ~SetLoadCarrier_Response_DataReaderView () {};
            private:
                SetLoadCarrier_Response_DataReaderView (const SetLoadCarrier_Response_DataReaderView &);
                SetLoadCarrier_Response_DataReaderView & operator = (const SetLoadCarrier_Response_DataReaderView &);
            };
            class Sample_SetLoadCarrier_Request_TypeSupportInterface;

            typedef Sample_SetLoadCarrier_Request_TypeSupportInterface * Sample_SetLoadCarrier_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetLoadCarrier_Request_TypeSupportInterface> Sample_SetLoadCarrier_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetLoadCarrier_Request_TypeSupportInterface> Sample_SetLoadCarrier_Request_TypeSupportInterface_out;


            class Sample_SetLoadCarrier_Request_DataWriter;

            typedef Sample_SetLoadCarrier_Request_DataWriter * Sample_SetLoadCarrier_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetLoadCarrier_Request_DataWriter> Sample_SetLoadCarrier_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetLoadCarrier_Request_DataWriter> Sample_SetLoadCarrier_Request_DataWriter_out;


            class Sample_SetLoadCarrier_Request_DataReader;

            typedef Sample_SetLoadCarrier_Request_DataReader * Sample_SetLoadCarrier_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetLoadCarrier_Request_DataReader> Sample_SetLoadCarrier_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetLoadCarrier_Request_DataReader> Sample_SetLoadCarrier_Request_DataReader_out;


            class Sample_SetLoadCarrier_Request_DataReaderView;

            typedef Sample_SetLoadCarrier_Request_DataReaderView * Sample_SetLoadCarrier_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetLoadCarrier_Request_DataReaderView> Sample_SetLoadCarrier_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetLoadCarrier_Request_DataReaderView> Sample_SetLoadCarrier_Request_DataReaderView_out;

            struct Sample_SetLoadCarrier_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetLoadCarrier_Request_, struct Sample_SetLoadCarrier_Request_Seq_uniq_> Sample_SetLoadCarrier_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetLoadCarrier_Request_Seq> Sample_SetLoadCarrier_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetLoadCarrier_Request_Seq> Sample_SetLoadCarrier_Request_Seq_out;

            class  Sample_SetLoadCarrier_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetLoadCarrier_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetLoadCarrier_Request_TypeSupportInterface_var _var_type;

                static Sample_SetLoadCarrier_Request_TypeSupportInterface_ptr _duplicate (Sample_SetLoadCarrier_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetLoadCarrier_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetLoadCarrier_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetLoadCarrier_Request_TypeSupportInterface () {};
                ~Sample_SetLoadCarrier_Request_TypeSupportInterface () {};
            private:
                Sample_SetLoadCarrier_Request_TypeSupportInterface (const Sample_SetLoadCarrier_Request_TypeSupportInterface &);
                Sample_SetLoadCarrier_Request_TypeSupportInterface & operator = (const Sample_SetLoadCarrier_Request_TypeSupportInterface &);
            };

            class  Sample_SetLoadCarrier_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetLoadCarrier_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SetLoadCarrier_Request_DataWriter_var _var_type;

                static Sample_SetLoadCarrier_Request_DataWriter_ptr _duplicate (Sample_SetLoadCarrier_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetLoadCarrier_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetLoadCarrier_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetLoadCarrier_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetLoadCarrier_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetLoadCarrier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetLoadCarrier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetLoadCarrier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetLoadCarrier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetLoadCarrier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetLoadCarrier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetLoadCarrier_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetLoadCarrier_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetLoadCarrier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetLoadCarrier_Request_& instance_data) = 0;

            protected:
                Sample_SetLoadCarrier_Request_DataWriter () {};
                ~Sample_SetLoadCarrier_Request_DataWriter () {};
            private:
                Sample_SetLoadCarrier_Request_DataWriter (const Sample_SetLoadCarrier_Request_DataWriter &);
                Sample_SetLoadCarrier_Request_DataWriter & operator = (const Sample_SetLoadCarrier_Request_DataWriter &);
            };

            class  Sample_SetLoadCarrier_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetLoadCarrier_Request_DataReader_ptr _ptr_type;
                typedef Sample_SetLoadCarrier_Request_DataReader_var _var_type;

                static Sample_SetLoadCarrier_Request_DataReader_ptr _duplicate (Sample_SetLoadCarrier_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetLoadCarrier_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetLoadCarrier_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetLoadCarrier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetLoadCarrier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetLoadCarrier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetLoadCarrier_Request_& instance) = 0;

            protected:
                Sample_SetLoadCarrier_Request_DataReader () {};
                ~Sample_SetLoadCarrier_Request_DataReader () {};
            private:
                Sample_SetLoadCarrier_Request_DataReader (const Sample_SetLoadCarrier_Request_DataReader &);
                Sample_SetLoadCarrier_Request_DataReader & operator = (const Sample_SetLoadCarrier_Request_DataReader &);
            };

            class  Sample_SetLoadCarrier_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetLoadCarrier_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SetLoadCarrier_Request_DataReaderView_var _var_type;

                static Sample_SetLoadCarrier_Request_DataReaderView_ptr _duplicate (Sample_SetLoadCarrier_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetLoadCarrier_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetLoadCarrier_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetLoadCarrier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetLoadCarrier_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetLoadCarrier_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetLoadCarrier_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetLoadCarrier_Request_& instance) = 0;

            protected:
                Sample_SetLoadCarrier_Request_DataReaderView () {};
                ~Sample_SetLoadCarrier_Request_DataReaderView () {};
            private:
                Sample_SetLoadCarrier_Request_DataReaderView (const Sample_SetLoadCarrier_Request_DataReaderView &);
                Sample_SetLoadCarrier_Request_DataReaderView & operator = (const Sample_SetLoadCarrier_Request_DataReaderView &);
            };
            class Sample_SetLoadCarrier_Response_TypeSupportInterface;

            typedef Sample_SetLoadCarrier_Response_TypeSupportInterface * Sample_SetLoadCarrier_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetLoadCarrier_Response_TypeSupportInterface> Sample_SetLoadCarrier_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetLoadCarrier_Response_TypeSupportInterface> Sample_SetLoadCarrier_Response_TypeSupportInterface_out;


            class Sample_SetLoadCarrier_Response_DataWriter;

            typedef Sample_SetLoadCarrier_Response_DataWriter * Sample_SetLoadCarrier_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetLoadCarrier_Response_DataWriter> Sample_SetLoadCarrier_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetLoadCarrier_Response_DataWriter> Sample_SetLoadCarrier_Response_DataWriter_out;


            class Sample_SetLoadCarrier_Response_DataReader;

            typedef Sample_SetLoadCarrier_Response_DataReader * Sample_SetLoadCarrier_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetLoadCarrier_Response_DataReader> Sample_SetLoadCarrier_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetLoadCarrier_Response_DataReader> Sample_SetLoadCarrier_Response_DataReader_out;


            class Sample_SetLoadCarrier_Response_DataReaderView;

            typedef Sample_SetLoadCarrier_Response_DataReaderView * Sample_SetLoadCarrier_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetLoadCarrier_Response_DataReaderView> Sample_SetLoadCarrier_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetLoadCarrier_Response_DataReaderView> Sample_SetLoadCarrier_Response_DataReaderView_out;

            struct Sample_SetLoadCarrier_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetLoadCarrier_Response_, struct Sample_SetLoadCarrier_Response_Seq_uniq_> Sample_SetLoadCarrier_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetLoadCarrier_Response_Seq> Sample_SetLoadCarrier_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetLoadCarrier_Response_Seq> Sample_SetLoadCarrier_Response_Seq_out;

            class  Sample_SetLoadCarrier_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetLoadCarrier_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetLoadCarrier_Response_TypeSupportInterface_var _var_type;

                static Sample_SetLoadCarrier_Response_TypeSupportInterface_ptr _duplicate (Sample_SetLoadCarrier_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetLoadCarrier_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetLoadCarrier_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetLoadCarrier_Response_TypeSupportInterface () {};
                ~Sample_SetLoadCarrier_Response_TypeSupportInterface () {};
            private:
                Sample_SetLoadCarrier_Response_TypeSupportInterface (const Sample_SetLoadCarrier_Response_TypeSupportInterface &);
                Sample_SetLoadCarrier_Response_TypeSupportInterface & operator = (const Sample_SetLoadCarrier_Response_TypeSupportInterface &);
            };

            class  Sample_SetLoadCarrier_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetLoadCarrier_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SetLoadCarrier_Response_DataWriter_var _var_type;

                static Sample_SetLoadCarrier_Response_DataWriter_ptr _duplicate (Sample_SetLoadCarrier_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetLoadCarrier_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetLoadCarrier_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetLoadCarrier_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetLoadCarrier_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetLoadCarrier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetLoadCarrier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetLoadCarrier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetLoadCarrier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetLoadCarrier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetLoadCarrier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetLoadCarrier_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetLoadCarrier_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetLoadCarrier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetLoadCarrier_Response_& instance_data) = 0;

            protected:
                Sample_SetLoadCarrier_Response_DataWriter () {};
                ~Sample_SetLoadCarrier_Response_DataWriter () {};
            private:
                Sample_SetLoadCarrier_Response_DataWriter (const Sample_SetLoadCarrier_Response_DataWriter &);
                Sample_SetLoadCarrier_Response_DataWriter & operator = (const Sample_SetLoadCarrier_Response_DataWriter &);
            };

            class  Sample_SetLoadCarrier_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetLoadCarrier_Response_DataReader_ptr _ptr_type;
                typedef Sample_SetLoadCarrier_Response_DataReader_var _var_type;

                static Sample_SetLoadCarrier_Response_DataReader_ptr _duplicate (Sample_SetLoadCarrier_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetLoadCarrier_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetLoadCarrier_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetLoadCarrier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetLoadCarrier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetLoadCarrier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetLoadCarrier_Response_& instance) = 0;

            protected:
                Sample_SetLoadCarrier_Response_DataReader () {};
                ~Sample_SetLoadCarrier_Response_DataReader () {};
            private:
                Sample_SetLoadCarrier_Response_DataReader (const Sample_SetLoadCarrier_Response_DataReader &);
                Sample_SetLoadCarrier_Response_DataReader & operator = (const Sample_SetLoadCarrier_Response_DataReader &);
            };

            class  Sample_SetLoadCarrier_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetLoadCarrier_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SetLoadCarrier_Response_DataReaderView_var _var_type;

                static Sample_SetLoadCarrier_Response_DataReaderView_ptr _duplicate (Sample_SetLoadCarrier_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetLoadCarrier_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetLoadCarrier_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetLoadCarrier_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetLoadCarrier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetLoadCarrier_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetLoadCarrier_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetLoadCarrier_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetLoadCarrier_Response_& instance) = 0;

            protected:
                Sample_SetLoadCarrier_Response_DataReaderView () {};
                ~Sample_SetLoadCarrier_Response_DataReaderView () {};
            private:
                Sample_SetLoadCarrier_Response_DataReaderView (const Sample_SetLoadCarrier_Response_DataReaderView &);
                Sample_SetLoadCarrier_Response_DataReaderView & operator = (const Sample_SetLoadCarrier_Response_DataReaderView &);
            };
        }

    }

}

#endif
