#ifndef _H_639DDA6BBCDE6B4983C0CF4F71510B4B_SetRegionOfInterest2D_DCPS_H_
#define _H_639DDA6BBCDE6B4983C0CF4F71510B4B_SetRegionOfInterest2D_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetRegionOfInterest2D_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetRegionOfInterest2D_Request_TypeSupportInterface;

            typedef SetRegionOfInterest2D_Request_TypeSupportInterface * SetRegionOfInterest2D_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest2D_Request_TypeSupportInterface> SetRegionOfInterest2D_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest2D_Request_TypeSupportInterface> SetRegionOfInterest2D_Request_TypeSupportInterface_out;


            class SetRegionOfInterest2D_Request_DataWriter;

            typedef SetRegionOfInterest2D_Request_DataWriter * SetRegionOfInterest2D_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest2D_Request_DataWriter> SetRegionOfInterest2D_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest2D_Request_DataWriter> SetRegionOfInterest2D_Request_DataWriter_out;


            class SetRegionOfInterest2D_Request_DataReader;

            typedef SetRegionOfInterest2D_Request_DataReader * SetRegionOfInterest2D_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest2D_Request_DataReader> SetRegionOfInterest2D_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest2D_Request_DataReader> SetRegionOfInterest2D_Request_DataReader_out;


            class SetRegionOfInterest2D_Request_DataReaderView;

            typedef SetRegionOfInterest2D_Request_DataReaderView * SetRegionOfInterest2D_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest2D_Request_DataReaderView> SetRegionOfInterest2D_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest2D_Request_DataReaderView> SetRegionOfInterest2D_Request_DataReaderView_out;

            struct SetRegionOfInterest2D_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetRegionOfInterest2D_Request_, struct SetRegionOfInterest2D_Request_Seq_uniq_> SetRegionOfInterest2D_Request_Seq;
            typedef DDS_DCPSSequence_var < SetRegionOfInterest2D_Request_Seq> SetRegionOfInterest2D_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetRegionOfInterest2D_Request_Seq> SetRegionOfInterest2D_Request_Seq_out;

            class  SetRegionOfInterest2D_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetRegionOfInterest2D_Request_TypeSupportInterface_var _var_type;

                static SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _duplicate (SetRegionOfInterest2D_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetRegionOfInterest2D_Request_TypeSupportInterface () {};
                ~SetRegionOfInterest2D_Request_TypeSupportInterface () {};
            private:
                SetRegionOfInterest2D_Request_TypeSupportInterface (const SetRegionOfInterest2D_Request_TypeSupportInterface &);
                SetRegionOfInterest2D_Request_TypeSupportInterface & operator = (const SetRegionOfInterest2D_Request_TypeSupportInterface &);
            };

            class  SetRegionOfInterest2D_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetRegionOfInterest2D_Request_DataWriter_ptr _ptr_type;
                typedef SetRegionOfInterest2D_Request_DataWriter_var _var_type;

                static SetRegionOfInterest2D_Request_DataWriter_ptr _duplicate (SetRegionOfInterest2D_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest2D_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest2D_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetRegionOfInterest2D_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetRegionOfInterest2D_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest2D_Request_& instance_data) = 0;

            protected:
                SetRegionOfInterest2D_Request_DataWriter () {};
                ~SetRegionOfInterest2D_Request_DataWriter () {};
            private:
                SetRegionOfInterest2D_Request_DataWriter (const SetRegionOfInterest2D_Request_DataWriter &);
                SetRegionOfInterest2D_Request_DataWriter & operator = (const SetRegionOfInterest2D_Request_DataWriter &);
            };

            class  SetRegionOfInterest2D_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetRegionOfInterest2D_Request_DataReader_ptr _ptr_type;
                typedef SetRegionOfInterest2D_Request_DataReader_var _var_type;

                static SetRegionOfInterest2D_Request_DataReader_ptr _duplicate (SetRegionOfInterest2D_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest2D_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest2D_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRegionOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRegionOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest2D_Request_& instance) = 0;

            protected:
                SetRegionOfInterest2D_Request_DataReader () {};
                ~SetRegionOfInterest2D_Request_DataReader () {};
            private:
                SetRegionOfInterest2D_Request_DataReader (const SetRegionOfInterest2D_Request_DataReader &);
                SetRegionOfInterest2D_Request_DataReader & operator = (const SetRegionOfInterest2D_Request_DataReader &);
            };

            class  SetRegionOfInterest2D_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetRegionOfInterest2D_Request_DataReaderView_ptr _ptr_type;
                typedef SetRegionOfInterest2D_Request_DataReaderView_var _var_type;

                static SetRegionOfInterest2D_Request_DataReaderView_ptr _duplicate (SetRegionOfInterest2D_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest2D_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest2D_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRegionOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRegionOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest2D_Request_& instance) = 0;

            protected:
                SetRegionOfInterest2D_Request_DataReaderView () {};
                ~SetRegionOfInterest2D_Request_DataReaderView () {};
            private:
                SetRegionOfInterest2D_Request_DataReaderView (const SetRegionOfInterest2D_Request_DataReaderView &);
                SetRegionOfInterest2D_Request_DataReaderView & operator = (const SetRegionOfInterest2D_Request_DataReaderView &);
            };
            class SetRegionOfInterest2D_Response_TypeSupportInterface;

            typedef SetRegionOfInterest2D_Response_TypeSupportInterface * SetRegionOfInterest2D_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest2D_Response_TypeSupportInterface> SetRegionOfInterest2D_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest2D_Response_TypeSupportInterface> SetRegionOfInterest2D_Response_TypeSupportInterface_out;


            class SetRegionOfInterest2D_Response_DataWriter;

            typedef SetRegionOfInterest2D_Response_DataWriter * SetRegionOfInterest2D_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest2D_Response_DataWriter> SetRegionOfInterest2D_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest2D_Response_DataWriter> SetRegionOfInterest2D_Response_DataWriter_out;


            class SetRegionOfInterest2D_Response_DataReader;

            typedef SetRegionOfInterest2D_Response_DataReader * SetRegionOfInterest2D_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest2D_Response_DataReader> SetRegionOfInterest2D_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest2D_Response_DataReader> SetRegionOfInterest2D_Response_DataReader_out;


            class SetRegionOfInterest2D_Response_DataReaderView;

            typedef SetRegionOfInterest2D_Response_DataReaderView * SetRegionOfInterest2D_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest2D_Response_DataReaderView> SetRegionOfInterest2D_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest2D_Response_DataReaderView> SetRegionOfInterest2D_Response_DataReaderView_out;

            struct SetRegionOfInterest2D_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetRegionOfInterest2D_Response_, struct SetRegionOfInterest2D_Response_Seq_uniq_> SetRegionOfInterest2D_Response_Seq;
            typedef DDS_DCPSSequence_var < SetRegionOfInterest2D_Response_Seq> SetRegionOfInterest2D_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetRegionOfInterest2D_Response_Seq> SetRegionOfInterest2D_Response_Seq_out;

            class  SetRegionOfInterest2D_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetRegionOfInterest2D_Response_TypeSupportInterface_var _var_type;

                static SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _duplicate (SetRegionOfInterest2D_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetRegionOfInterest2D_Response_TypeSupportInterface () {};
                ~SetRegionOfInterest2D_Response_TypeSupportInterface () {};
            private:
                SetRegionOfInterest2D_Response_TypeSupportInterface (const SetRegionOfInterest2D_Response_TypeSupportInterface &);
                SetRegionOfInterest2D_Response_TypeSupportInterface & operator = (const SetRegionOfInterest2D_Response_TypeSupportInterface &);
            };

            class  SetRegionOfInterest2D_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetRegionOfInterest2D_Response_DataWriter_ptr _ptr_type;
                typedef SetRegionOfInterest2D_Response_DataWriter_var _var_type;

                static SetRegionOfInterest2D_Response_DataWriter_ptr _duplicate (SetRegionOfInterest2D_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest2D_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest2D_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetRegionOfInterest2D_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetRegionOfInterest2D_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest2D_Response_& instance_data) = 0;

            protected:
                SetRegionOfInterest2D_Response_DataWriter () {};
                ~SetRegionOfInterest2D_Response_DataWriter () {};
            private:
                SetRegionOfInterest2D_Response_DataWriter (const SetRegionOfInterest2D_Response_DataWriter &);
                SetRegionOfInterest2D_Response_DataWriter & operator = (const SetRegionOfInterest2D_Response_DataWriter &);
            };

            class  SetRegionOfInterest2D_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetRegionOfInterest2D_Response_DataReader_ptr _ptr_type;
                typedef SetRegionOfInterest2D_Response_DataReader_var _var_type;

                static SetRegionOfInterest2D_Response_DataReader_ptr _duplicate (SetRegionOfInterest2D_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest2D_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest2D_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRegionOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRegionOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest2D_Response_& instance) = 0;

            protected:
                SetRegionOfInterest2D_Response_DataReader () {};
                ~SetRegionOfInterest2D_Response_DataReader () {};
            private:
                SetRegionOfInterest2D_Response_DataReader (const SetRegionOfInterest2D_Response_DataReader &);
                SetRegionOfInterest2D_Response_DataReader & operator = (const SetRegionOfInterest2D_Response_DataReader &);
            };

            class  SetRegionOfInterest2D_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetRegionOfInterest2D_Response_DataReaderView_ptr _ptr_type;
                typedef SetRegionOfInterest2D_Response_DataReaderView_var _var_type;

                static SetRegionOfInterest2D_Response_DataReaderView_ptr _duplicate (SetRegionOfInterest2D_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest2D_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest2D_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest2D_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRegionOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRegionOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest2D_Response_& instance) = 0;

            protected:
                SetRegionOfInterest2D_Response_DataReaderView () {};
                ~SetRegionOfInterest2D_Response_DataReaderView () {};
            private:
                SetRegionOfInterest2D_Response_DataReaderView (const SetRegionOfInterest2D_Response_DataReaderView &);
                SetRegionOfInterest2D_Response_DataReaderView & operator = (const SetRegionOfInterest2D_Response_DataReaderView &);
            };
            class Sample_SetRegionOfInterest2D_Request_TypeSupportInterface;

            typedef Sample_SetRegionOfInterest2D_Request_TypeSupportInterface * Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest2D_Request_TypeSupportInterface> Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest2D_Request_TypeSupportInterface> Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_out;


            class Sample_SetRegionOfInterest2D_Request_DataWriter;

            typedef Sample_SetRegionOfInterest2D_Request_DataWriter * Sample_SetRegionOfInterest2D_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest2D_Request_DataWriter> Sample_SetRegionOfInterest2D_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest2D_Request_DataWriter> Sample_SetRegionOfInterest2D_Request_DataWriter_out;


            class Sample_SetRegionOfInterest2D_Request_DataReader;

            typedef Sample_SetRegionOfInterest2D_Request_DataReader * Sample_SetRegionOfInterest2D_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest2D_Request_DataReader> Sample_SetRegionOfInterest2D_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest2D_Request_DataReader> Sample_SetRegionOfInterest2D_Request_DataReader_out;


            class Sample_SetRegionOfInterest2D_Request_DataReaderView;

            typedef Sample_SetRegionOfInterest2D_Request_DataReaderView * Sample_SetRegionOfInterest2D_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest2D_Request_DataReaderView> Sample_SetRegionOfInterest2D_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest2D_Request_DataReaderView> Sample_SetRegionOfInterest2D_Request_DataReaderView_out;

            struct Sample_SetRegionOfInterest2D_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetRegionOfInterest2D_Request_, struct Sample_SetRegionOfInterest2D_Request_Seq_uniq_> Sample_SetRegionOfInterest2D_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetRegionOfInterest2D_Request_Seq> Sample_SetRegionOfInterest2D_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetRegionOfInterest2D_Request_Seq> Sample_SetRegionOfInterest2D_Request_Seq_out;

            class  Sample_SetRegionOfInterest2D_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_var _var_type;

                static Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _duplicate (Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest2D_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetRegionOfInterest2D_Request_TypeSupportInterface () {};
                ~Sample_SetRegionOfInterest2D_Request_TypeSupportInterface () {};
            private:
                Sample_SetRegionOfInterest2D_Request_TypeSupportInterface (const Sample_SetRegionOfInterest2D_Request_TypeSupportInterface &);
                Sample_SetRegionOfInterest2D_Request_TypeSupportInterface & operator = (const Sample_SetRegionOfInterest2D_Request_TypeSupportInterface &);
            };

            class  Sample_SetRegionOfInterest2D_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetRegionOfInterest2D_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest2D_Request_DataWriter_var _var_type;

                static Sample_SetRegionOfInterest2D_Request_DataWriter_ptr _duplicate (Sample_SetRegionOfInterest2D_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest2D_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest2D_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetRegionOfInterest2D_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetRegionOfInterest2D_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetRegionOfInterest2D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest2D_Request_& instance_data) = 0;

            protected:
                Sample_SetRegionOfInterest2D_Request_DataWriter () {};
                ~Sample_SetRegionOfInterest2D_Request_DataWriter () {};
            private:
                Sample_SetRegionOfInterest2D_Request_DataWriter (const Sample_SetRegionOfInterest2D_Request_DataWriter &);
                Sample_SetRegionOfInterest2D_Request_DataWriter & operator = (const Sample_SetRegionOfInterest2D_Request_DataWriter &);
            };

            class  Sample_SetRegionOfInterest2D_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetRegionOfInterest2D_Request_DataReader_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest2D_Request_DataReader_var _var_type;

                static Sample_SetRegionOfInterest2D_Request_DataReader_ptr _duplicate (Sample_SetRegionOfInterest2D_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest2D_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest2D_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRegionOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRegionOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest2D_Request_& instance) = 0;

            protected:
                Sample_SetRegionOfInterest2D_Request_DataReader () {};
                ~Sample_SetRegionOfInterest2D_Request_DataReader () {};
            private:
                Sample_SetRegionOfInterest2D_Request_DataReader (const Sample_SetRegionOfInterest2D_Request_DataReader &);
                Sample_SetRegionOfInterest2D_Request_DataReader & operator = (const Sample_SetRegionOfInterest2D_Request_DataReader &);
            };

            class  Sample_SetRegionOfInterest2D_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetRegionOfInterest2D_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest2D_Request_DataReaderView_var _var_type;

                static Sample_SetRegionOfInterest2D_Request_DataReaderView_ptr _duplicate (Sample_SetRegionOfInterest2D_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest2D_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest2D_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRegionOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRegionOfInterest2D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRegionOfInterest2D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest2D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest2D_Request_& instance) = 0;

            protected:
                Sample_SetRegionOfInterest2D_Request_DataReaderView () {};
                ~Sample_SetRegionOfInterest2D_Request_DataReaderView () {};
            private:
                Sample_SetRegionOfInterest2D_Request_DataReaderView (const Sample_SetRegionOfInterest2D_Request_DataReaderView &);
                Sample_SetRegionOfInterest2D_Request_DataReaderView & operator = (const Sample_SetRegionOfInterest2D_Request_DataReaderView &);
            };
            class Sample_SetRegionOfInterest2D_Response_TypeSupportInterface;

            typedef Sample_SetRegionOfInterest2D_Response_TypeSupportInterface * Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest2D_Response_TypeSupportInterface> Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest2D_Response_TypeSupportInterface> Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_out;


            class Sample_SetRegionOfInterest2D_Response_DataWriter;

            typedef Sample_SetRegionOfInterest2D_Response_DataWriter * Sample_SetRegionOfInterest2D_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest2D_Response_DataWriter> Sample_SetRegionOfInterest2D_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest2D_Response_DataWriter> Sample_SetRegionOfInterest2D_Response_DataWriter_out;


            class Sample_SetRegionOfInterest2D_Response_DataReader;

            typedef Sample_SetRegionOfInterest2D_Response_DataReader * Sample_SetRegionOfInterest2D_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest2D_Response_DataReader> Sample_SetRegionOfInterest2D_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest2D_Response_DataReader> Sample_SetRegionOfInterest2D_Response_DataReader_out;


            class Sample_SetRegionOfInterest2D_Response_DataReaderView;

            typedef Sample_SetRegionOfInterest2D_Response_DataReaderView * Sample_SetRegionOfInterest2D_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest2D_Response_DataReaderView> Sample_SetRegionOfInterest2D_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest2D_Response_DataReaderView> Sample_SetRegionOfInterest2D_Response_DataReaderView_out;

            struct Sample_SetRegionOfInterest2D_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetRegionOfInterest2D_Response_, struct Sample_SetRegionOfInterest2D_Response_Seq_uniq_> Sample_SetRegionOfInterest2D_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetRegionOfInterest2D_Response_Seq> Sample_SetRegionOfInterest2D_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetRegionOfInterest2D_Response_Seq> Sample_SetRegionOfInterest2D_Response_Seq_out;

            class  Sample_SetRegionOfInterest2D_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_var _var_type;

                static Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _duplicate (Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest2D_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetRegionOfInterest2D_Response_TypeSupportInterface () {};
                ~Sample_SetRegionOfInterest2D_Response_TypeSupportInterface () {};
            private:
                Sample_SetRegionOfInterest2D_Response_TypeSupportInterface (const Sample_SetRegionOfInterest2D_Response_TypeSupportInterface &);
                Sample_SetRegionOfInterest2D_Response_TypeSupportInterface & operator = (const Sample_SetRegionOfInterest2D_Response_TypeSupportInterface &);
            };

            class  Sample_SetRegionOfInterest2D_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetRegionOfInterest2D_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest2D_Response_DataWriter_var _var_type;

                static Sample_SetRegionOfInterest2D_Response_DataWriter_ptr _duplicate (Sample_SetRegionOfInterest2D_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest2D_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest2D_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetRegionOfInterest2D_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetRegionOfInterest2D_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetRegionOfInterest2D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest2D_Response_& instance_data) = 0;

            protected:
                Sample_SetRegionOfInterest2D_Response_DataWriter () {};
                ~Sample_SetRegionOfInterest2D_Response_DataWriter () {};
            private:
                Sample_SetRegionOfInterest2D_Response_DataWriter (const Sample_SetRegionOfInterest2D_Response_DataWriter &);
                Sample_SetRegionOfInterest2D_Response_DataWriter & operator = (const Sample_SetRegionOfInterest2D_Response_DataWriter &);
            };

            class  Sample_SetRegionOfInterest2D_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetRegionOfInterest2D_Response_DataReader_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest2D_Response_DataReader_var _var_type;

                static Sample_SetRegionOfInterest2D_Response_DataReader_ptr _duplicate (Sample_SetRegionOfInterest2D_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest2D_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest2D_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRegionOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRegionOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest2D_Response_& instance) = 0;

            protected:
                Sample_SetRegionOfInterest2D_Response_DataReader () {};
                ~Sample_SetRegionOfInterest2D_Response_DataReader () {};
            private:
                Sample_SetRegionOfInterest2D_Response_DataReader (const Sample_SetRegionOfInterest2D_Response_DataReader &);
                Sample_SetRegionOfInterest2D_Response_DataReader & operator = (const Sample_SetRegionOfInterest2D_Response_DataReader &);
            };

            class  Sample_SetRegionOfInterest2D_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetRegionOfInterest2D_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest2D_Response_DataReaderView_var _var_type;

                static Sample_SetRegionOfInterest2D_Response_DataReaderView_ptr _duplicate (Sample_SetRegionOfInterest2D_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest2D_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest2D_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest2D_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRegionOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRegionOfInterest2D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRegionOfInterest2D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest2D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest2D_Response_& instance) = 0;

            protected:
                Sample_SetRegionOfInterest2D_Response_DataReaderView () {};
                ~Sample_SetRegionOfInterest2D_Response_DataReaderView () {};
            private:
                Sample_SetRegionOfInterest2D_Response_DataReaderView (const Sample_SetRegionOfInterest2D_Response_DataReaderView &);
                Sample_SetRegionOfInterest2D_Response_DataReaderView & operator = (const Sample_SetRegionOfInterest2D_Response_DataReaderView &);
            };
        }

    }

}

#endif
