#ifndef _H_71D4F84DD251CF2400F8ECACFEF255F1_SetRegionOfInterest3D_DCPS_H_
#define _H_71D4F84DD251CF2400F8ECACFEF255F1_SetRegionOfInterest3D_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetRegionOfInterest3D_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetRegionOfInterest3D_Request_TypeSupportInterface;

            typedef SetRegionOfInterest3D_Request_TypeSupportInterface * SetRegionOfInterest3D_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest3D_Request_TypeSupportInterface> SetRegionOfInterest3D_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest3D_Request_TypeSupportInterface> SetRegionOfInterest3D_Request_TypeSupportInterface_out;


            class SetRegionOfInterest3D_Request_DataWriter;

            typedef SetRegionOfInterest3D_Request_DataWriter * SetRegionOfInterest3D_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest3D_Request_DataWriter> SetRegionOfInterest3D_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest3D_Request_DataWriter> SetRegionOfInterest3D_Request_DataWriter_out;


            class SetRegionOfInterest3D_Request_DataReader;

            typedef SetRegionOfInterest3D_Request_DataReader * SetRegionOfInterest3D_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest3D_Request_DataReader> SetRegionOfInterest3D_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest3D_Request_DataReader> SetRegionOfInterest3D_Request_DataReader_out;


            class SetRegionOfInterest3D_Request_DataReaderView;

            typedef SetRegionOfInterest3D_Request_DataReaderView * SetRegionOfInterest3D_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest3D_Request_DataReaderView> SetRegionOfInterest3D_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest3D_Request_DataReaderView> SetRegionOfInterest3D_Request_DataReaderView_out;

            struct SetRegionOfInterest3D_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetRegionOfInterest3D_Request_, struct SetRegionOfInterest3D_Request_Seq_uniq_> SetRegionOfInterest3D_Request_Seq;
            typedef DDS_DCPSSequence_var < SetRegionOfInterest3D_Request_Seq> SetRegionOfInterest3D_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetRegionOfInterest3D_Request_Seq> SetRegionOfInterest3D_Request_Seq_out;

            class  SetRegionOfInterest3D_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetRegionOfInterest3D_Request_TypeSupportInterface_var _var_type;

                static SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _duplicate (SetRegionOfInterest3D_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetRegionOfInterest3D_Request_TypeSupportInterface () {};
                ~SetRegionOfInterest3D_Request_TypeSupportInterface () {};
            private:
                SetRegionOfInterest3D_Request_TypeSupportInterface (const SetRegionOfInterest3D_Request_TypeSupportInterface &);
                SetRegionOfInterest3D_Request_TypeSupportInterface & operator = (const SetRegionOfInterest3D_Request_TypeSupportInterface &);
            };

            class  SetRegionOfInterest3D_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetRegionOfInterest3D_Request_DataWriter_ptr _ptr_type;
                typedef SetRegionOfInterest3D_Request_DataWriter_var _var_type;

                static SetRegionOfInterest3D_Request_DataWriter_ptr _duplicate (SetRegionOfInterest3D_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest3D_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest3D_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetRegionOfInterest3D_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetRegionOfInterest3D_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest3D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest3D_Request_& instance_data) = 0;

            protected:
                SetRegionOfInterest3D_Request_DataWriter () {};
                ~SetRegionOfInterest3D_Request_DataWriter () {};
            private:
                SetRegionOfInterest3D_Request_DataWriter (const SetRegionOfInterest3D_Request_DataWriter &);
                SetRegionOfInterest3D_Request_DataWriter & operator = (const SetRegionOfInterest3D_Request_DataWriter &);
            };

            class  SetRegionOfInterest3D_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetRegionOfInterest3D_Request_DataReader_ptr _ptr_type;
                typedef SetRegionOfInterest3D_Request_DataReader_var _var_type;

                static SetRegionOfInterest3D_Request_DataReader_ptr _duplicate (SetRegionOfInterest3D_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest3D_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest3D_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRegionOfInterest3D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRegionOfInterest3D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest3D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest3D_Request_& instance) = 0;

            protected:
                SetRegionOfInterest3D_Request_DataReader () {};
                ~SetRegionOfInterest3D_Request_DataReader () {};
            private:
                SetRegionOfInterest3D_Request_DataReader (const SetRegionOfInterest3D_Request_DataReader &);
                SetRegionOfInterest3D_Request_DataReader & operator = (const SetRegionOfInterest3D_Request_DataReader &);
            };

            class  SetRegionOfInterest3D_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetRegionOfInterest3D_Request_DataReaderView_ptr _ptr_type;
                typedef SetRegionOfInterest3D_Request_DataReaderView_var _var_type;

                static SetRegionOfInterest3D_Request_DataReaderView_ptr _duplicate (SetRegionOfInterest3D_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest3D_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest3D_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRegionOfInterest3D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRegionOfInterest3D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest3D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest3D_Request_& instance) = 0;

            protected:
                SetRegionOfInterest3D_Request_DataReaderView () {};
                ~SetRegionOfInterest3D_Request_DataReaderView () {};
            private:
                SetRegionOfInterest3D_Request_DataReaderView (const SetRegionOfInterest3D_Request_DataReaderView &);
                SetRegionOfInterest3D_Request_DataReaderView & operator = (const SetRegionOfInterest3D_Request_DataReaderView &);
            };
            class SetRegionOfInterest3D_Response_TypeSupportInterface;

            typedef SetRegionOfInterest3D_Response_TypeSupportInterface * SetRegionOfInterest3D_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest3D_Response_TypeSupportInterface> SetRegionOfInterest3D_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest3D_Response_TypeSupportInterface> SetRegionOfInterest3D_Response_TypeSupportInterface_out;


            class SetRegionOfInterest3D_Response_DataWriter;

            typedef SetRegionOfInterest3D_Response_DataWriter * SetRegionOfInterest3D_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest3D_Response_DataWriter> SetRegionOfInterest3D_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest3D_Response_DataWriter> SetRegionOfInterest3D_Response_DataWriter_out;


            class SetRegionOfInterest3D_Response_DataReader;

            typedef SetRegionOfInterest3D_Response_DataReader * SetRegionOfInterest3D_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest3D_Response_DataReader> SetRegionOfInterest3D_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest3D_Response_DataReader> SetRegionOfInterest3D_Response_DataReader_out;


            class SetRegionOfInterest3D_Response_DataReaderView;

            typedef SetRegionOfInterest3D_Response_DataReaderView * SetRegionOfInterest3D_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetRegionOfInterest3D_Response_DataReaderView> SetRegionOfInterest3D_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetRegionOfInterest3D_Response_DataReaderView> SetRegionOfInterest3D_Response_DataReaderView_out;

            struct SetRegionOfInterest3D_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetRegionOfInterest3D_Response_, struct SetRegionOfInterest3D_Response_Seq_uniq_> SetRegionOfInterest3D_Response_Seq;
            typedef DDS_DCPSSequence_var < SetRegionOfInterest3D_Response_Seq> SetRegionOfInterest3D_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetRegionOfInterest3D_Response_Seq> SetRegionOfInterest3D_Response_Seq_out;

            class  SetRegionOfInterest3D_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetRegionOfInterest3D_Response_TypeSupportInterface_var _var_type;

                static SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _duplicate (SetRegionOfInterest3D_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetRegionOfInterest3D_Response_TypeSupportInterface () {};
                ~SetRegionOfInterest3D_Response_TypeSupportInterface () {};
            private:
                SetRegionOfInterest3D_Response_TypeSupportInterface (const SetRegionOfInterest3D_Response_TypeSupportInterface &);
                SetRegionOfInterest3D_Response_TypeSupportInterface & operator = (const SetRegionOfInterest3D_Response_TypeSupportInterface &);
            };

            class  SetRegionOfInterest3D_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetRegionOfInterest3D_Response_DataWriter_ptr _ptr_type;
                typedef SetRegionOfInterest3D_Response_DataWriter_var _var_type;

                static SetRegionOfInterest3D_Response_DataWriter_ptr _duplicate (SetRegionOfInterest3D_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest3D_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest3D_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetRegionOfInterest3D_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetRegionOfInterest3D_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest3D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest3D_Response_& instance_data) = 0;

            protected:
                SetRegionOfInterest3D_Response_DataWriter () {};
                ~SetRegionOfInterest3D_Response_DataWriter () {};
            private:
                SetRegionOfInterest3D_Response_DataWriter (const SetRegionOfInterest3D_Response_DataWriter &);
                SetRegionOfInterest3D_Response_DataWriter & operator = (const SetRegionOfInterest3D_Response_DataWriter &);
            };

            class  SetRegionOfInterest3D_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetRegionOfInterest3D_Response_DataReader_ptr _ptr_type;
                typedef SetRegionOfInterest3D_Response_DataReader_var _var_type;

                static SetRegionOfInterest3D_Response_DataReader_ptr _duplicate (SetRegionOfInterest3D_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest3D_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest3D_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRegionOfInterest3D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRegionOfInterest3D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest3D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest3D_Response_& instance) = 0;

            protected:
                SetRegionOfInterest3D_Response_DataReader () {};
                ~SetRegionOfInterest3D_Response_DataReader () {};
            private:
                SetRegionOfInterest3D_Response_DataReader (const SetRegionOfInterest3D_Response_DataReader &);
                SetRegionOfInterest3D_Response_DataReader & operator = (const SetRegionOfInterest3D_Response_DataReader &);
            };

            class  SetRegionOfInterest3D_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetRegionOfInterest3D_Response_DataReaderView_ptr _ptr_type;
                typedef SetRegionOfInterest3D_Response_DataReaderView_var _var_type;

                static SetRegionOfInterest3D_Response_DataReaderView_ptr _duplicate (SetRegionOfInterest3D_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetRegionOfInterest3D_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetRegionOfInterest3D_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetRegionOfInterest3D_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetRegionOfInterest3D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetRegionOfInterest3D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetRegionOfInterest3D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetRegionOfInterest3D_Response_& instance) = 0;

            protected:
                SetRegionOfInterest3D_Response_DataReaderView () {};
                ~SetRegionOfInterest3D_Response_DataReaderView () {};
            private:
                SetRegionOfInterest3D_Response_DataReaderView (const SetRegionOfInterest3D_Response_DataReaderView &);
                SetRegionOfInterest3D_Response_DataReaderView & operator = (const SetRegionOfInterest3D_Response_DataReaderView &);
            };
            class Sample_SetRegionOfInterest3D_Request_TypeSupportInterface;

            typedef Sample_SetRegionOfInterest3D_Request_TypeSupportInterface * Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest3D_Request_TypeSupportInterface> Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest3D_Request_TypeSupportInterface> Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_out;


            class Sample_SetRegionOfInterest3D_Request_DataWriter;

            typedef Sample_SetRegionOfInterest3D_Request_DataWriter * Sample_SetRegionOfInterest3D_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest3D_Request_DataWriter> Sample_SetRegionOfInterest3D_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest3D_Request_DataWriter> Sample_SetRegionOfInterest3D_Request_DataWriter_out;


            class Sample_SetRegionOfInterest3D_Request_DataReader;

            typedef Sample_SetRegionOfInterest3D_Request_DataReader * Sample_SetRegionOfInterest3D_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest3D_Request_DataReader> Sample_SetRegionOfInterest3D_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest3D_Request_DataReader> Sample_SetRegionOfInterest3D_Request_DataReader_out;


            class Sample_SetRegionOfInterest3D_Request_DataReaderView;

            typedef Sample_SetRegionOfInterest3D_Request_DataReaderView * Sample_SetRegionOfInterest3D_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest3D_Request_DataReaderView> Sample_SetRegionOfInterest3D_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest3D_Request_DataReaderView> Sample_SetRegionOfInterest3D_Request_DataReaderView_out;

            struct Sample_SetRegionOfInterest3D_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetRegionOfInterest3D_Request_, struct Sample_SetRegionOfInterest3D_Request_Seq_uniq_> Sample_SetRegionOfInterest3D_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetRegionOfInterest3D_Request_Seq> Sample_SetRegionOfInterest3D_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetRegionOfInterest3D_Request_Seq> Sample_SetRegionOfInterest3D_Request_Seq_out;

            class  Sample_SetRegionOfInterest3D_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_var _var_type;

                static Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _duplicate (Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest3D_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetRegionOfInterest3D_Request_TypeSupportInterface () {};
                ~Sample_SetRegionOfInterest3D_Request_TypeSupportInterface () {};
            private:
                Sample_SetRegionOfInterest3D_Request_TypeSupportInterface (const Sample_SetRegionOfInterest3D_Request_TypeSupportInterface &);
                Sample_SetRegionOfInterest3D_Request_TypeSupportInterface & operator = (const Sample_SetRegionOfInterest3D_Request_TypeSupportInterface &);
            };

            class  Sample_SetRegionOfInterest3D_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetRegionOfInterest3D_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest3D_Request_DataWriter_var _var_type;

                static Sample_SetRegionOfInterest3D_Request_DataWriter_ptr _duplicate (Sample_SetRegionOfInterest3D_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest3D_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest3D_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetRegionOfInterest3D_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetRegionOfInterest3D_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetRegionOfInterest3D_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest3D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest3D_Request_& instance_data) = 0;

            protected:
                Sample_SetRegionOfInterest3D_Request_DataWriter () {};
                ~Sample_SetRegionOfInterest3D_Request_DataWriter () {};
            private:
                Sample_SetRegionOfInterest3D_Request_DataWriter (const Sample_SetRegionOfInterest3D_Request_DataWriter &);
                Sample_SetRegionOfInterest3D_Request_DataWriter & operator = (const Sample_SetRegionOfInterest3D_Request_DataWriter &);
            };

            class  Sample_SetRegionOfInterest3D_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetRegionOfInterest3D_Request_DataReader_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest3D_Request_DataReader_var _var_type;

                static Sample_SetRegionOfInterest3D_Request_DataReader_ptr _duplicate (Sample_SetRegionOfInterest3D_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest3D_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest3D_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRegionOfInterest3D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRegionOfInterest3D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest3D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest3D_Request_& instance) = 0;

            protected:
                Sample_SetRegionOfInterest3D_Request_DataReader () {};
                ~Sample_SetRegionOfInterest3D_Request_DataReader () {};
            private:
                Sample_SetRegionOfInterest3D_Request_DataReader (const Sample_SetRegionOfInterest3D_Request_DataReader &);
                Sample_SetRegionOfInterest3D_Request_DataReader & operator = (const Sample_SetRegionOfInterest3D_Request_DataReader &);
            };

            class  Sample_SetRegionOfInterest3D_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetRegionOfInterest3D_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest3D_Request_DataReaderView_var _var_type;

                static Sample_SetRegionOfInterest3D_Request_DataReaderView_ptr _duplicate (Sample_SetRegionOfInterest3D_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest3D_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest3D_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRegionOfInterest3D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRegionOfInterest3D_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRegionOfInterest3D_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest3D_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest3D_Request_& instance) = 0;

            protected:
                Sample_SetRegionOfInterest3D_Request_DataReaderView () {};
                ~Sample_SetRegionOfInterest3D_Request_DataReaderView () {};
            private:
                Sample_SetRegionOfInterest3D_Request_DataReaderView (const Sample_SetRegionOfInterest3D_Request_DataReaderView &);
                Sample_SetRegionOfInterest3D_Request_DataReaderView & operator = (const Sample_SetRegionOfInterest3D_Request_DataReaderView &);
            };
            class Sample_SetRegionOfInterest3D_Response_TypeSupportInterface;

            typedef Sample_SetRegionOfInterest3D_Response_TypeSupportInterface * Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest3D_Response_TypeSupportInterface> Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest3D_Response_TypeSupportInterface> Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_out;


            class Sample_SetRegionOfInterest3D_Response_DataWriter;

            typedef Sample_SetRegionOfInterest3D_Response_DataWriter * Sample_SetRegionOfInterest3D_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest3D_Response_DataWriter> Sample_SetRegionOfInterest3D_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest3D_Response_DataWriter> Sample_SetRegionOfInterest3D_Response_DataWriter_out;


            class Sample_SetRegionOfInterest3D_Response_DataReader;

            typedef Sample_SetRegionOfInterest3D_Response_DataReader * Sample_SetRegionOfInterest3D_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest3D_Response_DataReader> Sample_SetRegionOfInterest3D_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest3D_Response_DataReader> Sample_SetRegionOfInterest3D_Response_DataReader_out;


            class Sample_SetRegionOfInterest3D_Response_DataReaderView;

            typedef Sample_SetRegionOfInterest3D_Response_DataReaderView * Sample_SetRegionOfInterest3D_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetRegionOfInterest3D_Response_DataReaderView> Sample_SetRegionOfInterest3D_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetRegionOfInterest3D_Response_DataReaderView> Sample_SetRegionOfInterest3D_Response_DataReaderView_out;

            struct Sample_SetRegionOfInterest3D_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetRegionOfInterest3D_Response_, struct Sample_SetRegionOfInterest3D_Response_Seq_uniq_> Sample_SetRegionOfInterest3D_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetRegionOfInterest3D_Response_Seq> Sample_SetRegionOfInterest3D_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetRegionOfInterest3D_Response_Seq> Sample_SetRegionOfInterest3D_Response_Seq_out;

            class  Sample_SetRegionOfInterest3D_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_var _var_type;

                static Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _duplicate (Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest3D_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetRegionOfInterest3D_Response_TypeSupportInterface () {};
                ~Sample_SetRegionOfInterest3D_Response_TypeSupportInterface () {};
            private:
                Sample_SetRegionOfInterest3D_Response_TypeSupportInterface (const Sample_SetRegionOfInterest3D_Response_TypeSupportInterface &);
                Sample_SetRegionOfInterest3D_Response_TypeSupportInterface & operator = (const Sample_SetRegionOfInterest3D_Response_TypeSupportInterface &);
            };

            class  Sample_SetRegionOfInterest3D_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetRegionOfInterest3D_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest3D_Response_DataWriter_var _var_type;

                static Sample_SetRegionOfInterest3D_Response_DataWriter_ptr _duplicate (Sample_SetRegionOfInterest3D_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest3D_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest3D_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetRegionOfInterest3D_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetRegionOfInterest3D_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetRegionOfInterest3D_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest3D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest3D_Response_& instance_data) = 0;

            protected:
                Sample_SetRegionOfInterest3D_Response_DataWriter () {};
                ~Sample_SetRegionOfInterest3D_Response_DataWriter () {};
            private:
                Sample_SetRegionOfInterest3D_Response_DataWriter (const Sample_SetRegionOfInterest3D_Response_DataWriter &);
                Sample_SetRegionOfInterest3D_Response_DataWriter & operator = (const Sample_SetRegionOfInterest3D_Response_DataWriter &);
            };

            class  Sample_SetRegionOfInterest3D_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetRegionOfInterest3D_Response_DataReader_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest3D_Response_DataReader_var _var_type;

                static Sample_SetRegionOfInterest3D_Response_DataReader_ptr _duplicate (Sample_SetRegionOfInterest3D_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest3D_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest3D_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRegionOfInterest3D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRegionOfInterest3D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest3D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest3D_Response_& instance) = 0;

            protected:
                Sample_SetRegionOfInterest3D_Response_DataReader () {};
                ~Sample_SetRegionOfInterest3D_Response_DataReader () {};
            private:
                Sample_SetRegionOfInterest3D_Response_DataReader (const Sample_SetRegionOfInterest3D_Response_DataReader &);
                Sample_SetRegionOfInterest3D_Response_DataReader & operator = (const Sample_SetRegionOfInterest3D_Response_DataReader &);
            };

            class  Sample_SetRegionOfInterest3D_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetRegionOfInterest3D_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SetRegionOfInterest3D_Response_DataReaderView_var _var_type;

                static Sample_SetRegionOfInterest3D_Response_DataReaderView_ptr _duplicate (Sample_SetRegionOfInterest3D_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetRegionOfInterest3D_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetRegionOfInterest3D_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetRegionOfInterest3D_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetRegionOfInterest3D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetRegionOfInterest3D_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetRegionOfInterest3D_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetRegionOfInterest3D_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetRegionOfInterest3D_Response_& instance) = 0;

            protected:
                Sample_SetRegionOfInterest3D_Response_DataReaderView () {};
                ~Sample_SetRegionOfInterest3D_Response_DataReaderView () {};
            private:
                Sample_SetRegionOfInterest3D_Response_DataReaderView (const Sample_SetRegionOfInterest3D_Response_DataReaderView &);
                Sample_SetRegionOfInterest3D_Response_DataReaderView & operator = (const Sample_SetRegionOfInterest3D_Response_DataReaderView &);
            };
        }

    }

}

#endif
