#ifndef _H_1D7CAE28B24644A9C5CD91E1B59080C5_SilhouetteMatchDetectObject__H_
#define _H_1D7CAE28B24644A9C5CD91E1B59080C5_SilhouetteMatchDetectObject__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/SilhouetteMatchObject_.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "rc_reason_msgs/msg/dds_opensplice/SilhouetteMatchInstance_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SilhouetteMatchDetectObject_Request_
            {
                ::rc_reason_msgs::msg::dds_::SilhouetteMatchObject_ object_to_detect_;
                ::DDS::Double offset_;
                ::DDS::String_mgr pose_frame_;
                ::geometry_msgs::msg::dds_::Pose_ robot_pose_;
            };

            typedef DDS_DCPSStruct_var<SilhouetteMatchDetectObject_Request_> SilhouetteMatchDetectObject_Request__var;
            typedef DDS_DCPSStruct_out < SilhouetteMatchDetectObject_Request_> SilhouetteMatchDetectObject_Request__out;

            struct  SilhouetteMatchDetectObject_Response_
            {
                struct _instances__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_reason_msgs::msg::dds_::SilhouetteMatchInstance_, struct _instances__seq_uniq_ > _instances__seq;
                typedef DDS_DCPSSequence_var< _instances__seq > _instances__seq_var;
                typedef DDS_DCPSSequence_out< _instances__seq > _instances__seq_out;
                ::builtin_interfaces::msg::dds_::Time_ timestamp_;
                ::DDS::String_mgr object_id_;
                _instances__seq instances_;
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<SilhouetteMatchDetectObject_Response_> SilhouetteMatchDetectObject_Response__var;
            typedef DDS_DCPSStruct_out < SilhouetteMatchDetectObject_Response_> SilhouetteMatchDetectObject_Response__out;

            struct  Sample_SilhouetteMatchDetectObject_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SilhouetteMatchDetectObject_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SilhouetteMatchDetectObject_Request_> Sample_SilhouetteMatchDetectObject_Request__var;
            typedef DDS_DCPSStruct_out < Sample_SilhouetteMatchDetectObject_Request_> Sample_SilhouetteMatchDetectObject_Request__out;

            struct  Sample_SilhouetteMatchDetectObject_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SilhouetteMatchDetectObject_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SilhouetteMatchDetectObject_Response_> Sample_SilhouetteMatchDetectObject_Response__var;
            typedef DDS_DCPSStruct_out < Sample_SilhouetteMatchDetectObject_Response_> Sample_SilhouetteMatchDetectObject_Response__out;

        }

    }

}

#endif /* _H_1D7CAE28B24644A9C5CD91E1B59080C5_SilhouetteMatchDetectObject__H_ */
