// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:srv/SetHandEyeCalibration.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__SET_HAND_EYE_CALIBRATION__STRUCT_HPP_
#define RC_REASON_MSGS__SRV__SET_HAND_EYE_CALIBRATION__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__SetHandEyeCalibration_Request __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__SetHandEyeCalibration_Request __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetHandEyeCalibration_Request_
{
  using Type = SetHandEyeCalibration_Request_<ContainerAllocator>;

  explicit SetHandEyeCalibration_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : pose(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->robot_mounted = false;
    }
  }

  explicit SetHandEyeCalibration_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : pose(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->robot_mounted = false;
    }
  }

  // field types and members
  using _pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _pose_type pose;
  using _robot_mounted_type =
    bool;
  _robot_mounted_type robot_mounted;

  // setters for named parameter idiom
  Type & set__pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__robot_mounted(
    const bool & _arg)
  {
    this->robot_mounted = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__SetHandEyeCalibration_Request
    std::shared_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__SetHandEyeCalibration_Request
    std::shared_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetHandEyeCalibration_Request_ & other) const
  {
    if (this->pose != other.pose) {
      return false;
    }
    if (this->robot_mounted != other.robot_mounted) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetHandEyeCalibration_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetHandEyeCalibration_Request_

// alias to use template instance with default allocator
using SetHandEyeCalibration_Request =
  rc_reason_msgs::srv::SetHandEyeCalibration_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__SetHandEyeCalibration_Response __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__SetHandEyeCalibration_Response __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetHandEyeCalibration_Response_
{
  using Type = SetHandEyeCalibration_Response_<ContainerAllocator>;

  explicit SetHandEyeCalibration_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->status = 0l;
      this->message = "";
    }
  }

  explicit SetHandEyeCalibration_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->status = 0l;
      this->message = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _status_type =
    int32_t;
  _status_type status;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__status(
    const int32_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__SetHandEyeCalibration_Response
    std::shared_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__SetHandEyeCalibration_Response
    std::shared_ptr<rc_reason_msgs::srv::SetHandEyeCalibration_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetHandEyeCalibration_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetHandEyeCalibration_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetHandEyeCalibration_Response_

// alias to use template instance with default allocator
using SetHandEyeCalibration_Response =
  rc_reason_msgs::srv::SetHandEyeCalibration_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{

namespace srv
{

struct SetHandEyeCalibration
{
  using Request = rc_reason_msgs::srv::SetHandEyeCalibration_Request;
  using Response = rc_reason_msgs::srv::SetHandEyeCalibration_Response;
};

}  // namespace srv

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__SET_HAND_EYE_CALIBRATION__STRUCT_HPP_
