#ifndef _H_C80F83E0F2BF631F408E81D86C52EA6B_CellFillingLevel__H_
#define _H_C80F83E0F2BF631F408E81D86C52EA6B_CellFillingLevel__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/Rectangle_.h"
#include "geometry_msgs/msg/dds_opensplice/Point_.h"
#include "rc_reason_msgs/msg/dds_opensplice/RangeValue_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  CellFillingLevel_
            {
                ::rc_reason_msgs::msg::dds_::Rectangle_ cell_size_;
                ::geometry_msgs::msg::dds_::Point_ cell_position_;
                ::rc_reason_msgs::msg::dds_::RangeValue_ level_in_percent_;
                ::rc_reason_msgs::msg::dds_::RangeValue_ level_free_in_meters_;
                ::DDS::Double coverage_;
            };

            typedef DDS_DCPSStruct_var<CellFillingLevel_> CellFillingLevel__var;
            typedef CellFillingLevel_& CellFillingLevel__out;

        }

    }

}

#endif /* _H_C80F83E0F2BF631F408E81D86C52EA6B_CellFillingLevel__H_ */
