#ifndef _H_C80F83E0F2BF631F408E81D86C52EA6B_CellFillingLevel_DCPS_H_
#define _H_C80F83E0F2BF631F408E81D86C52EA6B_CellFillingLevel_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CellFillingLevel_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CellFillingLevel_TypeSupportInterface;

            typedef CellFillingLevel_TypeSupportInterface * CellFillingLevel_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CellFillingLevel_TypeSupportInterface> CellFillingLevel_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CellFillingLevel_TypeSupportInterface> CellFillingLevel_TypeSupportInterface_out;


            class CellFillingLevel_DataWriter;

            typedef CellFillingLevel_DataWriter * CellFillingLevel_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CellFillingLevel_DataWriter> CellFillingLevel_DataWriter_var;
            typedef DDS_DCPSInterface_out < CellFillingLevel_DataWriter> CellFillingLevel_DataWriter_out;


            class CellFillingLevel_DataReader;

            typedef CellFillingLevel_DataReader * CellFillingLevel_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CellFillingLevel_DataReader> CellFillingLevel_DataReader_var;
            typedef DDS_DCPSInterface_out < CellFillingLevel_DataReader> CellFillingLevel_DataReader_out;


            class CellFillingLevel_DataReaderView;

            typedef CellFillingLevel_DataReaderView * CellFillingLevel_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CellFillingLevel_DataReaderView> CellFillingLevel_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CellFillingLevel_DataReaderView> CellFillingLevel_DataReaderView_out;

            struct CellFillingLevel_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < CellFillingLevel_, struct CellFillingLevel_Seq_uniq_> CellFillingLevel_Seq;
            typedef DDS_DCPSSequence_var < CellFillingLevel_Seq> CellFillingLevel_Seq_var;
            typedef DDS_DCPSSequence_out < CellFillingLevel_Seq> CellFillingLevel_Seq_out;

            class  CellFillingLevel_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CellFillingLevel_TypeSupportInterface_ptr _ptr_type;
                typedef CellFillingLevel_TypeSupportInterface_var _var_type;

                static CellFillingLevel_TypeSupportInterface_ptr _duplicate (CellFillingLevel_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CellFillingLevel_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CellFillingLevel_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CellFillingLevel_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CellFillingLevel_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CellFillingLevel_TypeSupportInterface () {};
                ~CellFillingLevel_TypeSupportInterface () {};
            private:
                CellFillingLevel_TypeSupportInterface (const CellFillingLevel_TypeSupportInterface &);
                CellFillingLevel_TypeSupportInterface & operator = (const CellFillingLevel_TypeSupportInterface &);
            };

            class  CellFillingLevel_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CellFillingLevel_DataWriter_ptr _ptr_type;
                typedef CellFillingLevel_DataWriter_var _var_type;

                static CellFillingLevel_DataWriter_ptr _duplicate (CellFillingLevel_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CellFillingLevel_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CellFillingLevel_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CellFillingLevel_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CellFillingLevel_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CellFillingLevel_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CellFillingLevel_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CellFillingLevel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CellFillingLevel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CellFillingLevel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CellFillingLevel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CellFillingLevel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CellFillingLevel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CellFillingLevel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CellFillingLevel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CellFillingLevel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CellFillingLevel_& instance_data) = 0;

            protected:
                CellFillingLevel_DataWriter () {};
                ~CellFillingLevel_DataWriter () {};
            private:
                CellFillingLevel_DataWriter (const CellFillingLevel_DataWriter &);
                CellFillingLevel_DataWriter & operator = (const CellFillingLevel_DataWriter &);
            };

            class  CellFillingLevel_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CellFillingLevel_DataReader_ptr _ptr_type;
                typedef CellFillingLevel_DataReader_var _var_type;

                static CellFillingLevel_DataReader_ptr _duplicate (CellFillingLevel_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CellFillingLevel_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CellFillingLevel_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CellFillingLevel_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CellFillingLevel_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CellFillingLevel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CellFillingLevel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CellFillingLevel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CellFillingLevel_& instance) = 0;

            protected:
                CellFillingLevel_DataReader () {};
                ~CellFillingLevel_DataReader () {};
            private:
                CellFillingLevel_DataReader (const CellFillingLevel_DataReader &);
                CellFillingLevel_DataReader & operator = (const CellFillingLevel_DataReader &);
            };

            class  CellFillingLevel_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CellFillingLevel_DataReaderView_ptr _ptr_type;
                typedef CellFillingLevel_DataReaderView_var _var_type;

                static CellFillingLevel_DataReaderView_ptr _duplicate (CellFillingLevel_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CellFillingLevel_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CellFillingLevel_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CellFillingLevel_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CellFillingLevel_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CellFillingLevel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CellFillingLevel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CellFillingLevel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CellFillingLevel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CellFillingLevel_& instance) = 0;

            protected:
                CellFillingLevel_DataReaderView () {};
                ~CellFillingLevel_DataReaderView () {};
            private:
                CellFillingLevel_DataReaderView (const CellFillingLevel_DataReaderView &);
                CellFillingLevel_DataReaderView & operator = (const CellFillingLevel_DataReaderView &);
            };
        }

    }

}

#endif
