#ifndef _H_B9D87E8F54F7617EAFEF114C51BF6904_Compartment_DCPS_H_
#define _H_B9D87E8F54F7617EAFEF114C51BF6904_Compartment_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Compartment_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Compartment_TypeSupportInterface;

            typedef Compartment_TypeSupportInterface * Compartment_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Compartment_TypeSupportInterface> Compartment_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Compartment_TypeSupportInterface> Compartment_TypeSupportInterface_out;


            class Compartment_DataWriter;

            typedef Compartment_DataWriter * Compartment_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Compartment_DataWriter> Compartment_DataWriter_var;
            typedef DDS_DCPSInterface_out < Compartment_DataWriter> Compartment_DataWriter_out;


            class Compartment_DataReader;

            typedef Compartment_DataReader * Compartment_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Compartment_DataReader> Compartment_DataReader_var;
            typedef DDS_DCPSInterface_out < Compartment_DataReader> Compartment_DataReader_out;


            class Compartment_DataReaderView;

            typedef Compartment_DataReaderView * Compartment_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Compartment_DataReaderView> Compartment_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Compartment_DataReaderView> Compartment_DataReaderView_out;

            struct Compartment_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Compartment_, struct Compartment_Seq_uniq_> Compartment_Seq;
            typedef DDS_DCPSSequence_var < Compartment_Seq> Compartment_Seq_var;
            typedef DDS_DCPSSequence_out < Compartment_Seq> Compartment_Seq_out;

            class  Compartment_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Compartment_TypeSupportInterface_ptr _ptr_type;
                typedef Compartment_TypeSupportInterface_var _var_type;

                static Compartment_TypeSupportInterface_ptr _duplicate (Compartment_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Compartment_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Compartment_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Compartment_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Compartment_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Compartment_TypeSupportInterface () {};
                ~Compartment_TypeSupportInterface () {};
            private:
                Compartment_TypeSupportInterface (const Compartment_TypeSupportInterface &);
                Compartment_TypeSupportInterface & operator = (const Compartment_TypeSupportInterface &);
            };

            class  Compartment_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Compartment_DataWriter_ptr _ptr_type;
                typedef Compartment_DataWriter_var _var_type;

                static Compartment_DataWriter_ptr _duplicate (Compartment_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Compartment_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Compartment_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Compartment_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Compartment_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Compartment_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Compartment_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Compartment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Compartment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Compartment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Compartment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Compartment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Compartment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Compartment_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Compartment_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Compartment_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Compartment_& instance_data) = 0;

            protected:
                Compartment_DataWriter () {};
                ~Compartment_DataWriter () {};
            private:
                Compartment_DataWriter (const Compartment_DataWriter &);
                Compartment_DataWriter & operator = (const Compartment_DataWriter &);
            };

            class  Compartment_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Compartment_DataReader_ptr _ptr_type;
                typedef Compartment_DataReader_var _var_type;

                static Compartment_DataReader_ptr _duplicate (Compartment_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Compartment_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Compartment_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Compartment_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Compartment_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Compartment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Compartment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Compartment_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Compartment_& instance) = 0;

            protected:
                Compartment_DataReader () {};
                ~Compartment_DataReader () {};
            private:
                Compartment_DataReader (const Compartment_DataReader &);
                Compartment_DataReader & operator = (const Compartment_DataReader &);
            };

            class  Compartment_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Compartment_DataReaderView_ptr _ptr_type;
                typedef Compartment_DataReaderView_var _var_type;

                static Compartment_DataReaderView_ptr _duplicate (Compartment_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Compartment_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Compartment_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Compartment_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Compartment_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Compartment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Compartment_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Compartment_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Compartment_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Compartment_& instance) = 0;

            protected:
                Compartment_DataReaderView () {};
                ~Compartment_DataReaderView () {};
            private:
                Compartment_DataReaderView (const Compartment_DataReaderView &);
                Compartment_DataReaderView & operator = (const Compartment_DataReaderView &);
            };
        }

    }

}

#endif
