#ifndef _H_6E8A0A1B2E7E9452EF908ED8D0B9E4B5_ItemModel_DCPS_H_
#define _H_6E8A0A1B2E7E9452EF908ED8D0B9E4B5_ItemModel_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ItemModel_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ItemModel_TypeSupportInterface;

            typedef ItemModel_TypeSupportInterface * ItemModel_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ItemModel_TypeSupportInterface> ItemModel_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ItemModel_TypeSupportInterface> ItemModel_TypeSupportInterface_out;


            class ItemModel_DataWriter;

            typedef ItemModel_DataWriter * ItemModel_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ItemModel_DataWriter> ItemModel_DataWriter_var;
            typedef DDS_DCPSInterface_out < ItemModel_DataWriter> ItemModel_DataWriter_out;


            class ItemModel_DataReader;

            typedef ItemModel_DataReader * ItemModel_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ItemModel_DataReader> ItemModel_DataReader_var;
            typedef DDS_DCPSInterface_out < ItemModel_DataReader> ItemModel_DataReader_out;


            class ItemModel_DataReaderView;

            typedef ItemModel_DataReaderView * ItemModel_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ItemModel_DataReaderView> ItemModel_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ItemModel_DataReaderView> ItemModel_DataReaderView_out;

            struct ItemModel_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ItemModel_, struct ItemModel_Seq_uniq_> ItemModel_Seq;
            typedef DDS_DCPSSequence_var < ItemModel_Seq> ItemModel_Seq_var;
            typedef DDS_DCPSSequence_out < ItemModel_Seq> ItemModel_Seq_out;

            class  ItemModel_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ItemModel_TypeSupportInterface_ptr _ptr_type;
                typedef ItemModel_TypeSupportInterface_var _var_type;

                static ItemModel_TypeSupportInterface_ptr _duplicate (ItemModel_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ItemModel_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ItemModel_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ItemModel_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ItemModel_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ItemModel_TypeSupportInterface () {};
                ~ItemModel_TypeSupportInterface () {};
            private:
                ItemModel_TypeSupportInterface (const ItemModel_TypeSupportInterface &);
                ItemModel_TypeSupportInterface & operator = (const ItemModel_TypeSupportInterface &);
            };

            class  ItemModel_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ItemModel_DataWriter_ptr _ptr_type;
                typedef ItemModel_DataWriter_var _var_type;

                static ItemModel_DataWriter_ptr _duplicate (ItemModel_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ItemModel_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ItemModel_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ItemModel_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ItemModel_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ItemModel_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ItemModel_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ItemModel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ItemModel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ItemModel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ItemModel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ItemModel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ItemModel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ItemModel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ItemModel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ItemModel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ItemModel_& instance_data) = 0;

            protected:
                ItemModel_DataWriter () {};
                ~ItemModel_DataWriter () {};
            private:
                ItemModel_DataWriter (const ItemModel_DataWriter &);
                ItemModel_DataWriter & operator = (const ItemModel_DataWriter &);
            };

            class  ItemModel_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ItemModel_DataReader_ptr _ptr_type;
                typedef ItemModel_DataReader_var _var_type;

                static ItemModel_DataReader_ptr _duplicate (ItemModel_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ItemModel_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ItemModel_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ItemModel_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ItemModel_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ItemModel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ItemModel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ItemModel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ItemModel_& instance) = 0;

            protected:
                ItemModel_DataReader () {};
                ~ItemModel_DataReader () {};
            private:
                ItemModel_DataReader (const ItemModel_DataReader &);
                ItemModel_DataReader & operator = (const ItemModel_DataReader &);
            };

            class  ItemModel_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ItemModel_DataReaderView_ptr _ptr_type;
                typedef ItemModel_DataReaderView_var _var_type;

                static ItemModel_DataReaderView_ptr _duplicate (ItemModel_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ItemModel_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ItemModel_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ItemModel_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ItemModel_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ItemModel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ItemModel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ItemModel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ItemModel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ItemModel_& instance) = 0;

            protected:
                ItemModel_DataReaderView () {};
                ~ItemModel_DataReaderView () {};
            private:
                ItemModel_DataReaderView (const ItemModel_DataReaderView &);
                ItemModel_DataReaderView & operator = (const ItemModel_DataReaderView &);
            };
        }

    }

}

#endif
