#ifndef _H_9515D445986F461D0112EABA2B45F5D9_RangeValue_DCPS_H_
#define _H_9515D445986F461D0112EABA2B45F5D9_RangeValue_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RangeValue_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RangeValue_TypeSupportInterface;

            typedef RangeValue_TypeSupportInterface * RangeValue_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RangeValue_TypeSupportInterface> RangeValue_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RangeValue_TypeSupportInterface> RangeValue_TypeSupportInterface_out;


            class RangeValue_DataWriter;

            typedef RangeValue_DataWriter * RangeValue_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RangeValue_DataWriter> RangeValue_DataWriter_var;
            typedef DDS_DCPSInterface_out < RangeValue_DataWriter> RangeValue_DataWriter_out;


            class RangeValue_DataReader;

            typedef RangeValue_DataReader * RangeValue_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RangeValue_DataReader> RangeValue_DataReader_var;
            typedef DDS_DCPSInterface_out < RangeValue_DataReader> RangeValue_DataReader_out;


            class RangeValue_DataReaderView;

            typedef RangeValue_DataReaderView * RangeValue_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RangeValue_DataReaderView> RangeValue_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RangeValue_DataReaderView> RangeValue_DataReaderView_out;

            struct RangeValue_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < RangeValue_, struct RangeValue_Seq_uniq_> RangeValue_Seq;
            typedef DDS_DCPSSequence_var < RangeValue_Seq> RangeValue_Seq_var;
            typedef DDS_DCPSSequence_out < RangeValue_Seq> RangeValue_Seq_out;

            class  RangeValue_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RangeValue_TypeSupportInterface_ptr _ptr_type;
                typedef RangeValue_TypeSupportInterface_var _var_type;

                static RangeValue_TypeSupportInterface_ptr _duplicate (RangeValue_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeValue_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RangeValue_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeValue_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeValue_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RangeValue_TypeSupportInterface () {};
                ~RangeValue_TypeSupportInterface () {};
            private:
                RangeValue_TypeSupportInterface (const RangeValue_TypeSupportInterface &);
                RangeValue_TypeSupportInterface & operator = (const RangeValue_TypeSupportInterface &);
            };

            class  RangeValue_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RangeValue_DataWriter_ptr _ptr_type;
                typedef RangeValue_DataWriter_var _var_type;

                static RangeValue_DataWriter_ptr _duplicate (RangeValue_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeValue_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RangeValue_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeValue_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeValue_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RangeValue_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RangeValue_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RangeValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RangeValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RangeValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RangeValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RangeValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RangeValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RangeValue_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RangeValue_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RangeValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeValue_& instance_data) = 0;

            protected:
                RangeValue_DataWriter () {};
                ~RangeValue_DataWriter () {};
            private:
                RangeValue_DataWriter (const RangeValue_DataWriter &);
                RangeValue_DataWriter & operator = (const RangeValue_DataWriter &);
            };

            class  RangeValue_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RangeValue_DataReader_ptr _ptr_type;
                typedef RangeValue_DataReader_var _var_type;

                static RangeValue_DataReader_ptr _duplicate (RangeValue_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeValue_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RangeValue_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeValue_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeValue_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RangeValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RangeValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RangeValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeValue_& instance) = 0;

            protected:
                RangeValue_DataReader () {};
                ~RangeValue_DataReader () {};
            private:
                RangeValue_DataReader (const RangeValue_DataReader &);
                RangeValue_DataReader & operator = (const RangeValue_DataReader &);
            };

            class  RangeValue_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RangeValue_DataReaderView_ptr _ptr_type;
                typedef RangeValue_DataReaderView_var _var_type;

                static RangeValue_DataReaderView_ptr _duplicate (RangeValue_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RangeValue_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RangeValue_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RangeValue_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RangeValue_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RangeValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RangeValue_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RangeValue_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RangeValue_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RangeValue_& instance) = 0;

            protected:
                RangeValue_DataReaderView () {};
                ~RangeValue_DataReaderView () {};
            private:
                RangeValue_DataReaderView (const RangeValue_DataReaderView &);
                RangeValue_DataReaderView & operator = (const RangeValue_DataReaderView &);
            };
        }

    }

}

#endif
