#ifndef _H_86621C60A13DE829EFD444A6955386EA_Rectangle_DCPS_H_
#define _H_86621C60A13DE829EFD444A6955386EA_Rectangle_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Rectangle_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Rectangle_TypeSupportInterface;

            typedef Rectangle_TypeSupportInterface * Rectangle_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Rectangle_TypeSupportInterface> Rectangle_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Rectangle_TypeSupportInterface> Rectangle_TypeSupportInterface_out;


            class Rectangle_DataWriter;

            typedef Rectangle_DataWriter * Rectangle_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Rectangle_DataWriter> Rectangle_DataWriter_var;
            typedef DDS_DCPSInterface_out < Rectangle_DataWriter> Rectangle_DataWriter_out;


            class Rectangle_DataReader;

            typedef Rectangle_DataReader * Rectangle_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Rectangle_DataReader> Rectangle_DataReader_var;
            typedef DDS_DCPSInterface_out < Rectangle_DataReader> Rectangle_DataReader_out;


            class Rectangle_DataReaderView;

            typedef Rectangle_DataReaderView * Rectangle_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Rectangle_DataReaderView> Rectangle_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Rectangle_DataReaderView> Rectangle_DataReaderView_out;

            struct Rectangle_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Rectangle_, struct Rectangle_Seq_uniq_> Rectangle_Seq;
            typedef DDS_DCPSSequence_var < Rectangle_Seq> Rectangle_Seq_var;
            typedef DDS_DCPSSequence_out < Rectangle_Seq> Rectangle_Seq_out;

            class  Rectangle_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Rectangle_TypeSupportInterface_ptr _ptr_type;
                typedef Rectangle_TypeSupportInterface_var _var_type;

                static Rectangle_TypeSupportInterface_ptr _duplicate (Rectangle_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rectangle_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Rectangle_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rectangle_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Rectangle_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Rectangle_TypeSupportInterface () {};
                ~Rectangle_TypeSupportInterface () {};
            private:
                Rectangle_TypeSupportInterface (const Rectangle_TypeSupportInterface &);
                Rectangle_TypeSupportInterface & operator = (const Rectangle_TypeSupportInterface &);
            };

            class  Rectangle_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Rectangle_DataWriter_ptr _ptr_type;
                typedef Rectangle_DataWriter_var _var_type;

                static Rectangle_DataWriter_ptr _duplicate (Rectangle_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rectangle_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Rectangle_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rectangle_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Rectangle_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Rectangle_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Rectangle_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Rectangle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Rectangle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Rectangle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Rectangle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Rectangle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Rectangle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Rectangle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Rectangle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Rectangle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rectangle_& instance_data) = 0;

            protected:
                Rectangle_DataWriter () {};
                ~Rectangle_DataWriter () {};
            private:
                Rectangle_DataWriter (const Rectangle_DataWriter &);
                Rectangle_DataWriter & operator = (const Rectangle_DataWriter &);
            };

            class  Rectangle_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Rectangle_DataReader_ptr _ptr_type;
                typedef Rectangle_DataReader_var _var_type;

                static Rectangle_DataReader_ptr _duplicate (Rectangle_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rectangle_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Rectangle_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rectangle_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Rectangle_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rectangle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rectangle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rectangle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rectangle_& instance) = 0;

            protected:
                Rectangle_DataReader () {};
                ~Rectangle_DataReader () {};
            private:
                Rectangle_DataReader (const Rectangle_DataReader &);
                Rectangle_DataReader & operator = (const Rectangle_DataReader &);
            };

            class  Rectangle_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Rectangle_DataReaderView_ptr _ptr_type;
                typedef Rectangle_DataReaderView_var _var_type;

                static Rectangle_DataReaderView_ptr _duplicate (Rectangle_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Rectangle_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Rectangle_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Rectangle_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Rectangle_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Rectangle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Rectangle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Rectangle_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Rectangle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Rectangle_& instance) = 0;

            protected:
                Rectangle_DataReaderView () {};
                ~Rectangle_DataReaderView () {};
            private:
                Rectangle_DataReaderView (const Rectangle_DataReaderView &);
                Rectangle_DataReaderView & operator = (const Rectangle_DataReaderView &);
            };
        }

    }

}

#endif
