#ifndef _H_FB8EF3D1BD872C4786977947DE02D65A_RegionOfInterest3D_DCPS_H_
#define _H_FB8EF3D1BD872C4786977947DE02D65A_RegionOfInterest3D_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RegionOfInterest3D_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RegionOfInterest3D_TypeSupportInterface;

            typedef RegionOfInterest3D_TypeSupportInterface * RegionOfInterest3D_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RegionOfInterest3D_TypeSupportInterface> RegionOfInterest3D_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RegionOfInterest3D_TypeSupportInterface> RegionOfInterest3D_TypeSupportInterface_out;


            class RegionOfInterest3D_DataWriter;

            typedef RegionOfInterest3D_DataWriter * RegionOfInterest3D_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RegionOfInterest3D_DataWriter> RegionOfInterest3D_DataWriter_var;
            typedef DDS_DCPSInterface_out < RegionOfInterest3D_DataWriter> RegionOfInterest3D_DataWriter_out;


            class RegionOfInterest3D_DataReader;

            typedef RegionOfInterest3D_DataReader * RegionOfInterest3D_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RegionOfInterest3D_DataReader> RegionOfInterest3D_DataReader_var;
            typedef DDS_DCPSInterface_out < RegionOfInterest3D_DataReader> RegionOfInterest3D_DataReader_out;


            class RegionOfInterest3D_DataReaderView;

            typedef RegionOfInterest3D_DataReaderView * RegionOfInterest3D_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RegionOfInterest3D_DataReaderView> RegionOfInterest3D_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RegionOfInterest3D_DataReaderView> RegionOfInterest3D_DataReaderView_out;

            struct RegionOfInterest3D_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RegionOfInterest3D_, struct RegionOfInterest3D_Seq_uniq_> RegionOfInterest3D_Seq;
            typedef DDS_DCPSSequence_var < RegionOfInterest3D_Seq> RegionOfInterest3D_Seq_var;
            typedef DDS_DCPSSequence_out < RegionOfInterest3D_Seq> RegionOfInterest3D_Seq_out;

            class  RegionOfInterest3D_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RegionOfInterest3D_TypeSupportInterface_ptr _ptr_type;
                typedef RegionOfInterest3D_TypeSupportInterface_var _var_type;

                static RegionOfInterest3D_TypeSupportInterface_ptr _duplicate (RegionOfInterest3D_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RegionOfInterest3D_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RegionOfInterest3D_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RegionOfInterest3D_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RegionOfInterest3D_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RegionOfInterest3D_TypeSupportInterface () {};
                ~RegionOfInterest3D_TypeSupportInterface () {};
            private:
                RegionOfInterest3D_TypeSupportInterface (const RegionOfInterest3D_TypeSupportInterface &);
                RegionOfInterest3D_TypeSupportInterface & operator = (const RegionOfInterest3D_TypeSupportInterface &);
            };

            class  RegionOfInterest3D_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RegionOfInterest3D_DataWriter_ptr _ptr_type;
                typedef RegionOfInterest3D_DataWriter_var _var_type;

                static RegionOfInterest3D_DataWriter_ptr _duplicate (RegionOfInterest3D_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RegionOfInterest3D_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RegionOfInterest3D_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RegionOfInterest3D_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RegionOfInterest3D_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RegionOfInterest3D_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RegionOfInterest3D_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RegionOfInterest3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RegionOfInterest3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RegionOfInterest3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RegionOfInterest3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RegionOfInterest3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RegionOfInterest3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RegionOfInterest3D_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RegionOfInterest3D_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RegionOfInterest3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RegionOfInterest3D_& instance_data) = 0;

            protected:
                RegionOfInterest3D_DataWriter () {};
                ~RegionOfInterest3D_DataWriter () {};
            private:
                RegionOfInterest3D_DataWriter (const RegionOfInterest3D_DataWriter &);
                RegionOfInterest3D_DataWriter & operator = (const RegionOfInterest3D_DataWriter &);
            };

            class  RegionOfInterest3D_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RegionOfInterest3D_DataReader_ptr _ptr_type;
                typedef RegionOfInterest3D_DataReader_var _var_type;

                static RegionOfInterest3D_DataReader_ptr _duplicate (RegionOfInterest3D_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RegionOfInterest3D_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RegionOfInterest3D_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RegionOfInterest3D_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RegionOfInterest3D_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RegionOfInterest3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RegionOfInterest3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RegionOfInterest3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RegionOfInterest3D_& instance) = 0;

            protected:
                RegionOfInterest3D_DataReader () {};
                ~RegionOfInterest3D_DataReader () {};
            private:
                RegionOfInterest3D_DataReader (const RegionOfInterest3D_DataReader &);
                RegionOfInterest3D_DataReader & operator = (const RegionOfInterest3D_DataReader &);
            };

            class  RegionOfInterest3D_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RegionOfInterest3D_DataReaderView_ptr _ptr_type;
                typedef RegionOfInterest3D_DataReaderView_var _var_type;

                static RegionOfInterest3D_DataReaderView_ptr _duplicate (RegionOfInterest3D_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RegionOfInterest3D_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RegionOfInterest3D_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RegionOfInterest3D_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RegionOfInterest3D_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RegionOfInterest3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RegionOfInterest3D_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RegionOfInterest3D_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RegionOfInterest3D_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RegionOfInterest3D_& instance) = 0;

            protected:
                RegionOfInterest3D_DataReaderView () {};
                ~RegionOfInterest3D_DataReaderView () {};
            private:
                RegionOfInterest3D_DataReaderView (const RegionOfInterest3D_DataReaderView &);
                RegionOfInterest3D_DataReaderView & operator = (const RegionOfInterest3D_DataReaderView &);
            };
        }

    }

}

#endif
