#ifndef _H_ADB5D59311A44AC2E054AC1A7E7202D5_SilhouetteMatchInstance_DCPS_H_
#define _H_ADB5D59311A44AC2E054AC1A7E7202D5_SilhouetteMatchInstance_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SilhouetteMatchInstance_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SilhouetteMatchInstance_TypeSupportInterface;

            typedef SilhouetteMatchInstance_TypeSupportInterface * SilhouetteMatchInstance_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchInstance_TypeSupportInterface> SilhouetteMatchInstance_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchInstance_TypeSupportInterface> SilhouetteMatchInstance_TypeSupportInterface_out;


            class SilhouetteMatchInstance_DataWriter;

            typedef SilhouetteMatchInstance_DataWriter * SilhouetteMatchInstance_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchInstance_DataWriter> SilhouetteMatchInstance_DataWriter_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchInstance_DataWriter> SilhouetteMatchInstance_DataWriter_out;


            class SilhouetteMatchInstance_DataReader;

            typedef SilhouetteMatchInstance_DataReader * SilhouetteMatchInstance_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchInstance_DataReader> SilhouetteMatchInstance_DataReader_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchInstance_DataReader> SilhouetteMatchInstance_DataReader_out;


            class SilhouetteMatchInstance_DataReaderView;

            typedef SilhouetteMatchInstance_DataReaderView * SilhouetteMatchInstance_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchInstance_DataReaderView> SilhouetteMatchInstance_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchInstance_DataReaderView> SilhouetteMatchInstance_DataReaderView_out;

            struct SilhouetteMatchInstance_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SilhouetteMatchInstance_, struct SilhouetteMatchInstance_Seq_uniq_> SilhouetteMatchInstance_Seq;
            typedef DDS_DCPSSequence_var < SilhouetteMatchInstance_Seq> SilhouetteMatchInstance_Seq_var;
            typedef DDS_DCPSSequence_out < SilhouetteMatchInstance_Seq> SilhouetteMatchInstance_Seq_out;

            class  SilhouetteMatchInstance_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SilhouetteMatchInstance_TypeSupportInterface_ptr _ptr_type;
                typedef SilhouetteMatchInstance_TypeSupportInterface_var _var_type;

                static SilhouetteMatchInstance_TypeSupportInterface_ptr _duplicate (SilhouetteMatchInstance_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchInstance_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchInstance_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchInstance_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchInstance_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SilhouetteMatchInstance_TypeSupportInterface () {};
                ~SilhouetteMatchInstance_TypeSupportInterface () {};
            private:
                SilhouetteMatchInstance_TypeSupportInterface (const SilhouetteMatchInstance_TypeSupportInterface &);
                SilhouetteMatchInstance_TypeSupportInterface & operator = (const SilhouetteMatchInstance_TypeSupportInterface &);
            };

            class  SilhouetteMatchInstance_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SilhouetteMatchInstance_DataWriter_ptr _ptr_type;
                typedef SilhouetteMatchInstance_DataWriter_var _var_type;

                static SilhouetteMatchInstance_DataWriter_ptr _duplicate (SilhouetteMatchInstance_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchInstance_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchInstance_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchInstance_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchInstance_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SilhouetteMatchInstance_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SilhouetteMatchInstance_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SilhouetteMatchInstance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SilhouetteMatchInstance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SilhouetteMatchInstance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SilhouetteMatchInstance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SilhouetteMatchInstance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SilhouetteMatchInstance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SilhouetteMatchInstance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SilhouetteMatchInstance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchInstance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchInstance_& instance_data) = 0;

            protected:
                SilhouetteMatchInstance_DataWriter () {};
                ~SilhouetteMatchInstance_DataWriter () {};
            private:
                SilhouetteMatchInstance_DataWriter (const SilhouetteMatchInstance_DataWriter &);
                SilhouetteMatchInstance_DataWriter & operator = (const SilhouetteMatchInstance_DataWriter &);
            };

            class  SilhouetteMatchInstance_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SilhouetteMatchInstance_DataReader_ptr _ptr_type;
                typedef SilhouetteMatchInstance_DataReader_var _var_type;

                static SilhouetteMatchInstance_DataReader_ptr _duplicate (SilhouetteMatchInstance_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchInstance_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchInstance_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchInstance_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchInstance_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SilhouetteMatchInstance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SilhouetteMatchInstance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchInstance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchInstance_& instance) = 0;

            protected:
                SilhouetteMatchInstance_DataReader () {};
                ~SilhouetteMatchInstance_DataReader () {};
            private:
                SilhouetteMatchInstance_DataReader (const SilhouetteMatchInstance_DataReader &);
                SilhouetteMatchInstance_DataReader & operator = (const SilhouetteMatchInstance_DataReader &);
            };

            class  SilhouetteMatchInstance_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SilhouetteMatchInstance_DataReaderView_ptr _ptr_type;
                typedef SilhouetteMatchInstance_DataReaderView_var _var_type;

                static SilhouetteMatchInstance_DataReaderView_ptr _duplicate (SilhouetteMatchInstance_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchInstance_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchInstance_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchInstance_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchInstance_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SilhouetteMatchInstance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SilhouetteMatchInstance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SilhouetteMatchInstance_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchInstance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchInstance_& instance) = 0;

            protected:
                SilhouetteMatchInstance_DataReaderView () {};
                ~SilhouetteMatchInstance_DataReaderView () {};
            private:
                SilhouetteMatchInstance_DataReaderView (const SilhouetteMatchInstance_DataReaderView &);
                SilhouetteMatchInstance_DataReaderView & operator = (const SilhouetteMatchInstance_DataReaderView &);
            };
        }

    }

}

#endif
