#ifndef _H_AF0568F9A26843F57EC307EBF37B6B4A_SuctionGrasp_DCPS_H_
#define _H_AF0568F9A26843F57EC307EBF37B6B4A_SuctionGrasp_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SuctionGrasp_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SuctionGrasp_TypeSupportInterface;

            typedef SuctionGrasp_TypeSupportInterface * SuctionGrasp_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SuctionGrasp_TypeSupportInterface> SuctionGrasp_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SuctionGrasp_TypeSupportInterface> SuctionGrasp_TypeSupportInterface_out;


            class SuctionGrasp_DataWriter;

            typedef SuctionGrasp_DataWriter * SuctionGrasp_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SuctionGrasp_DataWriter> SuctionGrasp_DataWriter_var;
            typedef DDS_DCPSInterface_out < SuctionGrasp_DataWriter> SuctionGrasp_DataWriter_out;


            class SuctionGrasp_DataReader;

            typedef SuctionGrasp_DataReader * SuctionGrasp_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SuctionGrasp_DataReader> SuctionGrasp_DataReader_var;
            typedef DDS_DCPSInterface_out < SuctionGrasp_DataReader> SuctionGrasp_DataReader_out;


            class SuctionGrasp_DataReaderView;

            typedef SuctionGrasp_DataReaderView * SuctionGrasp_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SuctionGrasp_DataReaderView> SuctionGrasp_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SuctionGrasp_DataReaderView> SuctionGrasp_DataReaderView_out;

            struct SuctionGrasp_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SuctionGrasp_, struct SuctionGrasp_Seq_uniq_> SuctionGrasp_Seq;
            typedef DDS_DCPSSequence_var < SuctionGrasp_Seq> SuctionGrasp_Seq_var;
            typedef DDS_DCPSSequence_out < SuctionGrasp_Seq> SuctionGrasp_Seq_out;

            class  SuctionGrasp_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SuctionGrasp_TypeSupportInterface_ptr _ptr_type;
                typedef SuctionGrasp_TypeSupportInterface_var _var_type;

                static SuctionGrasp_TypeSupportInterface_ptr _duplicate (SuctionGrasp_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SuctionGrasp_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SuctionGrasp_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SuctionGrasp_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SuctionGrasp_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SuctionGrasp_TypeSupportInterface () {};
                ~SuctionGrasp_TypeSupportInterface () {};
            private:
                SuctionGrasp_TypeSupportInterface (const SuctionGrasp_TypeSupportInterface &);
                SuctionGrasp_TypeSupportInterface & operator = (const SuctionGrasp_TypeSupportInterface &);
            };

            class  SuctionGrasp_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SuctionGrasp_DataWriter_ptr _ptr_type;
                typedef SuctionGrasp_DataWriter_var _var_type;

                static SuctionGrasp_DataWriter_ptr _duplicate (SuctionGrasp_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SuctionGrasp_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SuctionGrasp_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SuctionGrasp_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SuctionGrasp_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SuctionGrasp_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SuctionGrasp_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SuctionGrasp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SuctionGrasp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SuctionGrasp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SuctionGrasp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SuctionGrasp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SuctionGrasp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SuctionGrasp_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SuctionGrasp_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SuctionGrasp_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SuctionGrasp_& instance_data) = 0;

            protected:
                SuctionGrasp_DataWriter () {};
                ~SuctionGrasp_DataWriter () {};
            private:
                SuctionGrasp_DataWriter (const SuctionGrasp_DataWriter &);
                SuctionGrasp_DataWriter & operator = (const SuctionGrasp_DataWriter &);
            };

            class  SuctionGrasp_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SuctionGrasp_DataReader_ptr _ptr_type;
                typedef SuctionGrasp_DataReader_var _var_type;

                static SuctionGrasp_DataReader_ptr _duplicate (SuctionGrasp_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SuctionGrasp_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SuctionGrasp_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SuctionGrasp_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SuctionGrasp_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SuctionGrasp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SuctionGrasp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SuctionGrasp_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SuctionGrasp_& instance) = 0;

            protected:
                SuctionGrasp_DataReader () {};
                ~SuctionGrasp_DataReader () {};
            private:
                SuctionGrasp_DataReader (const SuctionGrasp_DataReader &);
                SuctionGrasp_DataReader & operator = (const SuctionGrasp_DataReader &);
            };

            class  SuctionGrasp_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SuctionGrasp_DataReaderView_ptr _ptr_type;
                typedef SuctionGrasp_DataReaderView_var _var_type;

                static SuctionGrasp_DataReaderView_ptr _duplicate (SuctionGrasp_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SuctionGrasp_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SuctionGrasp_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SuctionGrasp_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SuctionGrasp_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SuctionGrasp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SuctionGrasp_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SuctionGrasp_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SuctionGrasp_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SuctionGrasp_& instance) = 0;

            protected:
                SuctionGrasp_DataReaderView () {};
                ~SuctionGrasp_DataReaderView () {};
            private:
                SuctionGrasp_DataReaderView (const SuctionGrasp_DataReaderView &);
                SuctionGrasp_DataReaderView & operator = (const SuctionGrasp_DataReaderView &);
            };
        }

    }

}

#endif
