#ifndef _H_70187EE5E8894B93D9B8A065341B772E_Tag_DCPS_H_
#define _H_70187EE5E8894B93D9B8A065341B772E_Tag_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Tag_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Tag_TypeSupportInterface;

            typedef Tag_TypeSupportInterface * Tag_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Tag_TypeSupportInterface> Tag_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Tag_TypeSupportInterface> Tag_TypeSupportInterface_out;


            class Tag_DataWriter;

            typedef Tag_DataWriter * Tag_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Tag_DataWriter> Tag_DataWriter_var;
            typedef DDS_DCPSInterface_out < Tag_DataWriter> Tag_DataWriter_out;


            class Tag_DataReader;

            typedef Tag_DataReader * Tag_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Tag_DataReader> Tag_DataReader_var;
            typedef DDS_DCPSInterface_out < Tag_DataReader> Tag_DataReader_out;


            class Tag_DataReaderView;

            typedef Tag_DataReaderView * Tag_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Tag_DataReaderView> Tag_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Tag_DataReaderView> Tag_DataReaderView_out;

            struct Tag_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Tag_, struct Tag_Seq_uniq_> Tag_Seq;
            typedef DDS_DCPSSequence_var < Tag_Seq> Tag_Seq_var;
            typedef DDS_DCPSSequence_out < Tag_Seq> Tag_Seq_out;

            class  Tag_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Tag_TypeSupportInterface_ptr _ptr_type;
                typedef Tag_TypeSupportInterface_var _var_type;

                static Tag_TypeSupportInterface_ptr _duplicate (Tag_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Tag_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Tag_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Tag_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Tag_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Tag_TypeSupportInterface () {};
                ~Tag_TypeSupportInterface () {};
            private:
                Tag_TypeSupportInterface (const Tag_TypeSupportInterface &);
                Tag_TypeSupportInterface & operator = (const Tag_TypeSupportInterface &);
            };

            class  Tag_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Tag_DataWriter_ptr _ptr_type;
                typedef Tag_DataWriter_var _var_type;

                static Tag_DataWriter_ptr _duplicate (Tag_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Tag_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Tag_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Tag_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Tag_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Tag_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Tag_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Tag_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Tag_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Tag_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Tag_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Tag_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Tag_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Tag_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Tag_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Tag_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Tag_& instance_data) = 0;

            protected:
                Tag_DataWriter () {};
                ~Tag_DataWriter () {};
            private:
                Tag_DataWriter (const Tag_DataWriter &);
                Tag_DataWriter & operator = (const Tag_DataWriter &);
            };

            class  Tag_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Tag_DataReader_ptr _ptr_type;
                typedef Tag_DataReader_var _var_type;

                static Tag_DataReader_ptr _duplicate (Tag_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Tag_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Tag_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Tag_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Tag_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Tag_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Tag_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Tag_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Tag_& instance) = 0;

            protected:
                Tag_DataReader () {};
                ~Tag_DataReader () {};
            private:
                Tag_DataReader (const Tag_DataReader &);
                Tag_DataReader & operator = (const Tag_DataReader &);
            };

            class  Tag_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Tag_DataReaderView_ptr _ptr_type;
                typedef Tag_DataReaderView_var _var_type;

                static Tag_DataReaderView_ptr _duplicate (Tag_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Tag_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Tag_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Tag_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Tag_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Tag_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Tag_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Tag_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Tag_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Tag_& instance) = 0;

            protected:
                Tag_DataReaderView () {};
                ~Tag_DataReaderView () {};
            private:
                Tag_DataReaderView (const Tag_DataReaderView &);
                Tag_DataReaderView & operator = (const Tag_DataReaderView &);
            };
        }

    }

}

#endif
