// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:msg/Item.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__ITEM__FUNCTIONS_H_
#define RC_REASON_MSGS__MSG__ITEM__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "rc_reason_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "rc_reason_msgs/msg/item__struct.h"

/// Initialize msg/Item message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rc_reason_msgs__msg__Item
 * )) before or use
 * rc_reason_msgs__msg__Item__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
bool
rc_reason_msgs__msg__Item__init(rc_reason_msgs__msg__Item * msg);

/// Finalize msg/Item message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
void
rc_reason_msgs__msg__Item__fini(rc_reason_msgs__msg__Item * msg);

/// Create msg/Item message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rc_reason_msgs__msg__Item__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
rc_reason_msgs__msg__Item *
rc_reason_msgs__msg__Item__create();

/// Destroy msg/Item message.
/**
 * It calls
 * rc_reason_msgs__msg__Item__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
void
rc_reason_msgs__msg__Item__destroy(rc_reason_msgs__msg__Item * msg);


/// Initialize array of msg/Item messages.
/**
 * It allocates the memory for the number of elements and calls
 * rc_reason_msgs__msg__Item__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
bool
rc_reason_msgs__msg__Item__Sequence__init(rc_reason_msgs__msg__Item__Sequence * array, size_t size);

/// Finalize array of msg/Item messages.
/**
 * It calls
 * rc_reason_msgs__msg__Item__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
void
rc_reason_msgs__msg__Item__Sequence__fini(rc_reason_msgs__msg__Item__Sequence * array);

/// Create array of msg/Item messages.
/**
 * It allocates the memory for the array and calls
 * rc_reason_msgs__msg__Item__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
rc_reason_msgs__msg__Item__Sequence *
rc_reason_msgs__msg__Item__Sequence__create(size_t size);

/// Destroy array of msg/Item messages.
/**
 * It calls
 * rc_reason_msgs__msg__Item__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
void
rc_reason_msgs__msg__Item__Sequence__destroy(rc_reason_msgs__msg__Item__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__ITEM__FUNCTIONS_H_
