// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/RegionOfInterest2D.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__REGION_OF_INTEREST2_D__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__REGION_OF_INTEREST2_D__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__RegionOfInterest2D __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__RegionOfInterest2D __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RegionOfInterest2D_
{
  using Type = RegionOfInterest2D_<ContainerAllocator>;

  explicit RegionOfInterest2D_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
      this->offset_x = 0ul;
      this->offset_y = 0ul;
      this->width = 0ul;
      this->height = 0ul;
    }
  }

  explicit RegionOfInterest2D_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : id(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = "";
      this->offset_x = 0ul;
      this->offset_y = 0ul;
      this->width = 0ul;
      this->height = 0ul;
    }
  }

  // field types and members
  using _id_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _id_type id;
  using _offset_x_type =
    uint32_t;
  _offset_x_type offset_x;
  using _offset_y_type =
    uint32_t;
  _offset_y_type offset_y;
  using _width_type =
    uint32_t;
  _width_type width;
  using _height_type =
    uint32_t;
  _height_type height;

  // setters for named parameter idiom
  Type & set__id(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__offset_x(
    const uint32_t & _arg)
  {
    this->offset_x = _arg;
    return *this;
  }
  Type & set__offset_y(
    const uint32_t & _arg)
  {
    this->offset_y = _arg;
    return *this;
  }
  Type & set__width(
    const uint32_t & _arg)
  {
    this->width = _arg;
    return *this;
  }
  Type & set__height(
    const uint32_t & _arg)
  {
    this->height = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__RegionOfInterest2D
    std::shared_ptr<rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__RegionOfInterest2D
    std::shared_ptr<rc_reason_msgs::msg::RegionOfInterest2D_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RegionOfInterest2D_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->offset_x != other.offset_x) {
      return false;
    }
    if (this->offset_y != other.offset_y) {
      return false;
    }
    if (this->width != other.width) {
      return false;
    }
    if (this->height != other.height) {
      return false;
    }
    return true;
  }
  bool operator!=(const RegionOfInterest2D_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RegionOfInterest2D_

// alias to use template instance with default allocator
using RegionOfInterest2D =
  rc_reason_msgs::msg::RegionOfInterest2D_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__REGION_OF_INTEREST2_D__STRUCT_HPP_
