// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/SilhouetteMatchObject.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__SILHOUETTE_MATCH_OBJECT__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__SILHOUETTE_MATCH_OBJECT__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__SilhouetteMatchObject __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__SilhouetteMatchObject __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SilhouetteMatchObject_
{
  using Type = SilhouetteMatchObject_<ContainerAllocator>;

  explicit SilhouetteMatchObject_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->object_id = "";
      this->region_of_interest_2d_id = "";
    }
  }

  explicit SilhouetteMatchObject_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : object_id(_alloc),
    region_of_interest_2d_id(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->object_id = "";
      this->region_of_interest_2d_id = "";
    }
  }

  // field types and members
  using _object_id_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _object_id_type object_id;
  using _region_of_interest_2d_id_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _region_of_interest_2d_id_type region_of_interest_2d_id;

  // setters for named parameter idiom
  Type & set__object_id(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->object_id = _arg;
    return *this;
  }
  Type & set__region_of_interest_2d_id(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->region_of_interest_2d_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__SilhouetteMatchObject
    std::shared_ptr<rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__SilhouetteMatchObject
    std::shared_ptr<rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SilhouetteMatchObject_ & other) const
  {
    if (this->object_id != other.object_id) {
      return false;
    }
    if (this->region_of_interest_2d_id != other.region_of_interest_2d_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const SilhouetteMatchObject_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SilhouetteMatchObject_

// alias to use template instance with default allocator
using SilhouetteMatchObject =
  rc_reason_msgs::msg::SilhouetteMatchObject_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__SILHOUETTE_MATCH_OBJECT__STRUCT_HPP_
