#ifndef _H_AD703C43CAF8DBC01FE3135303A95060_CalibrateBasePlane_DCPS_H_
#define _H_AD703C43CAF8DBC01FE3135303A95060_CalibrateBasePlane_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CalibrateBasePlane_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class CalibrateBasePlane_Request_TypeSupportInterface;

            typedef CalibrateBasePlane_Request_TypeSupportInterface * CalibrateBasePlane_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CalibrateBasePlane_Request_TypeSupportInterface> CalibrateBasePlane_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CalibrateBasePlane_Request_TypeSupportInterface> CalibrateBasePlane_Request_TypeSupportInterface_out;


            class CalibrateBasePlane_Request_DataWriter;

            typedef CalibrateBasePlane_Request_DataWriter * CalibrateBasePlane_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CalibrateBasePlane_Request_DataWriter> CalibrateBasePlane_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < CalibrateBasePlane_Request_DataWriter> CalibrateBasePlane_Request_DataWriter_out;


            class CalibrateBasePlane_Request_DataReader;

            typedef CalibrateBasePlane_Request_DataReader * CalibrateBasePlane_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CalibrateBasePlane_Request_DataReader> CalibrateBasePlane_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < CalibrateBasePlane_Request_DataReader> CalibrateBasePlane_Request_DataReader_out;


            class CalibrateBasePlane_Request_DataReaderView;

            typedef CalibrateBasePlane_Request_DataReaderView * CalibrateBasePlane_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CalibrateBasePlane_Request_DataReaderView> CalibrateBasePlane_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CalibrateBasePlane_Request_DataReaderView> CalibrateBasePlane_Request_DataReaderView_out;

            struct CalibrateBasePlane_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CalibrateBasePlane_Request_, struct CalibrateBasePlane_Request_Seq_uniq_> CalibrateBasePlane_Request_Seq;
            typedef DDS_DCPSSequence_var < CalibrateBasePlane_Request_Seq> CalibrateBasePlane_Request_Seq_var;
            typedef DDS_DCPSSequence_out < CalibrateBasePlane_Request_Seq> CalibrateBasePlane_Request_Seq_out;

            class  CalibrateBasePlane_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CalibrateBasePlane_Request_TypeSupportInterface_ptr _ptr_type;
                typedef CalibrateBasePlane_Request_TypeSupportInterface_var _var_type;

                static CalibrateBasePlane_Request_TypeSupportInterface_ptr _duplicate (CalibrateBasePlane_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CalibrateBasePlane_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CalibrateBasePlane_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CalibrateBasePlane_Request_TypeSupportInterface () {};
                ~CalibrateBasePlane_Request_TypeSupportInterface () {};
            private:
                CalibrateBasePlane_Request_TypeSupportInterface (const CalibrateBasePlane_Request_TypeSupportInterface &);
                CalibrateBasePlane_Request_TypeSupportInterface & operator = (const CalibrateBasePlane_Request_TypeSupportInterface &);
            };

            class  CalibrateBasePlane_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CalibrateBasePlane_Request_DataWriter_ptr _ptr_type;
                typedef CalibrateBasePlane_Request_DataWriter_var _var_type;

                static CalibrateBasePlane_Request_DataWriter_ptr _duplicate (CalibrateBasePlane_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CalibrateBasePlane_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CalibrateBasePlane_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CalibrateBasePlane_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CalibrateBasePlane_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CalibrateBasePlane_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CalibrateBasePlane_Request_& instance_data) = 0;

            protected:
                CalibrateBasePlane_Request_DataWriter () {};
                ~CalibrateBasePlane_Request_DataWriter () {};
            private:
                CalibrateBasePlane_Request_DataWriter (const CalibrateBasePlane_Request_DataWriter &);
                CalibrateBasePlane_Request_DataWriter & operator = (const CalibrateBasePlane_Request_DataWriter &);
            };

            class  CalibrateBasePlane_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CalibrateBasePlane_Request_DataReader_ptr _ptr_type;
                typedef CalibrateBasePlane_Request_DataReader_var _var_type;

                static CalibrateBasePlane_Request_DataReader_ptr _duplicate (CalibrateBasePlane_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CalibrateBasePlane_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CalibrateBasePlane_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CalibrateBasePlane_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CalibrateBasePlane_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CalibrateBasePlane_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CalibrateBasePlane_Request_& instance) = 0;

            protected:
                CalibrateBasePlane_Request_DataReader () {};
                ~CalibrateBasePlane_Request_DataReader () {};
            private:
                CalibrateBasePlane_Request_DataReader (const CalibrateBasePlane_Request_DataReader &);
                CalibrateBasePlane_Request_DataReader & operator = (const CalibrateBasePlane_Request_DataReader &);
            };

            class  CalibrateBasePlane_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CalibrateBasePlane_Request_DataReaderView_ptr _ptr_type;
                typedef CalibrateBasePlane_Request_DataReaderView_var _var_type;

                static CalibrateBasePlane_Request_DataReaderView_ptr _duplicate (CalibrateBasePlane_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CalibrateBasePlane_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CalibrateBasePlane_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CalibrateBasePlane_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CalibrateBasePlane_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CalibrateBasePlane_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CalibrateBasePlane_Request_& instance) = 0;

            protected:
                CalibrateBasePlane_Request_DataReaderView () {};
                ~CalibrateBasePlane_Request_DataReaderView () {};
            private:
                CalibrateBasePlane_Request_DataReaderView (const CalibrateBasePlane_Request_DataReaderView &);
                CalibrateBasePlane_Request_DataReaderView & operator = (const CalibrateBasePlane_Request_DataReaderView &);
            };
            class CalibrateBasePlane_Response_TypeSupportInterface;

            typedef CalibrateBasePlane_Response_TypeSupportInterface * CalibrateBasePlane_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CalibrateBasePlane_Response_TypeSupportInterface> CalibrateBasePlane_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CalibrateBasePlane_Response_TypeSupportInterface> CalibrateBasePlane_Response_TypeSupportInterface_out;


            class CalibrateBasePlane_Response_DataWriter;

            typedef CalibrateBasePlane_Response_DataWriter * CalibrateBasePlane_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CalibrateBasePlane_Response_DataWriter> CalibrateBasePlane_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < CalibrateBasePlane_Response_DataWriter> CalibrateBasePlane_Response_DataWriter_out;


            class CalibrateBasePlane_Response_DataReader;

            typedef CalibrateBasePlane_Response_DataReader * CalibrateBasePlane_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CalibrateBasePlane_Response_DataReader> CalibrateBasePlane_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < CalibrateBasePlane_Response_DataReader> CalibrateBasePlane_Response_DataReader_out;


            class CalibrateBasePlane_Response_DataReaderView;

            typedef CalibrateBasePlane_Response_DataReaderView * CalibrateBasePlane_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CalibrateBasePlane_Response_DataReaderView> CalibrateBasePlane_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CalibrateBasePlane_Response_DataReaderView> CalibrateBasePlane_Response_DataReaderView_out;

            struct CalibrateBasePlane_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CalibrateBasePlane_Response_, struct CalibrateBasePlane_Response_Seq_uniq_> CalibrateBasePlane_Response_Seq;
            typedef DDS_DCPSSequence_var < CalibrateBasePlane_Response_Seq> CalibrateBasePlane_Response_Seq_var;
            typedef DDS_DCPSSequence_out < CalibrateBasePlane_Response_Seq> CalibrateBasePlane_Response_Seq_out;

            class  CalibrateBasePlane_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CalibrateBasePlane_Response_TypeSupportInterface_ptr _ptr_type;
                typedef CalibrateBasePlane_Response_TypeSupportInterface_var _var_type;

                static CalibrateBasePlane_Response_TypeSupportInterface_ptr _duplicate (CalibrateBasePlane_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CalibrateBasePlane_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CalibrateBasePlane_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CalibrateBasePlane_Response_TypeSupportInterface () {};
                ~CalibrateBasePlane_Response_TypeSupportInterface () {};
            private:
                CalibrateBasePlane_Response_TypeSupportInterface (const CalibrateBasePlane_Response_TypeSupportInterface &);
                CalibrateBasePlane_Response_TypeSupportInterface & operator = (const CalibrateBasePlane_Response_TypeSupportInterface &);
            };

            class  CalibrateBasePlane_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CalibrateBasePlane_Response_DataWriter_ptr _ptr_type;
                typedef CalibrateBasePlane_Response_DataWriter_var _var_type;

                static CalibrateBasePlane_Response_DataWriter_ptr _duplicate (CalibrateBasePlane_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CalibrateBasePlane_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CalibrateBasePlane_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CalibrateBasePlane_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CalibrateBasePlane_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CalibrateBasePlane_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CalibrateBasePlane_Response_& instance_data) = 0;

            protected:
                CalibrateBasePlane_Response_DataWriter () {};
                ~CalibrateBasePlane_Response_DataWriter () {};
            private:
                CalibrateBasePlane_Response_DataWriter (const CalibrateBasePlane_Response_DataWriter &);
                CalibrateBasePlane_Response_DataWriter & operator = (const CalibrateBasePlane_Response_DataWriter &);
            };

            class  CalibrateBasePlane_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CalibrateBasePlane_Response_DataReader_ptr _ptr_type;
                typedef CalibrateBasePlane_Response_DataReader_var _var_type;

                static CalibrateBasePlane_Response_DataReader_ptr _duplicate (CalibrateBasePlane_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CalibrateBasePlane_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CalibrateBasePlane_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CalibrateBasePlane_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CalibrateBasePlane_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CalibrateBasePlane_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CalibrateBasePlane_Response_& instance) = 0;

            protected:
                CalibrateBasePlane_Response_DataReader () {};
                ~CalibrateBasePlane_Response_DataReader () {};
            private:
                CalibrateBasePlane_Response_DataReader (const CalibrateBasePlane_Response_DataReader &);
                CalibrateBasePlane_Response_DataReader & operator = (const CalibrateBasePlane_Response_DataReader &);
            };

            class  CalibrateBasePlane_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CalibrateBasePlane_Response_DataReaderView_ptr _ptr_type;
                typedef CalibrateBasePlane_Response_DataReaderView_var _var_type;

                static CalibrateBasePlane_Response_DataReaderView_ptr _duplicate (CalibrateBasePlane_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CalibrateBasePlane_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CalibrateBasePlane_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CalibrateBasePlane_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CalibrateBasePlane_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CalibrateBasePlane_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CalibrateBasePlane_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CalibrateBasePlane_Response_& instance) = 0;

            protected:
                CalibrateBasePlane_Response_DataReaderView () {};
                ~CalibrateBasePlane_Response_DataReaderView () {};
            private:
                CalibrateBasePlane_Response_DataReaderView (const CalibrateBasePlane_Response_DataReaderView &);
                CalibrateBasePlane_Response_DataReaderView & operator = (const CalibrateBasePlane_Response_DataReaderView &);
            };
            class Sample_CalibrateBasePlane_Request_TypeSupportInterface;

            typedef Sample_CalibrateBasePlane_Request_TypeSupportInterface * Sample_CalibrateBasePlane_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_CalibrateBasePlane_Request_TypeSupportInterface> Sample_CalibrateBasePlane_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_CalibrateBasePlane_Request_TypeSupportInterface> Sample_CalibrateBasePlane_Request_TypeSupportInterface_out;


            class Sample_CalibrateBasePlane_Request_DataWriter;

            typedef Sample_CalibrateBasePlane_Request_DataWriter * Sample_CalibrateBasePlane_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_CalibrateBasePlane_Request_DataWriter> Sample_CalibrateBasePlane_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_CalibrateBasePlane_Request_DataWriter> Sample_CalibrateBasePlane_Request_DataWriter_out;


            class Sample_CalibrateBasePlane_Request_DataReader;

            typedef Sample_CalibrateBasePlane_Request_DataReader * Sample_CalibrateBasePlane_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_CalibrateBasePlane_Request_DataReader> Sample_CalibrateBasePlane_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_CalibrateBasePlane_Request_DataReader> Sample_CalibrateBasePlane_Request_DataReader_out;


            class Sample_CalibrateBasePlane_Request_DataReaderView;

            typedef Sample_CalibrateBasePlane_Request_DataReaderView * Sample_CalibrateBasePlane_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_CalibrateBasePlane_Request_DataReaderView> Sample_CalibrateBasePlane_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_CalibrateBasePlane_Request_DataReaderView> Sample_CalibrateBasePlane_Request_DataReaderView_out;

            struct Sample_CalibrateBasePlane_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_CalibrateBasePlane_Request_, struct Sample_CalibrateBasePlane_Request_Seq_uniq_> Sample_CalibrateBasePlane_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_CalibrateBasePlane_Request_Seq> Sample_CalibrateBasePlane_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_CalibrateBasePlane_Request_Seq> Sample_CalibrateBasePlane_Request_Seq_out;

            class  Sample_CalibrateBasePlane_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_CalibrateBasePlane_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_CalibrateBasePlane_Request_TypeSupportInterface_var _var_type;

                static Sample_CalibrateBasePlane_Request_TypeSupportInterface_ptr _duplicate (Sample_CalibrateBasePlane_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CalibrateBasePlane_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CalibrateBasePlane_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_CalibrateBasePlane_Request_TypeSupportInterface () {};
                ~Sample_CalibrateBasePlane_Request_TypeSupportInterface () {};
            private:
                Sample_CalibrateBasePlane_Request_TypeSupportInterface (const Sample_CalibrateBasePlane_Request_TypeSupportInterface &);
                Sample_CalibrateBasePlane_Request_TypeSupportInterface & operator = (const Sample_CalibrateBasePlane_Request_TypeSupportInterface &);
            };

            class  Sample_CalibrateBasePlane_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_CalibrateBasePlane_Request_DataWriter_ptr _ptr_type;
                typedef Sample_CalibrateBasePlane_Request_DataWriter_var _var_type;

                static Sample_CalibrateBasePlane_Request_DataWriter_ptr _duplicate (Sample_CalibrateBasePlane_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CalibrateBasePlane_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CalibrateBasePlane_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_CalibrateBasePlane_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_CalibrateBasePlane_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_CalibrateBasePlane_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_CalibrateBasePlane_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CalibrateBasePlane_Request_& instance_data) = 0;

            protected:
                Sample_CalibrateBasePlane_Request_DataWriter () {};
                ~Sample_CalibrateBasePlane_Request_DataWriter () {};
            private:
                Sample_CalibrateBasePlane_Request_DataWriter (const Sample_CalibrateBasePlane_Request_DataWriter &);
                Sample_CalibrateBasePlane_Request_DataWriter & operator = (const Sample_CalibrateBasePlane_Request_DataWriter &);
            };

            class  Sample_CalibrateBasePlane_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_CalibrateBasePlane_Request_DataReader_ptr _ptr_type;
                typedef Sample_CalibrateBasePlane_Request_DataReader_var _var_type;

                static Sample_CalibrateBasePlane_Request_DataReader_ptr _duplicate (Sample_CalibrateBasePlane_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CalibrateBasePlane_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CalibrateBasePlane_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CalibrateBasePlane_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CalibrateBasePlane_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CalibrateBasePlane_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CalibrateBasePlane_Request_& instance) = 0;

            protected:
                Sample_CalibrateBasePlane_Request_DataReader () {};
                ~Sample_CalibrateBasePlane_Request_DataReader () {};
            private:
                Sample_CalibrateBasePlane_Request_DataReader (const Sample_CalibrateBasePlane_Request_DataReader &);
                Sample_CalibrateBasePlane_Request_DataReader & operator = (const Sample_CalibrateBasePlane_Request_DataReader &);
            };

            class  Sample_CalibrateBasePlane_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_CalibrateBasePlane_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_CalibrateBasePlane_Request_DataReaderView_var _var_type;

                static Sample_CalibrateBasePlane_Request_DataReaderView_ptr _duplicate (Sample_CalibrateBasePlane_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CalibrateBasePlane_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CalibrateBasePlane_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CalibrateBasePlane_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CalibrateBasePlane_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CalibrateBasePlane_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CalibrateBasePlane_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CalibrateBasePlane_Request_& instance) = 0;

            protected:
                Sample_CalibrateBasePlane_Request_DataReaderView () {};
                ~Sample_CalibrateBasePlane_Request_DataReaderView () {};
            private:
                Sample_CalibrateBasePlane_Request_DataReaderView (const Sample_CalibrateBasePlane_Request_DataReaderView &);
                Sample_CalibrateBasePlane_Request_DataReaderView & operator = (const Sample_CalibrateBasePlane_Request_DataReaderView &);
            };
            class Sample_CalibrateBasePlane_Response_TypeSupportInterface;

            typedef Sample_CalibrateBasePlane_Response_TypeSupportInterface * Sample_CalibrateBasePlane_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_CalibrateBasePlane_Response_TypeSupportInterface> Sample_CalibrateBasePlane_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_CalibrateBasePlane_Response_TypeSupportInterface> Sample_CalibrateBasePlane_Response_TypeSupportInterface_out;


            class Sample_CalibrateBasePlane_Response_DataWriter;

            typedef Sample_CalibrateBasePlane_Response_DataWriter * Sample_CalibrateBasePlane_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_CalibrateBasePlane_Response_DataWriter> Sample_CalibrateBasePlane_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_CalibrateBasePlane_Response_DataWriter> Sample_CalibrateBasePlane_Response_DataWriter_out;


            class Sample_CalibrateBasePlane_Response_DataReader;

            typedef Sample_CalibrateBasePlane_Response_DataReader * Sample_CalibrateBasePlane_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_CalibrateBasePlane_Response_DataReader> Sample_CalibrateBasePlane_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_CalibrateBasePlane_Response_DataReader> Sample_CalibrateBasePlane_Response_DataReader_out;


            class Sample_CalibrateBasePlane_Response_DataReaderView;

            typedef Sample_CalibrateBasePlane_Response_DataReaderView * Sample_CalibrateBasePlane_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_CalibrateBasePlane_Response_DataReaderView> Sample_CalibrateBasePlane_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_CalibrateBasePlane_Response_DataReaderView> Sample_CalibrateBasePlane_Response_DataReaderView_out;

            struct Sample_CalibrateBasePlane_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_CalibrateBasePlane_Response_, struct Sample_CalibrateBasePlane_Response_Seq_uniq_> Sample_CalibrateBasePlane_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_CalibrateBasePlane_Response_Seq> Sample_CalibrateBasePlane_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_CalibrateBasePlane_Response_Seq> Sample_CalibrateBasePlane_Response_Seq_out;

            class  Sample_CalibrateBasePlane_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_CalibrateBasePlane_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_CalibrateBasePlane_Response_TypeSupportInterface_var _var_type;

                static Sample_CalibrateBasePlane_Response_TypeSupportInterface_ptr _duplicate (Sample_CalibrateBasePlane_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CalibrateBasePlane_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CalibrateBasePlane_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_CalibrateBasePlane_Response_TypeSupportInterface () {};
                ~Sample_CalibrateBasePlane_Response_TypeSupportInterface () {};
            private:
                Sample_CalibrateBasePlane_Response_TypeSupportInterface (const Sample_CalibrateBasePlane_Response_TypeSupportInterface &);
                Sample_CalibrateBasePlane_Response_TypeSupportInterface & operator = (const Sample_CalibrateBasePlane_Response_TypeSupportInterface &);
            };

            class  Sample_CalibrateBasePlane_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_CalibrateBasePlane_Response_DataWriter_ptr _ptr_type;
                typedef Sample_CalibrateBasePlane_Response_DataWriter_var _var_type;

                static Sample_CalibrateBasePlane_Response_DataWriter_ptr _duplicate (Sample_CalibrateBasePlane_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CalibrateBasePlane_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CalibrateBasePlane_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_CalibrateBasePlane_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_CalibrateBasePlane_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_CalibrateBasePlane_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_CalibrateBasePlane_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CalibrateBasePlane_Response_& instance_data) = 0;

            protected:
                Sample_CalibrateBasePlane_Response_DataWriter () {};
                ~Sample_CalibrateBasePlane_Response_DataWriter () {};
            private:
                Sample_CalibrateBasePlane_Response_DataWriter (const Sample_CalibrateBasePlane_Response_DataWriter &);
                Sample_CalibrateBasePlane_Response_DataWriter & operator = (const Sample_CalibrateBasePlane_Response_DataWriter &);
            };

            class  Sample_CalibrateBasePlane_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_CalibrateBasePlane_Response_DataReader_ptr _ptr_type;
                typedef Sample_CalibrateBasePlane_Response_DataReader_var _var_type;

                static Sample_CalibrateBasePlane_Response_DataReader_ptr _duplicate (Sample_CalibrateBasePlane_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CalibrateBasePlane_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CalibrateBasePlane_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CalibrateBasePlane_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CalibrateBasePlane_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CalibrateBasePlane_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CalibrateBasePlane_Response_& instance) = 0;

            protected:
                Sample_CalibrateBasePlane_Response_DataReader () {};
                ~Sample_CalibrateBasePlane_Response_DataReader () {};
            private:
                Sample_CalibrateBasePlane_Response_DataReader (const Sample_CalibrateBasePlane_Response_DataReader &);
                Sample_CalibrateBasePlane_Response_DataReader & operator = (const Sample_CalibrateBasePlane_Response_DataReader &);
            };

            class  Sample_CalibrateBasePlane_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_CalibrateBasePlane_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_CalibrateBasePlane_Response_DataReaderView_var _var_type;

                static Sample_CalibrateBasePlane_Response_DataReaderView_ptr _duplicate (Sample_CalibrateBasePlane_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_CalibrateBasePlane_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_CalibrateBasePlane_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_CalibrateBasePlane_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_CalibrateBasePlane_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_CalibrateBasePlane_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_CalibrateBasePlane_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_CalibrateBasePlane_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_CalibrateBasePlane_Response_& instance) = 0;

            protected:
                Sample_CalibrateBasePlane_Response_DataReaderView () {};
                ~Sample_CalibrateBasePlane_Response_DataReaderView () {};
            private:
                Sample_CalibrateBasePlane_Response_DataReaderView (const Sample_CalibrateBasePlane_Response_DataReaderView &);
                Sample_CalibrateBasePlane_Response_DataReaderView & operator = (const Sample_CalibrateBasePlane_Response_DataReaderView &);
            };
        }

    }

}

#endif
