#ifndef H_AD703C43CAF8DBC01FE3135303A95060_CalibrateBasePlane_SPLTYPES_H
#define H_AD703C43CAF8DBC01FE3135303A95060_CalibrateBasePlane_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_CalibrateBasePlane_.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_SplDcps.h"
#include "shape_msgs/msg/dds_opensplice/Plane_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_SplDcps.h"



extern c_metaObject __CalibrateBasePlane__rc_reason_msgs__load (c_base base);

extern c_metaObject __CalibrateBasePlane__rc_reason_msgs_srv__load (c_base base);

extern c_metaObject __CalibrateBasePlane__rc_reason_msgs_srv_dds___load (c_base base);

extern const char *rc_reason_msgs_srv_dds__CalibrateBasePlane_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__CalibrateBasePlane_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__CalibrateBasePlane_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__CalibrateBasePlane_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__CalibrateBasePlane_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__CalibrateBasePlane_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::CalibrateBasePlane_Request_ *from, struct _rc_reason_msgs_srv_dds__CalibrateBasePlane_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__CalibrateBasePlane_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__CalibrateBasePlane_Request_ {
    c_string pose_frame_;
    struct _geometry_msgs_msg_dds__Pose_ robot_pose_;
    c_string plane_estimation_method_;
    c_string stereo_plane_preference_;
    c_string region_of_interest_2d_id_;
    c_double offset_;
    struct _shape_msgs_msg_dds__Plane_ plane_;
};

extern const char *rc_reason_msgs_srv_dds__CalibrateBasePlane_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__CalibrateBasePlane_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__CalibrateBasePlane_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__CalibrateBasePlane_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__CalibrateBasePlane_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__CalibrateBasePlane_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::CalibrateBasePlane_Response_ *from, struct _rc_reason_msgs_srv_dds__CalibrateBasePlane_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__CalibrateBasePlane_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__CalibrateBasePlane_Response_ {
    struct _builtin_interfaces_msg_dds__Time_ timestamp_;
    c_string pose_frame_;
    struct _shape_msgs_msg_dds__Plane_ plane_;
    struct _rc_common_msgs_msg_dds__ReturnCode_ return_code_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_CalibrateBasePlane_Request_ *from, struct _rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__CalibrateBasePlane_Request_ request_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_CalibrateBasePlane_Response_ *from, struct _rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_CalibrateBasePlane_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__CalibrateBasePlane_Response_ response_;
};

#undef OS_API
#endif
