#ifndef H_C6B8CF14FBABAC2008EA820496232314_ComputeGrasps_SPLTYPES_H
#define H_C6B8CF14FBABAC2008EA820496232314_ComputeGrasps_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_ComputeGrasps_.h"
#include "rc_reason_msgs/msg/dds_opensplice/Compartment_SplDcps.h"
#include "rc_reason_msgs/msg/dds_opensplice/ItemModel_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_SplDcps.h"
#include "rc_reason_msgs/msg/dds_opensplice/CollisionDetection_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"
#include "rc_reason_msgs/msg/dds_opensplice/Item_SplDcps.h"
#include "rc_reason_msgs/msg/dds_opensplice/LoadCarrier_SplDcps.h"
#include "rc_reason_msgs/msg/dds_opensplice/SuctionGrasp_SplDcps.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_SplDcps.h"



extern c_metaObject __ComputeGrasps__rc_reason_msgs__load (c_base base);

extern c_metaObject __ComputeGrasps__rc_reason_msgs_srv__load (c_base base);

extern c_metaObject __ComputeGrasps__rc_reason_msgs_srv_dds___load (c_base base);

extern const char *rc_reason_msgs_srv_dds__ComputeGrasps_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__ComputeGrasps_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__ComputeGrasps_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__ComputeGrasps_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__ComputeGrasps_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__ComputeGrasps_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::ComputeGrasps_Request_ *from, struct _rc_reason_msgs_srv_dds__ComputeGrasps_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__ComputeGrasps_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__ComputeGrasps_Request_ {
    c_string pose_frame_;
    c_string region_of_interest_id_;
    c_string load_carrier_id_;
    struct _rc_reason_msgs_msg_dds__Compartment_ load_carrier_compartment_;
    c_sequence item_models_;
    c_double suction_surface_length_;
    c_double suction_surface_width_;
    struct _geometry_msgs_msg_dds__Pose_ robot_pose_;
    struct _rc_reason_msgs_msg_dds__CollisionDetection_ collision_detection_;
};

extern const char *rc_reason_msgs_srv_dds__ComputeGrasps_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__ComputeGrasps_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__ComputeGrasps_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__ComputeGrasps_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__ComputeGrasps_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__ComputeGrasps_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::ComputeGrasps_Response_ *from, struct _rc_reason_msgs_srv_dds__ComputeGrasps_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__ComputeGrasps_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__ComputeGrasps_Response_ {
    struct _builtin_interfaces_msg_dds__Time_ timestamp_;
    c_sequence items_;
    c_sequence load_carriers_;
    c_sequence grasps_;
    struct _rc_common_msgs_msg_dds__ReturnCode_ return_code_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_ComputeGrasps_Request_ *from, struct _rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__ComputeGrasps_Request_ request_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_ComputeGrasps_Response_ *from, struct _rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_ComputeGrasps_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__ComputeGrasps_Response_ response_;
};

#undef OS_API
#endif
