#ifndef _H_E78BB80ABEDBD799605B51CCFFD4290B_DetectItems_DCPS_H_
#define _H_E78BB80ABEDBD799605B51CCFFD4290B_DetectItems_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DetectItems_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class DetectItems_Request_TypeSupportInterface;

            typedef DetectItems_Request_TypeSupportInterface * DetectItems_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectItems_Request_TypeSupportInterface> DetectItems_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectItems_Request_TypeSupportInterface> DetectItems_Request_TypeSupportInterface_out;


            class DetectItems_Request_DataWriter;

            typedef DetectItems_Request_DataWriter * DetectItems_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectItems_Request_DataWriter> DetectItems_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectItems_Request_DataWriter> DetectItems_Request_DataWriter_out;


            class DetectItems_Request_DataReader;

            typedef DetectItems_Request_DataReader * DetectItems_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectItems_Request_DataReader> DetectItems_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectItems_Request_DataReader> DetectItems_Request_DataReader_out;


            class DetectItems_Request_DataReaderView;

            typedef DetectItems_Request_DataReaderView * DetectItems_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectItems_Request_DataReaderView> DetectItems_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectItems_Request_DataReaderView> DetectItems_Request_DataReaderView_out;

            struct DetectItems_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DetectItems_Request_, struct DetectItems_Request_Seq_uniq_> DetectItems_Request_Seq;
            typedef DDS_DCPSSequence_var < DetectItems_Request_Seq> DetectItems_Request_Seq_var;
            typedef DDS_DCPSSequence_out < DetectItems_Request_Seq> DetectItems_Request_Seq_out;

            class  DetectItems_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectItems_Request_TypeSupportInterface_ptr _ptr_type;
                typedef DetectItems_Request_TypeSupportInterface_var _var_type;

                static DetectItems_Request_TypeSupportInterface_ptr _duplicate (DetectItems_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectItems_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectItems_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectItems_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectItems_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectItems_Request_TypeSupportInterface () {};
                ~DetectItems_Request_TypeSupportInterface () {};
            private:
                DetectItems_Request_TypeSupportInterface (const DetectItems_Request_TypeSupportInterface &);
                DetectItems_Request_TypeSupportInterface & operator = (const DetectItems_Request_TypeSupportInterface &);
            };

            class  DetectItems_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectItems_Request_DataWriter_ptr _ptr_type;
                typedef DetectItems_Request_DataWriter_var _var_type;

                static DetectItems_Request_DataWriter_ptr _duplicate (DetectItems_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectItems_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectItems_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectItems_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectItems_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectItems_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectItems_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectItems_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectItems_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectItems_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectItems_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectItems_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectItems_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectItems_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectItems_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectItems_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectItems_Request_& instance_data) = 0;

            protected:
                DetectItems_Request_DataWriter () {};
                ~DetectItems_Request_DataWriter () {};
            private:
                DetectItems_Request_DataWriter (const DetectItems_Request_DataWriter &);
                DetectItems_Request_DataWriter & operator = (const DetectItems_Request_DataWriter &);
            };

            class  DetectItems_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectItems_Request_DataReader_ptr _ptr_type;
                typedef DetectItems_Request_DataReader_var _var_type;

                static DetectItems_Request_DataReader_ptr _duplicate (DetectItems_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectItems_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectItems_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectItems_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectItems_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectItems_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectItems_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectItems_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectItems_Request_& instance) = 0;

            protected:
                DetectItems_Request_DataReader () {};
                ~DetectItems_Request_DataReader () {};
            private:
                DetectItems_Request_DataReader (const DetectItems_Request_DataReader &);
                DetectItems_Request_DataReader & operator = (const DetectItems_Request_DataReader &);
            };

            class  DetectItems_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectItems_Request_DataReaderView_ptr _ptr_type;
                typedef DetectItems_Request_DataReaderView_var _var_type;

                static DetectItems_Request_DataReaderView_ptr _duplicate (DetectItems_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectItems_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectItems_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectItems_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectItems_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectItems_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectItems_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectItems_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectItems_Request_& instance) = 0;

            protected:
                DetectItems_Request_DataReaderView () {};
                ~DetectItems_Request_DataReaderView () {};
            private:
                DetectItems_Request_DataReaderView (const DetectItems_Request_DataReaderView &);
                DetectItems_Request_DataReaderView & operator = (const DetectItems_Request_DataReaderView &);
            };
            class DetectItems_Response_TypeSupportInterface;

            typedef DetectItems_Response_TypeSupportInterface * DetectItems_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectItems_Response_TypeSupportInterface> DetectItems_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectItems_Response_TypeSupportInterface> DetectItems_Response_TypeSupportInterface_out;


            class DetectItems_Response_DataWriter;

            typedef DetectItems_Response_DataWriter * DetectItems_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectItems_Response_DataWriter> DetectItems_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectItems_Response_DataWriter> DetectItems_Response_DataWriter_out;


            class DetectItems_Response_DataReader;

            typedef DetectItems_Response_DataReader * DetectItems_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectItems_Response_DataReader> DetectItems_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectItems_Response_DataReader> DetectItems_Response_DataReader_out;


            class DetectItems_Response_DataReaderView;

            typedef DetectItems_Response_DataReaderView * DetectItems_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectItems_Response_DataReaderView> DetectItems_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectItems_Response_DataReaderView> DetectItems_Response_DataReaderView_out;

            struct DetectItems_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DetectItems_Response_, struct DetectItems_Response_Seq_uniq_> DetectItems_Response_Seq;
            typedef DDS_DCPSSequence_var < DetectItems_Response_Seq> DetectItems_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DetectItems_Response_Seq> DetectItems_Response_Seq_out;

            class  DetectItems_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectItems_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DetectItems_Response_TypeSupportInterface_var _var_type;

                static DetectItems_Response_TypeSupportInterface_ptr _duplicate (DetectItems_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectItems_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectItems_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectItems_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectItems_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectItems_Response_TypeSupportInterface () {};
                ~DetectItems_Response_TypeSupportInterface () {};
            private:
                DetectItems_Response_TypeSupportInterface (const DetectItems_Response_TypeSupportInterface &);
                DetectItems_Response_TypeSupportInterface & operator = (const DetectItems_Response_TypeSupportInterface &);
            };

            class  DetectItems_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectItems_Response_DataWriter_ptr _ptr_type;
                typedef DetectItems_Response_DataWriter_var _var_type;

                static DetectItems_Response_DataWriter_ptr _duplicate (DetectItems_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectItems_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectItems_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectItems_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectItems_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectItems_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectItems_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectItems_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectItems_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectItems_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectItems_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectItems_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectItems_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectItems_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectItems_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectItems_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectItems_Response_& instance_data) = 0;

            protected:
                DetectItems_Response_DataWriter () {};
                ~DetectItems_Response_DataWriter () {};
            private:
                DetectItems_Response_DataWriter (const DetectItems_Response_DataWriter &);
                DetectItems_Response_DataWriter & operator = (const DetectItems_Response_DataWriter &);
            };

            class  DetectItems_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectItems_Response_DataReader_ptr _ptr_type;
                typedef DetectItems_Response_DataReader_var _var_type;

                static DetectItems_Response_DataReader_ptr _duplicate (DetectItems_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectItems_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectItems_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectItems_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectItems_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectItems_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectItems_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectItems_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectItems_Response_& instance) = 0;

            protected:
                DetectItems_Response_DataReader () {};
                ~DetectItems_Response_DataReader () {};
            private:
                DetectItems_Response_DataReader (const DetectItems_Response_DataReader &);
                DetectItems_Response_DataReader & operator = (const DetectItems_Response_DataReader &);
            };

            class  DetectItems_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectItems_Response_DataReaderView_ptr _ptr_type;
                typedef DetectItems_Response_DataReaderView_var _var_type;

                static DetectItems_Response_DataReaderView_ptr _duplicate (DetectItems_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectItems_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectItems_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectItems_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectItems_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectItems_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectItems_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectItems_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectItems_Response_& instance) = 0;

            protected:
                DetectItems_Response_DataReaderView () {};
                ~DetectItems_Response_DataReaderView () {};
            private:
                DetectItems_Response_DataReaderView (const DetectItems_Response_DataReaderView &);
                DetectItems_Response_DataReaderView & operator = (const DetectItems_Response_DataReaderView &);
            };
            class Sample_DetectItems_Request_TypeSupportInterface;

            typedef Sample_DetectItems_Request_TypeSupportInterface * Sample_DetectItems_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectItems_Request_TypeSupportInterface> Sample_DetectItems_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DetectItems_Request_TypeSupportInterface> Sample_DetectItems_Request_TypeSupportInterface_out;


            class Sample_DetectItems_Request_DataWriter;

            typedef Sample_DetectItems_Request_DataWriter * Sample_DetectItems_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectItems_Request_DataWriter> Sample_DetectItems_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DetectItems_Request_DataWriter> Sample_DetectItems_Request_DataWriter_out;


            class Sample_DetectItems_Request_DataReader;

            typedef Sample_DetectItems_Request_DataReader * Sample_DetectItems_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectItems_Request_DataReader> Sample_DetectItems_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DetectItems_Request_DataReader> Sample_DetectItems_Request_DataReader_out;


            class Sample_DetectItems_Request_DataReaderView;

            typedef Sample_DetectItems_Request_DataReaderView * Sample_DetectItems_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectItems_Request_DataReaderView> Sample_DetectItems_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DetectItems_Request_DataReaderView> Sample_DetectItems_Request_DataReaderView_out;

            struct Sample_DetectItems_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DetectItems_Request_, struct Sample_DetectItems_Request_Seq_uniq_> Sample_DetectItems_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_DetectItems_Request_Seq> Sample_DetectItems_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DetectItems_Request_Seq> Sample_DetectItems_Request_Seq_out;

            class  Sample_DetectItems_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DetectItems_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DetectItems_Request_TypeSupportInterface_var _var_type;

                static Sample_DetectItems_Request_TypeSupportInterface_ptr _duplicate (Sample_DetectItems_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectItems_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectItems_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DetectItems_Request_TypeSupportInterface () {};
                ~Sample_DetectItems_Request_TypeSupportInterface () {};
            private:
                Sample_DetectItems_Request_TypeSupportInterface (const Sample_DetectItems_Request_TypeSupportInterface &);
                Sample_DetectItems_Request_TypeSupportInterface & operator = (const Sample_DetectItems_Request_TypeSupportInterface &);
            };

            class  Sample_DetectItems_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DetectItems_Request_DataWriter_ptr _ptr_type;
                typedef Sample_DetectItems_Request_DataWriter_var _var_type;

                static Sample_DetectItems_Request_DataWriter_ptr _duplicate (Sample_DetectItems_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectItems_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectItems_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DetectItems_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DetectItems_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DetectItems_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DetectItems_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DetectItems_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DetectItems_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DetectItems_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DetectItems_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DetectItems_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DetectItems_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DetectItems_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectItems_Request_& instance_data) = 0;

            protected:
                Sample_DetectItems_Request_DataWriter () {};
                ~Sample_DetectItems_Request_DataWriter () {};
            private:
                Sample_DetectItems_Request_DataWriter (const Sample_DetectItems_Request_DataWriter &);
                Sample_DetectItems_Request_DataWriter & operator = (const Sample_DetectItems_Request_DataWriter &);
            };

            class  Sample_DetectItems_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DetectItems_Request_DataReader_ptr _ptr_type;
                typedef Sample_DetectItems_Request_DataReader_var _var_type;

                static Sample_DetectItems_Request_DataReader_ptr _duplicate (Sample_DetectItems_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectItems_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectItems_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectItems_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectItems_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectItems_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectItems_Request_& instance) = 0;

            protected:
                Sample_DetectItems_Request_DataReader () {};
                ~Sample_DetectItems_Request_DataReader () {};
            private:
                Sample_DetectItems_Request_DataReader (const Sample_DetectItems_Request_DataReader &);
                Sample_DetectItems_Request_DataReader & operator = (const Sample_DetectItems_Request_DataReader &);
            };

            class  Sample_DetectItems_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DetectItems_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_DetectItems_Request_DataReaderView_var _var_type;

                static Sample_DetectItems_Request_DataReaderView_ptr _duplicate (Sample_DetectItems_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectItems_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectItems_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectItems_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectItems_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectItems_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectItems_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectItems_Request_& instance) = 0;

            protected:
                Sample_DetectItems_Request_DataReaderView () {};
                ~Sample_DetectItems_Request_DataReaderView () {};
            private:
                Sample_DetectItems_Request_DataReaderView (const Sample_DetectItems_Request_DataReaderView &);
                Sample_DetectItems_Request_DataReaderView & operator = (const Sample_DetectItems_Request_DataReaderView &);
            };
            class Sample_DetectItems_Response_TypeSupportInterface;

            typedef Sample_DetectItems_Response_TypeSupportInterface * Sample_DetectItems_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectItems_Response_TypeSupportInterface> Sample_DetectItems_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DetectItems_Response_TypeSupportInterface> Sample_DetectItems_Response_TypeSupportInterface_out;


            class Sample_DetectItems_Response_DataWriter;

            typedef Sample_DetectItems_Response_DataWriter * Sample_DetectItems_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectItems_Response_DataWriter> Sample_DetectItems_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DetectItems_Response_DataWriter> Sample_DetectItems_Response_DataWriter_out;


            class Sample_DetectItems_Response_DataReader;

            typedef Sample_DetectItems_Response_DataReader * Sample_DetectItems_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectItems_Response_DataReader> Sample_DetectItems_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DetectItems_Response_DataReader> Sample_DetectItems_Response_DataReader_out;


            class Sample_DetectItems_Response_DataReaderView;

            typedef Sample_DetectItems_Response_DataReaderView * Sample_DetectItems_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectItems_Response_DataReaderView> Sample_DetectItems_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DetectItems_Response_DataReaderView> Sample_DetectItems_Response_DataReaderView_out;

            struct Sample_DetectItems_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DetectItems_Response_, struct Sample_DetectItems_Response_Seq_uniq_> Sample_DetectItems_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_DetectItems_Response_Seq> Sample_DetectItems_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DetectItems_Response_Seq> Sample_DetectItems_Response_Seq_out;

            class  Sample_DetectItems_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DetectItems_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DetectItems_Response_TypeSupportInterface_var _var_type;

                static Sample_DetectItems_Response_TypeSupportInterface_ptr _duplicate (Sample_DetectItems_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectItems_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectItems_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DetectItems_Response_TypeSupportInterface () {};
                ~Sample_DetectItems_Response_TypeSupportInterface () {};
            private:
                Sample_DetectItems_Response_TypeSupportInterface (const Sample_DetectItems_Response_TypeSupportInterface &);
                Sample_DetectItems_Response_TypeSupportInterface & operator = (const Sample_DetectItems_Response_TypeSupportInterface &);
            };

            class  Sample_DetectItems_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DetectItems_Response_DataWriter_ptr _ptr_type;
                typedef Sample_DetectItems_Response_DataWriter_var _var_type;

                static Sample_DetectItems_Response_DataWriter_ptr _duplicate (Sample_DetectItems_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectItems_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectItems_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DetectItems_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DetectItems_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DetectItems_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DetectItems_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DetectItems_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DetectItems_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DetectItems_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DetectItems_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DetectItems_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DetectItems_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DetectItems_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectItems_Response_& instance_data) = 0;

            protected:
                Sample_DetectItems_Response_DataWriter () {};
                ~Sample_DetectItems_Response_DataWriter () {};
            private:
                Sample_DetectItems_Response_DataWriter (const Sample_DetectItems_Response_DataWriter &);
                Sample_DetectItems_Response_DataWriter & operator = (const Sample_DetectItems_Response_DataWriter &);
            };

            class  Sample_DetectItems_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DetectItems_Response_DataReader_ptr _ptr_type;
                typedef Sample_DetectItems_Response_DataReader_var _var_type;

                static Sample_DetectItems_Response_DataReader_ptr _duplicate (Sample_DetectItems_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectItems_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectItems_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectItems_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectItems_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectItems_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectItems_Response_& instance) = 0;

            protected:
                Sample_DetectItems_Response_DataReader () {};
                ~Sample_DetectItems_Response_DataReader () {};
            private:
                Sample_DetectItems_Response_DataReader (const Sample_DetectItems_Response_DataReader &);
                Sample_DetectItems_Response_DataReader & operator = (const Sample_DetectItems_Response_DataReader &);
            };

            class  Sample_DetectItems_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DetectItems_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_DetectItems_Response_DataReaderView_var _var_type;

                static Sample_DetectItems_Response_DataReaderView_ptr _duplicate (Sample_DetectItems_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectItems_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectItems_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectItems_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectItems_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectItems_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectItems_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectItems_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectItems_Response_& instance) = 0;

            protected:
                Sample_DetectItems_Response_DataReaderView () {};
                ~Sample_DetectItems_Response_DataReaderView () {};
            private:
                Sample_DetectItems_Response_DataReaderView (const Sample_DetectItems_Response_DataReaderView &);
                Sample_DetectItems_Response_DataReaderView & operator = (const Sample_DetectItems_Response_DataReaderView &);
            };
        }

    }

}

#endif
