#ifndef H_E78BB80ABEDBD799605B51CCFFD4290B_DetectItems_SPLTYPES_H
#define H_E78BB80ABEDBD799605B51CCFFD4290B_DetectItems_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_DetectItems_.h"
#include "rc_reason_msgs/msg/dds_opensplice/Compartment_SplDcps.h"
#include "rc_reason_msgs/msg/dds_opensplice/ItemModel_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"
#include "rc_reason_msgs/msg/dds_opensplice/Item_SplDcps.h"
#include "rc_reason_msgs/msg/dds_opensplice/LoadCarrier_SplDcps.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_SplDcps.h"



extern c_metaObject __DetectItems__rc_reason_msgs__load (c_base base);

extern c_metaObject __DetectItems__rc_reason_msgs_srv__load (c_base base);

extern c_metaObject __DetectItems__rc_reason_msgs_srv_dds___load (c_base base);

extern const char *rc_reason_msgs_srv_dds__DetectItems_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__DetectItems_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__DetectItems_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__DetectItems_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__DetectItems_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__DetectItems_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::DetectItems_Request_ *from, struct _rc_reason_msgs_srv_dds__DetectItems_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__DetectItems_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__DetectItems_Request_ {
    c_string pose_frame_;
    c_string region_of_interest_id_;
    c_string load_carrier_id_;
    struct _rc_reason_msgs_msg_dds__Compartment_ load_carrier_compartment_;
    c_sequence item_models_;
    struct _geometry_msgs_msg_dds__Pose_ robot_pose_;
};

extern const char *rc_reason_msgs_srv_dds__DetectItems_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__DetectItems_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__DetectItems_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__DetectItems_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__DetectItems_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__DetectItems_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::DetectItems_Response_ *from, struct _rc_reason_msgs_srv_dds__DetectItems_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__DetectItems_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__DetectItems_Response_ {
    struct _builtin_interfaces_msg_dds__Time_ timestamp_;
    c_sequence items_;
    c_sequence load_carriers_;
    struct _rc_common_msgs_msg_dds__ReturnCode_ return_code_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_DetectItems_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_DetectItems_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_DetectItems_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_DetectItems_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_DetectItems_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_DetectItems_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_DetectItems_Request_ *from, struct _rc_reason_msgs_srv_dds__Sample_DetectItems_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_DetectItems_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_DetectItems_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__DetectItems_Request_ request_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_DetectItems_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_DetectItems_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_DetectItems_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_DetectItems_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_DetectItems_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_DetectItems_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_DetectItems_Response_ *from, struct _rc_reason_msgs_srv_dds__Sample_DetectItems_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_DetectItems_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_DetectItems_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__DetectItems_Response_ response_;
};

#undef OS_API
#endif
