#ifndef _H_B157AEB4492CB407A45902CF77AF8C69_DetectLoadCarriers__H_
#define _H_B157AEB4492CB407A45902CF77AF8C69_DetectLoadCarriers__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "rc_reason_msgs/msg/dds_opensplice/LoadCarrier_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  DetectLoadCarriers_Request_
            {
                struct _load_carrier_ids__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _load_carrier_ids__seq_uniq_ > _load_carrier_ids__seq;
                typedef DDS_DCPSUStrSeq_var< _load_carrier_ids__seq > _load_carrier_ids__seq_var;
                typedef DDS_DCPSUStrSeq_out< _load_carrier_ids__seq > _load_carrier_ids__seq_out;
                ::DDS::String_mgr pose_frame_;
                ::DDS::String_mgr region_of_interest_id_;
                _load_carrier_ids__seq load_carrier_ids_;
                ::geometry_msgs::msg::dds_::Pose_ robot_pose_;
            };

            typedef DDS_DCPSStruct_var<DetectLoadCarriers_Request_> DetectLoadCarriers_Request__var;
            typedef DDS_DCPSStruct_out < DetectLoadCarriers_Request_> DetectLoadCarriers_Request__out;

            struct  DetectLoadCarriers_Response_
            {
                struct _load_carriers__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_reason_msgs::msg::dds_::LoadCarrier_, struct _load_carriers__seq_uniq_ > _load_carriers__seq;
                typedef DDS_DCPSSequence_var< _load_carriers__seq > _load_carriers__seq_var;
                typedef DDS_DCPSSequence_out< _load_carriers__seq > _load_carriers__seq_out;
                ::builtin_interfaces::msg::dds_::Time_ timestamp_;
                _load_carriers__seq load_carriers_;
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<DetectLoadCarriers_Response_> DetectLoadCarriers_Response__var;
            typedef DDS_DCPSStruct_out < DetectLoadCarriers_Response_> DetectLoadCarriers_Response__out;

            struct  Sample_DetectLoadCarriers_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DetectLoadCarriers_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_DetectLoadCarriers_Request_> Sample_DetectLoadCarriers_Request__var;
            typedef DDS_DCPSStruct_out < Sample_DetectLoadCarriers_Request_> Sample_DetectLoadCarriers_Request__out;

            struct  Sample_DetectLoadCarriers_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DetectLoadCarriers_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_DetectLoadCarriers_Response_> Sample_DetectLoadCarriers_Response__var;
            typedef DDS_DCPSStruct_out < Sample_DetectLoadCarriers_Response_> Sample_DetectLoadCarriers_Response__out;

        }

    }

}

#endif /* _H_B157AEB4492CB407A45902CF77AF8C69_DetectLoadCarriers__H_ */
