#ifndef _H_B157AEB4492CB407A45902CF77AF8C69_DetectLoadCarriers_DCPS_H_
#define _H_B157AEB4492CB407A45902CF77AF8C69_DetectLoadCarriers_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DetectLoadCarriers_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class DetectLoadCarriers_Request_TypeSupportInterface;

            typedef DetectLoadCarriers_Request_TypeSupportInterface * DetectLoadCarriers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectLoadCarriers_Request_TypeSupportInterface> DetectLoadCarriers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectLoadCarriers_Request_TypeSupportInterface> DetectLoadCarriers_Request_TypeSupportInterface_out;


            class DetectLoadCarriers_Request_DataWriter;

            typedef DetectLoadCarriers_Request_DataWriter * DetectLoadCarriers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectLoadCarriers_Request_DataWriter> DetectLoadCarriers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectLoadCarriers_Request_DataWriter> DetectLoadCarriers_Request_DataWriter_out;


            class DetectLoadCarriers_Request_DataReader;

            typedef DetectLoadCarriers_Request_DataReader * DetectLoadCarriers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectLoadCarriers_Request_DataReader> DetectLoadCarriers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectLoadCarriers_Request_DataReader> DetectLoadCarriers_Request_DataReader_out;


            class DetectLoadCarriers_Request_DataReaderView;

            typedef DetectLoadCarriers_Request_DataReaderView * DetectLoadCarriers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectLoadCarriers_Request_DataReaderView> DetectLoadCarriers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectLoadCarriers_Request_DataReaderView> DetectLoadCarriers_Request_DataReaderView_out;

            struct DetectLoadCarriers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DetectLoadCarriers_Request_, struct DetectLoadCarriers_Request_Seq_uniq_> DetectLoadCarriers_Request_Seq;
            typedef DDS_DCPSSequence_var < DetectLoadCarriers_Request_Seq> DetectLoadCarriers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < DetectLoadCarriers_Request_Seq> DetectLoadCarriers_Request_Seq_out;

            class  DetectLoadCarriers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectLoadCarriers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef DetectLoadCarriers_Request_TypeSupportInterface_var _var_type;

                static DetectLoadCarriers_Request_TypeSupportInterface_ptr _duplicate (DetectLoadCarriers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectLoadCarriers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectLoadCarriers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectLoadCarriers_Request_TypeSupportInterface () {};
                ~DetectLoadCarriers_Request_TypeSupportInterface () {};
            private:
                DetectLoadCarriers_Request_TypeSupportInterface (const DetectLoadCarriers_Request_TypeSupportInterface &);
                DetectLoadCarriers_Request_TypeSupportInterface & operator = (const DetectLoadCarriers_Request_TypeSupportInterface &);
            };

            class  DetectLoadCarriers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectLoadCarriers_Request_DataWriter_ptr _ptr_type;
                typedef DetectLoadCarriers_Request_DataWriter_var _var_type;

                static DetectLoadCarriers_Request_DataWriter_ptr _duplicate (DetectLoadCarriers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectLoadCarriers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectLoadCarriers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectLoadCarriers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectLoadCarriers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectLoadCarriers_Request_& instance_data) = 0;

            protected:
                DetectLoadCarriers_Request_DataWriter () {};
                ~DetectLoadCarriers_Request_DataWriter () {};
            private:
                DetectLoadCarriers_Request_DataWriter (const DetectLoadCarriers_Request_DataWriter &);
                DetectLoadCarriers_Request_DataWriter & operator = (const DetectLoadCarriers_Request_DataWriter &);
            };

            class  DetectLoadCarriers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectLoadCarriers_Request_DataReader_ptr _ptr_type;
                typedef DetectLoadCarriers_Request_DataReader_var _var_type;

                static DetectLoadCarriers_Request_DataReader_ptr _duplicate (DetectLoadCarriers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectLoadCarriers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectLoadCarriers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectLoadCarriers_Request_& instance) = 0;

            protected:
                DetectLoadCarriers_Request_DataReader () {};
                ~DetectLoadCarriers_Request_DataReader () {};
            private:
                DetectLoadCarriers_Request_DataReader (const DetectLoadCarriers_Request_DataReader &);
                DetectLoadCarriers_Request_DataReader & operator = (const DetectLoadCarriers_Request_DataReader &);
            };

            class  DetectLoadCarriers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectLoadCarriers_Request_DataReaderView_ptr _ptr_type;
                typedef DetectLoadCarriers_Request_DataReaderView_var _var_type;

                static DetectLoadCarriers_Request_DataReaderView_ptr _duplicate (DetectLoadCarriers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectLoadCarriers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectLoadCarriers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectLoadCarriers_Request_& instance) = 0;

            protected:
                DetectLoadCarriers_Request_DataReaderView () {};
                ~DetectLoadCarriers_Request_DataReaderView () {};
            private:
                DetectLoadCarriers_Request_DataReaderView (const DetectLoadCarriers_Request_DataReaderView &);
                DetectLoadCarriers_Request_DataReaderView & operator = (const DetectLoadCarriers_Request_DataReaderView &);
            };
            class DetectLoadCarriers_Response_TypeSupportInterface;

            typedef DetectLoadCarriers_Response_TypeSupportInterface * DetectLoadCarriers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectLoadCarriers_Response_TypeSupportInterface> DetectLoadCarriers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectLoadCarriers_Response_TypeSupportInterface> DetectLoadCarriers_Response_TypeSupportInterface_out;


            class DetectLoadCarriers_Response_DataWriter;

            typedef DetectLoadCarriers_Response_DataWriter * DetectLoadCarriers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectLoadCarriers_Response_DataWriter> DetectLoadCarriers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectLoadCarriers_Response_DataWriter> DetectLoadCarriers_Response_DataWriter_out;


            class DetectLoadCarriers_Response_DataReader;

            typedef DetectLoadCarriers_Response_DataReader * DetectLoadCarriers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectLoadCarriers_Response_DataReader> DetectLoadCarriers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectLoadCarriers_Response_DataReader> DetectLoadCarriers_Response_DataReader_out;


            class DetectLoadCarriers_Response_DataReaderView;

            typedef DetectLoadCarriers_Response_DataReaderView * DetectLoadCarriers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectLoadCarriers_Response_DataReaderView> DetectLoadCarriers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectLoadCarriers_Response_DataReaderView> DetectLoadCarriers_Response_DataReaderView_out;

            struct DetectLoadCarriers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DetectLoadCarriers_Response_, struct DetectLoadCarriers_Response_Seq_uniq_> DetectLoadCarriers_Response_Seq;
            typedef DDS_DCPSSequence_var < DetectLoadCarriers_Response_Seq> DetectLoadCarriers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DetectLoadCarriers_Response_Seq> DetectLoadCarriers_Response_Seq_out;

            class  DetectLoadCarriers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectLoadCarriers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DetectLoadCarriers_Response_TypeSupportInterface_var _var_type;

                static DetectLoadCarriers_Response_TypeSupportInterface_ptr _duplicate (DetectLoadCarriers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectLoadCarriers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectLoadCarriers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectLoadCarriers_Response_TypeSupportInterface () {};
                ~DetectLoadCarriers_Response_TypeSupportInterface () {};
            private:
                DetectLoadCarriers_Response_TypeSupportInterface (const DetectLoadCarriers_Response_TypeSupportInterface &);
                DetectLoadCarriers_Response_TypeSupportInterface & operator = (const DetectLoadCarriers_Response_TypeSupportInterface &);
            };

            class  DetectLoadCarriers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectLoadCarriers_Response_DataWriter_ptr _ptr_type;
                typedef DetectLoadCarriers_Response_DataWriter_var _var_type;

                static DetectLoadCarriers_Response_DataWriter_ptr _duplicate (DetectLoadCarriers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectLoadCarriers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectLoadCarriers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectLoadCarriers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectLoadCarriers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectLoadCarriers_Response_& instance_data) = 0;

            protected:
                DetectLoadCarriers_Response_DataWriter () {};
                ~DetectLoadCarriers_Response_DataWriter () {};
            private:
                DetectLoadCarriers_Response_DataWriter (const DetectLoadCarriers_Response_DataWriter &);
                DetectLoadCarriers_Response_DataWriter & operator = (const DetectLoadCarriers_Response_DataWriter &);
            };

            class  DetectLoadCarriers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectLoadCarriers_Response_DataReader_ptr _ptr_type;
                typedef DetectLoadCarriers_Response_DataReader_var _var_type;

                static DetectLoadCarriers_Response_DataReader_ptr _duplicate (DetectLoadCarriers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectLoadCarriers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectLoadCarriers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectLoadCarriers_Response_& instance) = 0;

            protected:
                DetectLoadCarriers_Response_DataReader () {};
                ~DetectLoadCarriers_Response_DataReader () {};
            private:
                DetectLoadCarriers_Response_DataReader (const DetectLoadCarriers_Response_DataReader &);
                DetectLoadCarriers_Response_DataReader & operator = (const DetectLoadCarriers_Response_DataReader &);
            };

            class  DetectLoadCarriers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectLoadCarriers_Response_DataReaderView_ptr _ptr_type;
                typedef DetectLoadCarriers_Response_DataReaderView_var _var_type;

                static DetectLoadCarriers_Response_DataReaderView_ptr _duplicate (DetectLoadCarriers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectLoadCarriers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectLoadCarriers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectLoadCarriers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectLoadCarriers_Response_& instance) = 0;

            protected:
                DetectLoadCarriers_Response_DataReaderView () {};
                ~DetectLoadCarriers_Response_DataReaderView () {};
            private:
                DetectLoadCarriers_Response_DataReaderView (const DetectLoadCarriers_Response_DataReaderView &);
                DetectLoadCarriers_Response_DataReaderView & operator = (const DetectLoadCarriers_Response_DataReaderView &);
            };
            class Sample_DetectLoadCarriers_Request_TypeSupportInterface;

            typedef Sample_DetectLoadCarriers_Request_TypeSupportInterface * Sample_DetectLoadCarriers_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectLoadCarriers_Request_TypeSupportInterface> Sample_DetectLoadCarriers_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DetectLoadCarriers_Request_TypeSupportInterface> Sample_DetectLoadCarriers_Request_TypeSupportInterface_out;


            class Sample_DetectLoadCarriers_Request_DataWriter;

            typedef Sample_DetectLoadCarriers_Request_DataWriter * Sample_DetectLoadCarriers_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectLoadCarriers_Request_DataWriter> Sample_DetectLoadCarriers_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DetectLoadCarriers_Request_DataWriter> Sample_DetectLoadCarriers_Request_DataWriter_out;


            class Sample_DetectLoadCarriers_Request_DataReader;

            typedef Sample_DetectLoadCarriers_Request_DataReader * Sample_DetectLoadCarriers_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectLoadCarriers_Request_DataReader> Sample_DetectLoadCarriers_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DetectLoadCarriers_Request_DataReader> Sample_DetectLoadCarriers_Request_DataReader_out;


            class Sample_DetectLoadCarriers_Request_DataReaderView;

            typedef Sample_DetectLoadCarriers_Request_DataReaderView * Sample_DetectLoadCarriers_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectLoadCarriers_Request_DataReaderView> Sample_DetectLoadCarriers_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DetectLoadCarriers_Request_DataReaderView> Sample_DetectLoadCarriers_Request_DataReaderView_out;

            struct Sample_DetectLoadCarriers_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DetectLoadCarriers_Request_, struct Sample_DetectLoadCarriers_Request_Seq_uniq_> Sample_DetectLoadCarriers_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_DetectLoadCarriers_Request_Seq> Sample_DetectLoadCarriers_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DetectLoadCarriers_Request_Seq> Sample_DetectLoadCarriers_Request_Seq_out;

            class  Sample_DetectLoadCarriers_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DetectLoadCarriers_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DetectLoadCarriers_Request_TypeSupportInterface_var _var_type;

                static Sample_DetectLoadCarriers_Request_TypeSupportInterface_ptr _duplicate (Sample_DetectLoadCarriers_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectLoadCarriers_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectLoadCarriers_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DetectLoadCarriers_Request_TypeSupportInterface () {};
                ~Sample_DetectLoadCarriers_Request_TypeSupportInterface () {};
            private:
                Sample_DetectLoadCarriers_Request_TypeSupportInterface (const Sample_DetectLoadCarriers_Request_TypeSupportInterface &);
                Sample_DetectLoadCarriers_Request_TypeSupportInterface & operator = (const Sample_DetectLoadCarriers_Request_TypeSupportInterface &);
            };

            class  Sample_DetectLoadCarriers_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DetectLoadCarriers_Request_DataWriter_ptr _ptr_type;
                typedef Sample_DetectLoadCarriers_Request_DataWriter_var _var_type;

                static Sample_DetectLoadCarriers_Request_DataWriter_ptr _duplicate (Sample_DetectLoadCarriers_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectLoadCarriers_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectLoadCarriers_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DetectLoadCarriers_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DetectLoadCarriers_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DetectLoadCarriers_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DetectLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectLoadCarriers_Request_& instance_data) = 0;

            protected:
                Sample_DetectLoadCarriers_Request_DataWriter () {};
                ~Sample_DetectLoadCarriers_Request_DataWriter () {};
            private:
                Sample_DetectLoadCarriers_Request_DataWriter (const Sample_DetectLoadCarriers_Request_DataWriter &);
                Sample_DetectLoadCarriers_Request_DataWriter & operator = (const Sample_DetectLoadCarriers_Request_DataWriter &);
            };

            class  Sample_DetectLoadCarriers_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DetectLoadCarriers_Request_DataReader_ptr _ptr_type;
                typedef Sample_DetectLoadCarriers_Request_DataReader_var _var_type;

                static Sample_DetectLoadCarriers_Request_DataReader_ptr _duplicate (Sample_DetectLoadCarriers_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectLoadCarriers_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectLoadCarriers_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectLoadCarriers_Request_& instance) = 0;

            protected:
                Sample_DetectLoadCarriers_Request_DataReader () {};
                ~Sample_DetectLoadCarriers_Request_DataReader () {};
            private:
                Sample_DetectLoadCarriers_Request_DataReader (const Sample_DetectLoadCarriers_Request_DataReader &);
                Sample_DetectLoadCarriers_Request_DataReader & operator = (const Sample_DetectLoadCarriers_Request_DataReader &);
            };

            class  Sample_DetectLoadCarriers_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DetectLoadCarriers_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_DetectLoadCarriers_Request_DataReaderView_var _var_type;

                static Sample_DetectLoadCarriers_Request_DataReaderView_ptr _duplicate (Sample_DetectLoadCarriers_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectLoadCarriers_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectLoadCarriers_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectLoadCarriers_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectLoadCarriers_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectLoadCarriers_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectLoadCarriers_Request_& instance) = 0;

            protected:
                Sample_DetectLoadCarriers_Request_DataReaderView () {};
                ~Sample_DetectLoadCarriers_Request_DataReaderView () {};
            private:
                Sample_DetectLoadCarriers_Request_DataReaderView (const Sample_DetectLoadCarriers_Request_DataReaderView &);
                Sample_DetectLoadCarriers_Request_DataReaderView & operator = (const Sample_DetectLoadCarriers_Request_DataReaderView &);
            };
            class Sample_DetectLoadCarriers_Response_TypeSupportInterface;

            typedef Sample_DetectLoadCarriers_Response_TypeSupportInterface * Sample_DetectLoadCarriers_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectLoadCarriers_Response_TypeSupportInterface> Sample_DetectLoadCarriers_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DetectLoadCarriers_Response_TypeSupportInterface> Sample_DetectLoadCarriers_Response_TypeSupportInterface_out;


            class Sample_DetectLoadCarriers_Response_DataWriter;

            typedef Sample_DetectLoadCarriers_Response_DataWriter * Sample_DetectLoadCarriers_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectLoadCarriers_Response_DataWriter> Sample_DetectLoadCarriers_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DetectLoadCarriers_Response_DataWriter> Sample_DetectLoadCarriers_Response_DataWriter_out;


            class Sample_DetectLoadCarriers_Response_DataReader;

            typedef Sample_DetectLoadCarriers_Response_DataReader * Sample_DetectLoadCarriers_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectLoadCarriers_Response_DataReader> Sample_DetectLoadCarriers_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DetectLoadCarriers_Response_DataReader> Sample_DetectLoadCarriers_Response_DataReader_out;


            class Sample_DetectLoadCarriers_Response_DataReaderView;

            typedef Sample_DetectLoadCarriers_Response_DataReaderView * Sample_DetectLoadCarriers_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectLoadCarriers_Response_DataReaderView> Sample_DetectLoadCarriers_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DetectLoadCarriers_Response_DataReaderView> Sample_DetectLoadCarriers_Response_DataReaderView_out;

            struct Sample_DetectLoadCarriers_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DetectLoadCarriers_Response_, struct Sample_DetectLoadCarriers_Response_Seq_uniq_> Sample_DetectLoadCarriers_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_DetectLoadCarriers_Response_Seq> Sample_DetectLoadCarriers_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DetectLoadCarriers_Response_Seq> Sample_DetectLoadCarriers_Response_Seq_out;

            class  Sample_DetectLoadCarriers_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DetectLoadCarriers_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DetectLoadCarriers_Response_TypeSupportInterface_var _var_type;

                static Sample_DetectLoadCarriers_Response_TypeSupportInterface_ptr _duplicate (Sample_DetectLoadCarriers_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectLoadCarriers_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectLoadCarriers_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DetectLoadCarriers_Response_TypeSupportInterface () {};
                ~Sample_DetectLoadCarriers_Response_TypeSupportInterface () {};
            private:
                Sample_DetectLoadCarriers_Response_TypeSupportInterface (const Sample_DetectLoadCarriers_Response_TypeSupportInterface &);
                Sample_DetectLoadCarriers_Response_TypeSupportInterface & operator = (const Sample_DetectLoadCarriers_Response_TypeSupportInterface &);
            };

            class  Sample_DetectLoadCarriers_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DetectLoadCarriers_Response_DataWriter_ptr _ptr_type;
                typedef Sample_DetectLoadCarriers_Response_DataWriter_var _var_type;

                static Sample_DetectLoadCarriers_Response_DataWriter_ptr _duplicate (Sample_DetectLoadCarriers_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectLoadCarriers_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectLoadCarriers_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DetectLoadCarriers_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DetectLoadCarriers_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DetectLoadCarriers_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DetectLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectLoadCarriers_Response_& instance_data) = 0;

            protected:
                Sample_DetectLoadCarriers_Response_DataWriter () {};
                ~Sample_DetectLoadCarriers_Response_DataWriter () {};
            private:
                Sample_DetectLoadCarriers_Response_DataWriter (const Sample_DetectLoadCarriers_Response_DataWriter &);
                Sample_DetectLoadCarriers_Response_DataWriter & operator = (const Sample_DetectLoadCarriers_Response_DataWriter &);
            };

            class  Sample_DetectLoadCarriers_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DetectLoadCarriers_Response_DataReader_ptr _ptr_type;
                typedef Sample_DetectLoadCarriers_Response_DataReader_var _var_type;

                static Sample_DetectLoadCarriers_Response_DataReader_ptr _duplicate (Sample_DetectLoadCarriers_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectLoadCarriers_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectLoadCarriers_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectLoadCarriers_Response_& instance) = 0;

            protected:
                Sample_DetectLoadCarriers_Response_DataReader () {};
                ~Sample_DetectLoadCarriers_Response_DataReader () {};
            private:
                Sample_DetectLoadCarriers_Response_DataReader (const Sample_DetectLoadCarriers_Response_DataReader &);
                Sample_DetectLoadCarriers_Response_DataReader & operator = (const Sample_DetectLoadCarriers_Response_DataReader &);
            };

            class  Sample_DetectLoadCarriers_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DetectLoadCarriers_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_DetectLoadCarriers_Response_DataReaderView_var _var_type;

                static Sample_DetectLoadCarriers_Response_DataReaderView_ptr _duplicate (Sample_DetectLoadCarriers_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectLoadCarriers_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectLoadCarriers_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectLoadCarriers_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectLoadCarriers_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectLoadCarriers_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectLoadCarriers_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectLoadCarriers_Response_& instance) = 0;

            protected:
                Sample_DetectLoadCarriers_Response_DataReaderView () {};
                ~Sample_DetectLoadCarriers_Response_DataReaderView () {};
            private:
                Sample_DetectLoadCarriers_Response_DataReaderView (const Sample_DetectLoadCarriers_Response_DataReaderView &);
                Sample_DetectLoadCarriers_Response_DataReaderView & operator = (const Sample_DetectLoadCarriers_Response_DataReaderView &);
            };
        }

    }

}

#endif
