#ifndef _H_0023F4821A7EFF4FB603C23AAE99A5A9_DetectTags__H_
#define _H_0023F4821A7EFF4FB603C23AAE99A5A9_DetectTags__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/Tag_.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"
#include "rc_reason_msgs/msg/dds_opensplice/DetectedTag_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  DetectTags_Request_
            {
                struct _tags__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_reason_msgs::msg::dds_::Tag_, struct _tags__seq_uniq_ > _tags__seq;
                typedef DDS_DCPSSequence_var< _tags__seq > _tags__seq_var;
                typedef DDS_DCPSSequence_out< _tags__seq > _tags__seq_out;
                _tags__seq tags_;
                ::DDS::String_mgr pose_frame_;
                ::geometry_msgs::msg::dds_::Pose_ robot_pose_;
            };

            typedef DDS_DCPSStruct_var<DetectTags_Request_> DetectTags_Request__var;
            typedef DDS_DCPSStruct_out < DetectTags_Request_> DetectTags_Request__out;

            struct  DetectTags_Response_
            {
                struct _tags__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_reason_msgs::msg::dds_::DetectedTag_, struct _tags__seq_uniq_ > _tags__seq;
                typedef DDS_DCPSSequence_var< _tags__seq > _tags__seq_var;
                typedef DDS_DCPSSequence_out< _tags__seq > _tags__seq_out;
                _tags__seq tags_;
                ::builtin_interfaces::msg::dds_::Time_ timestamp_;
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<DetectTags_Response_> DetectTags_Response__var;
            typedef DDS_DCPSStruct_out < DetectTags_Response_> DetectTags_Response__out;

            struct  Sample_DetectTags_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DetectTags_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_DetectTags_Request_> Sample_DetectTags_Request__var;
            typedef DDS_DCPSStruct_out < Sample_DetectTags_Request_> Sample_DetectTags_Request__out;

            struct  Sample_DetectTags_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DetectTags_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_DetectTags_Response_> Sample_DetectTags_Response__var;
            typedef DDS_DCPSStruct_out < Sample_DetectTags_Response_> Sample_DetectTags_Response__out;

        }

    }

}

#endif /* _H_0023F4821A7EFF4FB603C23AAE99A5A9_DetectTags__H_ */
