#ifndef _H_0023F4821A7EFF4FB603C23AAE99A5A9_DetectTags_DCPS_H_
#define _H_0023F4821A7EFF4FB603C23AAE99A5A9_DetectTags_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DetectTags_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class DetectTags_Request_TypeSupportInterface;

            typedef DetectTags_Request_TypeSupportInterface * DetectTags_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectTags_Request_TypeSupportInterface> DetectTags_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectTags_Request_TypeSupportInterface> DetectTags_Request_TypeSupportInterface_out;


            class DetectTags_Request_DataWriter;

            typedef DetectTags_Request_DataWriter * DetectTags_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectTags_Request_DataWriter> DetectTags_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectTags_Request_DataWriter> DetectTags_Request_DataWriter_out;


            class DetectTags_Request_DataReader;

            typedef DetectTags_Request_DataReader * DetectTags_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectTags_Request_DataReader> DetectTags_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectTags_Request_DataReader> DetectTags_Request_DataReader_out;


            class DetectTags_Request_DataReaderView;

            typedef DetectTags_Request_DataReaderView * DetectTags_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectTags_Request_DataReaderView> DetectTags_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectTags_Request_DataReaderView> DetectTags_Request_DataReaderView_out;

            struct DetectTags_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DetectTags_Request_, struct DetectTags_Request_Seq_uniq_> DetectTags_Request_Seq;
            typedef DDS_DCPSSequence_var < DetectTags_Request_Seq> DetectTags_Request_Seq_var;
            typedef DDS_DCPSSequence_out < DetectTags_Request_Seq> DetectTags_Request_Seq_out;

            class  DetectTags_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectTags_Request_TypeSupportInterface_ptr _ptr_type;
                typedef DetectTags_Request_TypeSupportInterface_var _var_type;

                static DetectTags_Request_TypeSupportInterface_ptr _duplicate (DetectTags_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectTags_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectTags_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectTags_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectTags_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectTags_Request_TypeSupportInterface () {};
                ~DetectTags_Request_TypeSupportInterface () {};
            private:
                DetectTags_Request_TypeSupportInterface (const DetectTags_Request_TypeSupportInterface &);
                DetectTags_Request_TypeSupportInterface & operator = (const DetectTags_Request_TypeSupportInterface &);
            };

            class  DetectTags_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectTags_Request_DataWriter_ptr _ptr_type;
                typedef DetectTags_Request_DataWriter_var _var_type;

                static DetectTags_Request_DataWriter_ptr _duplicate (DetectTags_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectTags_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectTags_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectTags_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectTags_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectTags_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectTags_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectTags_Request_& instance_data) = 0;

            protected:
                DetectTags_Request_DataWriter () {};
                ~DetectTags_Request_DataWriter () {};
            private:
                DetectTags_Request_DataWriter (const DetectTags_Request_DataWriter &);
                DetectTags_Request_DataWriter & operator = (const DetectTags_Request_DataWriter &);
            };

            class  DetectTags_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectTags_Request_DataReader_ptr _ptr_type;
                typedef DetectTags_Request_DataReader_var _var_type;

                static DetectTags_Request_DataReader_ptr _duplicate (DetectTags_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectTags_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectTags_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectTags_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectTags_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectTags_Request_& instance) = 0;

            protected:
                DetectTags_Request_DataReader () {};
                ~DetectTags_Request_DataReader () {};
            private:
                DetectTags_Request_DataReader (const DetectTags_Request_DataReader &);
                DetectTags_Request_DataReader & operator = (const DetectTags_Request_DataReader &);
            };

            class  DetectTags_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectTags_Request_DataReaderView_ptr _ptr_type;
                typedef DetectTags_Request_DataReaderView_var _var_type;

                static DetectTags_Request_DataReaderView_ptr _duplicate (DetectTags_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectTags_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectTags_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectTags_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectTags_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectTags_Request_& instance) = 0;

            protected:
                DetectTags_Request_DataReaderView () {};
                ~DetectTags_Request_DataReaderView () {};
            private:
                DetectTags_Request_DataReaderView (const DetectTags_Request_DataReaderView &);
                DetectTags_Request_DataReaderView & operator = (const DetectTags_Request_DataReaderView &);
            };
            class DetectTags_Response_TypeSupportInterface;

            typedef DetectTags_Response_TypeSupportInterface * DetectTags_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectTags_Response_TypeSupportInterface> DetectTags_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectTags_Response_TypeSupportInterface> DetectTags_Response_TypeSupportInterface_out;


            class DetectTags_Response_DataWriter;

            typedef DetectTags_Response_DataWriter * DetectTags_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectTags_Response_DataWriter> DetectTags_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectTags_Response_DataWriter> DetectTags_Response_DataWriter_out;


            class DetectTags_Response_DataReader;

            typedef DetectTags_Response_DataReader * DetectTags_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectTags_Response_DataReader> DetectTags_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectTags_Response_DataReader> DetectTags_Response_DataReader_out;


            class DetectTags_Response_DataReaderView;

            typedef DetectTags_Response_DataReaderView * DetectTags_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectTags_Response_DataReaderView> DetectTags_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectTags_Response_DataReaderView> DetectTags_Response_DataReaderView_out;

            struct DetectTags_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DetectTags_Response_, struct DetectTags_Response_Seq_uniq_> DetectTags_Response_Seq;
            typedef DDS_DCPSSequence_var < DetectTags_Response_Seq> DetectTags_Response_Seq_var;
            typedef DDS_DCPSSequence_out < DetectTags_Response_Seq> DetectTags_Response_Seq_out;

            class  DetectTags_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectTags_Response_TypeSupportInterface_ptr _ptr_type;
                typedef DetectTags_Response_TypeSupportInterface_var _var_type;

                static DetectTags_Response_TypeSupportInterface_ptr _duplicate (DetectTags_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectTags_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectTags_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectTags_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectTags_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectTags_Response_TypeSupportInterface () {};
                ~DetectTags_Response_TypeSupportInterface () {};
            private:
                DetectTags_Response_TypeSupportInterface (const DetectTags_Response_TypeSupportInterface &);
                DetectTags_Response_TypeSupportInterface & operator = (const DetectTags_Response_TypeSupportInterface &);
            };

            class  DetectTags_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectTags_Response_DataWriter_ptr _ptr_type;
                typedef DetectTags_Response_DataWriter_var _var_type;

                static DetectTags_Response_DataWriter_ptr _duplicate (DetectTags_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectTags_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectTags_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectTags_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectTags_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectTags_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectTags_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectTags_Response_& instance_data) = 0;

            protected:
                DetectTags_Response_DataWriter () {};
                ~DetectTags_Response_DataWriter () {};
            private:
                DetectTags_Response_DataWriter (const DetectTags_Response_DataWriter &);
                DetectTags_Response_DataWriter & operator = (const DetectTags_Response_DataWriter &);
            };

            class  DetectTags_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectTags_Response_DataReader_ptr _ptr_type;
                typedef DetectTags_Response_DataReader_var _var_type;

                static DetectTags_Response_DataReader_ptr _duplicate (DetectTags_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectTags_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectTags_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectTags_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectTags_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectTags_Response_& instance) = 0;

            protected:
                DetectTags_Response_DataReader () {};
                ~DetectTags_Response_DataReader () {};
            private:
                DetectTags_Response_DataReader (const DetectTags_Response_DataReader &);
                DetectTags_Response_DataReader & operator = (const DetectTags_Response_DataReader &);
            };

            class  DetectTags_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectTags_Response_DataReaderView_ptr _ptr_type;
                typedef DetectTags_Response_DataReaderView_var _var_type;

                static DetectTags_Response_DataReaderView_ptr _duplicate (DetectTags_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectTags_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectTags_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectTags_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectTags_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectTags_Response_& instance) = 0;

            protected:
                DetectTags_Response_DataReaderView () {};
                ~DetectTags_Response_DataReaderView () {};
            private:
                DetectTags_Response_DataReaderView (const DetectTags_Response_DataReaderView &);
                DetectTags_Response_DataReaderView & operator = (const DetectTags_Response_DataReaderView &);
            };
            class Sample_DetectTags_Request_TypeSupportInterface;

            typedef Sample_DetectTags_Request_TypeSupportInterface * Sample_DetectTags_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectTags_Request_TypeSupportInterface> Sample_DetectTags_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DetectTags_Request_TypeSupportInterface> Sample_DetectTags_Request_TypeSupportInterface_out;


            class Sample_DetectTags_Request_DataWriter;

            typedef Sample_DetectTags_Request_DataWriter * Sample_DetectTags_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectTags_Request_DataWriter> Sample_DetectTags_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DetectTags_Request_DataWriter> Sample_DetectTags_Request_DataWriter_out;


            class Sample_DetectTags_Request_DataReader;

            typedef Sample_DetectTags_Request_DataReader * Sample_DetectTags_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectTags_Request_DataReader> Sample_DetectTags_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DetectTags_Request_DataReader> Sample_DetectTags_Request_DataReader_out;


            class Sample_DetectTags_Request_DataReaderView;

            typedef Sample_DetectTags_Request_DataReaderView * Sample_DetectTags_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectTags_Request_DataReaderView> Sample_DetectTags_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DetectTags_Request_DataReaderView> Sample_DetectTags_Request_DataReaderView_out;

            struct Sample_DetectTags_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DetectTags_Request_, struct Sample_DetectTags_Request_Seq_uniq_> Sample_DetectTags_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_DetectTags_Request_Seq> Sample_DetectTags_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DetectTags_Request_Seq> Sample_DetectTags_Request_Seq_out;

            class  Sample_DetectTags_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DetectTags_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DetectTags_Request_TypeSupportInterface_var _var_type;

                static Sample_DetectTags_Request_TypeSupportInterface_ptr _duplicate (Sample_DetectTags_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectTags_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectTags_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DetectTags_Request_TypeSupportInterface () {};
                ~Sample_DetectTags_Request_TypeSupportInterface () {};
            private:
                Sample_DetectTags_Request_TypeSupportInterface (const Sample_DetectTags_Request_TypeSupportInterface &);
                Sample_DetectTags_Request_TypeSupportInterface & operator = (const Sample_DetectTags_Request_TypeSupportInterface &);
            };

            class  Sample_DetectTags_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DetectTags_Request_DataWriter_ptr _ptr_type;
                typedef Sample_DetectTags_Request_DataWriter_var _var_type;

                static Sample_DetectTags_Request_DataWriter_ptr _duplicate (Sample_DetectTags_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectTags_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectTags_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DetectTags_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DetectTags_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DetectTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DetectTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DetectTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DetectTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DetectTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DetectTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DetectTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DetectTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DetectTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectTags_Request_& instance_data) = 0;

            protected:
                Sample_DetectTags_Request_DataWriter () {};
                ~Sample_DetectTags_Request_DataWriter () {};
            private:
                Sample_DetectTags_Request_DataWriter (const Sample_DetectTags_Request_DataWriter &);
                Sample_DetectTags_Request_DataWriter & operator = (const Sample_DetectTags_Request_DataWriter &);
            };

            class  Sample_DetectTags_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DetectTags_Request_DataReader_ptr _ptr_type;
                typedef Sample_DetectTags_Request_DataReader_var _var_type;

                static Sample_DetectTags_Request_DataReader_ptr _duplicate (Sample_DetectTags_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectTags_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectTags_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectTags_Request_& instance) = 0;

            protected:
                Sample_DetectTags_Request_DataReader () {};
                ~Sample_DetectTags_Request_DataReader () {};
            private:
                Sample_DetectTags_Request_DataReader (const Sample_DetectTags_Request_DataReader &);
                Sample_DetectTags_Request_DataReader & operator = (const Sample_DetectTags_Request_DataReader &);
            };

            class  Sample_DetectTags_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DetectTags_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_DetectTags_Request_DataReaderView_var _var_type;

                static Sample_DetectTags_Request_DataReaderView_ptr _duplicate (Sample_DetectTags_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectTags_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectTags_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectTags_Request_& instance) = 0;

            protected:
                Sample_DetectTags_Request_DataReaderView () {};
                ~Sample_DetectTags_Request_DataReaderView () {};
            private:
                Sample_DetectTags_Request_DataReaderView (const Sample_DetectTags_Request_DataReaderView &);
                Sample_DetectTags_Request_DataReaderView & operator = (const Sample_DetectTags_Request_DataReaderView &);
            };
            class Sample_DetectTags_Response_TypeSupportInterface;

            typedef Sample_DetectTags_Response_TypeSupportInterface * Sample_DetectTags_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectTags_Response_TypeSupportInterface> Sample_DetectTags_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_DetectTags_Response_TypeSupportInterface> Sample_DetectTags_Response_TypeSupportInterface_out;


            class Sample_DetectTags_Response_DataWriter;

            typedef Sample_DetectTags_Response_DataWriter * Sample_DetectTags_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectTags_Response_DataWriter> Sample_DetectTags_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_DetectTags_Response_DataWriter> Sample_DetectTags_Response_DataWriter_out;


            class Sample_DetectTags_Response_DataReader;

            typedef Sample_DetectTags_Response_DataReader * Sample_DetectTags_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectTags_Response_DataReader> Sample_DetectTags_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_DetectTags_Response_DataReader> Sample_DetectTags_Response_DataReader_out;


            class Sample_DetectTags_Response_DataReaderView;

            typedef Sample_DetectTags_Response_DataReaderView * Sample_DetectTags_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_DetectTags_Response_DataReaderView> Sample_DetectTags_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_DetectTags_Response_DataReaderView> Sample_DetectTags_Response_DataReaderView_out;

            struct Sample_DetectTags_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_DetectTags_Response_, struct Sample_DetectTags_Response_Seq_uniq_> Sample_DetectTags_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_DetectTags_Response_Seq> Sample_DetectTags_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_DetectTags_Response_Seq> Sample_DetectTags_Response_Seq_out;

            class  Sample_DetectTags_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_DetectTags_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_DetectTags_Response_TypeSupportInterface_var _var_type;

                static Sample_DetectTags_Response_TypeSupportInterface_ptr _duplicate (Sample_DetectTags_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectTags_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectTags_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_DetectTags_Response_TypeSupportInterface () {};
                ~Sample_DetectTags_Response_TypeSupportInterface () {};
            private:
                Sample_DetectTags_Response_TypeSupportInterface (const Sample_DetectTags_Response_TypeSupportInterface &);
                Sample_DetectTags_Response_TypeSupportInterface & operator = (const Sample_DetectTags_Response_TypeSupportInterface &);
            };

            class  Sample_DetectTags_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_DetectTags_Response_DataWriter_ptr _ptr_type;
                typedef Sample_DetectTags_Response_DataWriter_var _var_type;

                static Sample_DetectTags_Response_DataWriter_ptr _duplicate (Sample_DetectTags_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectTags_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectTags_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_DetectTags_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_DetectTags_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_DetectTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_DetectTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_DetectTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_DetectTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_DetectTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_DetectTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_DetectTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_DetectTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_DetectTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectTags_Response_& instance_data) = 0;

            protected:
                Sample_DetectTags_Response_DataWriter () {};
                ~Sample_DetectTags_Response_DataWriter () {};
            private:
                Sample_DetectTags_Response_DataWriter (const Sample_DetectTags_Response_DataWriter &);
                Sample_DetectTags_Response_DataWriter & operator = (const Sample_DetectTags_Response_DataWriter &);
            };

            class  Sample_DetectTags_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_DetectTags_Response_DataReader_ptr _ptr_type;
                typedef Sample_DetectTags_Response_DataReader_var _var_type;

                static Sample_DetectTags_Response_DataReader_ptr _duplicate (Sample_DetectTags_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectTags_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectTags_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectTags_Response_& instance) = 0;

            protected:
                Sample_DetectTags_Response_DataReader () {};
                ~Sample_DetectTags_Response_DataReader () {};
            private:
                Sample_DetectTags_Response_DataReader (const Sample_DetectTags_Response_DataReader &);
                Sample_DetectTags_Response_DataReader & operator = (const Sample_DetectTags_Response_DataReader &);
            };

            class  Sample_DetectTags_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_DetectTags_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_DetectTags_Response_DataReaderView_var _var_type;

                static Sample_DetectTags_Response_DataReaderView_ptr _duplicate (Sample_DetectTags_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_DetectTags_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_DetectTags_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_DetectTags_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_DetectTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_DetectTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_DetectTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_DetectTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_DetectTags_Response_& instance) = 0;

            protected:
                Sample_DetectTags_Response_DataReaderView () {};
                ~Sample_DetectTags_Response_DataReaderView () {};
            private:
                Sample_DetectTags_Response_DataReaderView (const Sample_DetectTags_Response_DataReaderView &);
                Sample_DetectTags_Response_DataReaderView & operator = (const Sample_DetectTags_Response_DataReaderView &);
            };
        }

    }

}

#endif
