#ifndef _H_3AA0EA0805EF9649204C3380D999CA21_GetBasePlaneCalibration__H_
#define _H_3AA0EA0805EF9649204C3380D999CA21_GetBasePlaneCalibration__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"
#include "shape_msgs/msg/dds_opensplice/Plane_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetBasePlaneCalibration_Request_
            {
                ::DDS::String_mgr pose_frame_;
                ::geometry_msgs::msg::dds_::Pose_ robot_pose_;
            };

            typedef DDS_DCPSStruct_var<GetBasePlaneCalibration_Request_> GetBasePlaneCalibration_Request__var;
            typedef DDS_DCPSStruct_out < GetBasePlaneCalibration_Request_> GetBasePlaneCalibration_Request__out;

            struct  GetBasePlaneCalibration_Response_
            {
                ::DDS::String_mgr pose_frame_;
                ::shape_msgs::msg::dds_::Plane_ plane_;
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<GetBasePlaneCalibration_Response_> GetBasePlaneCalibration_Response__var;
            typedef DDS_DCPSStruct_out < GetBasePlaneCalibration_Response_> GetBasePlaneCalibration_Response__out;

            struct  Sample_GetBasePlaneCalibration_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::GetBasePlaneCalibration_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetBasePlaneCalibration_Request_> Sample_GetBasePlaneCalibration_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetBasePlaneCalibration_Request_> Sample_GetBasePlaneCalibration_Request__out;

            struct  Sample_GetBasePlaneCalibration_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::GetBasePlaneCalibration_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetBasePlaneCalibration_Response_> Sample_GetBasePlaneCalibration_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetBasePlaneCalibration_Response_> Sample_GetBasePlaneCalibration_Response__out;

        }

    }

}

#endif /* _H_3AA0EA0805EF9649204C3380D999CA21_GetBasePlaneCalibration__H_ */
