#ifndef _H_3AA0EA0805EF9649204C3380D999CA21_GetBasePlaneCalibration_DCPS_H_
#define _H_3AA0EA0805EF9649204C3380D999CA21_GetBasePlaneCalibration_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetBasePlaneCalibration_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetBasePlaneCalibration_Request_TypeSupportInterface;

            typedef GetBasePlaneCalibration_Request_TypeSupportInterface * GetBasePlaneCalibration_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetBasePlaneCalibration_Request_TypeSupportInterface> GetBasePlaneCalibration_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetBasePlaneCalibration_Request_TypeSupportInterface> GetBasePlaneCalibration_Request_TypeSupportInterface_out;


            class GetBasePlaneCalibration_Request_DataWriter;

            typedef GetBasePlaneCalibration_Request_DataWriter * GetBasePlaneCalibration_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetBasePlaneCalibration_Request_DataWriter> GetBasePlaneCalibration_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetBasePlaneCalibration_Request_DataWriter> GetBasePlaneCalibration_Request_DataWriter_out;


            class GetBasePlaneCalibration_Request_DataReader;

            typedef GetBasePlaneCalibration_Request_DataReader * GetBasePlaneCalibration_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetBasePlaneCalibration_Request_DataReader> GetBasePlaneCalibration_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetBasePlaneCalibration_Request_DataReader> GetBasePlaneCalibration_Request_DataReader_out;


            class GetBasePlaneCalibration_Request_DataReaderView;

            typedef GetBasePlaneCalibration_Request_DataReaderView * GetBasePlaneCalibration_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetBasePlaneCalibration_Request_DataReaderView> GetBasePlaneCalibration_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetBasePlaneCalibration_Request_DataReaderView> GetBasePlaneCalibration_Request_DataReaderView_out;

            struct GetBasePlaneCalibration_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetBasePlaneCalibration_Request_, struct GetBasePlaneCalibration_Request_Seq_uniq_> GetBasePlaneCalibration_Request_Seq;
            typedef DDS_DCPSSequence_var < GetBasePlaneCalibration_Request_Seq> GetBasePlaneCalibration_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetBasePlaneCalibration_Request_Seq> GetBasePlaneCalibration_Request_Seq_out;

            class  GetBasePlaneCalibration_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetBasePlaneCalibration_Request_TypeSupportInterface_var _var_type;

                static GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _duplicate (GetBasePlaneCalibration_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetBasePlaneCalibration_Request_TypeSupportInterface () {};
                ~GetBasePlaneCalibration_Request_TypeSupportInterface () {};
            private:
                GetBasePlaneCalibration_Request_TypeSupportInterface (const GetBasePlaneCalibration_Request_TypeSupportInterface &);
                GetBasePlaneCalibration_Request_TypeSupportInterface & operator = (const GetBasePlaneCalibration_Request_TypeSupportInterface &);
            };

            class  GetBasePlaneCalibration_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetBasePlaneCalibration_Request_DataWriter_ptr _ptr_type;
                typedef GetBasePlaneCalibration_Request_DataWriter_var _var_type;

                static GetBasePlaneCalibration_Request_DataWriter_ptr _duplicate (GetBasePlaneCalibration_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBasePlaneCalibration_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBasePlaneCalibration_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetBasePlaneCalibration_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetBasePlaneCalibration_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBasePlaneCalibration_Request_& instance_data) = 0;

            protected:
                GetBasePlaneCalibration_Request_DataWriter () {};
                ~GetBasePlaneCalibration_Request_DataWriter () {};
            private:
                GetBasePlaneCalibration_Request_DataWriter (const GetBasePlaneCalibration_Request_DataWriter &);
                GetBasePlaneCalibration_Request_DataWriter & operator = (const GetBasePlaneCalibration_Request_DataWriter &);
            };

            class  GetBasePlaneCalibration_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetBasePlaneCalibration_Request_DataReader_ptr _ptr_type;
                typedef GetBasePlaneCalibration_Request_DataReader_var _var_type;

                static GetBasePlaneCalibration_Request_DataReader_ptr _duplicate (GetBasePlaneCalibration_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBasePlaneCalibration_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBasePlaneCalibration_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBasePlaneCalibration_Request_& instance) = 0;

            protected:
                GetBasePlaneCalibration_Request_DataReader () {};
                ~GetBasePlaneCalibration_Request_DataReader () {};
            private:
                GetBasePlaneCalibration_Request_DataReader (const GetBasePlaneCalibration_Request_DataReader &);
                GetBasePlaneCalibration_Request_DataReader & operator = (const GetBasePlaneCalibration_Request_DataReader &);
            };

            class  GetBasePlaneCalibration_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetBasePlaneCalibration_Request_DataReaderView_ptr _ptr_type;
                typedef GetBasePlaneCalibration_Request_DataReaderView_var _var_type;

                static GetBasePlaneCalibration_Request_DataReaderView_ptr _duplicate (GetBasePlaneCalibration_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBasePlaneCalibration_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBasePlaneCalibration_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBasePlaneCalibration_Request_& instance) = 0;

            protected:
                GetBasePlaneCalibration_Request_DataReaderView () {};
                ~GetBasePlaneCalibration_Request_DataReaderView () {};
            private:
                GetBasePlaneCalibration_Request_DataReaderView (const GetBasePlaneCalibration_Request_DataReaderView &);
                GetBasePlaneCalibration_Request_DataReaderView & operator = (const GetBasePlaneCalibration_Request_DataReaderView &);
            };
            class GetBasePlaneCalibration_Response_TypeSupportInterface;

            typedef GetBasePlaneCalibration_Response_TypeSupportInterface * GetBasePlaneCalibration_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetBasePlaneCalibration_Response_TypeSupportInterface> GetBasePlaneCalibration_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetBasePlaneCalibration_Response_TypeSupportInterface> GetBasePlaneCalibration_Response_TypeSupportInterface_out;


            class GetBasePlaneCalibration_Response_DataWriter;

            typedef GetBasePlaneCalibration_Response_DataWriter * GetBasePlaneCalibration_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetBasePlaneCalibration_Response_DataWriter> GetBasePlaneCalibration_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetBasePlaneCalibration_Response_DataWriter> GetBasePlaneCalibration_Response_DataWriter_out;


            class GetBasePlaneCalibration_Response_DataReader;

            typedef GetBasePlaneCalibration_Response_DataReader * GetBasePlaneCalibration_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetBasePlaneCalibration_Response_DataReader> GetBasePlaneCalibration_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetBasePlaneCalibration_Response_DataReader> GetBasePlaneCalibration_Response_DataReader_out;


            class GetBasePlaneCalibration_Response_DataReaderView;

            typedef GetBasePlaneCalibration_Response_DataReaderView * GetBasePlaneCalibration_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetBasePlaneCalibration_Response_DataReaderView> GetBasePlaneCalibration_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetBasePlaneCalibration_Response_DataReaderView> GetBasePlaneCalibration_Response_DataReaderView_out;

            struct GetBasePlaneCalibration_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetBasePlaneCalibration_Response_, struct GetBasePlaneCalibration_Response_Seq_uniq_> GetBasePlaneCalibration_Response_Seq;
            typedef DDS_DCPSSequence_var < GetBasePlaneCalibration_Response_Seq> GetBasePlaneCalibration_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetBasePlaneCalibration_Response_Seq> GetBasePlaneCalibration_Response_Seq_out;

            class  GetBasePlaneCalibration_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetBasePlaneCalibration_Response_TypeSupportInterface_var _var_type;

                static GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _duplicate (GetBasePlaneCalibration_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetBasePlaneCalibration_Response_TypeSupportInterface () {};
                ~GetBasePlaneCalibration_Response_TypeSupportInterface () {};
            private:
                GetBasePlaneCalibration_Response_TypeSupportInterface (const GetBasePlaneCalibration_Response_TypeSupportInterface &);
                GetBasePlaneCalibration_Response_TypeSupportInterface & operator = (const GetBasePlaneCalibration_Response_TypeSupportInterface &);
            };

            class  GetBasePlaneCalibration_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetBasePlaneCalibration_Response_DataWriter_ptr _ptr_type;
                typedef GetBasePlaneCalibration_Response_DataWriter_var _var_type;

                static GetBasePlaneCalibration_Response_DataWriter_ptr _duplicate (GetBasePlaneCalibration_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBasePlaneCalibration_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBasePlaneCalibration_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetBasePlaneCalibration_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetBasePlaneCalibration_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBasePlaneCalibration_Response_& instance_data) = 0;

            protected:
                GetBasePlaneCalibration_Response_DataWriter () {};
                ~GetBasePlaneCalibration_Response_DataWriter () {};
            private:
                GetBasePlaneCalibration_Response_DataWriter (const GetBasePlaneCalibration_Response_DataWriter &);
                GetBasePlaneCalibration_Response_DataWriter & operator = (const GetBasePlaneCalibration_Response_DataWriter &);
            };

            class  GetBasePlaneCalibration_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetBasePlaneCalibration_Response_DataReader_ptr _ptr_type;
                typedef GetBasePlaneCalibration_Response_DataReader_var _var_type;

                static GetBasePlaneCalibration_Response_DataReader_ptr _duplicate (GetBasePlaneCalibration_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBasePlaneCalibration_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBasePlaneCalibration_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBasePlaneCalibration_Response_& instance) = 0;

            protected:
                GetBasePlaneCalibration_Response_DataReader () {};
                ~GetBasePlaneCalibration_Response_DataReader () {};
            private:
                GetBasePlaneCalibration_Response_DataReader (const GetBasePlaneCalibration_Response_DataReader &);
                GetBasePlaneCalibration_Response_DataReader & operator = (const GetBasePlaneCalibration_Response_DataReader &);
            };

            class  GetBasePlaneCalibration_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetBasePlaneCalibration_Response_DataReaderView_ptr _ptr_type;
                typedef GetBasePlaneCalibration_Response_DataReaderView_var _var_type;

                static GetBasePlaneCalibration_Response_DataReaderView_ptr _duplicate (GetBasePlaneCalibration_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetBasePlaneCalibration_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetBasePlaneCalibration_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetBasePlaneCalibration_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetBasePlaneCalibration_Response_& instance) = 0;

            protected:
                GetBasePlaneCalibration_Response_DataReaderView () {};
                ~GetBasePlaneCalibration_Response_DataReaderView () {};
            private:
                GetBasePlaneCalibration_Response_DataReaderView (const GetBasePlaneCalibration_Response_DataReaderView &);
                GetBasePlaneCalibration_Response_DataReaderView & operator = (const GetBasePlaneCalibration_Response_DataReaderView &);
            };
            class Sample_GetBasePlaneCalibration_Request_TypeSupportInterface;

            typedef Sample_GetBasePlaneCalibration_Request_TypeSupportInterface * Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBasePlaneCalibration_Request_TypeSupportInterface> Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetBasePlaneCalibration_Request_TypeSupportInterface> Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_out;


            class Sample_GetBasePlaneCalibration_Request_DataWriter;

            typedef Sample_GetBasePlaneCalibration_Request_DataWriter * Sample_GetBasePlaneCalibration_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBasePlaneCalibration_Request_DataWriter> Sample_GetBasePlaneCalibration_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetBasePlaneCalibration_Request_DataWriter> Sample_GetBasePlaneCalibration_Request_DataWriter_out;


            class Sample_GetBasePlaneCalibration_Request_DataReader;

            typedef Sample_GetBasePlaneCalibration_Request_DataReader * Sample_GetBasePlaneCalibration_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBasePlaneCalibration_Request_DataReader> Sample_GetBasePlaneCalibration_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetBasePlaneCalibration_Request_DataReader> Sample_GetBasePlaneCalibration_Request_DataReader_out;


            class Sample_GetBasePlaneCalibration_Request_DataReaderView;

            typedef Sample_GetBasePlaneCalibration_Request_DataReaderView * Sample_GetBasePlaneCalibration_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBasePlaneCalibration_Request_DataReaderView> Sample_GetBasePlaneCalibration_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetBasePlaneCalibration_Request_DataReaderView> Sample_GetBasePlaneCalibration_Request_DataReaderView_out;

            struct Sample_GetBasePlaneCalibration_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetBasePlaneCalibration_Request_, struct Sample_GetBasePlaneCalibration_Request_Seq_uniq_> Sample_GetBasePlaneCalibration_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetBasePlaneCalibration_Request_Seq> Sample_GetBasePlaneCalibration_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetBasePlaneCalibration_Request_Seq> Sample_GetBasePlaneCalibration_Request_Seq_out;

            class  Sample_GetBasePlaneCalibration_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_var _var_type;

                static Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _duplicate (Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBasePlaneCalibration_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetBasePlaneCalibration_Request_TypeSupportInterface () {};
                ~Sample_GetBasePlaneCalibration_Request_TypeSupportInterface () {};
            private:
                Sample_GetBasePlaneCalibration_Request_TypeSupportInterface (const Sample_GetBasePlaneCalibration_Request_TypeSupportInterface &);
                Sample_GetBasePlaneCalibration_Request_TypeSupportInterface & operator = (const Sample_GetBasePlaneCalibration_Request_TypeSupportInterface &);
            };

            class  Sample_GetBasePlaneCalibration_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetBasePlaneCalibration_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetBasePlaneCalibration_Request_DataWriter_var _var_type;

                static Sample_GetBasePlaneCalibration_Request_DataWriter_ptr _duplicate (Sample_GetBasePlaneCalibration_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBasePlaneCalibration_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBasePlaneCalibration_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetBasePlaneCalibration_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetBasePlaneCalibration_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetBasePlaneCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBasePlaneCalibration_Request_& instance_data) = 0;

            protected:
                Sample_GetBasePlaneCalibration_Request_DataWriter () {};
                ~Sample_GetBasePlaneCalibration_Request_DataWriter () {};
            private:
                Sample_GetBasePlaneCalibration_Request_DataWriter (const Sample_GetBasePlaneCalibration_Request_DataWriter &);
                Sample_GetBasePlaneCalibration_Request_DataWriter & operator = (const Sample_GetBasePlaneCalibration_Request_DataWriter &);
            };

            class  Sample_GetBasePlaneCalibration_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetBasePlaneCalibration_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetBasePlaneCalibration_Request_DataReader_var _var_type;

                static Sample_GetBasePlaneCalibration_Request_DataReader_ptr _duplicate (Sample_GetBasePlaneCalibration_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBasePlaneCalibration_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBasePlaneCalibration_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBasePlaneCalibration_Request_& instance) = 0;

            protected:
                Sample_GetBasePlaneCalibration_Request_DataReader () {};
                ~Sample_GetBasePlaneCalibration_Request_DataReader () {};
            private:
                Sample_GetBasePlaneCalibration_Request_DataReader (const Sample_GetBasePlaneCalibration_Request_DataReader &);
                Sample_GetBasePlaneCalibration_Request_DataReader & operator = (const Sample_GetBasePlaneCalibration_Request_DataReader &);
            };

            class  Sample_GetBasePlaneCalibration_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetBasePlaneCalibration_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetBasePlaneCalibration_Request_DataReaderView_var _var_type;

                static Sample_GetBasePlaneCalibration_Request_DataReaderView_ptr _duplicate (Sample_GetBasePlaneCalibration_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBasePlaneCalibration_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBasePlaneCalibration_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetBasePlaneCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetBasePlaneCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetBasePlaneCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBasePlaneCalibration_Request_& instance) = 0;

            protected:
                Sample_GetBasePlaneCalibration_Request_DataReaderView () {};
                ~Sample_GetBasePlaneCalibration_Request_DataReaderView () {};
            private:
                Sample_GetBasePlaneCalibration_Request_DataReaderView (const Sample_GetBasePlaneCalibration_Request_DataReaderView &);
                Sample_GetBasePlaneCalibration_Request_DataReaderView & operator = (const Sample_GetBasePlaneCalibration_Request_DataReaderView &);
            };
            class Sample_GetBasePlaneCalibration_Response_TypeSupportInterface;

            typedef Sample_GetBasePlaneCalibration_Response_TypeSupportInterface * Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBasePlaneCalibration_Response_TypeSupportInterface> Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetBasePlaneCalibration_Response_TypeSupportInterface> Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_out;


            class Sample_GetBasePlaneCalibration_Response_DataWriter;

            typedef Sample_GetBasePlaneCalibration_Response_DataWriter * Sample_GetBasePlaneCalibration_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBasePlaneCalibration_Response_DataWriter> Sample_GetBasePlaneCalibration_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetBasePlaneCalibration_Response_DataWriter> Sample_GetBasePlaneCalibration_Response_DataWriter_out;


            class Sample_GetBasePlaneCalibration_Response_DataReader;

            typedef Sample_GetBasePlaneCalibration_Response_DataReader * Sample_GetBasePlaneCalibration_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBasePlaneCalibration_Response_DataReader> Sample_GetBasePlaneCalibration_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetBasePlaneCalibration_Response_DataReader> Sample_GetBasePlaneCalibration_Response_DataReader_out;


            class Sample_GetBasePlaneCalibration_Response_DataReaderView;

            typedef Sample_GetBasePlaneCalibration_Response_DataReaderView * Sample_GetBasePlaneCalibration_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetBasePlaneCalibration_Response_DataReaderView> Sample_GetBasePlaneCalibration_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetBasePlaneCalibration_Response_DataReaderView> Sample_GetBasePlaneCalibration_Response_DataReaderView_out;

            struct Sample_GetBasePlaneCalibration_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetBasePlaneCalibration_Response_, struct Sample_GetBasePlaneCalibration_Response_Seq_uniq_> Sample_GetBasePlaneCalibration_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetBasePlaneCalibration_Response_Seq> Sample_GetBasePlaneCalibration_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetBasePlaneCalibration_Response_Seq> Sample_GetBasePlaneCalibration_Response_Seq_out;

            class  Sample_GetBasePlaneCalibration_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_var _var_type;

                static Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _duplicate (Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBasePlaneCalibration_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetBasePlaneCalibration_Response_TypeSupportInterface () {};
                ~Sample_GetBasePlaneCalibration_Response_TypeSupportInterface () {};
            private:
                Sample_GetBasePlaneCalibration_Response_TypeSupportInterface (const Sample_GetBasePlaneCalibration_Response_TypeSupportInterface &);
                Sample_GetBasePlaneCalibration_Response_TypeSupportInterface & operator = (const Sample_GetBasePlaneCalibration_Response_TypeSupportInterface &);
            };

            class  Sample_GetBasePlaneCalibration_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetBasePlaneCalibration_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetBasePlaneCalibration_Response_DataWriter_var _var_type;

                static Sample_GetBasePlaneCalibration_Response_DataWriter_ptr _duplicate (Sample_GetBasePlaneCalibration_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBasePlaneCalibration_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBasePlaneCalibration_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetBasePlaneCalibration_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetBasePlaneCalibration_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetBasePlaneCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBasePlaneCalibration_Response_& instance_data) = 0;

            protected:
                Sample_GetBasePlaneCalibration_Response_DataWriter () {};
                ~Sample_GetBasePlaneCalibration_Response_DataWriter () {};
            private:
                Sample_GetBasePlaneCalibration_Response_DataWriter (const Sample_GetBasePlaneCalibration_Response_DataWriter &);
                Sample_GetBasePlaneCalibration_Response_DataWriter & operator = (const Sample_GetBasePlaneCalibration_Response_DataWriter &);
            };

            class  Sample_GetBasePlaneCalibration_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetBasePlaneCalibration_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetBasePlaneCalibration_Response_DataReader_var _var_type;

                static Sample_GetBasePlaneCalibration_Response_DataReader_ptr _duplicate (Sample_GetBasePlaneCalibration_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBasePlaneCalibration_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBasePlaneCalibration_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBasePlaneCalibration_Response_& instance) = 0;

            protected:
                Sample_GetBasePlaneCalibration_Response_DataReader () {};
                ~Sample_GetBasePlaneCalibration_Response_DataReader () {};
            private:
                Sample_GetBasePlaneCalibration_Response_DataReader (const Sample_GetBasePlaneCalibration_Response_DataReader &);
                Sample_GetBasePlaneCalibration_Response_DataReader & operator = (const Sample_GetBasePlaneCalibration_Response_DataReader &);
            };

            class  Sample_GetBasePlaneCalibration_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetBasePlaneCalibration_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetBasePlaneCalibration_Response_DataReaderView_var _var_type;

                static Sample_GetBasePlaneCalibration_Response_DataReaderView_ptr _duplicate (Sample_GetBasePlaneCalibration_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetBasePlaneCalibration_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetBasePlaneCalibration_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetBasePlaneCalibration_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetBasePlaneCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetBasePlaneCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetBasePlaneCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetBasePlaneCalibration_Response_& instance) = 0;

            protected:
                Sample_GetBasePlaneCalibration_Response_DataReaderView () {};
                ~Sample_GetBasePlaneCalibration_Response_DataReaderView () {};
            private:
                Sample_GetBasePlaneCalibration_Response_DataReaderView (const Sample_GetBasePlaneCalibration_Response_DataReaderView &);
                Sample_GetBasePlaneCalibration_Response_DataReaderView & operator = (const Sample_GetBasePlaneCalibration_Response_DataReaderView &);
            };
        }

    }

}

#endif
