#ifndef _H_7CF64F99DC6D41084FE00DC34064F962_GetLoadCarriers__H_
#define _H_7CF64F99DC6D41084FE00DC34064F962_GetLoadCarriers__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/LoadCarrier_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetLoadCarriers_Request_
            {
                struct _load_carrier_ids__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _load_carrier_ids__seq_uniq_ > _load_carrier_ids__seq;
                typedef DDS_DCPSUStrSeq_var< _load_carrier_ids__seq > _load_carrier_ids__seq_var;
                typedef DDS_DCPSUStrSeq_out< _load_carrier_ids__seq > _load_carrier_ids__seq_out;
                _load_carrier_ids__seq load_carrier_ids_;
            };

            typedef DDS_DCPSStruct_var<GetLoadCarriers_Request_> GetLoadCarriers_Request__var;
            typedef DDS_DCPSStruct_out < GetLoadCarriers_Request_> GetLoadCarriers_Request__out;

            struct  GetLoadCarriers_Response_
            {
                struct _load_carriers__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_reason_msgs::msg::dds_::LoadCarrier_, struct _load_carriers__seq_uniq_ > _load_carriers__seq;
                typedef DDS_DCPSSequence_var< _load_carriers__seq > _load_carriers__seq_var;
                typedef DDS_DCPSSequence_out< _load_carriers__seq > _load_carriers__seq_out;
                _load_carriers__seq load_carriers_;
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<GetLoadCarriers_Response_> GetLoadCarriers_Response__var;
            typedef DDS_DCPSStruct_out < GetLoadCarriers_Response_> GetLoadCarriers_Response__out;

            struct  Sample_GetLoadCarriers_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::GetLoadCarriers_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetLoadCarriers_Request_> Sample_GetLoadCarriers_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetLoadCarriers_Request_> Sample_GetLoadCarriers_Request__out;

            struct  Sample_GetLoadCarriers_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::GetLoadCarriers_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetLoadCarriers_Response_> Sample_GetLoadCarriers_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetLoadCarriers_Response_> Sample_GetLoadCarriers_Response__out;

        }

    }

}

#endif /* _H_7CF64F99DC6D41084FE00DC34064F962_GetLoadCarriers__H_ */
