#ifndef _H_06309AE2F7E2DE441D3AF1427C4734E5_HandEyeCalibrationTrigger__H_
#define _H_06309AE2F7E2DE441D3AF1427C4734E5_HandEyeCalibrationTrigger__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  HandEyeCalibrationTrigger_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<HandEyeCalibrationTrigger_Request_> HandEyeCalibrationTrigger_Request__var;
            typedef HandEyeCalibrationTrigger_Request_& HandEyeCalibrationTrigger_Request__out;

            struct  HandEyeCalibrationTrigger_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::Long status_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<HandEyeCalibrationTrigger_Response_> HandEyeCalibrationTrigger_Response__var;
            typedef DDS_DCPSStruct_out < HandEyeCalibrationTrigger_Response_> HandEyeCalibrationTrigger_Response__out;

            struct  Sample_HandEyeCalibrationTrigger_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::HandEyeCalibrationTrigger_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_HandEyeCalibrationTrigger_Request_> Sample_HandEyeCalibrationTrigger_Request__var;
            typedef Sample_HandEyeCalibrationTrigger_Request_& Sample_HandEyeCalibrationTrigger_Request__out;

            struct  Sample_HandEyeCalibrationTrigger_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::HandEyeCalibrationTrigger_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_HandEyeCalibrationTrigger_Response_> Sample_HandEyeCalibrationTrigger_Response__var;
            typedef DDS_DCPSStruct_out < Sample_HandEyeCalibrationTrigger_Response_> Sample_HandEyeCalibrationTrigger_Response__out;

        }

    }

}

#endif /* _H_06309AE2F7E2DE441D3AF1427C4734E5_HandEyeCalibrationTrigger__H_ */
