#ifndef _H_06309AE2F7E2DE441D3AF1427C4734E5_HandEyeCalibrationTrigger_DCPS_H_
#define _H_06309AE2F7E2DE441D3AF1427C4734E5_HandEyeCalibrationTrigger_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HandEyeCalibrationTrigger_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class HandEyeCalibrationTrigger_Request_TypeSupportInterface;

            typedef HandEyeCalibrationTrigger_Request_TypeSupportInterface * HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibrationTrigger_Request_TypeSupportInterface> HandEyeCalibrationTrigger_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibrationTrigger_Request_TypeSupportInterface> HandEyeCalibrationTrigger_Request_TypeSupportInterface_out;


            class HandEyeCalibrationTrigger_Request_DataWriter;

            typedef HandEyeCalibrationTrigger_Request_DataWriter * HandEyeCalibrationTrigger_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibrationTrigger_Request_DataWriter> HandEyeCalibrationTrigger_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibrationTrigger_Request_DataWriter> HandEyeCalibrationTrigger_Request_DataWriter_out;


            class HandEyeCalibrationTrigger_Request_DataReader;

            typedef HandEyeCalibrationTrigger_Request_DataReader * HandEyeCalibrationTrigger_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibrationTrigger_Request_DataReader> HandEyeCalibrationTrigger_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibrationTrigger_Request_DataReader> HandEyeCalibrationTrigger_Request_DataReader_out;


            class HandEyeCalibrationTrigger_Request_DataReaderView;

            typedef HandEyeCalibrationTrigger_Request_DataReaderView * HandEyeCalibrationTrigger_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibrationTrigger_Request_DataReaderView> HandEyeCalibrationTrigger_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibrationTrigger_Request_DataReaderView> HandEyeCalibrationTrigger_Request_DataReaderView_out;

            struct HandEyeCalibrationTrigger_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < HandEyeCalibrationTrigger_Request_, struct HandEyeCalibrationTrigger_Request_Seq_uniq_> HandEyeCalibrationTrigger_Request_Seq;
            typedef DDS_DCPSSequence_var < HandEyeCalibrationTrigger_Request_Seq> HandEyeCalibrationTrigger_Request_Seq_var;
            typedef DDS_DCPSSequence_out < HandEyeCalibrationTrigger_Request_Seq> HandEyeCalibrationTrigger_Request_Seq_out;

            class  HandEyeCalibrationTrigger_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _ptr_type;
                typedef HandEyeCalibrationTrigger_Request_TypeSupportInterface_var _var_type;

                static HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _duplicate (HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HandEyeCalibrationTrigger_Request_TypeSupportInterface () {};
                ~HandEyeCalibrationTrigger_Request_TypeSupportInterface () {};
            private:
                HandEyeCalibrationTrigger_Request_TypeSupportInterface (const HandEyeCalibrationTrigger_Request_TypeSupportInterface &);
                HandEyeCalibrationTrigger_Request_TypeSupportInterface & operator = (const HandEyeCalibrationTrigger_Request_TypeSupportInterface &);
            };

            class  HandEyeCalibrationTrigger_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HandEyeCalibrationTrigger_Request_DataWriter_ptr _ptr_type;
                typedef HandEyeCalibrationTrigger_Request_DataWriter_var _var_type;

                static HandEyeCalibrationTrigger_Request_DataWriter_ptr _duplicate (HandEyeCalibrationTrigger_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibrationTrigger_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibrationTrigger_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HandEyeCalibrationTrigger_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HandEyeCalibrationTrigger_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibrationTrigger_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibrationTrigger_Request_& instance_data) = 0;

            protected:
                HandEyeCalibrationTrigger_Request_DataWriter () {};
                ~HandEyeCalibrationTrigger_Request_DataWriter () {};
            private:
                HandEyeCalibrationTrigger_Request_DataWriter (const HandEyeCalibrationTrigger_Request_DataWriter &);
                HandEyeCalibrationTrigger_Request_DataWriter & operator = (const HandEyeCalibrationTrigger_Request_DataWriter &);
            };

            class  HandEyeCalibrationTrigger_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HandEyeCalibrationTrigger_Request_DataReader_ptr _ptr_type;
                typedef HandEyeCalibrationTrigger_Request_DataReader_var _var_type;

                static HandEyeCalibrationTrigger_Request_DataReader_ptr _duplicate (HandEyeCalibrationTrigger_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibrationTrigger_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibrationTrigger_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HandEyeCalibrationTrigger_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HandEyeCalibrationTrigger_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibrationTrigger_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibrationTrigger_Request_& instance) = 0;

            protected:
                HandEyeCalibrationTrigger_Request_DataReader () {};
                ~HandEyeCalibrationTrigger_Request_DataReader () {};
            private:
                HandEyeCalibrationTrigger_Request_DataReader (const HandEyeCalibrationTrigger_Request_DataReader &);
                HandEyeCalibrationTrigger_Request_DataReader & operator = (const HandEyeCalibrationTrigger_Request_DataReader &);
            };

            class  HandEyeCalibrationTrigger_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HandEyeCalibrationTrigger_Request_DataReaderView_ptr _ptr_type;
                typedef HandEyeCalibrationTrigger_Request_DataReaderView_var _var_type;

                static HandEyeCalibrationTrigger_Request_DataReaderView_ptr _duplicate (HandEyeCalibrationTrigger_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibrationTrigger_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibrationTrigger_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HandEyeCalibrationTrigger_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HandEyeCalibrationTrigger_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibrationTrigger_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibrationTrigger_Request_& instance) = 0;

            protected:
                HandEyeCalibrationTrigger_Request_DataReaderView () {};
                ~HandEyeCalibrationTrigger_Request_DataReaderView () {};
            private:
                HandEyeCalibrationTrigger_Request_DataReaderView (const HandEyeCalibrationTrigger_Request_DataReaderView &);
                HandEyeCalibrationTrigger_Request_DataReaderView & operator = (const HandEyeCalibrationTrigger_Request_DataReaderView &);
            };
            class HandEyeCalibrationTrigger_Response_TypeSupportInterface;

            typedef HandEyeCalibrationTrigger_Response_TypeSupportInterface * HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibrationTrigger_Response_TypeSupportInterface> HandEyeCalibrationTrigger_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibrationTrigger_Response_TypeSupportInterface> HandEyeCalibrationTrigger_Response_TypeSupportInterface_out;


            class HandEyeCalibrationTrigger_Response_DataWriter;

            typedef HandEyeCalibrationTrigger_Response_DataWriter * HandEyeCalibrationTrigger_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibrationTrigger_Response_DataWriter> HandEyeCalibrationTrigger_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibrationTrigger_Response_DataWriter> HandEyeCalibrationTrigger_Response_DataWriter_out;


            class HandEyeCalibrationTrigger_Response_DataReader;

            typedef HandEyeCalibrationTrigger_Response_DataReader * HandEyeCalibrationTrigger_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibrationTrigger_Response_DataReader> HandEyeCalibrationTrigger_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibrationTrigger_Response_DataReader> HandEyeCalibrationTrigger_Response_DataReader_out;


            class HandEyeCalibrationTrigger_Response_DataReaderView;

            typedef HandEyeCalibrationTrigger_Response_DataReaderView * HandEyeCalibrationTrigger_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HandEyeCalibrationTrigger_Response_DataReaderView> HandEyeCalibrationTrigger_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HandEyeCalibrationTrigger_Response_DataReaderView> HandEyeCalibrationTrigger_Response_DataReaderView_out;

            struct HandEyeCalibrationTrigger_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HandEyeCalibrationTrigger_Response_, struct HandEyeCalibrationTrigger_Response_Seq_uniq_> HandEyeCalibrationTrigger_Response_Seq;
            typedef DDS_DCPSSequence_var < HandEyeCalibrationTrigger_Response_Seq> HandEyeCalibrationTrigger_Response_Seq_var;
            typedef DDS_DCPSSequence_out < HandEyeCalibrationTrigger_Response_Seq> HandEyeCalibrationTrigger_Response_Seq_out;

            class  HandEyeCalibrationTrigger_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _ptr_type;
                typedef HandEyeCalibrationTrigger_Response_TypeSupportInterface_var _var_type;

                static HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _duplicate (HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HandEyeCalibrationTrigger_Response_TypeSupportInterface () {};
                ~HandEyeCalibrationTrigger_Response_TypeSupportInterface () {};
            private:
                HandEyeCalibrationTrigger_Response_TypeSupportInterface (const HandEyeCalibrationTrigger_Response_TypeSupportInterface &);
                HandEyeCalibrationTrigger_Response_TypeSupportInterface & operator = (const HandEyeCalibrationTrigger_Response_TypeSupportInterface &);
            };

            class  HandEyeCalibrationTrigger_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HandEyeCalibrationTrigger_Response_DataWriter_ptr _ptr_type;
                typedef HandEyeCalibrationTrigger_Response_DataWriter_var _var_type;

                static HandEyeCalibrationTrigger_Response_DataWriter_ptr _duplicate (HandEyeCalibrationTrigger_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibrationTrigger_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibrationTrigger_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HandEyeCalibrationTrigger_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HandEyeCalibrationTrigger_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibrationTrigger_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibrationTrigger_Response_& instance_data) = 0;

            protected:
                HandEyeCalibrationTrigger_Response_DataWriter () {};
                ~HandEyeCalibrationTrigger_Response_DataWriter () {};
            private:
                HandEyeCalibrationTrigger_Response_DataWriter (const HandEyeCalibrationTrigger_Response_DataWriter &);
                HandEyeCalibrationTrigger_Response_DataWriter & operator = (const HandEyeCalibrationTrigger_Response_DataWriter &);
            };

            class  HandEyeCalibrationTrigger_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HandEyeCalibrationTrigger_Response_DataReader_ptr _ptr_type;
                typedef HandEyeCalibrationTrigger_Response_DataReader_var _var_type;

                static HandEyeCalibrationTrigger_Response_DataReader_ptr _duplicate (HandEyeCalibrationTrigger_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibrationTrigger_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibrationTrigger_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HandEyeCalibrationTrigger_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HandEyeCalibrationTrigger_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibrationTrigger_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibrationTrigger_Response_& instance) = 0;

            protected:
                HandEyeCalibrationTrigger_Response_DataReader () {};
                ~HandEyeCalibrationTrigger_Response_DataReader () {};
            private:
                HandEyeCalibrationTrigger_Response_DataReader (const HandEyeCalibrationTrigger_Response_DataReader &);
                HandEyeCalibrationTrigger_Response_DataReader & operator = (const HandEyeCalibrationTrigger_Response_DataReader &);
            };

            class  HandEyeCalibrationTrigger_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HandEyeCalibrationTrigger_Response_DataReaderView_ptr _ptr_type;
                typedef HandEyeCalibrationTrigger_Response_DataReaderView_var _var_type;

                static HandEyeCalibrationTrigger_Response_DataReaderView_ptr _duplicate (HandEyeCalibrationTrigger_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HandEyeCalibrationTrigger_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HandEyeCalibrationTrigger_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HandEyeCalibrationTrigger_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HandEyeCalibrationTrigger_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HandEyeCalibrationTrigger_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HandEyeCalibrationTrigger_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HandEyeCalibrationTrigger_Response_& instance) = 0;

            protected:
                HandEyeCalibrationTrigger_Response_DataReaderView () {};
                ~HandEyeCalibrationTrigger_Response_DataReaderView () {};
            private:
                HandEyeCalibrationTrigger_Response_DataReaderView (const HandEyeCalibrationTrigger_Response_DataReaderView &);
                HandEyeCalibrationTrigger_Response_DataReaderView & operator = (const HandEyeCalibrationTrigger_Response_DataReaderView &);
            };
            class Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface;

            typedef Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface * Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface> Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface> Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_out;


            class Sample_HandEyeCalibrationTrigger_Request_DataWriter;

            typedef Sample_HandEyeCalibrationTrigger_Request_DataWriter * Sample_HandEyeCalibrationTrigger_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibrationTrigger_Request_DataWriter> Sample_HandEyeCalibrationTrigger_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibrationTrigger_Request_DataWriter> Sample_HandEyeCalibrationTrigger_Request_DataWriter_out;


            class Sample_HandEyeCalibrationTrigger_Request_DataReader;

            typedef Sample_HandEyeCalibrationTrigger_Request_DataReader * Sample_HandEyeCalibrationTrigger_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibrationTrigger_Request_DataReader> Sample_HandEyeCalibrationTrigger_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibrationTrigger_Request_DataReader> Sample_HandEyeCalibrationTrigger_Request_DataReader_out;


            class Sample_HandEyeCalibrationTrigger_Request_DataReaderView;

            typedef Sample_HandEyeCalibrationTrigger_Request_DataReaderView * Sample_HandEyeCalibrationTrigger_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibrationTrigger_Request_DataReaderView> Sample_HandEyeCalibrationTrigger_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibrationTrigger_Request_DataReaderView> Sample_HandEyeCalibrationTrigger_Request_DataReaderView_out;

            struct Sample_HandEyeCalibrationTrigger_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_HandEyeCalibrationTrigger_Request_, struct Sample_HandEyeCalibrationTrigger_Request_Seq_uniq_> Sample_HandEyeCalibrationTrigger_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_HandEyeCalibrationTrigger_Request_Seq> Sample_HandEyeCalibrationTrigger_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_HandEyeCalibrationTrigger_Request_Seq> Sample_HandEyeCalibrationTrigger_Request_Seq_out;

            class  Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_var _var_type;

                static Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _duplicate (Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface () {};
                ~Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface () {};
            private:
                Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface (const Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface &);
                Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface & operator = (const Sample_HandEyeCalibrationTrigger_Request_TypeSupportInterface &);
            };

            class  Sample_HandEyeCalibrationTrigger_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_HandEyeCalibrationTrigger_Request_DataWriter_ptr _ptr_type;
                typedef Sample_HandEyeCalibrationTrigger_Request_DataWriter_var _var_type;

                static Sample_HandEyeCalibrationTrigger_Request_DataWriter_ptr _duplicate (Sample_HandEyeCalibrationTrigger_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibrationTrigger_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibrationTrigger_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_HandEyeCalibrationTrigger_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_HandEyeCalibrationTrigger_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_HandEyeCalibrationTrigger_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibrationTrigger_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibrationTrigger_Request_& instance_data) = 0;

            protected:
                Sample_HandEyeCalibrationTrigger_Request_DataWriter () {};
                ~Sample_HandEyeCalibrationTrigger_Request_DataWriter () {};
            private:
                Sample_HandEyeCalibrationTrigger_Request_DataWriter (const Sample_HandEyeCalibrationTrigger_Request_DataWriter &);
                Sample_HandEyeCalibrationTrigger_Request_DataWriter & operator = (const Sample_HandEyeCalibrationTrigger_Request_DataWriter &);
            };

            class  Sample_HandEyeCalibrationTrigger_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_HandEyeCalibrationTrigger_Request_DataReader_ptr _ptr_type;
                typedef Sample_HandEyeCalibrationTrigger_Request_DataReader_var _var_type;

                static Sample_HandEyeCalibrationTrigger_Request_DataReader_ptr _duplicate (Sample_HandEyeCalibrationTrigger_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibrationTrigger_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibrationTrigger_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HandEyeCalibrationTrigger_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HandEyeCalibrationTrigger_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibrationTrigger_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibrationTrigger_Request_& instance) = 0;

            protected:
                Sample_HandEyeCalibrationTrigger_Request_DataReader () {};
                ~Sample_HandEyeCalibrationTrigger_Request_DataReader () {};
            private:
                Sample_HandEyeCalibrationTrigger_Request_DataReader (const Sample_HandEyeCalibrationTrigger_Request_DataReader &);
                Sample_HandEyeCalibrationTrigger_Request_DataReader & operator = (const Sample_HandEyeCalibrationTrigger_Request_DataReader &);
            };

            class  Sample_HandEyeCalibrationTrigger_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_HandEyeCalibrationTrigger_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_HandEyeCalibrationTrigger_Request_DataReaderView_var _var_type;

                static Sample_HandEyeCalibrationTrigger_Request_DataReaderView_ptr _duplicate (Sample_HandEyeCalibrationTrigger_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibrationTrigger_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibrationTrigger_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HandEyeCalibrationTrigger_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HandEyeCalibrationTrigger_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HandEyeCalibrationTrigger_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibrationTrigger_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibrationTrigger_Request_& instance) = 0;

            protected:
                Sample_HandEyeCalibrationTrigger_Request_DataReaderView () {};
                ~Sample_HandEyeCalibrationTrigger_Request_DataReaderView () {};
            private:
                Sample_HandEyeCalibrationTrigger_Request_DataReaderView (const Sample_HandEyeCalibrationTrigger_Request_DataReaderView &);
                Sample_HandEyeCalibrationTrigger_Request_DataReaderView & operator = (const Sample_HandEyeCalibrationTrigger_Request_DataReaderView &);
            };
            class Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface;

            typedef Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface * Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface> Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface> Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_out;


            class Sample_HandEyeCalibrationTrigger_Response_DataWriter;

            typedef Sample_HandEyeCalibrationTrigger_Response_DataWriter * Sample_HandEyeCalibrationTrigger_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibrationTrigger_Response_DataWriter> Sample_HandEyeCalibrationTrigger_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibrationTrigger_Response_DataWriter> Sample_HandEyeCalibrationTrigger_Response_DataWriter_out;


            class Sample_HandEyeCalibrationTrigger_Response_DataReader;

            typedef Sample_HandEyeCalibrationTrigger_Response_DataReader * Sample_HandEyeCalibrationTrigger_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibrationTrigger_Response_DataReader> Sample_HandEyeCalibrationTrigger_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibrationTrigger_Response_DataReader> Sample_HandEyeCalibrationTrigger_Response_DataReader_out;


            class Sample_HandEyeCalibrationTrigger_Response_DataReaderView;

            typedef Sample_HandEyeCalibrationTrigger_Response_DataReaderView * Sample_HandEyeCalibrationTrigger_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_HandEyeCalibrationTrigger_Response_DataReaderView> Sample_HandEyeCalibrationTrigger_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_HandEyeCalibrationTrigger_Response_DataReaderView> Sample_HandEyeCalibrationTrigger_Response_DataReaderView_out;

            struct Sample_HandEyeCalibrationTrigger_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_HandEyeCalibrationTrigger_Response_, struct Sample_HandEyeCalibrationTrigger_Response_Seq_uniq_> Sample_HandEyeCalibrationTrigger_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_HandEyeCalibrationTrigger_Response_Seq> Sample_HandEyeCalibrationTrigger_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_HandEyeCalibrationTrigger_Response_Seq> Sample_HandEyeCalibrationTrigger_Response_Seq_out;

            class  Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_var _var_type;

                static Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _duplicate (Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface () {};
                ~Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface () {};
            private:
                Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface (const Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface &);
                Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface & operator = (const Sample_HandEyeCalibrationTrigger_Response_TypeSupportInterface &);
            };

            class  Sample_HandEyeCalibrationTrigger_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_HandEyeCalibrationTrigger_Response_DataWriter_ptr _ptr_type;
                typedef Sample_HandEyeCalibrationTrigger_Response_DataWriter_var _var_type;

                static Sample_HandEyeCalibrationTrigger_Response_DataWriter_ptr _duplicate (Sample_HandEyeCalibrationTrigger_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibrationTrigger_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibrationTrigger_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_HandEyeCalibrationTrigger_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_HandEyeCalibrationTrigger_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_HandEyeCalibrationTrigger_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibrationTrigger_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibrationTrigger_Response_& instance_data) = 0;

            protected:
                Sample_HandEyeCalibrationTrigger_Response_DataWriter () {};
                ~Sample_HandEyeCalibrationTrigger_Response_DataWriter () {};
            private:
                Sample_HandEyeCalibrationTrigger_Response_DataWriter (const Sample_HandEyeCalibrationTrigger_Response_DataWriter &);
                Sample_HandEyeCalibrationTrigger_Response_DataWriter & operator = (const Sample_HandEyeCalibrationTrigger_Response_DataWriter &);
            };

            class  Sample_HandEyeCalibrationTrigger_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_HandEyeCalibrationTrigger_Response_DataReader_ptr _ptr_type;
                typedef Sample_HandEyeCalibrationTrigger_Response_DataReader_var _var_type;

                static Sample_HandEyeCalibrationTrigger_Response_DataReader_ptr _duplicate (Sample_HandEyeCalibrationTrigger_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibrationTrigger_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibrationTrigger_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HandEyeCalibrationTrigger_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HandEyeCalibrationTrigger_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibrationTrigger_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibrationTrigger_Response_& instance) = 0;

            protected:
                Sample_HandEyeCalibrationTrigger_Response_DataReader () {};
                ~Sample_HandEyeCalibrationTrigger_Response_DataReader () {};
            private:
                Sample_HandEyeCalibrationTrigger_Response_DataReader (const Sample_HandEyeCalibrationTrigger_Response_DataReader &);
                Sample_HandEyeCalibrationTrigger_Response_DataReader & operator = (const Sample_HandEyeCalibrationTrigger_Response_DataReader &);
            };

            class  Sample_HandEyeCalibrationTrigger_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_HandEyeCalibrationTrigger_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_HandEyeCalibrationTrigger_Response_DataReaderView_var _var_type;

                static Sample_HandEyeCalibrationTrigger_Response_DataReaderView_ptr _duplicate (Sample_HandEyeCalibrationTrigger_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HandEyeCalibrationTrigger_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HandEyeCalibrationTrigger_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HandEyeCalibrationTrigger_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HandEyeCalibrationTrigger_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HandEyeCalibrationTrigger_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HandEyeCalibrationTrigger_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HandEyeCalibrationTrigger_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HandEyeCalibrationTrigger_Response_& instance) = 0;

            protected:
                Sample_HandEyeCalibrationTrigger_Response_DataReaderView () {};
                ~Sample_HandEyeCalibrationTrigger_Response_DataReaderView () {};
            private:
                Sample_HandEyeCalibrationTrigger_Response_DataReaderView (const Sample_HandEyeCalibrationTrigger_Response_DataReaderView &);
                Sample_HandEyeCalibrationTrigger_Response_DataReaderView & operator = (const Sample_HandEyeCalibrationTrigger_Response_DataReaderView &);
            };
        }

    }

}

#endif
