#ifndef _H_BFB04E4F46022A40E76CC5AF46E63AB6_SetHandEyeCalibrationPose_DCPS_H_
#define _H_BFB04E4F46022A40E76CC5AF46E63AB6_SetHandEyeCalibrationPose_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetHandEyeCalibrationPose_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetHandEyeCalibrationPose_Request_TypeSupportInterface;

            typedef SetHandEyeCalibrationPose_Request_TypeSupportInterface * SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibrationPose_Request_TypeSupportInterface> SetHandEyeCalibrationPose_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibrationPose_Request_TypeSupportInterface> SetHandEyeCalibrationPose_Request_TypeSupportInterface_out;


            class SetHandEyeCalibrationPose_Request_DataWriter;

            typedef SetHandEyeCalibrationPose_Request_DataWriter * SetHandEyeCalibrationPose_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibrationPose_Request_DataWriter> SetHandEyeCalibrationPose_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibrationPose_Request_DataWriter> SetHandEyeCalibrationPose_Request_DataWriter_out;


            class SetHandEyeCalibrationPose_Request_DataReader;

            typedef SetHandEyeCalibrationPose_Request_DataReader * SetHandEyeCalibrationPose_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibrationPose_Request_DataReader> SetHandEyeCalibrationPose_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibrationPose_Request_DataReader> SetHandEyeCalibrationPose_Request_DataReader_out;


            class SetHandEyeCalibrationPose_Request_DataReaderView;

            typedef SetHandEyeCalibrationPose_Request_DataReaderView * SetHandEyeCalibrationPose_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibrationPose_Request_DataReaderView> SetHandEyeCalibrationPose_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibrationPose_Request_DataReaderView> SetHandEyeCalibrationPose_Request_DataReaderView_out;

            struct SetHandEyeCalibrationPose_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SetHandEyeCalibrationPose_Request_, struct SetHandEyeCalibrationPose_Request_Seq_uniq_> SetHandEyeCalibrationPose_Request_Seq;
            typedef DDS_DCPSSequence_var < SetHandEyeCalibrationPose_Request_Seq> SetHandEyeCalibrationPose_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetHandEyeCalibrationPose_Request_Seq> SetHandEyeCalibrationPose_Request_Seq_out;

            class  SetHandEyeCalibrationPose_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetHandEyeCalibrationPose_Request_TypeSupportInterface_var _var_type;

                static SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _duplicate (SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetHandEyeCalibrationPose_Request_TypeSupportInterface () {};
                ~SetHandEyeCalibrationPose_Request_TypeSupportInterface () {};
            private:
                SetHandEyeCalibrationPose_Request_TypeSupportInterface (const SetHandEyeCalibrationPose_Request_TypeSupportInterface &);
                SetHandEyeCalibrationPose_Request_TypeSupportInterface & operator = (const SetHandEyeCalibrationPose_Request_TypeSupportInterface &);
            };

            class  SetHandEyeCalibrationPose_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetHandEyeCalibrationPose_Request_DataWriter_ptr _ptr_type;
                typedef SetHandEyeCalibrationPose_Request_DataWriter_var _var_type;

                static SetHandEyeCalibrationPose_Request_DataWriter_ptr _duplicate (SetHandEyeCalibrationPose_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibrationPose_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibrationPose_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetHandEyeCalibrationPose_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetHandEyeCalibrationPose_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibrationPose_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibrationPose_Request_& instance_data) = 0;

            protected:
                SetHandEyeCalibrationPose_Request_DataWriter () {};
                ~SetHandEyeCalibrationPose_Request_DataWriter () {};
            private:
                SetHandEyeCalibrationPose_Request_DataWriter (const SetHandEyeCalibrationPose_Request_DataWriter &);
                SetHandEyeCalibrationPose_Request_DataWriter & operator = (const SetHandEyeCalibrationPose_Request_DataWriter &);
            };

            class  SetHandEyeCalibrationPose_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetHandEyeCalibrationPose_Request_DataReader_ptr _ptr_type;
                typedef SetHandEyeCalibrationPose_Request_DataReader_var _var_type;

                static SetHandEyeCalibrationPose_Request_DataReader_ptr _duplicate (SetHandEyeCalibrationPose_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibrationPose_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibrationPose_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetHandEyeCalibrationPose_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetHandEyeCalibrationPose_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibrationPose_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibrationPose_Request_& instance) = 0;

            protected:
                SetHandEyeCalibrationPose_Request_DataReader () {};
                ~SetHandEyeCalibrationPose_Request_DataReader () {};
            private:
                SetHandEyeCalibrationPose_Request_DataReader (const SetHandEyeCalibrationPose_Request_DataReader &);
                SetHandEyeCalibrationPose_Request_DataReader & operator = (const SetHandEyeCalibrationPose_Request_DataReader &);
            };

            class  SetHandEyeCalibrationPose_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetHandEyeCalibrationPose_Request_DataReaderView_ptr _ptr_type;
                typedef SetHandEyeCalibrationPose_Request_DataReaderView_var _var_type;

                static SetHandEyeCalibrationPose_Request_DataReaderView_ptr _duplicate (SetHandEyeCalibrationPose_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibrationPose_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibrationPose_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetHandEyeCalibrationPose_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetHandEyeCalibrationPose_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibrationPose_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibrationPose_Request_& instance) = 0;

            protected:
                SetHandEyeCalibrationPose_Request_DataReaderView () {};
                ~SetHandEyeCalibrationPose_Request_DataReaderView () {};
            private:
                SetHandEyeCalibrationPose_Request_DataReaderView (const SetHandEyeCalibrationPose_Request_DataReaderView &);
                SetHandEyeCalibrationPose_Request_DataReaderView & operator = (const SetHandEyeCalibrationPose_Request_DataReaderView &);
            };
            class SetHandEyeCalibrationPose_Response_TypeSupportInterface;

            typedef SetHandEyeCalibrationPose_Response_TypeSupportInterface * SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibrationPose_Response_TypeSupportInterface> SetHandEyeCalibrationPose_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibrationPose_Response_TypeSupportInterface> SetHandEyeCalibrationPose_Response_TypeSupportInterface_out;


            class SetHandEyeCalibrationPose_Response_DataWriter;

            typedef SetHandEyeCalibrationPose_Response_DataWriter * SetHandEyeCalibrationPose_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibrationPose_Response_DataWriter> SetHandEyeCalibrationPose_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibrationPose_Response_DataWriter> SetHandEyeCalibrationPose_Response_DataWriter_out;


            class SetHandEyeCalibrationPose_Response_DataReader;

            typedef SetHandEyeCalibrationPose_Response_DataReader * SetHandEyeCalibrationPose_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibrationPose_Response_DataReader> SetHandEyeCalibrationPose_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibrationPose_Response_DataReader> SetHandEyeCalibrationPose_Response_DataReader_out;


            class SetHandEyeCalibrationPose_Response_DataReaderView;

            typedef SetHandEyeCalibrationPose_Response_DataReaderView * SetHandEyeCalibrationPose_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibrationPose_Response_DataReaderView> SetHandEyeCalibrationPose_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibrationPose_Response_DataReaderView> SetHandEyeCalibrationPose_Response_DataReaderView_out;

            struct SetHandEyeCalibrationPose_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetHandEyeCalibrationPose_Response_, struct SetHandEyeCalibrationPose_Response_Seq_uniq_> SetHandEyeCalibrationPose_Response_Seq;
            typedef DDS_DCPSSequence_var < SetHandEyeCalibrationPose_Response_Seq> SetHandEyeCalibrationPose_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetHandEyeCalibrationPose_Response_Seq> SetHandEyeCalibrationPose_Response_Seq_out;

            class  SetHandEyeCalibrationPose_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetHandEyeCalibrationPose_Response_TypeSupportInterface_var _var_type;

                static SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _duplicate (SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetHandEyeCalibrationPose_Response_TypeSupportInterface () {};
                ~SetHandEyeCalibrationPose_Response_TypeSupportInterface () {};
            private:
                SetHandEyeCalibrationPose_Response_TypeSupportInterface (const SetHandEyeCalibrationPose_Response_TypeSupportInterface &);
                SetHandEyeCalibrationPose_Response_TypeSupportInterface & operator = (const SetHandEyeCalibrationPose_Response_TypeSupportInterface &);
            };

            class  SetHandEyeCalibrationPose_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetHandEyeCalibrationPose_Response_DataWriter_ptr _ptr_type;
                typedef SetHandEyeCalibrationPose_Response_DataWriter_var _var_type;

                static SetHandEyeCalibrationPose_Response_DataWriter_ptr _duplicate (SetHandEyeCalibrationPose_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibrationPose_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibrationPose_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetHandEyeCalibrationPose_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetHandEyeCalibrationPose_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibrationPose_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibrationPose_Response_& instance_data) = 0;

            protected:
                SetHandEyeCalibrationPose_Response_DataWriter () {};
                ~SetHandEyeCalibrationPose_Response_DataWriter () {};
            private:
                SetHandEyeCalibrationPose_Response_DataWriter (const SetHandEyeCalibrationPose_Response_DataWriter &);
                SetHandEyeCalibrationPose_Response_DataWriter & operator = (const SetHandEyeCalibrationPose_Response_DataWriter &);
            };

            class  SetHandEyeCalibrationPose_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetHandEyeCalibrationPose_Response_DataReader_ptr _ptr_type;
                typedef SetHandEyeCalibrationPose_Response_DataReader_var _var_type;

                static SetHandEyeCalibrationPose_Response_DataReader_ptr _duplicate (SetHandEyeCalibrationPose_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibrationPose_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibrationPose_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetHandEyeCalibrationPose_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetHandEyeCalibrationPose_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibrationPose_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibrationPose_Response_& instance) = 0;

            protected:
                SetHandEyeCalibrationPose_Response_DataReader () {};
                ~SetHandEyeCalibrationPose_Response_DataReader () {};
            private:
                SetHandEyeCalibrationPose_Response_DataReader (const SetHandEyeCalibrationPose_Response_DataReader &);
                SetHandEyeCalibrationPose_Response_DataReader & operator = (const SetHandEyeCalibrationPose_Response_DataReader &);
            };

            class  SetHandEyeCalibrationPose_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetHandEyeCalibrationPose_Response_DataReaderView_ptr _ptr_type;
                typedef SetHandEyeCalibrationPose_Response_DataReaderView_var _var_type;

                static SetHandEyeCalibrationPose_Response_DataReaderView_ptr _duplicate (SetHandEyeCalibrationPose_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibrationPose_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibrationPose_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibrationPose_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetHandEyeCalibrationPose_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetHandEyeCalibrationPose_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibrationPose_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibrationPose_Response_& instance) = 0;

            protected:
                SetHandEyeCalibrationPose_Response_DataReaderView () {};
                ~SetHandEyeCalibrationPose_Response_DataReaderView () {};
            private:
                SetHandEyeCalibrationPose_Response_DataReaderView (const SetHandEyeCalibrationPose_Response_DataReaderView &);
                SetHandEyeCalibrationPose_Response_DataReaderView & operator = (const SetHandEyeCalibrationPose_Response_DataReaderView &);
            };
            class Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface;

            typedef Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface * Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface> Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface> Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_out;


            class Sample_SetHandEyeCalibrationPose_Request_DataWriter;

            typedef Sample_SetHandEyeCalibrationPose_Request_DataWriter * Sample_SetHandEyeCalibrationPose_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibrationPose_Request_DataWriter> Sample_SetHandEyeCalibrationPose_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibrationPose_Request_DataWriter> Sample_SetHandEyeCalibrationPose_Request_DataWriter_out;


            class Sample_SetHandEyeCalibrationPose_Request_DataReader;

            typedef Sample_SetHandEyeCalibrationPose_Request_DataReader * Sample_SetHandEyeCalibrationPose_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibrationPose_Request_DataReader> Sample_SetHandEyeCalibrationPose_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibrationPose_Request_DataReader> Sample_SetHandEyeCalibrationPose_Request_DataReader_out;


            class Sample_SetHandEyeCalibrationPose_Request_DataReaderView;

            typedef Sample_SetHandEyeCalibrationPose_Request_DataReaderView * Sample_SetHandEyeCalibrationPose_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibrationPose_Request_DataReaderView> Sample_SetHandEyeCalibrationPose_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibrationPose_Request_DataReaderView> Sample_SetHandEyeCalibrationPose_Request_DataReaderView_out;

            struct Sample_SetHandEyeCalibrationPose_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_SetHandEyeCalibrationPose_Request_, struct Sample_SetHandEyeCalibrationPose_Request_Seq_uniq_> Sample_SetHandEyeCalibrationPose_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetHandEyeCalibrationPose_Request_Seq> Sample_SetHandEyeCalibrationPose_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetHandEyeCalibrationPose_Request_Seq> Sample_SetHandEyeCalibrationPose_Request_Seq_out;

            class  Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_var _var_type;

                static Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _duplicate (Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface () {};
                ~Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface () {};
            private:
                Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface (const Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface &);
                Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface & operator = (const Sample_SetHandEyeCalibrationPose_Request_TypeSupportInterface &);
            };

            class  Sample_SetHandEyeCalibrationPose_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetHandEyeCalibrationPose_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibrationPose_Request_DataWriter_var _var_type;

                static Sample_SetHandEyeCalibrationPose_Request_DataWriter_ptr _duplicate (Sample_SetHandEyeCalibrationPose_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibrationPose_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibrationPose_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetHandEyeCalibrationPose_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetHandEyeCalibrationPose_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetHandEyeCalibrationPose_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibrationPose_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibrationPose_Request_& instance_data) = 0;

            protected:
                Sample_SetHandEyeCalibrationPose_Request_DataWriter () {};
                ~Sample_SetHandEyeCalibrationPose_Request_DataWriter () {};
            private:
                Sample_SetHandEyeCalibrationPose_Request_DataWriter (const Sample_SetHandEyeCalibrationPose_Request_DataWriter &);
                Sample_SetHandEyeCalibrationPose_Request_DataWriter & operator = (const Sample_SetHandEyeCalibrationPose_Request_DataWriter &);
            };

            class  Sample_SetHandEyeCalibrationPose_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetHandEyeCalibrationPose_Request_DataReader_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibrationPose_Request_DataReader_var _var_type;

                static Sample_SetHandEyeCalibrationPose_Request_DataReader_ptr _duplicate (Sample_SetHandEyeCalibrationPose_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibrationPose_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibrationPose_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetHandEyeCalibrationPose_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetHandEyeCalibrationPose_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibrationPose_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibrationPose_Request_& instance) = 0;

            protected:
                Sample_SetHandEyeCalibrationPose_Request_DataReader () {};
                ~Sample_SetHandEyeCalibrationPose_Request_DataReader () {};
            private:
                Sample_SetHandEyeCalibrationPose_Request_DataReader (const Sample_SetHandEyeCalibrationPose_Request_DataReader &);
                Sample_SetHandEyeCalibrationPose_Request_DataReader & operator = (const Sample_SetHandEyeCalibrationPose_Request_DataReader &);
            };

            class  Sample_SetHandEyeCalibrationPose_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetHandEyeCalibrationPose_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibrationPose_Request_DataReaderView_var _var_type;

                static Sample_SetHandEyeCalibrationPose_Request_DataReaderView_ptr _duplicate (Sample_SetHandEyeCalibrationPose_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibrationPose_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibrationPose_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetHandEyeCalibrationPose_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetHandEyeCalibrationPose_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetHandEyeCalibrationPose_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibrationPose_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibrationPose_Request_& instance) = 0;

            protected:
                Sample_SetHandEyeCalibrationPose_Request_DataReaderView () {};
                ~Sample_SetHandEyeCalibrationPose_Request_DataReaderView () {};
            private:
                Sample_SetHandEyeCalibrationPose_Request_DataReaderView (const Sample_SetHandEyeCalibrationPose_Request_DataReaderView &);
                Sample_SetHandEyeCalibrationPose_Request_DataReaderView & operator = (const Sample_SetHandEyeCalibrationPose_Request_DataReaderView &);
            };
            class Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface;

            typedef Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface * Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface> Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface> Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_out;


            class Sample_SetHandEyeCalibrationPose_Response_DataWriter;

            typedef Sample_SetHandEyeCalibrationPose_Response_DataWriter * Sample_SetHandEyeCalibrationPose_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibrationPose_Response_DataWriter> Sample_SetHandEyeCalibrationPose_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibrationPose_Response_DataWriter> Sample_SetHandEyeCalibrationPose_Response_DataWriter_out;


            class Sample_SetHandEyeCalibrationPose_Response_DataReader;

            typedef Sample_SetHandEyeCalibrationPose_Response_DataReader * Sample_SetHandEyeCalibrationPose_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibrationPose_Response_DataReader> Sample_SetHandEyeCalibrationPose_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibrationPose_Response_DataReader> Sample_SetHandEyeCalibrationPose_Response_DataReader_out;


            class Sample_SetHandEyeCalibrationPose_Response_DataReaderView;

            typedef Sample_SetHandEyeCalibrationPose_Response_DataReaderView * Sample_SetHandEyeCalibrationPose_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibrationPose_Response_DataReaderView> Sample_SetHandEyeCalibrationPose_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibrationPose_Response_DataReaderView> Sample_SetHandEyeCalibrationPose_Response_DataReaderView_out;

            struct Sample_SetHandEyeCalibrationPose_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetHandEyeCalibrationPose_Response_, struct Sample_SetHandEyeCalibrationPose_Response_Seq_uniq_> Sample_SetHandEyeCalibrationPose_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetHandEyeCalibrationPose_Response_Seq> Sample_SetHandEyeCalibrationPose_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetHandEyeCalibrationPose_Response_Seq> Sample_SetHandEyeCalibrationPose_Response_Seq_out;

            class  Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_var _var_type;

                static Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _duplicate (Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface () {};
                ~Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface () {};
            private:
                Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface (const Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface &);
                Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface & operator = (const Sample_SetHandEyeCalibrationPose_Response_TypeSupportInterface &);
            };

            class  Sample_SetHandEyeCalibrationPose_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetHandEyeCalibrationPose_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibrationPose_Response_DataWriter_var _var_type;

                static Sample_SetHandEyeCalibrationPose_Response_DataWriter_ptr _duplicate (Sample_SetHandEyeCalibrationPose_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibrationPose_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibrationPose_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetHandEyeCalibrationPose_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetHandEyeCalibrationPose_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetHandEyeCalibrationPose_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibrationPose_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibrationPose_Response_& instance_data) = 0;

            protected:
                Sample_SetHandEyeCalibrationPose_Response_DataWriter () {};
                ~Sample_SetHandEyeCalibrationPose_Response_DataWriter () {};
            private:
                Sample_SetHandEyeCalibrationPose_Response_DataWriter (const Sample_SetHandEyeCalibrationPose_Response_DataWriter &);
                Sample_SetHandEyeCalibrationPose_Response_DataWriter & operator = (const Sample_SetHandEyeCalibrationPose_Response_DataWriter &);
            };

            class  Sample_SetHandEyeCalibrationPose_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetHandEyeCalibrationPose_Response_DataReader_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibrationPose_Response_DataReader_var _var_type;

                static Sample_SetHandEyeCalibrationPose_Response_DataReader_ptr _duplicate (Sample_SetHandEyeCalibrationPose_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibrationPose_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibrationPose_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetHandEyeCalibrationPose_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetHandEyeCalibrationPose_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibrationPose_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibrationPose_Response_& instance) = 0;

            protected:
                Sample_SetHandEyeCalibrationPose_Response_DataReader () {};
                ~Sample_SetHandEyeCalibrationPose_Response_DataReader () {};
            private:
                Sample_SetHandEyeCalibrationPose_Response_DataReader (const Sample_SetHandEyeCalibrationPose_Response_DataReader &);
                Sample_SetHandEyeCalibrationPose_Response_DataReader & operator = (const Sample_SetHandEyeCalibrationPose_Response_DataReader &);
            };

            class  Sample_SetHandEyeCalibrationPose_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetHandEyeCalibrationPose_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibrationPose_Response_DataReaderView_var _var_type;

                static Sample_SetHandEyeCalibrationPose_Response_DataReaderView_ptr _duplicate (Sample_SetHandEyeCalibrationPose_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibrationPose_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibrationPose_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibrationPose_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetHandEyeCalibrationPose_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetHandEyeCalibrationPose_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetHandEyeCalibrationPose_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibrationPose_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibrationPose_Response_& instance) = 0;

            protected:
                Sample_SetHandEyeCalibrationPose_Response_DataReaderView () {};
                ~Sample_SetHandEyeCalibrationPose_Response_DataReaderView () {};
            private:
                Sample_SetHandEyeCalibrationPose_Response_DataReaderView (const Sample_SetHandEyeCalibrationPose_Response_DataReaderView &);
                Sample_SetHandEyeCalibrationPose_Response_DataReaderView & operator = (const Sample_SetHandEyeCalibrationPose_Response_DataReaderView &);
            };
        }

    }

}

#endif
