#ifndef _H_0909920BD7D4CA775D436AD868175F48_SetHandEyeCalibration__H_
#define _H_0909920BD7D4CA775D436AD868175F48_SetHandEyeCalibration__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SetHandEyeCalibration_Request_
            {
                ::geometry_msgs::msg::dds_::Pose_ pose_;
                ::DDS::Boolean robot_mounted_;
            };

            typedef DDS_DCPSStruct_var<SetHandEyeCalibration_Request_> SetHandEyeCalibration_Request__var;
            typedef SetHandEyeCalibration_Request_& SetHandEyeCalibration_Request__out;

            struct  SetHandEyeCalibration_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::Long status_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<SetHandEyeCalibration_Response_> SetHandEyeCalibration_Response__var;
            typedef DDS_DCPSStruct_out < SetHandEyeCalibration_Response_> SetHandEyeCalibration_Response__out;

            struct  Sample_SetHandEyeCalibration_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SetHandEyeCalibration_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetHandEyeCalibration_Request_> Sample_SetHandEyeCalibration_Request__var;
            typedef Sample_SetHandEyeCalibration_Request_& Sample_SetHandEyeCalibration_Request__out;

            struct  Sample_SetHandEyeCalibration_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SetHandEyeCalibration_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetHandEyeCalibration_Response_> Sample_SetHandEyeCalibration_Response__var;
            typedef DDS_DCPSStruct_out < Sample_SetHandEyeCalibration_Response_> Sample_SetHandEyeCalibration_Response__out;

        }

    }

}

#endif /* _H_0909920BD7D4CA775D436AD868175F48_SetHandEyeCalibration__H_ */
