#ifndef _H_0909920BD7D4CA775D436AD868175F48_SetHandEyeCalibration_DCPS_H_
#define _H_0909920BD7D4CA775D436AD868175F48_SetHandEyeCalibration_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SetHandEyeCalibration_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SetHandEyeCalibration_Request_TypeSupportInterface;

            typedef SetHandEyeCalibration_Request_TypeSupportInterface * SetHandEyeCalibration_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibration_Request_TypeSupportInterface> SetHandEyeCalibration_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibration_Request_TypeSupportInterface> SetHandEyeCalibration_Request_TypeSupportInterface_out;


            class SetHandEyeCalibration_Request_DataWriter;

            typedef SetHandEyeCalibration_Request_DataWriter * SetHandEyeCalibration_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibration_Request_DataWriter> SetHandEyeCalibration_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibration_Request_DataWriter> SetHandEyeCalibration_Request_DataWriter_out;


            class SetHandEyeCalibration_Request_DataReader;

            typedef SetHandEyeCalibration_Request_DataReader * SetHandEyeCalibration_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibration_Request_DataReader> SetHandEyeCalibration_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibration_Request_DataReader> SetHandEyeCalibration_Request_DataReader_out;


            class SetHandEyeCalibration_Request_DataReaderView;

            typedef SetHandEyeCalibration_Request_DataReaderView * SetHandEyeCalibration_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibration_Request_DataReaderView> SetHandEyeCalibration_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibration_Request_DataReaderView> SetHandEyeCalibration_Request_DataReaderView_out;

            struct SetHandEyeCalibration_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SetHandEyeCalibration_Request_, struct SetHandEyeCalibration_Request_Seq_uniq_> SetHandEyeCalibration_Request_Seq;
            typedef DDS_DCPSSequence_var < SetHandEyeCalibration_Request_Seq> SetHandEyeCalibration_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SetHandEyeCalibration_Request_Seq> SetHandEyeCalibration_Request_Seq_out;

            class  SetHandEyeCalibration_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetHandEyeCalibration_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SetHandEyeCalibration_Request_TypeSupportInterface_var _var_type;

                static SetHandEyeCalibration_Request_TypeSupportInterface_ptr _duplicate (SetHandEyeCalibration_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibration_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibration_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetHandEyeCalibration_Request_TypeSupportInterface () {};
                ~SetHandEyeCalibration_Request_TypeSupportInterface () {};
            private:
                SetHandEyeCalibration_Request_TypeSupportInterface (const SetHandEyeCalibration_Request_TypeSupportInterface &);
                SetHandEyeCalibration_Request_TypeSupportInterface & operator = (const SetHandEyeCalibration_Request_TypeSupportInterface &);
            };

            class  SetHandEyeCalibration_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetHandEyeCalibration_Request_DataWriter_ptr _ptr_type;
                typedef SetHandEyeCalibration_Request_DataWriter_var _var_type;

                static SetHandEyeCalibration_Request_DataWriter_ptr _duplicate (SetHandEyeCalibration_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibration_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibration_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetHandEyeCalibration_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetHandEyeCalibration_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibration_Request_& instance_data) = 0;

            protected:
                SetHandEyeCalibration_Request_DataWriter () {};
                ~SetHandEyeCalibration_Request_DataWriter () {};
            private:
                SetHandEyeCalibration_Request_DataWriter (const SetHandEyeCalibration_Request_DataWriter &);
                SetHandEyeCalibration_Request_DataWriter & operator = (const SetHandEyeCalibration_Request_DataWriter &);
            };

            class  SetHandEyeCalibration_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetHandEyeCalibration_Request_DataReader_ptr _ptr_type;
                typedef SetHandEyeCalibration_Request_DataReader_var _var_type;

                static SetHandEyeCalibration_Request_DataReader_ptr _duplicate (SetHandEyeCalibration_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibration_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibration_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetHandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetHandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibration_Request_& instance) = 0;

            protected:
                SetHandEyeCalibration_Request_DataReader () {};
                ~SetHandEyeCalibration_Request_DataReader () {};
            private:
                SetHandEyeCalibration_Request_DataReader (const SetHandEyeCalibration_Request_DataReader &);
                SetHandEyeCalibration_Request_DataReader & operator = (const SetHandEyeCalibration_Request_DataReader &);
            };

            class  SetHandEyeCalibration_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetHandEyeCalibration_Request_DataReaderView_ptr _ptr_type;
                typedef SetHandEyeCalibration_Request_DataReaderView_var _var_type;

                static SetHandEyeCalibration_Request_DataReaderView_ptr _duplicate (SetHandEyeCalibration_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibration_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibration_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetHandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetHandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibration_Request_& instance) = 0;

            protected:
                SetHandEyeCalibration_Request_DataReaderView () {};
                ~SetHandEyeCalibration_Request_DataReaderView () {};
            private:
                SetHandEyeCalibration_Request_DataReaderView (const SetHandEyeCalibration_Request_DataReaderView &);
                SetHandEyeCalibration_Request_DataReaderView & operator = (const SetHandEyeCalibration_Request_DataReaderView &);
            };
            class SetHandEyeCalibration_Response_TypeSupportInterface;

            typedef SetHandEyeCalibration_Response_TypeSupportInterface * SetHandEyeCalibration_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibration_Response_TypeSupportInterface> SetHandEyeCalibration_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibration_Response_TypeSupportInterface> SetHandEyeCalibration_Response_TypeSupportInterface_out;


            class SetHandEyeCalibration_Response_DataWriter;

            typedef SetHandEyeCalibration_Response_DataWriter * SetHandEyeCalibration_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibration_Response_DataWriter> SetHandEyeCalibration_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibration_Response_DataWriter> SetHandEyeCalibration_Response_DataWriter_out;


            class SetHandEyeCalibration_Response_DataReader;

            typedef SetHandEyeCalibration_Response_DataReader * SetHandEyeCalibration_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibration_Response_DataReader> SetHandEyeCalibration_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibration_Response_DataReader> SetHandEyeCalibration_Response_DataReader_out;


            class SetHandEyeCalibration_Response_DataReaderView;

            typedef SetHandEyeCalibration_Response_DataReaderView * SetHandEyeCalibration_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SetHandEyeCalibration_Response_DataReaderView> SetHandEyeCalibration_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SetHandEyeCalibration_Response_DataReaderView> SetHandEyeCalibration_Response_DataReaderView_out;

            struct SetHandEyeCalibration_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SetHandEyeCalibration_Response_, struct SetHandEyeCalibration_Response_Seq_uniq_> SetHandEyeCalibration_Response_Seq;
            typedef DDS_DCPSSequence_var < SetHandEyeCalibration_Response_Seq> SetHandEyeCalibration_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SetHandEyeCalibration_Response_Seq> SetHandEyeCalibration_Response_Seq_out;

            class  SetHandEyeCalibration_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SetHandEyeCalibration_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SetHandEyeCalibration_Response_TypeSupportInterface_var _var_type;

                static SetHandEyeCalibration_Response_TypeSupportInterface_ptr _duplicate (SetHandEyeCalibration_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibration_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibration_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SetHandEyeCalibration_Response_TypeSupportInterface () {};
                ~SetHandEyeCalibration_Response_TypeSupportInterface () {};
            private:
                SetHandEyeCalibration_Response_TypeSupportInterface (const SetHandEyeCalibration_Response_TypeSupportInterface &);
                SetHandEyeCalibration_Response_TypeSupportInterface & operator = (const SetHandEyeCalibration_Response_TypeSupportInterface &);
            };

            class  SetHandEyeCalibration_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SetHandEyeCalibration_Response_DataWriter_ptr _ptr_type;
                typedef SetHandEyeCalibration_Response_DataWriter_var _var_type;

                static SetHandEyeCalibration_Response_DataWriter_ptr _duplicate (SetHandEyeCalibration_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibration_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibration_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SetHandEyeCalibration_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SetHandEyeCalibration_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibration_Response_& instance_data) = 0;

            protected:
                SetHandEyeCalibration_Response_DataWriter () {};
                ~SetHandEyeCalibration_Response_DataWriter () {};
            private:
                SetHandEyeCalibration_Response_DataWriter (const SetHandEyeCalibration_Response_DataWriter &);
                SetHandEyeCalibration_Response_DataWriter & operator = (const SetHandEyeCalibration_Response_DataWriter &);
            };

            class  SetHandEyeCalibration_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SetHandEyeCalibration_Response_DataReader_ptr _ptr_type;
                typedef SetHandEyeCalibration_Response_DataReader_var _var_type;

                static SetHandEyeCalibration_Response_DataReader_ptr _duplicate (SetHandEyeCalibration_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibration_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibration_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetHandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetHandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibration_Response_& instance) = 0;

            protected:
                SetHandEyeCalibration_Response_DataReader () {};
                ~SetHandEyeCalibration_Response_DataReader () {};
            private:
                SetHandEyeCalibration_Response_DataReader (const SetHandEyeCalibration_Response_DataReader &);
                SetHandEyeCalibration_Response_DataReader & operator = (const SetHandEyeCalibration_Response_DataReader &);
            };

            class  SetHandEyeCalibration_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SetHandEyeCalibration_Response_DataReaderView_ptr _ptr_type;
                typedef SetHandEyeCalibration_Response_DataReaderView_var _var_type;

                static SetHandEyeCalibration_Response_DataReaderView_ptr _duplicate (SetHandEyeCalibration_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SetHandEyeCalibration_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SetHandEyeCalibration_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SetHandEyeCalibration_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SetHandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SetHandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SetHandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SetHandEyeCalibration_Response_& instance) = 0;

            protected:
                SetHandEyeCalibration_Response_DataReaderView () {};
                ~SetHandEyeCalibration_Response_DataReaderView () {};
            private:
                SetHandEyeCalibration_Response_DataReaderView (const SetHandEyeCalibration_Response_DataReaderView &);
                SetHandEyeCalibration_Response_DataReaderView & operator = (const SetHandEyeCalibration_Response_DataReaderView &);
            };
            class Sample_SetHandEyeCalibration_Request_TypeSupportInterface;

            typedef Sample_SetHandEyeCalibration_Request_TypeSupportInterface * Sample_SetHandEyeCalibration_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibration_Request_TypeSupportInterface> Sample_SetHandEyeCalibration_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibration_Request_TypeSupportInterface> Sample_SetHandEyeCalibration_Request_TypeSupportInterface_out;


            class Sample_SetHandEyeCalibration_Request_DataWriter;

            typedef Sample_SetHandEyeCalibration_Request_DataWriter * Sample_SetHandEyeCalibration_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibration_Request_DataWriter> Sample_SetHandEyeCalibration_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibration_Request_DataWriter> Sample_SetHandEyeCalibration_Request_DataWriter_out;


            class Sample_SetHandEyeCalibration_Request_DataReader;

            typedef Sample_SetHandEyeCalibration_Request_DataReader * Sample_SetHandEyeCalibration_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibration_Request_DataReader> Sample_SetHandEyeCalibration_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibration_Request_DataReader> Sample_SetHandEyeCalibration_Request_DataReader_out;


            class Sample_SetHandEyeCalibration_Request_DataReaderView;

            typedef Sample_SetHandEyeCalibration_Request_DataReaderView * Sample_SetHandEyeCalibration_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibration_Request_DataReaderView> Sample_SetHandEyeCalibration_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibration_Request_DataReaderView> Sample_SetHandEyeCalibration_Request_DataReaderView_out;

            struct Sample_SetHandEyeCalibration_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_SetHandEyeCalibration_Request_, struct Sample_SetHandEyeCalibration_Request_Seq_uniq_> Sample_SetHandEyeCalibration_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetHandEyeCalibration_Request_Seq> Sample_SetHandEyeCalibration_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetHandEyeCalibration_Request_Seq> Sample_SetHandEyeCalibration_Request_Seq_out;

            class  Sample_SetHandEyeCalibration_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetHandEyeCalibration_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibration_Request_TypeSupportInterface_var _var_type;

                static Sample_SetHandEyeCalibration_Request_TypeSupportInterface_ptr _duplicate (Sample_SetHandEyeCalibration_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibration_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibration_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetHandEyeCalibration_Request_TypeSupportInterface () {};
                ~Sample_SetHandEyeCalibration_Request_TypeSupportInterface () {};
            private:
                Sample_SetHandEyeCalibration_Request_TypeSupportInterface (const Sample_SetHandEyeCalibration_Request_TypeSupportInterface &);
                Sample_SetHandEyeCalibration_Request_TypeSupportInterface & operator = (const Sample_SetHandEyeCalibration_Request_TypeSupportInterface &);
            };

            class  Sample_SetHandEyeCalibration_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetHandEyeCalibration_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibration_Request_DataWriter_var _var_type;

                static Sample_SetHandEyeCalibration_Request_DataWriter_ptr _duplicate (Sample_SetHandEyeCalibration_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibration_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibration_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetHandEyeCalibration_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetHandEyeCalibration_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetHandEyeCalibration_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibration_Request_& instance_data) = 0;

            protected:
                Sample_SetHandEyeCalibration_Request_DataWriter () {};
                ~Sample_SetHandEyeCalibration_Request_DataWriter () {};
            private:
                Sample_SetHandEyeCalibration_Request_DataWriter (const Sample_SetHandEyeCalibration_Request_DataWriter &);
                Sample_SetHandEyeCalibration_Request_DataWriter & operator = (const Sample_SetHandEyeCalibration_Request_DataWriter &);
            };

            class  Sample_SetHandEyeCalibration_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetHandEyeCalibration_Request_DataReader_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibration_Request_DataReader_var _var_type;

                static Sample_SetHandEyeCalibration_Request_DataReader_ptr _duplicate (Sample_SetHandEyeCalibration_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibration_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibration_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetHandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetHandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibration_Request_& instance) = 0;

            protected:
                Sample_SetHandEyeCalibration_Request_DataReader () {};
                ~Sample_SetHandEyeCalibration_Request_DataReader () {};
            private:
                Sample_SetHandEyeCalibration_Request_DataReader (const Sample_SetHandEyeCalibration_Request_DataReader &);
                Sample_SetHandEyeCalibration_Request_DataReader & operator = (const Sample_SetHandEyeCalibration_Request_DataReader &);
            };

            class  Sample_SetHandEyeCalibration_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetHandEyeCalibration_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibration_Request_DataReaderView_var _var_type;

                static Sample_SetHandEyeCalibration_Request_DataReaderView_ptr _duplicate (Sample_SetHandEyeCalibration_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibration_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibration_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetHandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetHandEyeCalibration_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetHandEyeCalibration_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibration_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibration_Request_& instance) = 0;

            protected:
                Sample_SetHandEyeCalibration_Request_DataReaderView () {};
                ~Sample_SetHandEyeCalibration_Request_DataReaderView () {};
            private:
                Sample_SetHandEyeCalibration_Request_DataReaderView (const Sample_SetHandEyeCalibration_Request_DataReaderView &);
                Sample_SetHandEyeCalibration_Request_DataReaderView & operator = (const Sample_SetHandEyeCalibration_Request_DataReaderView &);
            };
            class Sample_SetHandEyeCalibration_Response_TypeSupportInterface;

            typedef Sample_SetHandEyeCalibration_Response_TypeSupportInterface * Sample_SetHandEyeCalibration_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibration_Response_TypeSupportInterface> Sample_SetHandEyeCalibration_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibration_Response_TypeSupportInterface> Sample_SetHandEyeCalibration_Response_TypeSupportInterface_out;


            class Sample_SetHandEyeCalibration_Response_DataWriter;

            typedef Sample_SetHandEyeCalibration_Response_DataWriter * Sample_SetHandEyeCalibration_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibration_Response_DataWriter> Sample_SetHandEyeCalibration_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibration_Response_DataWriter> Sample_SetHandEyeCalibration_Response_DataWriter_out;


            class Sample_SetHandEyeCalibration_Response_DataReader;

            typedef Sample_SetHandEyeCalibration_Response_DataReader * Sample_SetHandEyeCalibration_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibration_Response_DataReader> Sample_SetHandEyeCalibration_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibration_Response_DataReader> Sample_SetHandEyeCalibration_Response_DataReader_out;


            class Sample_SetHandEyeCalibration_Response_DataReaderView;

            typedef Sample_SetHandEyeCalibration_Response_DataReaderView * Sample_SetHandEyeCalibration_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SetHandEyeCalibration_Response_DataReaderView> Sample_SetHandEyeCalibration_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SetHandEyeCalibration_Response_DataReaderView> Sample_SetHandEyeCalibration_Response_DataReaderView_out;

            struct Sample_SetHandEyeCalibration_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SetHandEyeCalibration_Response_, struct Sample_SetHandEyeCalibration_Response_Seq_uniq_> Sample_SetHandEyeCalibration_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SetHandEyeCalibration_Response_Seq> Sample_SetHandEyeCalibration_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SetHandEyeCalibration_Response_Seq> Sample_SetHandEyeCalibration_Response_Seq_out;

            class  Sample_SetHandEyeCalibration_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SetHandEyeCalibration_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibration_Response_TypeSupportInterface_var _var_type;

                static Sample_SetHandEyeCalibration_Response_TypeSupportInterface_ptr _duplicate (Sample_SetHandEyeCalibration_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibration_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibration_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SetHandEyeCalibration_Response_TypeSupportInterface () {};
                ~Sample_SetHandEyeCalibration_Response_TypeSupportInterface () {};
            private:
                Sample_SetHandEyeCalibration_Response_TypeSupportInterface (const Sample_SetHandEyeCalibration_Response_TypeSupportInterface &);
                Sample_SetHandEyeCalibration_Response_TypeSupportInterface & operator = (const Sample_SetHandEyeCalibration_Response_TypeSupportInterface &);
            };

            class  Sample_SetHandEyeCalibration_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SetHandEyeCalibration_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibration_Response_DataWriter_var _var_type;

                static Sample_SetHandEyeCalibration_Response_DataWriter_ptr _duplicate (Sample_SetHandEyeCalibration_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibration_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibration_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SetHandEyeCalibration_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SetHandEyeCalibration_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SetHandEyeCalibration_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibration_Response_& instance_data) = 0;

            protected:
                Sample_SetHandEyeCalibration_Response_DataWriter () {};
                ~Sample_SetHandEyeCalibration_Response_DataWriter () {};
            private:
                Sample_SetHandEyeCalibration_Response_DataWriter (const Sample_SetHandEyeCalibration_Response_DataWriter &);
                Sample_SetHandEyeCalibration_Response_DataWriter & operator = (const Sample_SetHandEyeCalibration_Response_DataWriter &);
            };

            class  Sample_SetHandEyeCalibration_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SetHandEyeCalibration_Response_DataReader_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibration_Response_DataReader_var _var_type;

                static Sample_SetHandEyeCalibration_Response_DataReader_ptr _duplicate (Sample_SetHandEyeCalibration_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibration_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibration_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetHandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetHandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibration_Response_& instance) = 0;

            protected:
                Sample_SetHandEyeCalibration_Response_DataReader () {};
                ~Sample_SetHandEyeCalibration_Response_DataReader () {};
            private:
                Sample_SetHandEyeCalibration_Response_DataReader (const Sample_SetHandEyeCalibration_Response_DataReader &);
                Sample_SetHandEyeCalibration_Response_DataReader & operator = (const Sample_SetHandEyeCalibration_Response_DataReader &);
            };

            class  Sample_SetHandEyeCalibration_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SetHandEyeCalibration_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SetHandEyeCalibration_Response_DataReaderView_var _var_type;

                static Sample_SetHandEyeCalibration_Response_DataReaderView_ptr _duplicate (Sample_SetHandEyeCalibration_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SetHandEyeCalibration_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SetHandEyeCalibration_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SetHandEyeCalibration_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SetHandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SetHandEyeCalibration_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SetHandEyeCalibration_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SetHandEyeCalibration_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SetHandEyeCalibration_Response_& instance) = 0;

            protected:
                Sample_SetHandEyeCalibration_Response_DataReaderView () {};
                ~Sample_SetHandEyeCalibration_Response_DataReaderView () {};
            private:
                Sample_SetHandEyeCalibration_Response_DataReaderView (const Sample_SetHandEyeCalibration_Response_DataReaderView &);
                Sample_SetHandEyeCalibration_Response_DataReaderView & operator = (const Sample_SetHandEyeCalibration_Response_DataReaderView &);
            };
        }

    }

}

#endif
