#ifndef H_0909920BD7D4CA775D436AD868175F48_SetHandEyeCalibration_SPLTYPES_H
#define H_0909920BD7D4CA775D436AD868175F48_SetHandEyeCalibration_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_SetHandEyeCalibration_.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_SplDcps.h"



extern c_metaObject __SetHandEyeCalibration__rc_reason_msgs__load (c_base base);

extern c_metaObject __SetHandEyeCalibration__rc_reason_msgs_srv__load (c_base base);

extern c_metaObject __SetHandEyeCalibration__rc_reason_msgs_srv_dds___load (c_base base);

extern const char *rc_reason_msgs_srv_dds__SetHandEyeCalibration_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__SetHandEyeCalibration_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__SetHandEyeCalibration_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__SetHandEyeCalibration_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__SetHandEyeCalibration_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__SetHandEyeCalibration_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::SetHandEyeCalibration_Request_ *from, struct _rc_reason_msgs_srv_dds__SetHandEyeCalibration_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__SetHandEyeCalibration_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__SetHandEyeCalibration_Request_ {
    struct _geometry_msgs_msg_dds__Pose_ pose_;
    c_bool robot_mounted_;
};

extern const char *rc_reason_msgs_srv_dds__SetHandEyeCalibration_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__SetHandEyeCalibration_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__SetHandEyeCalibration_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__SetHandEyeCalibration_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__SetHandEyeCalibration_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__SetHandEyeCalibration_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::SetHandEyeCalibration_Response_ *from, struct _rc_reason_msgs_srv_dds__SetHandEyeCalibration_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__SetHandEyeCalibration_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__SetHandEyeCalibration_Response_ {
    c_bool success_;
    c_long status_;
    c_string message_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_SetHandEyeCalibration_Request_ *from, struct _rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__SetHandEyeCalibration_Request_ request_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_SetHandEyeCalibration_Response_ *from, struct _rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_SetHandEyeCalibration_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__SetHandEyeCalibration_Response_ response_;
};

#undef OS_API
#endif
