#ifndef _H_639DDA6BBCDE6B4983C0CF4F71510B4B_SetRegionOfInterest2D__H_
#define _H_639DDA6BBCDE6B4983C0CF4F71510B4B_SetRegionOfInterest2D__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/RegionOfInterest2D_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SetRegionOfInterest2D_Request_
            {
                ::rc_reason_msgs::msg::dds_::RegionOfInterest2D_ region_of_interest_2d_;
            };

            typedef DDS_DCPSStruct_var<SetRegionOfInterest2D_Request_> SetRegionOfInterest2D_Request__var;
            typedef DDS_DCPSStruct_out < SetRegionOfInterest2D_Request_> SetRegionOfInterest2D_Request__out;

            struct  SetRegionOfInterest2D_Response_
            {
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<SetRegionOfInterest2D_Response_> SetRegionOfInterest2D_Response__var;
            typedef DDS_DCPSStruct_out < SetRegionOfInterest2D_Response_> SetRegionOfInterest2D_Response__out;

            struct  Sample_SetRegionOfInterest2D_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SetRegionOfInterest2D_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetRegionOfInterest2D_Request_> Sample_SetRegionOfInterest2D_Request__var;
            typedef DDS_DCPSStruct_out < Sample_SetRegionOfInterest2D_Request_> Sample_SetRegionOfInterest2D_Request__out;

            struct  Sample_SetRegionOfInterest2D_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SetRegionOfInterest2D_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetRegionOfInterest2D_Response_> Sample_SetRegionOfInterest2D_Response__var;
            typedef DDS_DCPSStruct_out < Sample_SetRegionOfInterest2D_Response_> Sample_SetRegionOfInterest2D_Response__out;

        }

    }

}

#endif /* _H_639DDA6BBCDE6B4983C0CF4F71510B4B_SetRegionOfInterest2D__H_ */
