#ifndef _H_71D4F84DD251CF2400F8ECACFEF255F1_SetRegionOfInterest3D__H_
#define _H_71D4F84DD251CF2400F8ECACFEF255F1_SetRegionOfInterest3D__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/RegionOfInterest3D_.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  SetRegionOfInterest3D_Request_
            {
                ::rc_reason_msgs::msg::dds_::RegionOfInterest3D_ region_of_interest_;
                ::geometry_msgs::msg::dds_::Pose_ robot_pose_;
            };

            typedef DDS_DCPSStruct_var<SetRegionOfInterest3D_Request_> SetRegionOfInterest3D_Request__var;
            typedef DDS_DCPSStruct_out < SetRegionOfInterest3D_Request_> SetRegionOfInterest3D_Request__out;

            struct  SetRegionOfInterest3D_Response_
            {
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<SetRegionOfInterest3D_Response_> SetRegionOfInterest3D_Response__var;
            typedef DDS_DCPSStruct_out < SetRegionOfInterest3D_Response_> SetRegionOfInterest3D_Response__out;

            struct  Sample_SetRegionOfInterest3D_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SetRegionOfInterest3D_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetRegionOfInterest3D_Request_> Sample_SetRegionOfInterest3D_Request__var;
            typedef DDS_DCPSStruct_out < Sample_SetRegionOfInterest3D_Request_> Sample_SetRegionOfInterest3D_Request__out;

            struct  Sample_SetRegionOfInterest3D_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::SetRegionOfInterest3D_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_SetRegionOfInterest3D_Response_> Sample_SetRegionOfInterest3D_Response__var;
            typedef DDS_DCPSStruct_out < Sample_SetRegionOfInterest3D_Response_> Sample_SetRegionOfInterest3D_Response__out;

        }

    }

}

#endif /* _H_71D4F84DD251CF2400F8ECACFEF255F1_SetRegionOfInterest3D__H_ */
