#ifndef H_71D4F84DD251CF2400F8ECACFEF255F1_SetRegionOfInterest3D_SPLTYPES_H
#define H_71D4F84DD251CF2400F8ECACFEF255F1_SetRegionOfInterest3D_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_SetRegionOfInterest3D_.h"
#include "rc_reason_msgs/msg/dds_opensplice/RegionOfInterest3D_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_SplDcps.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_SplDcps.h"



extern c_metaObject __SetRegionOfInterest3D__rc_reason_msgs__load (c_base base);

extern c_metaObject __SetRegionOfInterest3D__rc_reason_msgs_srv__load (c_base base);

extern c_metaObject __SetRegionOfInterest3D__rc_reason_msgs_srv_dds___load (c_base base);

extern const char *rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::SetRegionOfInterest3D_Request_ *from, struct _rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Request_ {
    struct _rc_reason_msgs_msg_dds__RegionOfInterest3D_ region_of_interest_;
    struct _geometry_msgs_msg_dds__Pose_ robot_pose_;
};

extern const char *rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::SetRegionOfInterest3D_Response_ *from, struct _rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Response_ {
    struct _rc_common_msgs_msg_dds__ReturnCode_ return_code_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_SetRegionOfInterest3D_Request_ *from, struct _rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Request_ request_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_SetRegionOfInterest3D_Response_ *from, struct _rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_SetRegionOfInterest3D_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__SetRegionOfInterest3D_Response_ response_;
};

#undef OS_API
#endif
