#ifndef _H_1D7CAE28B24644A9C5CD91E1B59080C5_SilhouetteMatchDetectObject_DCPS_H_
#define _H_1D7CAE28B24644A9C5CD91E1B59080C5_SilhouetteMatchDetectObject_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SilhouetteMatchDetectObject_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class SilhouetteMatchDetectObject_Request_TypeSupportInterface;

            typedef SilhouetteMatchDetectObject_Request_TypeSupportInterface * SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchDetectObject_Request_TypeSupportInterface> SilhouetteMatchDetectObject_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchDetectObject_Request_TypeSupportInterface> SilhouetteMatchDetectObject_Request_TypeSupportInterface_out;


            class SilhouetteMatchDetectObject_Request_DataWriter;

            typedef SilhouetteMatchDetectObject_Request_DataWriter * SilhouetteMatchDetectObject_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchDetectObject_Request_DataWriter> SilhouetteMatchDetectObject_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchDetectObject_Request_DataWriter> SilhouetteMatchDetectObject_Request_DataWriter_out;


            class SilhouetteMatchDetectObject_Request_DataReader;

            typedef SilhouetteMatchDetectObject_Request_DataReader * SilhouetteMatchDetectObject_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchDetectObject_Request_DataReader> SilhouetteMatchDetectObject_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchDetectObject_Request_DataReader> SilhouetteMatchDetectObject_Request_DataReader_out;


            class SilhouetteMatchDetectObject_Request_DataReaderView;

            typedef SilhouetteMatchDetectObject_Request_DataReaderView * SilhouetteMatchDetectObject_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchDetectObject_Request_DataReaderView> SilhouetteMatchDetectObject_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchDetectObject_Request_DataReaderView> SilhouetteMatchDetectObject_Request_DataReaderView_out;

            struct SilhouetteMatchDetectObject_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SilhouetteMatchDetectObject_Request_, struct SilhouetteMatchDetectObject_Request_Seq_uniq_> SilhouetteMatchDetectObject_Request_Seq;
            typedef DDS_DCPSSequence_var < SilhouetteMatchDetectObject_Request_Seq> SilhouetteMatchDetectObject_Request_Seq_var;
            typedef DDS_DCPSSequence_out < SilhouetteMatchDetectObject_Request_Seq> SilhouetteMatchDetectObject_Request_Seq_out;

            class  SilhouetteMatchDetectObject_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _ptr_type;
                typedef SilhouetteMatchDetectObject_Request_TypeSupportInterface_var _var_type;

                static SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _duplicate (SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SilhouetteMatchDetectObject_Request_TypeSupportInterface () {};
                ~SilhouetteMatchDetectObject_Request_TypeSupportInterface () {};
            private:
                SilhouetteMatchDetectObject_Request_TypeSupportInterface (const SilhouetteMatchDetectObject_Request_TypeSupportInterface &);
                SilhouetteMatchDetectObject_Request_TypeSupportInterface & operator = (const SilhouetteMatchDetectObject_Request_TypeSupportInterface &);
            };

            class  SilhouetteMatchDetectObject_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SilhouetteMatchDetectObject_Request_DataWriter_ptr _ptr_type;
                typedef SilhouetteMatchDetectObject_Request_DataWriter_var _var_type;

                static SilhouetteMatchDetectObject_Request_DataWriter_ptr _duplicate (SilhouetteMatchDetectObject_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchDetectObject_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchDetectObject_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SilhouetteMatchDetectObject_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SilhouetteMatchDetectObject_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchDetectObject_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchDetectObject_Request_& instance_data) = 0;

            protected:
                SilhouetteMatchDetectObject_Request_DataWriter () {};
                ~SilhouetteMatchDetectObject_Request_DataWriter () {};
            private:
                SilhouetteMatchDetectObject_Request_DataWriter (const SilhouetteMatchDetectObject_Request_DataWriter &);
                SilhouetteMatchDetectObject_Request_DataWriter & operator = (const SilhouetteMatchDetectObject_Request_DataWriter &);
            };

            class  SilhouetteMatchDetectObject_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SilhouetteMatchDetectObject_Request_DataReader_ptr _ptr_type;
                typedef SilhouetteMatchDetectObject_Request_DataReader_var _var_type;

                static SilhouetteMatchDetectObject_Request_DataReader_ptr _duplicate (SilhouetteMatchDetectObject_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchDetectObject_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchDetectObject_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SilhouetteMatchDetectObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SilhouetteMatchDetectObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchDetectObject_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchDetectObject_Request_& instance) = 0;

            protected:
                SilhouetteMatchDetectObject_Request_DataReader () {};
                ~SilhouetteMatchDetectObject_Request_DataReader () {};
            private:
                SilhouetteMatchDetectObject_Request_DataReader (const SilhouetteMatchDetectObject_Request_DataReader &);
                SilhouetteMatchDetectObject_Request_DataReader & operator = (const SilhouetteMatchDetectObject_Request_DataReader &);
            };

            class  SilhouetteMatchDetectObject_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SilhouetteMatchDetectObject_Request_DataReaderView_ptr _ptr_type;
                typedef SilhouetteMatchDetectObject_Request_DataReaderView_var _var_type;

                static SilhouetteMatchDetectObject_Request_DataReaderView_ptr _duplicate (SilhouetteMatchDetectObject_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchDetectObject_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchDetectObject_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SilhouetteMatchDetectObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SilhouetteMatchDetectObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchDetectObject_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchDetectObject_Request_& instance) = 0;

            protected:
                SilhouetteMatchDetectObject_Request_DataReaderView () {};
                ~SilhouetteMatchDetectObject_Request_DataReaderView () {};
            private:
                SilhouetteMatchDetectObject_Request_DataReaderView (const SilhouetteMatchDetectObject_Request_DataReaderView &);
                SilhouetteMatchDetectObject_Request_DataReaderView & operator = (const SilhouetteMatchDetectObject_Request_DataReaderView &);
            };
            class SilhouetteMatchDetectObject_Response_TypeSupportInterface;

            typedef SilhouetteMatchDetectObject_Response_TypeSupportInterface * SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchDetectObject_Response_TypeSupportInterface> SilhouetteMatchDetectObject_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchDetectObject_Response_TypeSupportInterface> SilhouetteMatchDetectObject_Response_TypeSupportInterface_out;


            class SilhouetteMatchDetectObject_Response_DataWriter;

            typedef SilhouetteMatchDetectObject_Response_DataWriter * SilhouetteMatchDetectObject_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchDetectObject_Response_DataWriter> SilhouetteMatchDetectObject_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchDetectObject_Response_DataWriter> SilhouetteMatchDetectObject_Response_DataWriter_out;


            class SilhouetteMatchDetectObject_Response_DataReader;

            typedef SilhouetteMatchDetectObject_Response_DataReader * SilhouetteMatchDetectObject_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchDetectObject_Response_DataReader> SilhouetteMatchDetectObject_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchDetectObject_Response_DataReader> SilhouetteMatchDetectObject_Response_DataReader_out;


            class SilhouetteMatchDetectObject_Response_DataReaderView;

            typedef SilhouetteMatchDetectObject_Response_DataReaderView * SilhouetteMatchDetectObject_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SilhouetteMatchDetectObject_Response_DataReaderView> SilhouetteMatchDetectObject_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SilhouetteMatchDetectObject_Response_DataReaderView> SilhouetteMatchDetectObject_Response_DataReaderView_out;

            struct SilhouetteMatchDetectObject_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SilhouetteMatchDetectObject_Response_, struct SilhouetteMatchDetectObject_Response_Seq_uniq_> SilhouetteMatchDetectObject_Response_Seq;
            typedef DDS_DCPSSequence_var < SilhouetteMatchDetectObject_Response_Seq> SilhouetteMatchDetectObject_Response_Seq_var;
            typedef DDS_DCPSSequence_out < SilhouetteMatchDetectObject_Response_Seq> SilhouetteMatchDetectObject_Response_Seq_out;

            class  SilhouetteMatchDetectObject_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _ptr_type;
                typedef SilhouetteMatchDetectObject_Response_TypeSupportInterface_var _var_type;

                static SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _duplicate (SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SilhouetteMatchDetectObject_Response_TypeSupportInterface () {};
                ~SilhouetteMatchDetectObject_Response_TypeSupportInterface () {};
            private:
                SilhouetteMatchDetectObject_Response_TypeSupportInterface (const SilhouetteMatchDetectObject_Response_TypeSupportInterface &);
                SilhouetteMatchDetectObject_Response_TypeSupportInterface & operator = (const SilhouetteMatchDetectObject_Response_TypeSupportInterface &);
            };

            class  SilhouetteMatchDetectObject_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SilhouetteMatchDetectObject_Response_DataWriter_ptr _ptr_type;
                typedef SilhouetteMatchDetectObject_Response_DataWriter_var _var_type;

                static SilhouetteMatchDetectObject_Response_DataWriter_ptr _duplicate (SilhouetteMatchDetectObject_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchDetectObject_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchDetectObject_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SilhouetteMatchDetectObject_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SilhouetteMatchDetectObject_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchDetectObject_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchDetectObject_Response_& instance_data) = 0;

            protected:
                SilhouetteMatchDetectObject_Response_DataWriter () {};
                ~SilhouetteMatchDetectObject_Response_DataWriter () {};
            private:
                SilhouetteMatchDetectObject_Response_DataWriter (const SilhouetteMatchDetectObject_Response_DataWriter &);
                SilhouetteMatchDetectObject_Response_DataWriter & operator = (const SilhouetteMatchDetectObject_Response_DataWriter &);
            };

            class  SilhouetteMatchDetectObject_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SilhouetteMatchDetectObject_Response_DataReader_ptr _ptr_type;
                typedef SilhouetteMatchDetectObject_Response_DataReader_var _var_type;

                static SilhouetteMatchDetectObject_Response_DataReader_ptr _duplicate (SilhouetteMatchDetectObject_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchDetectObject_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchDetectObject_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SilhouetteMatchDetectObject_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SilhouetteMatchDetectObject_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchDetectObject_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchDetectObject_Response_& instance) = 0;

            protected:
                SilhouetteMatchDetectObject_Response_DataReader () {};
                ~SilhouetteMatchDetectObject_Response_DataReader () {};
            private:
                SilhouetteMatchDetectObject_Response_DataReader (const SilhouetteMatchDetectObject_Response_DataReader &);
                SilhouetteMatchDetectObject_Response_DataReader & operator = (const SilhouetteMatchDetectObject_Response_DataReader &);
            };

            class  SilhouetteMatchDetectObject_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SilhouetteMatchDetectObject_Response_DataReaderView_ptr _ptr_type;
                typedef SilhouetteMatchDetectObject_Response_DataReaderView_var _var_type;

                static SilhouetteMatchDetectObject_Response_DataReaderView_ptr _duplicate (SilhouetteMatchDetectObject_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SilhouetteMatchDetectObject_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SilhouetteMatchDetectObject_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SilhouetteMatchDetectObject_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SilhouetteMatchDetectObject_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SilhouetteMatchDetectObject_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SilhouetteMatchDetectObject_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SilhouetteMatchDetectObject_Response_& instance) = 0;

            protected:
                SilhouetteMatchDetectObject_Response_DataReaderView () {};
                ~SilhouetteMatchDetectObject_Response_DataReaderView () {};
            private:
                SilhouetteMatchDetectObject_Response_DataReaderView (const SilhouetteMatchDetectObject_Response_DataReaderView &);
                SilhouetteMatchDetectObject_Response_DataReaderView & operator = (const SilhouetteMatchDetectObject_Response_DataReaderView &);
            };
            class Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface;

            typedef Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface * Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface> Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface> Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_out;


            class Sample_SilhouetteMatchDetectObject_Request_DataWriter;

            typedef Sample_SilhouetteMatchDetectObject_Request_DataWriter * Sample_SilhouetteMatchDetectObject_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SilhouetteMatchDetectObject_Request_DataWriter> Sample_SilhouetteMatchDetectObject_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SilhouetteMatchDetectObject_Request_DataWriter> Sample_SilhouetteMatchDetectObject_Request_DataWriter_out;


            class Sample_SilhouetteMatchDetectObject_Request_DataReader;

            typedef Sample_SilhouetteMatchDetectObject_Request_DataReader * Sample_SilhouetteMatchDetectObject_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SilhouetteMatchDetectObject_Request_DataReader> Sample_SilhouetteMatchDetectObject_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SilhouetteMatchDetectObject_Request_DataReader> Sample_SilhouetteMatchDetectObject_Request_DataReader_out;


            class Sample_SilhouetteMatchDetectObject_Request_DataReaderView;

            typedef Sample_SilhouetteMatchDetectObject_Request_DataReaderView * Sample_SilhouetteMatchDetectObject_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SilhouetteMatchDetectObject_Request_DataReaderView> Sample_SilhouetteMatchDetectObject_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SilhouetteMatchDetectObject_Request_DataReaderView> Sample_SilhouetteMatchDetectObject_Request_DataReaderView_out;

            struct Sample_SilhouetteMatchDetectObject_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SilhouetteMatchDetectObject_Request_, struct Sample_SilhouetteMatchDetectObject_Request_Seq_uniq_> Sample_SilhouetteMatchDetectObject_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_SilhouetteMatchDetectObject_Request_Seq> Sample_SilhouetteMatchDetectObject_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SilhouetteMatchDetectObject_Request_Seq> Sample_SilhouetteMatchDetectObject_Request_Seq_out;

            class  Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_var _var_type;

                static Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _duplicate (Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface () {};
                ~Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface () {};
            private:
                Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface (const Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface &);
                Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface & operator = (const Sample_SilhouetteMatchDetectObject_Request_TypeSupportInterface &);
            };

            class  Sample_SilhouetteMatchDetectObject_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SilhouetteMatchDetectObject_Request_DataWriter_ptr _ptr_type;
                typedef Sample_SilhouetteMatchDetectObject_Request_DataWriter_var _var_type;

                static Sample_SilhouetteMatchDetectObject_Request_DataWriter_ptr _duplicate (Sample_SilhouetteMatchDetectObject_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SilhouetteMatchDetectObject_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SilhouetteMatchDetectObject_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SilhouetteMatchDetectObject_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SilhouetteMatchDetectObject_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SilhouetteMatchDetectObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SilhouetteMatchDetectObject_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SilhouetteMatchDetectObject_Request_& instance_data) = 0;

            protected:
                Sample_SilhouetteMatchDetectObject_Request_DataWriter () {};
                ~Sample_SilhouetteMatchDetectObject_Request_DataWriter () {};
            private:
                Sample_SilhouetteMatchDetectObject_Request_DataWriter (const Sample_SilhouetteMatchDetectObject_Request_DataWriter &);
                Sample_SilhouetteMatchDetectObject_Request_DataWriter & operator = (const Sample_SilhouetteMatchDetectObject_Request_DataWriter &);
            };

            class  Sample_SilhouetteMatchDetectObject_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SilhouetteMatchDetectObject_Request_DataReader_ptr _ptr_type;
                typedef Sample_SilhouetteMatchDetectObject_Request_DataReader_var _var_type;

                static Sample_SilhouetteMatchDetectObject_Request_DataReader_ptr _duplicate (Sample_SilhouetteMatchDetectObject_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SilhouetteMatchDetectObject_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SilhouetteMatchDetectObject_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SilhouetteMatchDetectObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SilhouetteMatchDetectObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SilhouetteMatchDetectObject_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SilhouetteMatchDetectObject_Request_& instance) = 0;

            protected:
                Sample_SilhouetteMatchDetectObject_Request_DataReader () {};
                ~Sample_SilhouetteMatchDetectObject_Request_DataReader () {};
            private:
                Sample_SilhouetteMatchDetectObject_Request_DataReader (const Sample_SilhouetteMatchDetectObject_Request_DataReader &);
                Sample_SilhouetteMatchDetectObject_Request_DataReader & operator = (const Sample_SilhouetteMatchDetectObject_Request_DataReader &);
            };

            class  Sample_SilhouetteMatchDetectObject_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SilhouetteMatchDetectObject_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_SilhouetteMatchDetectObject_Request_DataReaderView_var _var_type;

                static Sample_SilhouetteMatchDetectObject_Request_DataReaderView_ptr _duplicate (Sample_SilhouetteMatchDetectObject_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SilhouetteMatchDetectObject_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SilhouetteMatchDetectObject_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SilhouetteMatchDetectObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SilhouetteMatchDetectObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SilhouetteMatchDetectObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SilhouetteMatchDetectObject_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SilhouetteMatchDetectObject_Request_& instance) = 0;

            protected:
                Sample_SilhouetteMatchDetectObject_Request_DataReaderView () {};
                ~Sample_SilhouetteMatchDetectObject_Request_DataReaderView () {};
            private:
                Sample_SilhouetteMatchDetectObject_Request_DataReaderView (const Sample_SilhouetteMatchDetectObject_Request_DataReaderView &);
                Sample_SilhouetteMatchDetectObject_Request_DataReaderView & operator = (const Sample_SilhouetteMatchDetectObject_Request_DataReaderView &);
            };
            class Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface;

            typedef Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface * Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface> Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface> Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_out;


            class Sample_SilhouetteMatchDetectObject_Response_DataWriter;

            typedef Sample_SilhouetteMatchDetectObject_Response_DataWriter * Sample_SilhouetteMatchDetectObject_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_SilhouetteMatchDetectObject_Response_DataWriter> Sample_SilhouetteMatchDetectObject_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_SilhouetteMatchDetectObject_Response_DataWriter> Sample_SilhouetteMatchDetectObject_Response_DataWriter_out;


            class Sample_SilhouetteMatchDetectObject_Response_DataReader;

            typedef Sample_SilhouetteMatchDetectObject_Response_DataReader * Sample_SilhouetteMatchDetectObject_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_SilhouetteMatchDetectObject_Response_DataReader> Sample_SilhouetteMatchDetectObject_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_SilhouetteMatchDetectObject_Response_DataReader> Sample_SilhouetteMatchDetectObject_Response_DataReader_out;


            class Sample_SilhouetteMatchDetectObject_Response_DataReaderView;

            typedef Sample_SilhouetteMatchDetectObject_Response_DataReaderView * Sample_SilhouetteMatchDetectObject_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_SilhouetteMatchDetectObject_Response_DataReaderView> Sample_SilhouetteMatchDetectObject_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_SilhouetteMatchDetectObject_Response_DataReaderView> Sample_SilhouetteMatchDetectObject_Response_DataReaderView_out;

            struct Sample_SilhouetteMatchDetectObject_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_SilhouetteMatchDetectObject_Response_, struct Sample_SilhouetteMatchDetectObject_Response_Seq_uniq_> Sample_SilhouetteMatchDetectObject_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_SilhouetteMatchDetectObject_Response_Seq> Sample_SilhouetteMatchDetectObject_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_SilhouetteMatchDetectObject_Response_Seq> Sample_SilhouetteMatchDetectObject_Response_Seq_out;

            class  Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_var _var_type;

                static Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _duplicate (Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface () {};
                ~Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface () {};
            private:
                Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface (const Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface &);
                Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface & operator = (const Sample_SilhouetteMatchDetectObject_Response_TypeSupportInterface &);
            };

            class  Sample_SilhouetteMatchDetectObject_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_SilhouetteMatchDetectObject_Response_DataWriter_ptr _ptr_type;
                typedef Sample_SilhouetteMatchDetectObject_Response_DataWriter_var _var_type;

                static Sample_SilhouetteMatchDetectObject_Response_DataWriter_ptr _duplicate (Sample_SilhouetteMatchDetectObject_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SilhouetteMatchDetectObject_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SilhouetteMatchDetectObject_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_SilhouetteMatchDetectObject_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_SilhouetteMatchDetectObject_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_SilhouetteMatchDetectObject_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_SilhouetteMatchDetectObject_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SilhouetteMatchDetectObject_Response_& instance_data) = 0;

            protected:
                Sample_SilhouetteMatchDetectObject_Response_DataWriter () {};
                ~Sample_SilhouetteMatchDetectObject_Response_DataWriter () {};
            private:
                Sample_SilhouetteMatchDetectObject_Response_DataWriter (const Sample_SilhouetteMatchDetectObject_Response_DataWriter &);
                Sample_SilhouetteMatchDetectObject_Response_DataWriter & operator = (const Sample_SilhouetteMatchDetectObject_Response_DataWriter &);
            };

            class  Sample_SilhouetteMatchDetectObject_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_SilhouetteMatchDetectObject_Response_DataReader_ptr _ptr_type;
                typedef Sample_SilhouetteMatchDetectObject_Response_DataReader_var _var_type;

                static Sample_SilhouetteMatchDetectObject_Response_DataReader_ptr _duplicate (Sample_SilhouetteMatchDetectObject_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SilhouetteMatchDetectObject_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SilhouetteMatchDetectObject_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SilhouetteMatchDetectObject_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SilhouetteMatchDetectObject_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SilhouetteMatchDetectObject_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SilhouetteMatchDetectObject_Response_& instance) = 0;

            protected:
                Sample_SilhouetteMatchDetectObject_Response_DataReader () {};
                ~Sample_SilhouetteMatchDetectObject_Response_DataReader () {};
            private:
                Sample_SilhouetteMatchDetectObject_Response_DataReader (const Sample_SilhouetteMatchDetectObject_Response_DataReader &);
                Sample_SilhouetteMatchDetectObject_Response_DataReader & operator = (const Sample_SilhouetteMatchDetectObject_Response_DataReader &);
            };

            class  Sample_SilhouetteMatchDetectObject_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_SilhouetteMatchDetectObject_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_SilhouetteMatchDetectObject_Response_DataReaderView_var _var_type;

                static Sample_SilhouetteMatchDetectObject_Response_DataReaderView_ptr _duplicate (Sample_SilhouetteMatchDetectObject_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_SilhouetteMatchDetectObject_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_SilhouetteMatchDetectObject_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_SilhouetteMatchDetectObject_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_SilhouetteMatchDetectObject_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_SilhouetteMatchDetectObject_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_SilhouetteMatchDetectObject_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_SilhouetteMatchDetectObject_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_SilhouetteMatchDetectObject_Response_& instance) = 0;

            protected:
                Sample_SilhouetteMatchDetectObject_Response_DataReaderView () {};
                ~Sample_SilhouetteMatchDetectObject_Response_DataReaderView () {};
            private:
                Sample_SilhouetteMatchDetectObject_Response_DataReaderView (const Sample_SilhouetteMatchDetectObject_Response_DataReaderView &);
                Sample_SilhouetteMatchDetectObject_Response_DataReaderView & operator = (const Sample_SilhouetteMatchDetectObject_Response_DataReaderView &);
            };
        }

    }

}

#endif
