#ifndef H_1D7CAE28B24644A9C5CD91E1B59080C5_SilhouetteMatchDetectObject_SPLTYPES_H
#define H_1D7CAE28B24644A9C5CD91E1B59080C5_SilhouetteMatchDetectObject_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_SilhouetteMatchDetectObject_.h"
#include "rc_reason_msgs/msg/dds_opensplice/SilhouetteMatchObject_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"
#include "rc_reason_msgs/msg/dds_opensplice/SilhouetteMatchInstance_SplDcps.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_SplDcps.h"



extern c_metaObject __SilhouetteMatchDetectObject__rc_reason_msgs__load (c_base base);

extern c_metaObject __SilhouetteMatchDetectObject__rc_reason_msgs_srv__load (c_base base);

extern c_metaObject __SilhouetteMatchDetectObject__rc_reason_msgs_srv_dds___load (c_base base);

extern const char *rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::SilhouetteMatchDetectObject_Request_ *from, struct _rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Request_ {
    struct _rc_reason_msgs_msg_dds__SilhouetteMatchObject_ object_to_detect_;
    c_double offset_;
    c_string pose_frame_;
    struct _geometry_msgs_msg_dds__Pose_ robot_pose_;
};

extern const char *rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::SilhouetteMatchDetectObject_Response_ *from, struct _rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Response_ {
    struct _builtin_interfaces_msg_dds__Time_ timestamp_;
    c_string object_id_;
    c_sequence instances_;
    struct _rc_common_msgs_msg_dds__ReturnCode_ return_code_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Request__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Request__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Request__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Request___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Request_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Request___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_SilhouetteMatchDetectObject_Request_ *from, struct _rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Request_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Request___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Request_ request_;
};

extern const char *rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Response__metaDescriptor[];
extern const int rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Response__metaDescriptorArrLength;
extern const int rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Response__metaDescriptorLength;
extern c_metaObject __rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Response___load (c_base base);
struct _rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Response_ ;
extern  v_copyin_result __rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Response___copyIn(c_base base, const struct rc_reason_msgs::srv::dds_::Sample_SilhouetteMatchDetectObject_Response_ *from, struct _rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Response_ *to);
extern  void __rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Response___copyOut(const void *_from, void *_to);
struct _rc_reason_msgs_srv_dds__Sample_SilhouetteMatchDetectObject_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _rc_reason_msgs_srv_dds__SilhouetteMatchDetectObject_Response_ response_;
};

#undef OS_API
#endif
