// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:srv/DeleteRegionsOfInterest3D.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DELETE_REGIONS_OF_INTEREST3_D__STRUCT_HPP_
#define RC_REASON_MSGS__SRV__DELETE_REGIONS_OF_INTEREST3_D__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__DeleteRegionsOfInterest3D_Request __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__DeleteRegionsOfInterest3D_Request __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DeleteRegionsOfInterest3D_Request_
{
  using Type = DeleteRegionsOfInterest3D_Request_<ContainerAllocator>;

  explicit DeleteRegionsOfInterest3D_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit DeleteRegionsOfInterest3D_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _region_of_interest_ids_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _region_of_interest_ids_type region_of_interest_ids;

  // setters for named parameter idiom
  Type & set__region_of_interest_ids(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->region_of_interest_ids = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__DeleteRegionsOfInterest3D_Request
    std::shared_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__DeleteRegionsOfInterest3D_Request
    std::shared_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DeleteRegionsOfInterest3D_Request_ & other) const
  {
    if (this->region_of_interest_ids != other.region_of_interest_ids) {
      return false;
    }
    return true;
  }
  bool operator!=(const DeleteRegionsOfInterest3D_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DeleteRegionsOfInterest3D_Request_

// alias to use template instance with default allocator
using DeleteRegionsOfInterest3D_Request =
  rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'return_code'
#include "rc_common_msgs/msg/return_code__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__DeleteRegionsOfInterest3D_Response __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__DeleteRegionsOfInterest3D_Response __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DeleteRegionsOfInterest3D_Response_
{
  using Type = DeleteRegionsOfInterest3D_Response_<ContainerAllocator>;

  explicit DeleteRegionsOfInterest3D_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : return_code(_init)
  {
    (void)_init;
  }

  explicit DeleteRegionsOfInterest3D_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : return_code(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _return_code_type =
    rc_common_msgs::msg::ReturnCode_<ContainerAllocator>;
  _return_code_type return_code;

  // setters for named parameter idiom
  Type & set__return_code(
    const rc_common_msgs::msg::ReturnCode_<ContainerAllocator> & _arg)
  {
    this->return_code = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__DeleteRegionsOfInterest3D_Response
    std::shared_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__DeleteRegionsOfInterest3D_Response
    std::shared_ptr<rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DeleteRegionsOfInterest3D_Response_ & other) const
  {
    if (this->return_code != other.return_code) {
      return false;
    }
    return true;
  }
  bool operator!=(const DeleteRegionsOfInterest3D_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DeleteRegionsOfInterest3D_Response_

// alias to use template instance with default allocator
using DeleteRegionsOfInterest3D_Response =
  rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{

namespace srv
{

struct DeleteRegionsOfInterest3D
{
  using Request = rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Request;
  using Response = rc_reason_msgs::srv::DeleteRegionsOfInterest3D_Response;
};

}  // namespace srv

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DELETE_REGIONS_OF_INTEREST3_D__STRUCT_HPP_
