// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/DetectFillingLevel.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETECT_FILLING_LEVEL__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETECT_FILLING_LEVEL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'pose_frame'
// Member 'region_of_interest_id'
// Member 'load_carrier_ids'
#include "rosidl_generator_c/string.h"
// Member 'robot_pose'
#include "geometry_msgs/msg/pose__struct.h"
// Member 'filling_level_cell_count'
#include "rc_reason_msgs/msg/grid_size__struct.h"

// Struct defined in srv/DetectFillingLevel in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__DetectFillingLevel_Request
{
  rosidl_generator_c__String pose_frame;
  rosidl_generator_c__String region_of_interest_id;
  rosidl_generator_c__String__Sequence load_carrier_ids;
  geometry_msgs__msg__Pose robot_pose;
  rc_reason_msgs__msg__GridSize filling_level_cell_count;
} rc_reason_msgs__srv__DetectFillingLevel_Request;

// Struct for a sequence of rc_reason_msgs__srv__DetectFillingLevel_Request.
typedef struct rc_reason_msgs__srv__DetectFillingLevel_Request__Sequence
{
  rc_reason_msgs__srv__DetectFillingLevel_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__DetectFillingLevel_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/time__struct.h"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/load_carrier_with_filling_level__struct.h"
// Member 'return_code'
#include "rc_common_msgs/msg/return_code__struct.h"

// Struct defined in srv/DetectFillingLevel in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__DetectFillingLevel_Response
{
  builtin_interfaces__msg__Time timestamp;
  rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence load_carriers;
  rc_common_msgs__msg__ReturnCode return_code;
} rc_reason_msgs__srv__DetectFillingLevel_Response;

// Struct for a sequence of rc_reason_msgs__srv__DetectFillingLevel_Response.
typedef struct rc_reason_msgs__srv__DetectFillingLevel_Response__Sequence
{
  rc_reason_msgs__srv__DetectFillingLevel_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__DetectFillingLevel_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETECT_FILLING_LEVEL__STRUCT_H_
