// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:srv/GetLoadCarriers.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/get_load_carriers__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `load_carrier_ids`
#include "rosidl_generator_c/string_functions.h"

bool
rc_reason_msgs__srv__GetLoadCarriers_Request__init(rc_reason_msgs__srv__GetLoadCarriers_Request * msg)
{
  if (!msg) {
    return false;
  }
  // load_carrier_ids
  if (!rosidl_generator_c__String__Sequence__init(&msg->load_carrier_ids, 0)) {
    rc_reason_msgs__srv__GetLoadCarriers_Request__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__GetLoadCarriers_Request__fini(rc_reason_msgs__srv__GetLoadCarriers_Request * msg)
{
  if (!msg) {
    return;
  }
  // load_carrier_ids
  rosidl_generator_c__String__Sequence__fini(&msg->load_carrier_ids);
}

rc_reason_msgs__srv__GetLoadCarriers_Request *
rc_reason_msgs__srv__GetLoadCarriers_Request__create()
{
  rc_reason_msgs__srv__GetLoadCarriers_Request * msg = (rc_reason_msgs__srv__GetLoadCarriers_Request *)malloc(sizeof(rc_reason_msgs__srv__GetLoadCarriers_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__GetLoadCarriers_Request));
  bool success = rc_reason_msgs__srv__GetLoadCarriers_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__GetLoadCarriers_Request__destroy(rc_reason_msgs__srv__GetLoadCarriers_Request * msg)
{
  if (msg) {
    rc_reason_msgs__srv__GetLoadCarriers_Request__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence__init(rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__srv__GetLoadCarriers_Request * data = NULL;
  if (size) {
    data = (rc_reason_msgs__srv__GetLoadCarriers_Request *)calloc(size, sizeof(rc_reason_msgs__srv__GetLoadCarriers_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__GetLoadCarriers_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__GetLoadCarriers_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence__fini(rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__GetLoadCarriers_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence *
rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence__create(size_t size)
{
  rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence * array = (rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence *)malloc(sizeof(rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence__destroy(rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence * array)
{
  if (array) {
    rc_reason_msgs__srv__GetLoadCarriers_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `load_carriers`
#include "rc_reason_msgs/msg/load_carrier__functions.h"
// Member `return_code`
#include "rc_common_msgs/msg/return_code__functions.h"

bool
rc_reason_msgs__srv__GetLoadCarriers_Response__init(rc_reason_msgs__srv__GetLoadCarriers_Response * msg)
{
  if (!msg) {
    return false;
  }
  // load_carriers
  if (!rc_reason_msgs__msg__LoadCarrier__Sequence__init(&msg->load_carriers, 0)) {
    rc_reason_msgs__srv__GetLoadCarriers_Response__fini(msg);
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__init(&msg->return_code)) {
    rc_reason_msgs__srv__GetLoadCarriers_Response__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__GetLoadCarriers_Response__fini(rc_reason_msgs__srv__GetLoadCarriers_Response * msg)
{
  if (!msg) {
    return;
  }
  // load_carriers
  rc_reason_msgs__msg__LoadCarrier__Sequence__fini(&msg->load_carriers);
  // return_code
  rc_common_msgs__msg__ReturnCode__fini(&msg->return_code);
}

rc_reason_msgs__srv__GetLoadCarriers_Response *
rc_reason_msgs__srv__GetLoadCarriers_Response__create()
{
  rc_reason_msgs__srv__GetLoadCarriers_Response * msg = (rc_reason_msgs__srv__GetLoadCarriers_Response *)malloc(sizeof(rc_reason_msgs__srv__GetLoadCarriers_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__GetLoadCarriers_Response));
  bool success = rc_reason_msgs__srv__GetLoadCarriers_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__GetLoadCarriers_Response__destroy(rc_reason_msgs__srv__GetLoadCarriers_Response * msg)
{
  if (msg) {
    rc_reason_msgs__srv__GetLoadCarriers_Response__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence__init(rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__srv__GetLoadCarriers_Response * data = NULL;
  if (size) {
    data = (rc_reason_msgs__srv__GetLoadCarriers_Response *)calloc(size, sizeof(rc_reason_msgs__srv__GetLoadCarriers_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__GetLoadCarriers_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__GetLoadCarriers_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence__fini(rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__GetLoadCarriers_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence *
rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence__create(size_t size)
{
  rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence * array = (rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence *)malloc(sizeof(rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence__destroy(rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence * array)
{
  if (array) {
    rc_reason_msgs__srv__GetLoadCarriers_Response__Sequence__fini(array);
  }
  free(array);
}
