// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:srv/HandEyeCalibration.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/hand_eye_calibration__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

bool
rc_reason_msgs__srv__HandEyeCalibration_Request__init(rc_reason_msgs__srv__HandEyeCalibration_Request * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Request__fini(rc_reason_msgs__srv__HandEyeCalibration_Request * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

rc_reason_msgs__srv__HandEyeCalibration_Request *
rc_reason_msgs__srv__HandEyeCalibration_Request__create()
{
  rc_reason_msgs__srv__HandEyeCalibration_Request * msg = (rc_reason_msgs__srv__HandEyeCalibration_Request *)malloc(sizeof(rc_reason_msgs__srv__HandEyeCalibration_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__HandEyeCalibration_Request));
  bool success = rc_reason_msgs__srv__HandEyeCalibration_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Request__destroy(rc_reason_msgs__srv__HandEyeCalibration_Request * msg)
{
  if (msg) {
    rc_reason_msgs__srv__HandEyeCalibration_Request__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__init(rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__srv__HandEyeCalibration_Request * data = NULL;
  if (size) {
    data = (rc_reason_msgs__srv__HandEyeCalibration_Request *)calloc(size, sizeof(rc_reason_msgs__srv__HandEyeCalibration_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__HandEyeCalibration_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__HandEyeCalibration_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__fini(rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__HandEyeCalibration_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence *
rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__create(size_t size)
{
  rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * array = (rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence *)malloc(sizeof(rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__destroy(rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * array)
{
  if (array) {
    rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `message`
#include "rosidl_generator_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/pose__functions.h"

bool
rc_reason_msgs__srv__HandEyeCalibration_Response__init(rc_reason_msgs__srv__HandEyeCalibration_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // status
  // message
  if (!rosidl_generator_c__String__init(&msg->message)) {
    rc_reason_msgs__srv__HandEyeCalibration_Response__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    rc_reason_msgs__srv__HandEyeCalibration_Response__fini(msg);
    return false;
  }
  // error
  // translation_error_meter
  // rotation_error_degree
  // robot_mounted
  return true;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Response__fini(rc_reason_msgs__srv__HandEyeCalibration_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // status
  // message
  rosidl_generator_c__String__fini(&msg->message);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // error
  // translation_error_meter
  // rotation_error_degree
  // robot_mounted
}

rc_reason_msgs__srv__HandEyeCalibration_Response *
rc_reason_msgs__srv__HandEyeCalibration_Response__create()
{
  rc_reason_msgs__srv__HandEyeCalibration_Response * msg = (rc_reason_msgs__srv__HandEyeCalibration_Response *)malloc(sizeof(rc_reason_msgs__srv__HandEyeCalibration_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__HandEyeCalibration_Response));
  bool success = rc_reason_msgs__srv__HandEyeCalibration_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Response__destroy(rc_reason_msgs__srv__HandEyeCalibration_Response * msg)
{
  if (msg) {
    rc_reason_msgs__srv__HandEyeCalibration_Response__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__init(rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__srv__HandEyeCalibration_Response * data = NULL;
  if (size) {
    data = (rc_reason_msgs__srv__HandEyeCalibration_Response *)calloc(size, sizeof(rc_reason_msgs__srv__HandEyeCalibration_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__HandEyeCalibration_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__HandEyeCalibration_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__fini(rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__HandEyeCalibration_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence *
rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__create(size_t size)
{
  rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * array = (rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence *)malloc(sizeof(rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__destroy(rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * array)
{
  if (array) {
    rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__fini(array);
  }
  free(array);
}
