// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:srv/SilhouetteMatchDetectObject.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_HPP_
#define RC_REASON_MSGS__SRV__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'object_to_detect'
#include "rc_reason_msgs/msg/silhouette_match_object__struct.hpp"
// Member 'robot_pose'
#include "geometry_msgs/msg/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SilhouetteMatchDetectObject_Request_
{
  using Type = SilhouetteMatchDetectObject_Request_<ContainerAllocator>;

  explicit SilhouetteMatchDetectObject_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : object_to_detect(_init),
    robot_pose(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->offset = 0.0;
      this->pose_frame = "";
    }
  }

  explicit SilhouetteMatchDetectObject_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : object_to_detect(_alloc, _init),
    pose_frame(_alloc),
    robot_pose(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->offset = 0.0;
      this->pose_frame = "";
    }
  }

  // field types and members
  using _object_to_detect_type =
    rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator>;
  _object_to_detect_type object_to_detect;
  using _offset_type =
    double;
  _offset_type offset;
  using _pose_frame_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _pose_frame_type pose_frame;
  using _robot_pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _robot_pose_type robot_pose;

  // setters for named parameter idiom
  Type & set__object_to_detect(
    const rc_reason_msgs::msg::SilhouetteMatchObject_<ContainerAllocator> & _arg)
  {
    this->object_to_detect = _arg;
    return *this;
  }
  Type & set__offset(
    const double & _arg)
  {
    this->offset = _arg;
    return *this;
  }
  Type & set__pose_frame(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->pose_frame = _arg;
    return *this;
  }
  Type & set__robot_pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->robot_pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SilhouetteMatchDetectObject_Request_ & other) const
  {
    if (this->object_to_detect != other.object_to_detect) {
      return false;
    }
    if (this->offset != other.offset) {
      return false;
    }
    if (this->pose_frame != other.pose_frame) {
      return false;
    }
    if (this->robot_pose != other.robot_pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const SilhouetteMatchDetectObject_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SilhouetteMatchDetectObject_Request_

// alias to use template instance with default allocator
using SilhouetteMatchDetectObject_Request =
  rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/time__struct.hpp"
// Member 'instances'
#include "rc_reason_msgs/msg/silhouette_match_instance__struct.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/return_code__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SilhouetteMatchDetectObject_Response_
{
  using Type = SilhouetteMatchDetectObject_Response_<ContainerAllocator>;

  explicit SilhouetteMatchDetectObject_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : timestamp(_init),
    return_code(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->object_id = "";
    }
  }

  explicit SilhouetteMatchDetectObject_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : timestamp(_alloc, _init),
    object_id(_alloc),
    return_code(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->object_id = "";
    }
  }

  // field types and members
  using _timestamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _timestamp_type timestamp;
  using _object_id_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _object_id_type object_id;
  using _instances_type =
    std::vector<rc_reason_msgs::msg::SilhouetteMatchInstance_<ContainerAllocator>, typename ContainerAllocator::template rebind<rc_reason_msgs::msg::SilhouetteMatchInstance_<ContainerAllocator>>::other>;
  _instances_type instances;
  using _return_code_type =
    rc_common_msgs::msg::ReturnCode_<ContainerAllocator>;
  _return_code_type return_code;

  // setters for named parameter idiom
  Type & set__timestamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__object_id(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->object_id = _arg;
    return *this;
  }
  Type & set__instances(
    const std::vector<rc_reason_msgs::msg::SilhouetteMatchInstance_<ContainerAllocator>, typename ContainerAllocator::template rebind<rc_reason_msgs::msg::SilhouetteMatchInstance_<ContainerAllocator>>::other> & _arg)
  {
    this->instances = _arg;
    return *this;
  }
  Type & set__return_code(
    const rc_common_msgs::msg::ReturnCode_<ContainerAllocator> & _arg)
  {
    this->return_code = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response
    std::shared_ptr<rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SilhouetteMatchDetectObject_Response_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->object_id != other.object_id) {
      return false;
    }
    if (this->instances != other.instances) {
      return false;
    }
    if (this->return_code != other.return_code) {
      return false;
    }
    return true;
  }
  bool operator!=(const SilhouetteMatchDetectObject_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SilhouetteMatchDetectObject_Response_

// alias to use template instance with default allocator
using SilhouetteMatchDetectObject_Response =
  rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{

namespace srv
{

struct SilhouetteMatchDetectObject
{
  using Request = rc_reason_msgs::srv::SilhouetteMatchDetectObject_Request;
  using Response = rc_reason_msgs::srv::SilhouetteMatchDetectObject_Response;
};

}  // namespace srv

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__SILHOUETTE_MATCH_DETECT_OBJECT__STRUCT_HPP_
